! Description:
!   Provide named kind parameters for use in declarations of real and integer 
!    variables with specific byte sizes (i.e. one, two, four, and eight byte
!    integers; four and eight byte reals). The parameters can then be used
!    in (KIND = XX) modifiers in declarations.
!   A single function (byteSizesOK()) is provided to ensure that the selected 
!    kind parameters are correct.
!  
! Input Parameters:
!   None.
!
! Output Parameters:
!   Public parameters, fixed at compile time:
!     OneByteInt, TwoByteInt, FourByteInt, EightByteInt
!                                     FourByteReal, EightByteRadl
!
! References and Credits:
!   Written by
!    Robert Pincus
!    Cooperative Institue for Meteorological Satellite Studies
!    University of Wisconsin - Madison
!    1225 W. Dayton St. 
!    Madison, Wisconsin 53706
!    Robert.Pincus@ssec.wisc.edu
!
! Design Notes:
!   Fortran 90 doesn't allow one to check the number of bytes in a real variable;
!     we check only that four byte and eight byte reals have different kind parameters. 
!
module typesizes
  implicit none
  public
  integer, parameter ::   OneByteInt = selected_int_kind(2), &
                          TwoByteInt = selected_int_kind(4), &
                         FourByteInt = selected_int_kind(9), &
                        EightByteInt = selected_int_kind(18)

  integer, parameter ::                                          &
                        FourByteReal = selected_real_kind(P =  6, R =  37), &
                       EightByteReal = selected_real_kind(P = 13, R = 307)
contains
  logical function byteSizesOK()
  ! Users may call this function once to ensure that the kind parameters 
  !   the module defines are available with the current compiler. 
  ! We can't ensure that the two REAL kinds are actually four and 
  !   eight bytes long, but we can ensure that they are distinct. 
  ! Early Fortran 90 compilers would sometimes report incorrect results for 
  !   the bit_size intrinsic, but I haven't seen this in a long time. 

    ! Local variables
    integer (kind =  OneByteInt)  :: One
    integer (kind =  TwoByteInt)  :: Two
    integer (kind = FourByteInt)  :: Four
    integer (kind = EightByteInt) :: Eight

    if (bit_size( One) == 8  .and. bit_size( Two)   == 16 .and.  &
        bit_size(Four) == 32 .and. bit_size( Eight) == 64 .and.  &
        FourByteReal > 0 .and. EightByteReal > 0 .and. &
        FourByteReal /= EightByteReal) then
      byteSizesOK = .true.
    else
      byteSizesOK = .false.
    end if
  end function byteSizesOK
end module typeSizes

!-------- Array/string put/get routines given start, count, and stride -------

! Replacement for fort-varsio.c

! Written by: Richard Weed, Ph.D.
!             Center for Advanced Vehicular Systems
!             Mississippi State University
!             rweed@cavs.msstate.edu


! License (and other Lawyer Language)
 
! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Corporation for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1.: Sept  2005 - Initial Cray X1 version
! Version 2.: May   2006 - Updated to support g95
!                          Updated to pass start, counts, and strides as
!                          C_PTR variables
! Version 3.: April 2009 - Updated for netCDF 4.0.1
! Version 4.: April 2010 - Updated for netCDF 4.1.1
!                          Added preprocessor tests for int and real types
! Version 5.: Jan.  2016 - Replaced automatic arrays for starts, counts,
!                          and strides with allocatable arrays and general
!                          text cleanup

!--------------------------------- nf_put_vars_text ----------------------
 Function nf_put_vars_text(ncid, varid, start, counts, strides, text) &
                           RESULT(status)

! Write out a character string given start, count, and stride

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN) :: ncid, varid
 Integer,          Intent(IN) :: start(*), counts(*), strides(*)
 Character(LEN=*), Intent(IN) :: text 

 Integer                      :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:)

 cncid    = ncid
 cvarid   = varid - 1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(ndims))
     ALLOCATE(ccounts(ndims))
     ALLOCATE(cstrides(ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
   EndIf
 EndIf

 cstatus = nc_put_vars_text(cncid, cvarid, cstartptr, ccountsptr, &
                            cstridesptr, text)

 status = cstatus

 End Function nf_put_vars_text
!--------------------------------- nf_put_vars_text_a ----------------------
 Function nf_put_vars_text_a(ncid, varid, start, counts, strides, text) &
                                RESULT(status)

! Write out array of characters given start, count, and stride
! Special version for case where string is an array of characters

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN) :: ncid, varid
 Integer,          Intent(IN) :: start(*), counts(*), strides(*)
 Character(LEN=1), Intent(IN) :: text(*) 

 Integer                      :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:)

 cncid    = ncid
 cvarid   = varid - 1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(ndims))
     ALLOCATE(ccounts(ndims))
     ALLOCATE(cstrides(ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
   EndIf
 EndIf

 cstatus = nc_put_vars_text(cncid, cvarid, cstartptr, ccountsptr, &
                            cstridesptr, text)
 status = cstatus

 End Function nf_put_vars_text_a
!--------------------------------- nf_put_vars_int1 ------------------------
 Function nf_put_vars_int1(ncid, varid, start, counts, strides, i1vals) &
                           RESULT(status)

! Write out 8 bit integer array given start, count, and stride

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,         Intent(IN) :: ncid, varid
 Integer,         Intent(IN) :: start(*), counts(*), strides(*)
 Integer(NFINT1), Intent(IN) :: i1vals(*)

 Integer                          :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:)

 If (C_SIGNED_CHAR < 0) Then ! schar not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf

 cncid    = ncid
 cvarid   = varid - 1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(ndims))
     ALLOCATE(ccounts(ndims))
     ALLOCATE(cstrides(ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
   EndIf
 EndIf

#if NF_INT1_IS_C_SIGNED_CHAR
 cstatus = nc_put_vars_schar(cncid, cvarid, cstartptr, ccountsptr, &
                             cstridesptr, i1vals)
#elif NF_INT1_IS_C_SHORT
 cstatus = nc_put_vars_short(cncid, cvarid, cstartptr, ccountsptr, &
                             cstridesptr, i1vals)
#elif NF_INT1_IS_C_INT
 cstatus = nc_put_vars_int(cncid, cvarid, cstartptr, ccountsptr, &
                           cstridesptr, i1vals)
#elif NF_INT1_IS_C_LONG
 cstatus = nc_put_vars_long(cncid, cvarid, cstartptr, ccountsptr, &
                            cstridesptr, i1vals)
#endif

 status = cstatus

! Make sure we have no dangling pointers and unallocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_put_vars_int1
!--------------------------------- nf_put_vars_int2 ------------------------
 Function nf_put_vars_int2(ncid, varid, start, counts, strides, i2vals) &
                              RESULT(status)

! Write out 16 bit integer array given start, count, and stride

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,         Intent(IN) :: ncid, varid
 Integer,         Intent(IN) :: start(*), counts(*), strides(*)
 Integer(NFINT2), Intent(IN) :: i2vals(*)

 Integer                          :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:)

 If (C_SHORT < 0) Then ! short not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf

 cncid    = ncid
 cvarid   = varid - 1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(ndims))
     ALLOCATE(ccounts(ndims))
     ALLOCATE(cstrides(ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
   EndIf
 EndIf

#if NF_INT2_IS_C_SHORT
 cstatus = nc_put_vars_short(cncid, cvarid, cstartptr, ccountsptr, &
                             cstridesptr, i2vals)
#elif NF_INT2_IS_C_INT
 cstatus = nc_put_vars_int(cncid, cvarid, cstartptr, ccountsptr, &
                           cstridesptr, i2vals)
#elif NF_INT2_IS_C_LONG
 cstatus = nc_put_vars_long(cncid, cvarid, cstartptr, ccountsptr, &
                            cstridesptr, i2vals)
#endif

 status = cstatus

! Make sure we have no dangling pointers and unallocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_put_vars_int2
!--------------------------------- nf_put_vars_int -------------------------
 Function nf_put_vars_int(ncid, varid, start, counts, strides, ivals) &
                             RESULT(status)

! Write out default integer array given start, count, and stride

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,        Intent(IN) :: ncid, varid
 Integer,        Intent(IN) :: start(*), counts(*), strides(*)
 Integer(NFINT), Intent(IN) :: ivals(*)

 Integer                    :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:)

 cncid    = ncid
 cvarid   = varid - 1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(ndims))
     ALLOCATE(ccounts(ndims))
     ALLOCATE(cstrides(ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
   EndIf
 EndIf

#if NF_INT_IS_C_INT
 cstatus = nc_put_vars_int(cncid, cvarid, cstartptr, ccountsptr, &
                           cstridesptr, ivals)
#elif NF_INT_IS_C_LONG
 cstatus = nc_put_vars_long(cncid, cvarid, cstartptr, ccountsptr, &
                            cstridesptr, ivals)
#endif

 status = cstatus

! Make sure we have no dangling pointers and unallocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_put_vars_int
!--------------------------------- nf_put_vars_real ------------------------
 Function nf_put_vars_real(ncid, varid, start, counts, strides, rvals) &
                              RESULT(status)

! Write out 32 bit real array given start, count, and stride

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,      Intent(IN) :: ncid, varid
 Integer,      Intent(IN) :: start(*), counts(*), strides(*)
 Real(NFREAL), Intent(IN) :: rvals(*)

 Integer                  :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:)

 cncid    = ncid
 cvarid   = varid - 1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(ndims))
     ALLOCATE(ccounts(ndims))
     ALLOCATE(cstrides(ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
   EndIf
 EndIf

#if NF_REAL_IS_C_DOUBLE
 cstatus = nc_put_vars_double(cncid, cvarid, cstartptr, ccountsptr, &
                              cstridesptr, rvals)
#else
 cstatus = nc_put_vars_float(cncid, cvarid, cstartptr, ccountsptr, &
                             cstridesptr, rvals)
#endif

 status = cstatus

! Make sure we have no dangling pointers and unallocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_put_vars_real
!--------------------------------- nf_put_vars_double ----------------------
 Function nf_put_vars_double(ncid, varid, start, counts, strides, dvals) &
                               RESULT(status)

! Write out 64 bit real array given start, count, and stride

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,   Intent(IN) :: ncid, varid
 Integer,   Intent(IN) :: start(*), counts(*), strides(*)
 Real(RK8), Intent(IN) :: dvals(*)

 Integer               :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:)

 cncid    = ncid
 cvarid   = varid - 1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(ndims))
     ALLOCATE(ccounts(ndims))
     ALLOCATE(cstrides(ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
   EndIf
 EndIf

 cstatus = nc_put_vars_double(cncid, cvarid, cstartptr, ccountsptr, &
                              cstridesptr, dvals)

 status = cstatus

! Make sure we have no dangling pointers and unallocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_put_vars_double
!--------------------------------- nf_put_vars_int64 --------------------------
 Function nf_put_vars_int64(ncid, varid, start, counts, strides, ivals) &
                             RESULT(status)

! Write out 64 bit integer array given start, count, and stride

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,      Intent(IN) :: ncid, varid
 Integer,      Intent(IN) :: start(*), counts(*), strides(*)
 Integer(IK8), Intent(IN) :: ivals(*)

 Integer                  :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:)

 cncid    = ncid
 cvarid   = varid - 1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(ndims))
     ALLOCATE(ccounts(ndims))
     ALLOCATE(cstrides(ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
   EndIf
 EndIf

 cstatus = nc_put_vars_longlong(cncid, cvarid, cstartptr, ccountsptr, &
                                cstridesptr, ivals)

 status = cstatus

! Make sure there are no dangling pointers or allocated values

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_put_vars_int64
!--------------------------------- nf_put_vars -----------------------------
 Function nf_put_vars(ncid, varid, start, counts, strides, values) &
                      RESULT(status)

! Write out a variable of any type. We use a C interop character string to
! hold the values. Therefore, an explicit interface to nf_put_vars should NOT
! be used in the calling program. Just use external 

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,                Intent(IN)         :: ncid, varid
 Integer,                Intent(IN)         :: start(*), counts(*), strides(*)
 Character(KIND=C_CHAR), Intent(IN), TARGET :: values(*) 
 Integer                                    :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr, cvaluesptr 
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:)

 cncid    = ncid
 cvarid   = varid - 1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(ndims))
     ALLOCATE(ccounts(ndims))
     ALLOCATE(cstrides(ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
   EndIf
 EndIf

 cvaluesptr = C_LOC(values)

 cstatus = nc_put_vars(cncid, cvarid, cstartptr, ccountsptr, &
                       cstridesptr, cvaluesptr)

 status = cstatus

! Make sure we have no dangling pointers and unallocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_put_vars
!--------------------------------- nf_get_vars_text ----------------------
 Function nf_get_vars_text(ncid, varid, start, counts, strides, text) &
                                RESULT(status)

! Read in a character string from  dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(IN)  :: start(*), counts(*), strides(*)
 Character(LEN=*), Intent(OUT) :: text 

 Integer                       :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:)

 cncid    = ncid
 cvarid   = varid - 1 ! Subtract 1 to get C varid
 text     = REPEAT(" ", LEN(text))

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(ndims))
     ALLOCATE(ccounts(ndims))
     ALLOCATE(cstrides(ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
   EndIf
 EndIf

 cstatus = nc_get_vars_text(cncid, cvarid, cstartptr, ccountsptr, &
                            cstridesptr, text)

 status = cstatus

! Make sure we have no dangling pointers and unallocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_get_vars_text
!--------------------------------- nf_get_vars_text_a ----------------------
 Function nf_get_vars_text_a(ncid, varid, start, counts, strides, text) &
                                RESULT(status)

! Read in an array of characters given start, count, and stride

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(IN)  :: start(*), counts(*), strides(*)
 Character(LEN=1), Intent(OUT) :: text(*)

 Integer                       :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:)

 cncid    = ncid
 cvarid   = varid - 1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(ndims))
     ALLOCATE(ccounts(ndims))
     ALLOCATE(cstrides(ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
   EndIf
 EndIf

 cstatus = nc_get_vars_text(cncid, cvarid, cstartptr, ccountsptr, &
                            cstridesptr, text)

 status = cstatus

! Make sure we have no dangling pointers and unallocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_get_vars_text_a
!--------------------------------- nf_get_vars_int1 ------------------------
 Function nf_get_vars_int1(ncid, varid, start, counts, strides, i1vals) &
                              RESULT(status)

! Read in 8 bit integer array given start, count, and stride

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,         Intent(IN)  :: ncid, varid
 Integer,         Intent(IN)  :: start(*), counts(*), strides(*)
 Integer(NFINT1), Intent(OUT) :: i1vals(*)

 Integer                           :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:)

 If (C_SIGNED_CHAR < 0) Then ! schar not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf

 cncid    = ncid
 cvarid   = varid - 1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(ndims))
     ALLOCATE(ccounts(ndims))
     ALLOCATE(cstrides(ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
   EndIf
 EndIf

#if NF_INT1_IS_C_SIGNED_CHAR
 cstatus = nc_get_vars_schar(cncid, cvarid, cstartptr, ccountsptr, &
                             cstridesptr, i1vals)
#elif NF_INT1_IS_C_SHORT
 cstatus = nc_get_vars_short(cncid, cvarid, cstartptr, ccountsptr, &
                             cstridesptr, i1vals)
#elif NF_INT1_IS_C_INT
 cstatus = nc_get_vars_int(cncid, cvarid, cstartptr, ccountsptr, &
                            cstridesptr, i1vals)
#elif NF_INT1_IS_C_LONG
 cstatus = nc_get_vars_long(cncid, cvarid, cstartptr, ccountsptr, &
                             cstridesptr, i1vals)
#endif

 status = cstatus

! Make sure we have no dangling pointers and unallocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_get_vars_int1
!--------------------------------- nf_get_vars_int2 ------------------------
 Function nf_get_vars_int2(ncid, varid, start, counts, strides, i2vals) &
                              RESULT(status)

! Read in 16 bit integer array given start, count, and stride

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,         Intent(IN)  :: ncid, varid
 Integer,         Intent(IN)  :: start(*), counts(*), strides(*)
 Integer(NFINT2), Intent(OUT) :: i2vals(*)

 Integer                           :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:)

 If (C_SHORT < 0) Then ! short not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf

 cncid    = ncid
 cvarid   = varid - 1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(ndims))
     ALLOCATE(ccounts(ndims))
     ALLOCATE(cstrides(ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
   EndIf
 EndIf

#if NF_INT2_IS_C_SHORT
 cstatus = nc_get_vars_short(cncid, cvarid, cstartptr, ccountsptr, &
                             cstridesptr, i2vals)
#elif NF_INT2_IS_C_INT
 cstatus = nc_get_vars_int(cncid, cvarid, cstartptr, ccountsptr, &
                           cstridesptr, i2vals)
#elif NF_INT2_IS_C_LONG
 cstatus = nc_get_vars_long(cncid, cvarid, cstartptr, ccountsptr, &
                            cstridesptr, i2vals)
#endif

 status = cstatus

! Make sure we have no dangling pointers and unallocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_get_vars_int2
!--------------------------------- nf_get_vars_int -------------------------
 Function nf_get_vars_int(ncid, varid, start, counts, strides, ivals) &
                             RESULT(status)

! Read in default integer array given start, count, and stride

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,        Intent(IN)  :: ncid, varid
 Integer,        Intent(IN)  :: start(*), counts(*), strides(*)
 Integer(NFINT), Intent(OUT) :: ivals(*)

 Integer                     :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:)

 cncid    = ncid
 cvarid   = varid - 1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(ndims))
     ALLOCATE(ccounts(ndims))
     ALLOCATE(cstrides(ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
   EndIf
 EndIf

#if NF_INT_IS_C_INT
 cstatus = nc_get_vars_int(cncid, cvarid, cstartptr, ccountsptr, &
                           cstridesptr, ivals)
#elif NF_INT_IS_C_LONG
 cstatus = nc_get_vars_long(cncid, cvarid, cstartptr, ccountsptr, &
                            cstridesptr, ivals)
#endif

 status = cstatus

! Make sure we have no dangling pointers and unallocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_get_vars_int
!--------------------------------- nf_get_vars_real ------------------------
 Function nf_get_vars_real(ncid, varid, start, counts, strides, rvals) &
                              RESULT(status)

! Read in 32 bit real array given start, count, and stride

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,      Intent(IN)  :: ncid, varid
 Integer,      Intent(IN)  :: start(*), counts(*), strides(*)
 Real(NFREAL), Intent(OUT) :: rvals(*)

 Integer                   :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:)

 cncid    = ncid
 cvarid   = varid - 1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(ndims))
     ALLOCATE(ccounts(ndims))
     ALLOCATE(cstrides(ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
   EndIf
 EndIf

#if NF_REAL_IS_C_DOUBLE
 cstatus = nc_get_vars_double(cncid, cvarid, cstartptr, ccountsptr, &
                              cstridesptr, rvals)
#else
 cstatus = nc_get_vars_float(cncid, cvarid, cstartptr, ccountsptr, &
                             cstridesptr, rvals)
#endif

 status = cstatus

! Make sure we have no dangling pointers and unallocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_get_vars_real
!--------------------------------- nf_get_vars_double ----------------------
 Function nf_get_vars_double(ncid, varid, start, counts, strides, dvals) &
                                RESULT(status)

! Read in 64 bit real array given start, count, and stride

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,   Intent(IN)  :: ncid, varid
 Integer,   Intent(IN)  :: start(*), counts(*), strides(*)
 Real(RK8), Intent(OUT) :: dvals(*)

 Integer                :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:)

 cncid    = ncid
 cvarid   = varid - 1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(ndims))
     ALLOCATE(ccounts(ndims))
     ALLOCATE(cstrides(ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
   EndIf
 EndIf

 cstatus = nc_get_vars_double(cncid, cvarid, cstartptr, ccountsptr, &
                              cstridesptr, dvals)

 status = cstatus

! Make sure we have no dangling pointers and unallocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_get_vars_double
!--------------------------------- nf_get_vars_int64 --------------------------
 Function nf_get_vars_int64(ncid, varid, start, counts, strides, ivals) &
                             RESULT(status)

! Read in 64 bit integer array given start, count, and stride

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,      Intent(IN)  :: ncid, varid
 Integer,      Intent(IN)  :: start(*), counts(*), strides(*)
 Integer(IK8), Intent(OUT) :: ivals(*)

 Integer                   :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:)

 cncid    = ncid
 cvarid   = varid - 1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(ndims))
     ALLOCATE(ccounts(ndims))
     ALLOCATE(cstrides(ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
   EndIf
 EndIf

 cstatus = nc_get_vars_longlong(cncid, cvarid, cstartptr, ccountsptr, &
                                cstridesptr, ivals)
 status = cstatus

! Make sure there are no dangling pointers or allocated values

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_get_vars_int64
!--------------------------------- nf_get_vars ----------------------------
 Function nf_get_vars(ncid, varid, start, counts, strides, values) &
                      RESULT(status)

! Read in a variable of any type. We use a C interop character string to
! hold the values. Therefore, an explicit interface to nf_put_vars should NOT
! be used in the calling program. Just use external 

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,                Intent(IN)    :: ncid, varid
 Integer,                Intent(IN)    :: start(*), counts(*), strides(*)
 Character(KIND=C_CHAR), Intent(INOUT) :: values

 Integer                               :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:)

 cncid    = ncid
 cvarid   = varid - 1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(ndims))
     ALLOCATE(ccounts(ndims))
     ALLOCATE(cstrides(ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
   EndIf
 EndIf

 cstatus = nc_get_vars(cncid, cvarid, cstartptr, ccountsptr, &
                       cstridesptr, values)

 status = cstatus

! Make sure we have no dangling pointers and unallocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_get_vars

#include "nfconfig.inc"
!--- Array put/get routines for different types for given start and count ----

! Replacement for fort-varaio.c

! Written by: Richard Weed, Ph.D.
!             Center for Advanced Vehicular Systems 
!             Mississippi State University
!             rweed@cavs.msstate.edu


! License (and other Lawyer Language)
 
! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Corporation for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1.: Sept. 2005 - Initial Cray X1 version
! Version 2.: May   2006 - Updated to support g95
!                          Updated to pass start and counts as C_PTR
!                          variables
! Version 3.: April 2009 - Updated for netCDF 4.0.1
! Version 4.: April 2010 - Updated for netCDF 4.1.1
!                          Added preprocessor test for int and real types
         
!--------------------------------- nf_put_vara_text ----------------------
 Function nf_put_vara_text(ncid, varid, start, counts, text) RESULT(status)

! Write out a character string to dataset for given start and count vectors

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN) :: ncid, varid
 Integer,          Intent(IN) :: start(*), counts(*)
 Character(LEN=*), Intent(IN) :: text

 Integer                      :: status

 Integer(KIND=C_INT)            :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1 ! Subtract 1 to get C varid
 cstart  = 0
 ccounts = 0

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! flip array order for C and subtract 1 from start
     cstart(1:ndims)  = start(ndims:1:-1)-1
     ccounts(1:ndims) = counts(ndims:1:-1)
   EndIf
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 EndIf

 cstatus = nc_put_vara_text(cncid, cvarid, cstartptr, ccountsptr, text)

 status = cstatus

 End Function nf_put_vara_text
!--------------------------------- nf_put_vara_text_a ----------------------
 Function nf_put_vara_text_a(ncid, varid, start, counts, text) RESULT(status)

! Write out an array of characters to dataset for given start and count vectors

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN) :: ncid, varid
 Integer,          Intent(IN) :: start(*), counts(*)
 Character(LEN=1), Intent(IN) :: text(*)

 Integer                      :: status

 Integer(KIND=C_INT)            :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1 ! Subtract 1 to get C varid
 cstart  = 0
 ccounts = 0

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! flip array order for C and subtract 1 from start
     cstart(1:ndims)  = start(ndims:1:-1)-1
     ccounts(1:ndims) = counts(ndims:1:-1)
   EndIf
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 EndIf

 cstatus = nc_put_vara_text(cncid, cvarid, cstartptr, ccountsptr, text)

 status = cstatus

 End Function nf_put_vara_text_a
!--------------------------------- nf_put_vara_int1 ------------------------
 Function nf_put_vara_int1(ncid, varid, start, counts, i1vals) RESULT(status)

! Write out 8 bit integer array to dataset for given start and count vectors

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,              Intent(IN) :: ncid, varid
 Integer,              Intent(IN) :: start(*), counts(*)
 Integer(KIND=NFINT1), Intent(IN) :: i1vals(*)

 Integer                          :: status

 Integer(KIND=C_INT)            :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Integer                        :: ndims

 If (C_SIGNED_CHAR < 0) Then ! schar not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf

 cncid   = ncid
 cvarid  = varid - 1 ! Subtract 1 to get C varid
 cstart  = 0
 ccounts = 0

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! flip array order for C and subtract 1 from start
     cstart(1:ndims)  = start(ndims:1:-1)-1
     ccounts(1:ndims) = counts(ndims:1:-1)
   EndIf
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 EndIf

#if NF_INT1_IS_C_SIGNED_CHAR
 cstatus = nc_put_vara_schar(cncid, cvarid, cstartptr, ccountsptr, i1vals)
#elif NF_INT1_IS_C_SHORT
 cstatus = nc_put_vara_short(cncid, cvarid, cstartptr, ccountsptr, i1vals)
#elif NF_INT1_IS_C_INT
 cstatus = nc_put_vara_int(cncid, cvarid, cstartptr, ccountsptr, i1vals)
#elif NF_INT1_IS_C_LONG
 cstatus = nc_put_vara_long(cncid, cvarid, cstartptr, ccountsptr, i1vals)
#endif
 
 status = cstatus

 End Function nf_put_vara_int1
!--------------------------------- nf_put_vara_int2 ------------------------
 Function nf_put_vara_int2(ncid, varid, start, counts, i2vals) RESULT(status)

! Write out 16 bit integer array to dataset for given start and count vectors

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,              Intent(IN) :: ncid, varid
 Integer,              Intent(IN) :: start(*), counts(*)
 Integer(KIND=NFINT2), Intent(IN) :: i2vals(*)

 Integer                          :: status

 Integer(KIND=C_INT)            :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Integer                        :: ndims

 If (C_SHORT < 0) Then ! short not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf

 cncid   = ncid
 cvarid  = varid - 1 ! Subtract 1 to get C varid
 cstart  = 0
 ccounts = 0

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! flip array order for C and subtract 1 from start
     cstart(1:ndims)  = start(ndims:1:-1)-1
     ccounts(1:ndims) = counts(ndims:1:-1)
   EndIf
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 EndIf

#if NF_INT2_IS_C_SHORT
 cstatus = nc_put_vara_short(cncid, cvarid, cstartptr, ccountsptr, i2vals)
#elif NF_INT2_IS_C_INT
 cstatus = nc_put_vara_int(cncid, cvarid, cstartptr, ccountsptr, i2vals)
#elif NF_INT2_IS_C_LONG
 cstatus = nc_put_vara_long(cncid, cvarid, cstartptr, ccountsptr, i2vals)
#endif

 status = cstatus

 End Function nf_put_vara_int2
!--------------------------------- nf_put_vara_int -------------------------
 Function nf_put_vara_int(ncid, varid, start, counts, ivals) RESULT(status)

! Write out default integer array to dataset for given start and count vectors

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,        Intent(IN) :: ncid, varid
 Integer,        Intent(IN) :: start(*), counts(*)
 Integer(NFINT), Intent(IN) :: ivals(*)

 Integer                    :: status

 Integer(KIND=C_INT)            :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1 ! Subtract 1 to get C varid
 cstart  = 0
 ccounts = 0

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! flip array order for C and subtract 1 from start
     cstart(1:ndims)  = start(ndims:1:-1)-1
     ccounts(1:ndims) = counts(ndims:1:-1)
   EndIf
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 EndIf

#if NF_INT_IS_C_INT
 cstatus = nc_put_vara_int(cncid, cvarid, cstartptr, ccountsptr, ivals)
#elif NF_INT_IS_C_LONG
 cstatus = nc_put_vara_long(cncid, cvarid, cstartptr, ccountsptr, ivals)
#endif

 status = cstatus

 End Function nf_put_vara_int
!--------------------------------- nf_put_vara_real ------------------------
 Function nf_put_vara_real(ncid, varid, start, counts, rvals) RESULT(status)

! Write out real(RK4) array to dataset for given start and count vectors

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,      Intent(IN) :: ncid, varid
 Integer,      Intent(IN) :: start(*), counts(*)
 Real(NFREAL), Intent(IN) :: rvals(*)

 Integer                  :: status

 Integer(KIND=C_INT)            :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1 ! Subtract 1 to get C varid
 cstart  = 0
 ccounts = 0

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! flip array order for C and subtract 1 from start
     cstart(1:ndims)  = start(ndims:1:-1)-1
     ccounts(1:ndims) = counts(ndims:1:-1)
   EndIf
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 EndIf

#if NF_REAL_IS_C_DOUBLE
 cstatus = nc_put_vara_double(cncid, cvarid, cstartptr, ccountsptr, rvals)
#else
 cstatus = nc_put_vara_float(cncid, cvarid, cstartptr, ccountsptr, rvals)
#endif

 status = cstatus

 End Function nf_put_vara_real
!--------------------------------- nf_put_vara_double ----------------------
 Function nf_put_vara_double(ncid, varid, start, counts, dvals) &
                                RESULT(status)

! Write out real(RK8) variable to dataset for given start and count vectors

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,   Intent(IN) :: ncid, varid
 Integer,   Intent(IN) :: start(*), counts(*)
 Real(RK8), Intent(IN) :: dvals(*)

 Integer               :: status

 Integer(KIND=C_INT)            :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1 ! Subtract 1 to get C varid
 cstart  = 0
 ccounts = 0

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims) ! get varid dimension

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! flip array order for C and subtract 1 from start
     cstart(1:ndims)  = start(ndims:1:-1)-1
     ccounts(1:ndims) = counts(ndims:1:-1)
   EndIf
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 EndIf

 cstatus = nc_put_vara_double(cncid, cvarid, cstartptr, ccountsptr, dvals)

 status = cstatus

 End Function nf_put_vara_double
!--------------------------------- nf_put_vara ------------------------------
 Function nf_put_vara(ncid, varid, start, counts, values) RESULT(status)

! Write out an array of any type. We use a C interop character string to
! pass values. Therefore, an explicit interface to nf_put_vara should not
! be used in the calling routine. Just use external. 

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,                Intent(IN)         :: ncid, varid
 Integer,                Intent(IN)         :: start(*), counts(*)
 Character(KIND=C_CHAR), Intent(IN), TARGET :: values(*)
! Type(C_PTR),            VALUE              :: values
 Integer                                    :: status

 Integer(KIND=C_INT)            :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr, cvaluesptr
! Type(C_PTR)                    :: cstartptr, ccountsptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1 ! Subtract 1 to get C varid
 cstart  = 0
 ccounts = 0

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! flip array order for C and subtract 1 from start
     cstart(1:ndims)  = start(ndims:1:-1)-1
     ccounts(1:ndims) = counts(ndims:1:-1)
   EndIf
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 EndIf

 cvaluesptr = C_LOC(values)

 cstatus = nc_put_vara(cncid, cvarid, cstartptr, ccountsptr, cvaluesptr)
! cstatus = nc_put_vara(cncid, cvarid, cstartptr, ccountsptr, values)

 status = cstatus

 End Function nf_put_vara
!--------------------------------- nf_get_vara_text ----------------------
 Function nf_get_vara_text(ncid, varid, start, counts, text) RESULT(status)

! Read in a character string from dataset for given start and count vectors 

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(IN)  :: start(*), counts(*)
 Character(LEN=*), Intent(OUT) :: text

 Integer                       :: status

 Integer(KIND=C_INT)            :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1 ! Subtract 1 to get C varid
 cstart  = 0
 ccounts = 0
 text    = REPEAT(" ", LEN(text))

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! flip array order for C and subtract 1 from start
     cstart(1:ndims)  = start(ndims:1:-1)-1
     ccounts(1:ndims) = counts(ndims:1:-1)
   EndIf
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 EndIf

 cstatus = nc_get_vara_text(cncid, cvarid, cstartptr, ccountsptr, text)

 status = cstatus

 End Function nf_get_vara_text
!--------------------------------- nf_get_vara_text_a ----------------------
 Function nf_get_vara_text_a(ncid, varid, start, counts, text) RESULT(status)

! Read in an array of characters for given start and count vectors 

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(IN)  :: start(*), counts(*)
 Character(LEN=1), Intent(OUT) :: text(*)

 Integer                       :: status

 Integer(KIND=C_INT)            :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1 ! Subtract 1 to get C varid
 cstart  = 0
 ccounts = 0

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! flip array order for C and subtract 1 from start
     cstart(1:ndims)  = start(ndims:1:-1)-1
     ccounts(1:ndims) = counts(ndims:1:-1)
   EndIf
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 EndIf

 cstatus = nc_get_vara_text(cncid, cvarid, cstartptr, ccountsptr, text)

 status = cstatus

 End Function nf_get_vara_text_a
!--------------------------------- nf_get_vara_int1 ------------------------
 Function nf_get_vara_int1(ncid, varid, start, counts, i1vals) RESULT(status)

! Read in 8 bit integer array from dataset for given start and count vectors 

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,              Intent(IN)  :: ncid, varid
 Integer,              Intent(IN)  :: start(*), counts(*)
 Integer(KIND=NFINT1), Intent(OUT) :: i1vals(*)

 Integer                           :: status

 Integer(KIND=C_INT)            :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Integer                        :: ndims

 If (C_SIGNED_CHAR < 0) Then ! schar not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf

 cncid   = ncid
 cvarid  = varid - 1 ! Subtract 1 to get C varid
 cstart  = 0
 ccounts = 0

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! flip array order for C and subtract 1 from start
     cstart(1:ndims)  = start(ndims:1:-1)-1
     ccounts(1:ndims) = counts(ndims:1:-1)
   EndIf
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 EndIf

#if NF_INT1_IS_C_SIGNED_CHAR
 cstatus = nc_get_vara_schar(cncid, cvarid, cstartptr, ccountsptr, i1vals)
#elif NF_INT1_IS_C_SHORT
 cstatus = nc_get_vara_short(cncid, cvarid, cstartptr, ccountsptr, i1vals)
#elif NF_INT1_IS_C_INT
 cstatus = nc_get_vara_int(cncid, cvarid, cstartptr, ccountsptr, i1vals)
#elif NF_INT1_IS_C_LONG
 cstatus = nc_get_vara_long(cncid, cvarid, cstartptr, ccountsptr, i1vals)
#endif

 status = cstatus

 End Function nf_get_vara_int1
!--------------------------------- nf_get_vara_int2 ------------------------
 Function nf_get_vara_int2(ncid, varid, start, counts, i2vals) RESULT(status)

! Read in 16 bit integer array from dataset for given start and count vectors

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,              Intent(IN)  :: ncid, varid
 Integer,              Intent(IN)  :: start(*), counts(*)
 Integer(KIND=NFINT2), Intent(OUT) :: i2vals(*)

 Integer                           :: status

 Integer(KIND=C_INT)            :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Integer                        :: ndims

 If (C_SHORT < 0) Then ! short not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf

 cncid   = ncid
 cvarid  = varid - 1 ! Subtract 1 to get C varid
 cstart  = 0
 ccounts = 0

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! flip array order for C and subtract 1 from start
     cstart(1:ndims)  = start(ndims:1:-1)-1
     ccounts(1:ndims) = counts(ndims:1:-1)
   EndIf
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 EndIf

#if NF_INT2_IS_C_SHORT
 cstatus = nc_get_vara_short(cncid, cvarid, cstartptr, ccountsptr, i2vals)
#elif NF_INT2_IS_C_INT
 cstatus = nc_get_vara_int(cncid, cvarid, cstartptr, ccountsptr, i2vals)
#elif NF_INT2_IS_C_LONG
 cstatus = nc_get_vara_long(cncid, cvarid, cstartptr, ccountsptr, i2vals)
#endif

 status = cstatus

 End Function nf_get_vara_int2
!--------------------------------- nf_get_vara_int -------------------------
 Function nf_get_vara_int(ncid, varid, start, counts, ivals) RESULT(status)

! Read in default integer array from dataset for given start and count vectors 

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,        Intent(IN)  :: ncid, varid
 Integer,        Intent(IN)  :: start(*), counts(*)
 Integer(NFINT), Intent(OUT) :: ivals(*)

 Integer                     :: status

 Integer(KIND=C_INT)            :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1 ! Subtract 1 to get C varid
 cstart  = 0
 ccounts = 0

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! flip array order for C and subtract 1 from start
     cstart(1:ndims)  = start(ndims:1:-1)-1
     ccounts(1:ndims) = counts(ndims:1:-1)
   EndIf
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 EndIf

#if NF_INT_IS_C_INT
 cstatus = nc_get_vara_int(cncid, cvarid, cstartptr, ccountsptr, ivals)
#elif NF_INT_IS_C_LONG 
 cstatus = nc_get_vara_long(cncid, cvarid, cstartptr, ccountsptr, ivals)
#endif

 status = cstatus

 End Function nf_get_vara_int
!--------------------------------- nf_get_vara_real ------------------------
 Function nf_get_vara_real(ncid, varid, start, counts, rvals) RESULT(status)

! Read in real(RK4) array from dataset for given start and count vectors

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,      Intent(IN)  :: ncid, varid
 Integer,      Intent(IN)  :: start(*), counts(*)
 Real(NFREAL), Intent(OUT) :: rvals(*)

 Integer                   :: status

 Integer(KIND=C_INT)            :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1 ! Subtract 1 to get C varid
 cstart  = 0
 ccounts = 0

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! flip array order for C and subtract 1 from start
     cstart(1:ndims)  = start(ndims:1:-1)-1
     ccounts(1:ndims) = counts(ndims:1:-1)
   EndIf
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 EndIf

#if NF_REAL_IS_C_DOUBLE
 cstatus = nc_get_vara_double(cncid, cvarid, cstartptr, ccountsptr, rvals)
#else
 cstatus = nc_get_vara_float(cncid, cvarid, cstartptr, ccountsptr, rvals)
#endif

 status = cstatus

 End Function nf_get_vara_real
!--------------------------------- nf_get_vara_double ----------------------
 Function nf_get_vara_double(ncid, varid, start, counts, dvals) &
                             RESULT(status)

! Read in Real(RK8) array from dataset for given start and count vectors

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,   Intent(IN)  :: ncid, varid
 Integer,   Intent(IN)  :: start(*), counts(*)
 Real(RK8), Intent(OUT) :: dvals(*)

 Integer                :: status

 Integer(KIND=C_INT)            :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1 ! Subtract 1 to get C varid
 cstart  = 0
 ccounts = 0

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims) ! get varid dimension

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! flip array order for C and subtract 1 from start
     cstart(1:ndims)  = start(ndims:1:-1)-1
     ccounts(1:ndims) = counts(ndims:1:-1)
   EndIf
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 EndIf

 cstatus = nc_get_vara_double(cncid, cvarid, cstartptr, ccountsptr, dvals)

 status = cstatus

 End Function nf_get_vara_double
!--------------------------------- nf_get_vara ------------------------------
 Function nf_get_vara(ncid, varid, start, counts, values) RESULT(status)

! Read in an array of any type. We use a C interop character string to
! pass values. Therefore, an explicit interface to nf_put_vara should not
! be used in the calling routine. Just use external. 

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,                Intent(IN)            :: ncid, varid
 Integer,                Intent(IN)            :: start(*), counts(*)
 Character(KIND=C_CHAR), Intent(INOUT), TARGET :: values(*)
! Type(C_PTR),            VALUE                 :: values
 Integer                                       :: status

 Integer(KIND=C_INT)            :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1 ! Subtract 1 to get C varid
 cstart  = 0
 ccounts = 0

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! flip array order for C and subtract 1 from start
     cstart(1:ndims)  = start(ndims:1:-1)-1
     ccounts(1:ndims) = counts(ndims:1:-1)
   EndIf
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 EndIf

 cstatus = nc_get_vara(cncid, cvarid, cstartptr, ccountsptr, values)

 status = cstatus

 End Function nf_get_vara

function nf90_put_var_1D_EightByteInt(ncid, varid, values, start, count, stride, map)
  integer,                         intent( in) :: ncid, varid
  integer (kind = EightByteInt), dimension(:), intent( in) :: values
  integer, dimension(:), optional, intent( in) :: start, count, stride, map
  integer                                      :: nf90_put_var_1D_EightByteInt
  
  integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
  integer                               :: numDims, counter, format_num
  
  ! Set local arguments to default values
  numDims                 = size(shape(values))
  localStart (:         ) = 1
  localCount (:numDims  ) = shape(values)
  localCount (numDims+1:) = 1
  localStride(:         ) = 1
  localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
  
  if(present(start))  localStart (:size(start) )  = start(:)
  if(present(count))  localCount (:size(count) )  = count(:)
  if(present(stride)) localStride(:size(stride)) = stride(:)
  nf90_put_var_1D_EightByteInt = nf_inq_format(ncid, format_num)
  if (nf90_put_var_1D_EightByteInt .eq. nf90_noerr) then
     if (format_num .eq. nf90_format_netcdf4) then
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_put_var_1D_EightByteInt = &
                nf_put_varm_int64(ncid, varid, localStart, localCount, localStride, localMap, values)
        else if(present(stride)) then
           nf90_put_var_1D_EightByteInt = &
                nf_put_vars_int64(ncid, varid, localStart, localCount, localStride, values)
        else
           nf90_put_var_1D_EightByteInt = &
                nf_put_vara_int64(ncid, varid, localStart, localCount, values)
        end if
     else
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_put_var_1D_EightByteInt = &
                nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
        else if(present(stride)) then
           nf90_put_var_1D_EightByteInt = &
                nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
        else
           nf90_put_var_1D_EightByteInt = &
                nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
        end if
     endif
  endif
end function nf90_put_var_1D_EightByteInt

function nf90_put_var_2D_EightByteInt(ncid, varid, values, start, count, stride, map)
  integer,                         intent( in) :: ncid, varid
  integer (kind = EightByteInt), dimension(:, :), &
       intent( in) :: values
  integer, dimension(:), optional, intent( in) :: start, count, stride, map
  integer                                      :: nf90_put_var_2D_EightByteInt

  integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
  integer                               :: numDims, counter, format_num

  ! Set local arguments to default values
  numDims                 = size(shape(values))
  localStart (:         ) = 1
  localCount (:numDims  ) = shape(values)
  localCount (numDims+1:) = 1
  localStride(:         ) = 1
  localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

  if(present(start))  localStart (:size(start) )  = start(:)
  if(present(count))  localCount (:size(count) )  = count(:)
  if(present(stride)) localStride(:size(stride)) = stride(:)
  nf90_put_var_2D_EightByteInt = nf_inq_format(ncid, format_num)
  if (nf90_put_var_2D_EightByteInt .eq. nf90_noerr) then
     if (format_num .eq. nf90_format_netcdf4) then
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_put_var_2D_EightByteInt = &
                nf_put_varm_int64(ncid, varid, localStart, localCount, localStride, localMap, values)
        else if(present(stride)) then
           nf90_put_var_2D_EightByteInt = &
                nf_put_vars_int64(ncid, varid, localStart, localCount, localStride, values)
        else
           nf90_put_var_2D_EightByteInt = &
                nf_put_vara_int64(ncid, varid, localStart, localCount, values)
        end if
     else
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_put_var_2D_EightByteInt = &
                nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
        else if(present(stride)) then
           nf90_put_var_2D_EightByteInt = &
                nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
        else
           nf90_put_var_2D_EightByteInt = &
                nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
        end if
     endif
  endif

end function nf90_put_var_2D_EightByteInt


function nf90_put_var_3D_EightByteInt(ncid, varid, values, start, count, stride, map)
  integer,                         intent( in) :: ncid, varid
  integer (kind = EightByteInt), dimension(:, :, :), &
       intent( in) :: values
  integer, dimension(:), optional, intent( in) :: start, count, stride, map
  integer                                      :: nf90_put_var_3D_EightByteInt

  integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
  integer                               :: numDims, counter, format_num

  ! Set local arguments to default values
  numDims                 = size(shape(values))
  localStart (:         ) = 1
  localCount (:numDims  ) = shape(values)
  localCount (numDims+1:) = 1
  localStride(:         ) = 1
  localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

  if(present(start))  localStart (:size(start) )  = start(:)
  if(present(count))  localCount (:size(count) )  = count(:)
  if(present(stride)) localStride(:size(stride)) = stride(:)
  nf90_put_var_3D_EightByteInt = nf_inq_format(ncid, format_num)
  if (nf90_put_var_3D_EightByteInt .eq. nf90_noerr) then
     if (format_num .eq. nf90_format_netcdf4) then
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_put_var_3D_EightByteInt = &
                nf_put_varm_int64(ncid, varid, localStart, localCount, localStride, localMap, values)
        else if(present(stride)) then
           nf90_put_var_3D_EightByteInt = &
                nf_put_vars_int64(ncid, varid, localStart, localCount, localStride, values)
        else
           nf90_put_var_3D_EightByteInt = &
                nf_put_vara_int64(ncid, varid, localStart, localCount, values)
        end if
     else
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_put_var_3D_EightByteInt = &
                nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
        else if(present(stride)) then
           nf90_put_var_3D_EightByteInt = &
                nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
        else
           nf90_put_var_3D_EightByteInt = &
                nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
        end if
     endif
  endif
end function nf90_put_var_3D_EightByteInt


function nf90_put_var_4D_EightByteInt(ncid, varid, values, start, count, stride, map)
  integer,                         intent( in) :: ncid, varid
  integer (kind = EightByteInt), dimension(:, :, :, :), &
       intent( in) :: values
  integer, dimension(:), optional, intent( in) :: start, count, stride, map
  integer                                      :: nf90_put_var_4D_EightByteInt

  integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
  integer                               :: numDims, counter, format_num

  ! Set local arguments to default values
  numDims                 = size(shape(values))
  localStart (:         ) = 1
  localCount (:numDims  ) = shape(values)
  localCount (numDims+1:) = 1
  localStride(:         ) = 1
  localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

  if(present(start))  localStart (:size(start) )  = start(:)
  if(present(count))  localCount (:size(count) )  = count(:)
  if(present(stride)) localStride(:size(stride)) = stride(:)
  nf90_put_var_4D_EightByteInt = nf_inq_format(ncid, format_num)
  if (nf90_put_var_4D_EightByteInt .eq. nf90_noerr) then
     if (format_num .eq. nf90_format_netcdf4) then
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_put_var_4D_EightByteInt = &
                nf_put_varm_int64(ncid, varid, localStart, localCount, localStride, localMap, values)
        else if(present(stride)) then
           nf90_put_var_4D_EightByteInt = &
                nf_put_vars_int64(ncid, varid, localStart, localCount, localStride, values)
        else
           nf90_put_var_4D_EightByteInt = &
                nf_put_vara_int64(ncid, varid, localStart, localCount, values)
        end if
     else
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_put_var_4D_EightByteInt = &
                nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
        else if(present(stride)) then
           nf90_put_var_4D_EightByteInt = &
                nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
        else
           nf90_put_var_4D_EightByteInt = &
                nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
        end if
     end if
  end if
end function nf90_put_var_4D_EightByteInt


function nf90_put_var_5D_EightByteInt(ncid, varid, values, start, count, stride, map)
  integer,                         intent( in) :: ncid, varid
  integer (kind = EightByteInt), dimension(:, :, :, :, :), &
       intent( in) :: values
  integer, dimension(:), optional, intent( in) :: start, count, stride, map
  integer                                      :: nf90_put_var_5D_EightByteInt

  integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
  integer                               :: numDims, counter, format_num

  ! Set local arguments to default values
  numDims                 = size(shape(values))
  localStart (:         ) = 1
  localCount (:numDims  ) = shape(values)
  localCount (numDims+1:) = 1
  localStride(:         ) = 1
  localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

  if(present(start))  localStart (:size(start) )  = start(:)
  if(present(count))  localCount (:size(count) )  = count(:)
  if(present(stride)) localStride(:size(stride)) = stride(:)
  nf90_put_var_5D_EightByteInt = nf_inq_format(ncid, format_num)
  if (nf90_put_var_5D_EightByteInt .eq. nf90_noerr) then
     if (format_num .eq. nf90_format_netcdf4) then
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_put_var_5D_EightByteInt = &
                nf_put_varm_int64(ncid, varid, localStart, localCount, localStride, localMap, values)
        else if(present(stride)) then
           nf90_put_var_5D_EightByteInt = &
                nf_put_vars_int64(ncid, varid, localStart, localCount, localStride, values)
        else
           nf90_put_var_5D_EightByteInt = &
                nf_put_vara_int64(ncid, varid, localStart, localCount, values)
        end if
     else
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_put_var_5D_EightByteInt = &
                nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
        else if(present(stride)) then
           nf90_put_var_5D_EightByteInt = &
                nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
        else
           nf90_put_var_5D_EightByteInt = &
                nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
        end if
     end if
  end if
end function nf90_put_var_5D_EightByteInt


function nf90_put_var_6D_EightByteInt(ncid, varid, values, start, count, stride, map)
  integer,                         intent( in) :: ncid, varid
  integer (kind = EightByteInt), dimension(:, :, :, :, :, :), &
       intent( in) :: values
  integer, dimension(:), optional, intent( in) :: start, count, stride, map
  integer                                      :: nf90_put_var_6D_EightByteInt

  integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
  integer                               :: numDims, counter, format_num

  ! Set local arguments to default values
  numDims                 = size(shape(values))
  localStart (:         ) = 1
  localCount (:numDims  ) = shape(values)
  localCount (numDims+1:) = 1
  localStride(:         ) = 1
  localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

  if(present(start))  localStart (:size(start) )  = start(:)
  if(present(count))  localCount (:size(count) )  = count(:)
  if(present(stride)) localStride(:size(stride)) = stride(:)
  nf90_put_var_6D_EightByteInt = nf_inq_format(ncid, format_num)
  if (nf90_put_var_6D_EightByteInt .eq. nf90_noerr) then
     if (format_num .eq. nf90_format_netcdf4) then
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_put_var_6D_EightByteInt = &
                nf_put_varm_int64(ncid, varid, localStart, localCount, localStride, localMap, values)
        else if(present(stride)) then
           nf90_put_var_6D_EightByteInt = &
                nf_put_vars_int64(ncid, varid, localStart, localCount, localStride, values)
        else
           nf90_put_var_6D_EightByteInt = &
                nf_put_vara_int64(ncid, varid, localStart, localCount, values)
        end if
     else
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_put_var_6D_EightByteInt = &
                nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
        else if(present(stride)) then
           nf90_put_var_6D_EightByteInt = &
                nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
        else
           nf90_put_var_6D_EightByteInt = &
                nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
        end if
     end if
  end if
end function nf90_put_var_6D_EightByteInt


function nf90_put_var_7D_EightByteInt(ncid, varid, values, start, count, stride, map)
  integer,                         intent( in) :: ncid, varid
  integer (kind = EightByteInt), dimension(:, :, :, :, :, :, :), &
       intent( in) :: values
  integer, dimension(:), optional, intent( in) :: start, count, stride, map
  integer                                      :: nf90_put_var_7D_EightByteInt

  integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
  integer                               :: numDims, counter, format_num

  ! Set local arguments to default values
  numDims                 = size(shape(values))
  localStart (:         ) = 1
  localCount (:numDims  ) = shape(values)
  localCount (numDims+1:) = 1
  localStride(:         ) = 1
  localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

  if(present(start))  localStart (:size(start) )  = start(:)
  if(present(count))  localCount (:size(count) )  = count(:)
  if(present(stride)) localStride(:size(stride)) = stride(:)
  nf90_put_var_7D_EightByteInt = nf_inq_format(ncid, format_num)
  if (nf90_put_var_7D_EightByteInt .eq. nf90_noerr) then
     if (format_num .eq. nf90_format_netcdf4) then
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_put_var_7D_EightByteInt = &
                nf_put_varm_int64(ncid, varid, localStart, localCount, localStride, localMap, values)
        else if(present(stride)) then
           nf90_put_var_7D_EightByteInt = &
                nf_put_vars_int64(ncid, varid, localStart, localCount, localStride, values)
        else
           nf90_put_var_7D_EightByteInt = &
                nf_put_vara_int64(ncid, varid, localStart, localCount, values)
        end if
     else
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_put_var_7D_EightByteInt = &
                nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
        else if(present(stride)) then
           nf90_put_var_7D_EightByteInt = &
                nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
        else
           nf90_put_var_7D_EightByteInt = &
                nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
        end if
     end if
  end if
end function nf90_put_var_7D_EightByteInt


function nf90_get_var_1D_EightByteInt(ncid, varid, values, start, count, stride, map)
  integer,                         intent( in) :: ncid, varid
  integer (kind = EightByteInt), dimension(:), &
       intent(out) :: values
  integer, dimension(:), optional, intent( in) :: start, count, stride, map
  integer                                      :: nf90_get_var_1D_EightByteInt

  integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
  integer                               :: numDims, counter, format_num
  integer, dimension(size(values))      :: defaultIntArray
  integer (kind = EightByteInt), dimension(size(values))      :: defaultInt8Array

  ! Set local arguments to default values
  numDims                 = size(shape(values))
  localStart (:         ) = 1
  localCount (:numDims  ) = shape(values)
  localCount (numDims+1:) = 1
  localStride(:         ) = 1
  localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

  if(present(start))  localStart (:size(start) )  = start(:)
  if(present(count))  localCount (:size(count) )  = count(:)
  if(present(stride)) localStride(:size(stride)) = stride(:)
  nf90_get_var_1D_EightByteInt = nf_inq_format(ncid, format_num)
  if (nf90_get_var_1D_EightByteInt .eq. nf90_noerr) then
     if (format_num .eq. nf90_format_netcdf4) then
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_get_var_1D_EightByteInt = &
                nf_get_varm_int64(ncid, varid, localStart, localCount, localStride, localMap, defaultInt8Array)
        else if(present(stride)) then
           nf90_get_var_1D_EightByteInt = &
                nf_get_vars_int64(ncid, varid, localStart, localCount, localStride, defaultInt8Array)
        else
           nf90_get_var_1D_EightByteInt = &
                nf_get_vara_int64(ncid, varid, localStart, localCount, defaultInt8Array)
        end if
        values(:) = reshape(defaultInt8Array(:), shape(values))
     else
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_get_var_1D_EightByteInt = &
                nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
        else if(present(stride)) then
           nf90_get_var_1D_EightByteInt = &
                nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
        else
           nf90_get_var_1D_EightByteInt = &
                nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
        end if
        values(:) = reshape(defaultIntArray(:), shape(values))
     endif
  endif
end function nf90_get_var_1D_EightByteInt


function nf90_get_var_2D_EightByteInt(ncid, varid, values, start, count, stride, map)
  integer,                         intent( in) :: ncid, varid
  integer (kind = EightByteInt), dimension(:, :), &
       intent(out) :: values
  integer, dimension(:), optional, intent( in) :: start, count, stride, map
  integer                                      :: nf90_get_var_2D_EightByteInt

  integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
  integer                               :: numDims, counter, format_num
  integer, dimension(size(values))      :: defaultIntArray
  integer (kind = EightByteInt), dimension(size(values))      :: defaultInt8Array

  ! Set local arguments to default values
  numDims                 = size(shape(values))
  localStart (:         ) = 1
  localCount (:numDims  ) = shape(values)
  localCount (numDims+1:) = 1
  localStride(:         ) = 1
  localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

  if(present(start))  localStart (:size(start) )  = start(:)
  if(present(count))  localCount (:size(count) )  = count(:)
  if(present(stride)) localStride(:size(stride)) = stride(:)
  nf90_get_var_2D_EightByteInt = nf_inq_format(ncid, format_num)
  if (nf90_get_var_2D_EightByteInt .eq. nf90_noerr) then
     if (format_num .eq. nf90_format_netcdf4) then
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_get_var_2D_EightByteInt = &
                nf_get_varm_int64(ncid, varid, localStart, localCount, localStride, localMap, defaultInt8Array)
        else if(present(stride)) then
           nf90_get_var_2D_EightByteInt = &
                nf_get_vars_int64(ncid, varid, localStart, localCount, localStride, defaultInt8Array)
        else
           nf90_get_var_2D_EightByteInt = &
                nf_get_vara_int64(ncid, varid, localStart, localCount, defaultInt8Array)
        end if
        values(:, :) = reshape(defaultInt8Array(:), shape(values))
     else
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_get_var_2D_EightByteInt = &
                nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
        else if(present(stride)) then
           nf90_get_var_2D_EightByteInt = &
                nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
        else
           nf90_get_var_2D_EightByteInt = &
                nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
        end if
        values(:, :) = reshape(defaultIntArray(:), shape(values))
     end if
  end if
end function nf90_get_var_2D_EightByteInt


function nf90_get_var_3D_EightByteInt(ncid, varid, values, start, count, stride, map)
  integer,                         intent( in) :: ncid, varid
  integer (kind = EightByteInt), dimension(:, :, :), &
       intent(out) :: values
  integer, dimension(:), optional, intent( in) :: start, count, stride, map
  integer                                      :: nf90_get_var_3D_EightByteInt

  integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
  integer                               :: numDims, counter, format_num
  integer, dimension(size(values))      :: defaultIntArray
  integer (kind = EightByteInt), dimension(size(values))      :: defaultInt8Array

  ! Set local arguments to default values
  numDims                 = size(shape(values))
  localStart (:         ) = 1
  localCount (:numDims  ) = shape(values)
  localCount (numDims+1:) = 1
  localStride(:         ) = 1
  localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

  if(present(start))  localStart (:size(start) )  = start(:)
  if(present(count))  localCount (:size(count) )  = count(:)
  if(present(stride)) localStride(:size(stride)) = stride(:)
  nf90_get_var_3D_EightByteInt = nf_inq_format(ncid, format_num)
  if (nf90_get_var_3D_EightByteInt .eq. nf90_noerr) then
     if (format_num .eq. nf90_format_netcdf4) then
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_get_var_3D_EightByteInt = &
                nf_get_varm_int64(ncid, varid, localStart, localCount, localStride, localMap, defaultInt8Array)
        else if(present(stride)) then
           nf90_get_var_3D_EightByteInt = &
                nf_get_vars_int64(ncid, varid, localStart, localCount, localStride, defaultInt8Array)
        else
           nf90_get_var_3D_EightByteInt = &
                nf_get_vara_int64(ncid, varid, localStart, localCount, defaultInt8Array)
        end if
        values(:, :, :) = reshape(defaultInt8Array(:), shape(values))
     else
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_get_var_3D_EightByteInt = &
                nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
        else if(present(stride)) then
           nf90_get_var_3D_EightByteInt = &
                nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
        else
           nf90_get_var_3D_EightByteInt = &
                nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
        end if
        values(:, :, :) = reshape(defaultIntArray(:), shape(values))
     end if
  end if
end function nf90_get_var_3D_EightByteInt


function nf90_get_var_4D_EightByteInt(ncid, varid, values, start, count, stride, map)
  integer,                         intent( in) :: ncid, varid
  integer (kind = EightByteInt), dimension(:, :, :, :), &
       intent(out) :: values
  integer, dimension(:), optional, intent( in) :: start, count, stride, map
  integer                                      :: nf90_get_var_4D_EightByteInt

  integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
  integer                               :: numDims, counter, format_num
  integer, dimension(size(values))      :: defaultIntArray
  integer (kind = EightByteInt), dimension(size(values))      :: defaultInt8Array

  ! Set local arguments to default values
  numDims                 = size(shape(values))
  localStart (:         ) = 1
  localCount (:numDims  ) = shape(values)
  localCount (numDims+1:) = 1
  localStride(:         ) = 1
  localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

  if(present(start))  localStart (:size(start) )  = start(:)
  if(present(count))  localCount (:size(count) )  = count(:)
  if(present(stride)) localStride(:size(stride)) = stride(:)
  nf90_get_var_4D_EightByteInt = nf_inq_format(ncid, format_num)
  if (nf90_get_var_4D_EightByteInt .eq. nf90_noerr) then
     if (format_num .eq. nf90_format_netcdf4) then
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_get_var_4D_EightByteInt = &
                nf_get_varm_int64(ncid, varid, localStart, localCount, localStride, localMap, defaultInt8Array)
        else if(present(stride)) then
           nf90_get_var_4D_EightByteInt = &
                nf_get_vars_int64(ncid, varid, localStart, localCount, localStride, defaultInt8Array)
        else
           nf90_get_var_4D_EightByteInt = &
                nf_get_vara_int64(ncid, varid, localStart, localCount, defaultInt8Array)
        end if
        values(:, :, :, :) = reshape(defaultInt8Array(:), shape(values))
     else
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_get_var_4D_EightByteInt = &
                nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
        else if(present(stride)) then
           nf90_get_var_4D_EightByteInt = &
                nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
        else
           nf90_get_var_4D_EightByteInt = &
                nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
        end if
        values(:, :, :, :) = reshape(defaultIntArray(:), shape(values))
     end if
  end if
end function nf90_get_var_4D_EightByteInt


function nf90_get_var_5D_EightByteInt(ncid, varid, values, start, count, stride, map)
  integer,                         intent( in) :: ncid, varid
  integer (kind = EightByteInt), dimension(:, :, :, :, :), &
       intent(out) :: values
  integer, dimension(:), optional, intent( in) :: start, count, stride, map
  integer                                      :: nf90_get_var_5D_EightByteInt

  integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
  integer                               :: numDims, counter, format_num
  integer, dimension(size(values))      :: defaultIntArray
  integer (kind = EightByteInt), dimension(size(values))      :: defaultInt8Array

  ! Set local arguments to default values
  numDims                 = size(shape(values))
  localStart (:         ) = 1
  localCount (:numDims  ) = shape(values)
  localCount (numDims+1:) = 1
  localStride(:         ) = 1
  localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

  if(present(start))  localStart (:size(start) )  = start(:)
  if(present(count))  localCount (:size(count) )  = count(:)
  if(present(stride)) localStride(:size(stride)) = stride(:)
  nf90_get_var_5D_EightByteInt = nf_inq_format(ncid, format_num)
  if (nf90_get_var_5D_EightByteInt .eq. nf90_noerr) then
     if (format_num .eq. nf90_format_netcdf4) then
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_get_var_5D_EightByteInt = &
                nf_get_varm_int64(ncid, varid, localStart, localCount, localStride, localMap, defaultInt8Array)
        else if(present(stride)) then
           nf90_get_var_5D_EightByteInt = &
                nf_get_vars_int64(ncid, varid, localStart, localCount, localStride, defaultInt8Array)
        else
           nf90_get_var_5D_EightByteInt = &
                nf_get_vara_int64(ncid, varid, localStart, localCount, defaultInt8Array)
        end if
        values(:, :, :, :, :) = reshape(defaultInt8Array(:), shape(values))
     else
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_get_var_5D_EightByteInt = &
                nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
        else if(present(stride)) then
           nf90_get_var_5D_EightByteInt = &
                nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
        else
           nf90_get_var_5D_EightByteInt = &
                nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
        end if
        values(:, :, :, :, :) = reshape(defaultIntArray(:), shape(values))
     end if
  end if
end function nf90_get_var_5D_EightByteInt


function nf90_get_var_6D_EightByteInt(ncid, varid, values, start, count, stride, map)
  integer,                         intent( in) :: ncid, varid
  integer (kind = EightByteInt), dimension(:, :, :, :, :, :), &
       intent(out) :: values
  integer, dimension(:), optional, intent( in) :: start, count, stride, map
  integer                                      :: nf90_get_var_6D_EightByteInt

  integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
  integer                               :: numDims, counter, format_num
  integer, dimension(size(values))      :: defaultIntArray
  integer (kind = EightByteInt), dimension(size(values))      :: defaultInt8Array

  ! Set local arguments to default values
  numDims                 = size(shape(values))
  localStart (:         ) = 1
  localCount (:numDims  ) = shape(values)
  localCount (numDims+1:) = 1
  localStride(:         ) = 1
  localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

  if(present(start))  localStart (:size(start) )  = start(:)
  if(present(count))  localCount (:size(count) )  = count(:)
  if(present(stride)) localStride(:size(stride)) = stride(:)
  nf90_get_var_6D_EightByteInt = nf_inq_format(ncid, format_num)
  if (nf90_get_var_6D_EightByteInt .eq. nf90_noerr) then
     if (format_num .eq. nf90_format_netcdf4) then
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_get_var_6D_EightByteInt = &
                nf_get_varm_int64(ncid, varid, localStart, localCount, localStride, localMap, defaultInt8Array)
        else if(present(stride)) then
           nf90_get_var_6D_EightByteInt = &
                nf_get_vars_int64(ncid, varid, localStart, localCount, localStride, defaultInt8Array)
        else
           nf90_get_var_6D_EightByteInt = &
                nf_get_vara_int64(ncid, varid, localStart, localCount, defaultInt8Array)
        end if
        values(:, :, :, :, :, :) = reshape(defaultInt8Array(:), shape(values))
     else
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_get_var_6D_EightByteInt = &
                nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
        else if(present(stride)) then
           nf90_get_var_6D_EightByteInt = &
                nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
        else
           nf90_get_var_6D_EightByteInt = &
                nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
        end if
        values(:, :, :, :, :, :) = reshape(defaultIntArray(:), shape(values))
     end if
  end if
end function nf90_get_var_6D_EightByteInt


function nf90_get_var_7D_EightByteInt(ncid, varid, values, start, count, stride, map)
  integer,                         intent( in) :: ncid, varid
  integer (kind = EightByteInt), dimension(:, :, :, :, :, :, :), &
       intent(out) :: values
  integer, dimension(:), optional, intent( in) :: start, count, stride, map
  integer                                      :: nf90_get_var_7D_EightByteInt

  integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
  integer                               :: numDims, counter, format_num
  integer, dimension(size(values))      :: defaultIntArray
  integer (kind = EightByteInt), dimension(size(values))      :: defaultInt8Array

  ! Set local arguments to default values
  numDims                 = size(shape(values))
  localStart (:         ) = 1
  localCount (:numDims  ) = shape(values)
  localCount (numDims+1:) = 1
  localStride(:         ) = 1
  localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

  if(present(start))  localStart (:size(start) )  = start(:)
  if(present(count))  localCount (:size(count) )  = count(:)
  if(present(stride)) localStride(:size(stride)) = stride(:)
  nf90_get_var_7D_EightByteInt = nf_inq_format(ncid, format_num)
  if (nf90_get_var_7D_EightByteInt .eq. nf90_noerr) then
     if (format_num .eq. nf90_format_netcdf4) then
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_get_var_7D_EightByteInt = &
                nf_get_varm_int64(ncid, varid, localStart, localCount, localStride, localMap, defaultInt8Array)
        else if(present(stride)) then
           nf90_get_var_7D_EightByteInt = &
                nf_get_vars_int64(ncid, varid, localStart, localCount, localStride, defaultInt8Array)
        else
           nf90_get_var_7D_EightByteInt = &
                nf_get_vara_int64(ncid, varid, localStart, localCount, defaultInt8Array)
        end if
        values(:, :, :, :, :, :, :) = reshape(defaultInt8Array(:), shape(values))
     else
        if(present(map))  then
           localMap   (:size(map))    = map(:)
           nf90_get_var_7D_EightByteInt = &
                nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
        else if(present(stride)) then
           nf90_get_var_7D_EightByteInt = &
                nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
        else
           nf90_get_var_7D_EightByteInt = &
                nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
        end if
        values(:, :, :, :, :, :, :) = reshape(defaultIntArray(:), shape(values))
     end if
  end if
  
end function nf90_get_var_7D_EightByteInt


function nf90_put_var_EightByteInt(ncid, varid, values, start)
  integer,                         intent( in) :: ncid, varid
  integer (kind = EightByteInt), intent( in) :: values
  integer, dimension(:), optional, intent( in) :: start
  integer                                      :: nf90_put_var_EightByteInt

  integer, dimension(nf90_max_var_dims) :: localIndex
  integer                               :: counter, format_num

  ! Set local arguments to default values
  localIndex(:) = 1
  if(present(start)) localIndex(:size(start)) = start(:)

  nf90_put_var_EightByteInt = nf_inq_format(ncid, format_num)
  if (nf90_put_var_EightByteInt .eq. nf90_noerr) then
     if (format_num .eq. nf90_format_netcdf4) then
        nf90_put_var_EightByteInt = nf_put_var1_int64(ncid, varid, localIndex, values)
     else
        nf90_put_var_EightByteInt = nf_put_var1_int(ncid, varid, localIndex, int(values))
     endif
  endif
end function nf90_put_var_EightByteInt


function nf90_get_var_EightByteInt(ncid, varid, values, start)
  integer,                         intent( in) :: ncid, varid
  integer (kind = EightByteInt), intent(out) :: values
  integer, dimension(:), optional, intent( in) :: start
  integer                                      :: nf90_get_var_EightByteInt

  integer, dimension(nf90_max_var_dims) :: localIndex
  integer                               :: counter, format_num
  integer                               :: defaultInteger
  integer (kind = EightByteInt)         :: defaultInteger8

  ! Set local arguments to default values
  localIndex(:) = 1
  if(present(start)) localIndex(:size(start)) = start(:)

  nf90_get_var_EightByteInt = nf_inq_format(ncid, format_num)
  if (nf90_get_var_EightByteInt .eq. nf90_noerr) then
     if (format_num .eq. nf90_format_netcdf4) then
        nf90_get_var_EightByteInt = nf_get_var1_int64(ncid, varid, localIndex, defaultInteger8)
        values = defaultInteger8
     else
        nf90_get_var_EightByteInt = nf_get_var1_int(ncid, varid, localIndex, defaultInteger)
        values = defaultInteger
     endif
  endif
end function nf90_get_var_EightByteInt

!-------------------------------- nf_create_par -------------------------------
 Function nf_create_par (path, cmode, comm, info, ncid) RESULT(status)

! create parallel file

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: cmode, comm, info
 Character(LEN=*), Intent(IN)  :: path
 Integer,          Intent(OUT) :: ncid

 Integer                       :: status

 Integer(C_INT)               :: ccmode, ccomm, cinfo, cncid, cstatus
 Character(LEN=(LEN(path)+1)) :: cpath
 Integer                      :: ie

 ccmode = cmode
 ccomm  = comm
 cinfo  = info
 cncid  = 0
 cpath  = addCNullChar(path, ie) ! add a C Null char and strip trailing blanks

 cstatus = nc_create_par_fortran(cpath(1:ie), ccmode, ccomm, cinfo, cncid)

 If (cstatus == NC_NOERR) Then
    ncid = cncid
 EndIf
 status = cstatus

 End Function nf_create_par
!-------------------------------- nf_open_par --------------------------------
 Function nf_open_par (path, mode, comm, info, ncid) RESULT(status)

! open a parallel file

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: mode, comm, info
 Character(LEN=*), Intent(IN)  :: path
 Integer,          Intent(OUT) :: ncid

 Integer                       :: status

 Integer(C_INT)               :: cmode, ccomm, cinfo, cncid, cstatus
 Character(LEN=(LEN(path)+1)) :: cpath
 Integer                      :: ie

 cmode = mode
 ccomm = comm
 cinfo = info
 cncid = 0
 cpath = addCNullChar(path, ie)

 cstatus = nc_open_par_fortran(cpath(1:ie), cmode, ccomm, cinfo, cncid)

 If (cstatus == NC_NOERR) Then
   ncid = cncid
 EndIf
 status = cstatus

 End Function nf_open_par
!-------------------------------- nf_var_par_access -------------------------
 Function nf_var_par_access( ncid, varid, iaccess) RESULT (status)

! set parallel variable access

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN) :: ncid, varid, iaccess

 Integer             :: status

 Integer(C_INT) :: cncid, cvarid, caccess, cstatus

 cncid   = ncid
 cvarid  = varid - 1
 caccess = iaccess

 cstatus = nc_var_par_access(cncid, cvarid, caccess)

 status = cstatus

 End Function nf_var_par_access

  ! ----- 
  ! Variable definitions and inquiry
  ! ----- 
  function nf90_def_var_Scalar(ncid, name, xtype, varid)
    integer, intent( in) :: ncid
    character (len = *), intent( in) :: name
    integer, intent(in) :: xtype
    integer, intent(out) :: varid
    integer :: nf90_def_var_Scalar
    
    ! Dummy - shouldn't get used
    integer, dimension(1) :: dimids

    ! These may not be used with scalars, but it causes an interface
    ! violation if they are not optional arguments.
    
    nf90_def_var_Scalar = nf_def_var(ncid, name, xtype, 0, dimids, varid)
  end function nf90_def_var_Scalar
  ! ----- 
  function nf90_def_var_oneDim(ncid, name, xtype, dimids, varid, contiguous, &
       chunksizes, deflate_level, shuffle, fletcher32, endianness, &
       cache_size, cache_nelems, cache_preemption)
    integer, intent( in) :: ncid
    character (len = *), intent( in) :: name
    integer, intent(in) :: xtype
    integer, intent(in) :: dimids
    integer, intent(out) :: varid
    logical, optional, intent(in) :: contiguous
    integer, optional, intent(in) :: chunksizes
    integer, optional, intent(in) :: deflate_level
    logical, optional, intent(in) :: shuffle, fletcher32
    integer, optional, intent(in) :: endianness
    integer, optional, intent(in) :: cache_size, cache_nelems, cache_preemption
    integer :: nf90_def_var_oneDim
    
    integer, dimension(1) :: dimidsA, chunksizes1
    integer :: size1 = -1, nelems1 = -1, preemption1 = -1
    integer :: contiguous1

    ! Put this int into an array, where all decent folk keep ids.
    dimidsA(1) = dimids

    ! This is forbidden! Don't even think about it.
    if (present(contiguous)) then
       if (contiguous .and. present(chunksizes)) then
          nf90_def_var_oneDim = nf90_einval
          return
       end if
    end if
    if (present(contiguous)) then
       if (.not. contiguous .and. .not. present(chunksizes)) then
          nf90_def_var_oneDim = nf90_einval
          return
       end if
    end if
    

    ! Define the variable. 
    nf90_def_var_oneDim = nf_def_var(ncid, name, xtype, 1, dimidsA, varid)
    if (nf90_def_var_oneDim .ne. nf90_noerr) return

    ! Handle chunksizes and contiguous.
    if (present(chunksizes) .or. present(contiguous)) then
       if (present(contiguous)) then
          if (contiguous) then
             contiguous1 = nf90_contiguous
          else
             contiguous1 = nf90_notcontiguous
          endif
       endif
       if (present(chunksizes)) then
          contiguous1 = 0
          chunksizes1(1) = chunksizes
       endif
       nf90_def_var_oneDim = nf_def_var_chunking(ncid, varid, contiguous1, chunksizes1)       
    endif
    if (present(contiguous)) then
       if (contiguous) then
          chunksizes1(1) = 0
          nf90_def_var_oneDim = nf_def_var_chunking(ncid, varid, 1, chunksizes1(1:1))       
       endif
    endif
    if (nf90_def_var_oneDim .ne. nf90_noerr) return
    
    ! Handle deflate and shuffle.
    if (present(deflate_level)) then
       if (deflate_level .gt. 0) then
          if (present(shuffle)) then
             if (shuffle) then
                nf90_def_var_oneDim = nf_def_var_deflate(ncid, varid, 1, 1, deflate_level)       
             else
                nf90_def_var_oneDim = nf_def_var_deflate(ncid, varid, 0, 1, deflate_level)       
             end if
             if (nf90_def_var_oneDim .ne. nf90_noerr) return
          end if
       end if
    endif

    ! Handle fletcher32.
    if (present(fletcher32)) then
       if (fletcher32) then
          nf90_def_var_oneDim = nf_def_var_fletcher32(ncid, varid, 1)       
          if (nf90_def_var_oneDim .ne. nf90_noerr) return
       endif
    endif

    ! Handle endianness.
    if (present(endianness)) then
       nf90_def_var_oneDim = nf_def_var_endian(ncid, varid, endianness)       
       if (nf90_def_var_oneDim .ne. nf90_noerr) return
    endif

    ! Set the cache if the user wants to.
    if (present(cache_size) .or. present(cache_nelems) .or. &
         present(cache_preemption)) then
       ! Negative values mean leave it alone.
       if (present(cache_size)) size1 = cache_size
       if (present(cache_nelems)) nelems1 = cache_nelems
       if (present(cache_preemption)) preemption1 = cache_preemption
       
       nf90_def_var_oneDim = nf_set_var_chunk_cache(ncid, varid, &
            size1, nelems1, preemption1)
       if (nf90_def_var_oneDim .ne. nf90_noerr) return
    endif

  end function nf90_def_var_oneDim
  ! ----- 
  function nf90_def_var_ManyDims(ncid, name, xtype, dimids, varid, contiguous, &
       chunksizes, deflate_level, shuffle, fletcher32, endianness, cache_size, &
       cache_nelems, cache_preemption)
    integer, intent(in) :: ncid
    character (len = *), intent(in) :: name
    integer, intent( in) :: xtype
    integer, dimension(:), intent(in) :: dimids
    integer, intent(out) :: varid
    logical, optional, intent(in) :: contiguous
    integer, optional, dimension(:), intent(in) :: chunksizes
    integer, optional, intent(in) :: deflate_level
    logical, optional, intent(in) :: shuffle, fletcher32
    integer, optional, intent(in) :: endianness
    integer, optional, intent(in) :: cache_size, cache_nelems, cache_preemption
    integer :: nf90_def_var_ManyDims

    ! Local variables.
    integer :: contiguous1, d
    integer :: size1 = -1, nelems1 = -1, preemption1 = -1
    integer, dimension(nf90_max_dims) :: chunksizes1

    ! This is forbidden!
    if (present(contiguous)) then
       if (contiguous .and. present(chunksizes)) then
          nf90_def_var_ManyDims = nf90_einval
          return
       end if
    end if
    if (present(contiguous)) then
       if (.not. contiguous .and. .not. present(chunksizes)) then
          nf90_def_var_ManyDims = nf90_einval
          return
       endif
    end if

    ! Be nice and check array size.
    if (present(chunksizes)) then
       if (size(chunksizes) .ne. size(dimids)) then
          nf90_def_var_ManyDims = nf90_einval
          return
       end if
    end if
    
    ! Define the variable. 
    nf90_def_var_ManyDims = nf_def_var(ncid, name, xtype, size(dimids), dimids, varid)
    if (nf90_def_var_ManyDims .ne. nf90_noerr) return

    ! Handle chunksizes and contiguous.
    if (present(chunksizes) .or. present(contiguous)) then
       if (present(contiguous)) then
          if (contiguous) then
             contiguous1 = nf90_contiguous
          else
             contiguous1 = nf90_notcontiguous
          endif
       endif
       if (present(chunksizes)) then
          contiguous1 = 0
          do d = 1, size(dimids)
             chunksizes1(d) = chunksizes(d)
          end do
       endif
       nf90_def_var_ManyDims = nf_def_var_chunking(ncid, varid, contiguous1, chunksizes1)       
    endif
    if (present(contiguous)) then
       if (contiguous) then
          chunksizes1(1) = 0
          nf90_def_var_ManyDims = nf_def_var_chunking(ncid, varid, 1, chunksizes1(1:1))       
       endif
    endif
    if (nf90_def_var_ManyDims .ne. nf90_noerr) return
    
    ! Handle deflate and shuffle.
    if (present(deflate_level)) then
       if (deflate_level .gt. 0) then
          if (present(shuffle)) then
             if (shuffle) then
                nf90_def_var_ManyDims = nf_def_var_deflate(ncid, varid, 1, 1, deflate_level)       
             else
                nf90_def_var_ManyDims = nf_def_var_deflate(ncid, varid, 0, 1, deflate_level)       
             end if
          else
             nf90_def_var_ManyDims = nf_def_var_deflate(ncid, varid, 0, 1, deflate_level)       
          end if
       end if
    endif
    if (nf90_def_var_ManyDims .ne. nf90_noerr) return

    ! Handle fletcher32.
    if (present(fletcher32)) then
       if (fletcher32) then
          nf90_def_var_ManyDims = nf_def_var_fletcher32(ncid, varid, 1)       
       endif
    endif
    if (nf90_def_var_ManyDims .ne. nf90_noerr) return

    ! Handle endianness.
    if (present(endianness)) then
       nf90_def_var_ManyDims = nf_def_var_endian(ncid, varid, endianness)       
    endif

    ! Set the cache if the user wants to.
    if (present(cache_size) .or. present(cache_nelems) .or. &
         present(cache_preemption)) then
       ! Negative values mean leave it alone.
       if (present(cache_size)) size1 = cache_size
       if (present(cache_nelems)) nelems1 = cache_nelems
       if (present(cache_preemption)) preemption1 = cache_preemption
       
       nf90_def_var_ManyDims = nf_set_var_chunk_cache(ncid, varid, &
            size1, nelems1, preemption1)
       if (nf90_def_var_ManyDims .ne. nf90_noerr) return
    endif

  end function nf90_def_var_ManyDims
  ! ----- 
  function nf90_inq_varid(ncid, name, varid)
    integer, intent(in) :: ncid
    character (len = *), intent( in) :: name
    integer, intent(out) :: varid
    integer :: nf90_inq_varid
    
    nf90_inq_varid = nf_inq_varid(ncid, name, varid)
    if (nf90_inq_varid .ne. nf90_noerr) return

  end function nf90_inq_varid
  ! ----- 
  function nf90_set_var_chunk_cache(ncid, varid, size, nelems, preemption)
    integer, intent(in) :: ncid, varid, size, nelems, preemption
    integer :: nf90_set_var_chunk_cache
    
    nf90_set_var_chunk_cache = nf_set_var_chunk_cache(ncid, varid, &
         size, nelems, preemption)
    if (nf90_set_var_chunk_cache .ne. nf90_noerr) return

  end function nf90_set_var_chunk_cache
  ! ----- 
  function nf90_inquire_variable(ncid, varid, name, xtype, ndims, dimids, nAtts, &
       contiguous, chunksizes, deflate_level, shuffle, fletcher32, endianness, &
       cache_size, cache_nelems, cache_preemption)
    integer, intent(in) :: ncid, varid
    character (len = *), optional, intent(out) :: name
    integer, optional, intent(out) :: xtype, ndims 
    integer, dimension(:), optional, intent(out) :: dimids
    integer, optional, intent(out) :: nAtts
    logical, optional, intent(out) :: contiguous
    integer, optional, dimension(:), intent(out) :: chunksizes
    integer, optional, intent(out) :: deflate_level
    logical, optional, intent(out) :: shuffle, fletcher32
    integer, optional, intent(out) :: endianness
    integer, optional, intent(out) :: cache_size, cache_nelems, cache_preemption
    integer :: nf90_inquire_variable
    
    ! Local variables
    character (len = nf90_max_name) :: varName = ''
    integer :: externalType, numDimensions
    integer, dimension(nf90_max_var_dims) :: dimensionIDs
    integer :: numAttributes
    integer :: deflate1, deflate_level1, contiguous1, shuffle1, fletcher321
    integer, dimension(nf90_max_dims) :: chunksizes1
    integer :: size1, nelems1, preemption1
    integer :: d

    ! Learn the basic facts.
    nf90_inquire_variable = nf_inq_var(ncid, varid, varName, externalType, &
                                       numDimensions, dimensionIDs, numAttributes)
    if (nf90_inquire_variable .ne. nf90_noerr) return
    
    ! Tell the user what he wants to know.
    if (present(name)) name = trim(varName)
    if (present(xtype)) xtype = externalType
    if (present(ndims)) ndims = numDimensions
    if (present(dimids)) then
       if (size(dimids) .ge. numDimensions) then
          dimids(:numDimensions) = dimensionIDs(:numDimensions)
       else
          nf90_inquire_variable = nf90_einval
       endif
    endif
    if (present(nAtts)) nAtts = numAttributes

    ! Get the chunksizes and contiguous settings, if desired.
    if (present(chunksizes) .or. present(contiguous)) then
       nf90_inquire_variable = nf_inq_var_chunking(ncid, varid, contiguous1, chunksizes1)
       if (nf90_inquire_variable .ne. nf90_noerr) return
       if (present(contiguous)) contiguous = contiguous1 .ne. nf90_notcontiguous
       if (present(chunksizes)) then
          do d = 1, numDimensions
             chunksizes(d) = chunksizes1(d)
          end do
       endif
    endif

    ! Get the fletcher32 settings, if desired.
    if (present(fletcher32)) then
       nf90_inquire_variable = nf_inq_var_fletcher32(ncid, varid, fletcher321)
       if (nf90_inquire_variable .ne. nf90_noerr) return
       fletcher32 = fletcher321 .gt. 0
    endif
    
    ! Get the deflate and shuffle settings, if desired.
    if (present(deflate_level) .or. present(shuffle)) then
       nf90_inquire_variable = nf_inq_var_deflate(ncid, varid, shuffle1, deflate1, deflate_level1)
       if (nf90_inquire_variable .ne. nf90_noerr) return
       if (present(deflate_level)) deflate_level = deflate_level1
       if (present(shuffle)) shuffle = shuffle1 .ne. 0
    endif

    ! And the endianness...
    if (present(endianness)) then
       nf90_inquire_variable = nf_inq_var_endian(ncid, varid, endianness)
       if (nf90_inquire_variable .ne. nf90_noerr) return
    endif

    ! Does the user want cache settings?
    if (present(cache_size) .or. present(cache_nelems) .or. present(cache_preemption)) then
       nf90_inquire_variable = nf_get_var_chunk_cache(ncid, varid, &
            size1, nelems1, preemption1)
       if (nf90_inquire_variable .ne. nf90_noerr) return
       if (present(cache_size)) cache_size = size1
       if (present(cache_nelems)) cache_nelems = nelems1
       if (present(cache_preemption)) cache_preemption = preemption1
    endif
  end function nf90_inquire_variable
  ! ----- 
  function nf90_rename_var(ncid, varid, newname)
    integer,             intent( in) :: ncid, varid
    character (len = *), intent( in) :: newname
    integer                          :: nf90_rename_var
    
    nf90_rename_var = nf_rename_var(ncid, varid, newname)
  end function nf90_rename_var
  ! ----- 

!                netCDF 4 specific FORTRAN functions

! Replacement for fort-nc4.c

! Written by: Richard Weed, Ph.D.
!             Center for Advanced Vehicular Systems  
!             Mississippi State University 
!             rweed@cavs.msstate.edu


! License (and other Lawyer Language)
 
! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Corporation for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1.- June  2006 - Based on netCDF 3.6.2 beta code and 4.0 alpha code
! Version 2.- July  2007 - Based on netCDF 3.6.2 snapshot and 4.0 beta code
! Version 3.- April 2009 - Based on NetCDF 4.0.1 release
! Version 4.- April 2010 - Based on NetCDF 4.1.1 release
! Version 5.- Aug.  2013 - Added nf_rename_grp to align with netCDF-C 4.3.1
! Version 6.- Sep.  2013 - Changed fill routines to support different types
! Version 7.- May   2014 - Ensure return error status checked from C API calls          
 
!-------------------------------- nf_create_par -------------------------------
 Function nf_create_par (path, cmode, comm, info, ncid) RESULT(status)

! create parallel file

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: cmode, comm, info
 Character(LEN=*), Intent(IN)  :: path
 Integer,          Intent(OUT) :: ncid

 Integer                       :: status

 Integer(KIND=C_INT)          :: ccmode, ccomm, cinfo, cncid, cstatus
 Character(LEN=(LEN(path)+1)) :: cpath
 Integer                      :: ie

 ccmode = cmode
 ccomm  = comm
 cinfo  = info
 cncid  = 0
 cpath  = addCNullChar(path, ie) ! add a C Null char and strip trailing blanks

 cstatus = nc_create_par_fortran(cpath(1:ie+1), ccmode, ccomm, cinfo, cncid)

 If (cstatus == NC_NOERR) Then
    ncid = cncid
 EndIf
 status = cstatus

 End Function nf_create_par
!-------------------------------- nf_open_par --------------------------------
 Function nf_open_par (path, mode, comm, info, ncid) RESULT(status)

! open a parallel file

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: mode, comm, info
 Character(LEN=*), Intent(IN)  :: path
 Integer,          Intent(OUT) :: ncid

 Integer                       :: status

 Integer(KIND=C_INT)          :: cmode, ccomm, cinfo, cncid, cstatus
 Character(LEN=(LEN(path)+1)) :: cpath
 Integer                      :: ie

 cmode = mode
 ccomm = comm
 cinfo = info
 cncid = 0
 cpath = addCNullChar(path, ie)

 cstatus = nc_open_par_fortran(cpath(1:ie+1), cmode, ccomm, cinfo, cncid)

 If (cstatus == NC_NOERR) Then
   ncid = cncid
 EndIf
 status = cstatus

 End Function nf_open_par
!-------------------------------- nf_var_par_access -------------------------
 Function nf_var_par_access( ncid, varid, iaccess) RESULT (status)

! set variable access

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN) :: ncid, varid, iaccess

 Integer             :: status

 Integer(KIND=C_INT) :: cncid, cvarid, caccess, cstatus

 cncid   = ncid
 cvarid  = varid - 1
 caccess = iaccess

 cstatus = nc_var_par_access(cncid, cvarid, caccess)

 status = cstatus

 End Function nf_var_par_access
!-------------------------------- nf_inq_ncid ---------------------------------
 Function nf_inq_ncid(ncid, name, groupid) RESULT (status)

! inquire ncid  

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: groupid

 Integer                       :: status

 Integer(KIND=C_INT)        :: cncid, cgroupid, cstatus
 Character(LEN=LEN(name)+1) :: cname
 Integer                    :: ie

 cncid    = ncid
 cgroupid = 0
 cname    = REPEAT(" ",LEN(cname))
 cname    = addCNullChar(name, ie)

 cstatus = nc_inq_ncid(cncid, cname(1:ie+1), cgroupid)

 If (cstatus == NC_NOERR) Then
    groupid = cgroupid
 EndIf
 status  = cstatus

 End Function nf_inq_ncid
!-------------------------------- nf_inq_grps ---------------------------------
 Function nf_inq_grps( ncid, numgrps, ncids) RESULT (status)

! inquire number of grps and ncids

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)    :: ncid
 Integer, Intent(INOUT) :: ncids(*)
 Integer, Intent(OUT)   :: numgrps
 Integer                :: status

 Integer(KIND=C_INT)    :: cncid, cnumgrps, cstatus
 Integer(KIND=C_INT)    :: cncids(NC_MAX_DIMS)

 cncid    = ncid
 cnumgrps = 0
 ncids(1) = 0
 
 cstatus = nc_inq_grps(cncid, cnumgrps, cncids)

 If (cstatus == NC_NOERR) Then
    numgrps = cnumgrps
    ncids(1:numgrps) = cncids(1:numgrps)
 EndIf
 status  = cstatus

 End Function nf_inq_grps
!-------------------------------- nf_inq_grpname ------------------------------
 Function nf_inq_grpname( ncid, name) RESULT (status)

! inquire group name 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid
 Character(LEN=*), Intent(OUT) :: name

 Integer                       :: status

 Integer(KIND=C_INT)        :: cncid, cstatus
 Character(LEN=NC_MAX_NAME) :: cname
 Integer                    :: nlen

 cncid = ncid
 nlen  = LEN(name)
 name  = REPEAT(" ",LEN(name))
 cname = REPEAT(" ",LEN(cname))
 
 cstatus = nc_inq_grpname(cncid, cname)

 If (cstatus == NC_NOERR) Then
    name = stripCNullChar(cname,nlen) ! Strip null char and trailing blanks 
 EndIf
 status = cstatus

 End Function nf_inq_grpname
!-------------------------------- nf_inq_grpname_full -------------------------
 Function nf_inq_grpname_full( ncid, nlen, name) RESULT (status)

! inquire full group name and length 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid
 Character(LEN=*), Intent(OUT) :: name
 Integer,          Intent(OUT) :: nlen

 Integer                       :: status

 Integer(KIND=C_INT)        :: cncid, cstatus
 Integer(KIND=C_SIZE_T)     :: clen
 Character(LEN=LEN(name)+1) :: cname
 Integer                    :: nl

 cncid  = ncid
 nl     = LEN(name)
 name   = REPEAT(" ",LEN(name))
 cname  = REPEAT(" ",LEN(cname))
 
 cstatus = nc_inq_grpname_full(cncid, clen, cname)

 If (cstatus == NC_NOERR) Then
    nlen = clen  
    name = stripCNullChar(cname, nl)
 EndIf
 status = cstatus

 End Function nf_inq_grpname_full
!-------------------------------- nf_inq_grpname_len --------------------------
 Function nf_inq_grpname_len( ncid, nlen) RESULT (status)

! inquire length of full group name

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid
 Integer, Intent(OUT) :: nlen

 Integer              :: status

 Integer(KIND=C_INT)    :: cncid, cstatus
 Integer(KIND=C_SIZE_T) :: clen

 cncid  = ncid
 
 cstatus = nc_inq_grpname_len(cncid, clen)

 If (cstatus == NC_NOERR) Then
    ! Return name length 
     nlen = clen
 EndIf
 status = cstatus

 End Function nf_inq_grpname_len
!-------------------------------- nf_inq_grp_parent ---------------------------
 Function nf_inq_grp_parent( ncid,parent_ncid) RESULT (status)

! inquire group parent number

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)    :: ncid
 Integer, Intent(INOUT) :: parent_ncid

 Integer                :: status

 Integer(KIND=C_INT) :: cncid, cparent_ncid, cstatus

 cncid  = ncid

 cstatus = nc_inq_grp_parent(cncid, cparent_ncid)

 If (cstatus == NC_NOERR) Then
    parent_ncid = cparent_ncid
 EndIf
 status  = cstatus

 End Function nf_inq_grp_parent
!-------------------------------- nf_inq_grp_ncid -----------------------------
 Function nf_inq_grp_ncid( ncid, grp_name, parent_ncid) RESULT (status)

! inquire parent_ncid given group name 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)    :: ncid
 Character(LEN=*), Intent(IN)    :: grp_name
 Integer,          Intent(INOUT) :: parent_ncid

 Integer                         :: status

 Integer(KIND=C_INT)              :: cncid, cstatus, cparent_ncid
 Character(LEN=(LEN(grp_name)+1)) :: cgrp_name
 Integer                          :: ie

 cgrp_name = REPEAT(" ",LEN(cgrp_name))
 cgrp_name = addCNullChar(grp_name, ie)
 cncid     = ncid

 cstatus = nc_inq_grp_ncid(cncid, cgrp_name(1:ie+1), cparent_ncid)

 If (cstatus == NC_NOERR) Then
    parent_ncid = cparent_ncid
 EndIf
 status  = cstatus

 End Function nf_inq_grp_ncid
!-------------------------------- nf_inq_grp_full_ncid ------------------------
 Function nf_inq_grp_full_ncid( ncid, name, grp_ncid) RESULT (status)

! inquire grp ncid given full group name 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)    :: ncid
 Character(LEN=*), Intent(INOUT) :: name
 Integer,          Intent(INOUT) :: grp_ncid

 Integer                         :: status

 Integer(KIND=C_INT)          :: cncid, cstatus, cgrp_ncid
 Character(LEN=(LEN(name)+1)) :: cgrp_name
 Integer                      :: ie

! Test for C Null character in path and strip trailing blanks

 cncid     = ncid
 cgrp_name = REPEAT(" ",LEN(cgrp_name))
 cgrp_name = addCNullChar(name, ie)

 cstatus = nc_inq_grp_full_ncid(cncid, cgrp_name(1:ie+1), cgrp_ncid)

 If (cstatus == NC_NOERR) Then
    grp_ncid = cgrp_ncid
 EndIf
 status  = cstatus

 End Function nf_inq_grp_full_ncid
!-------------------------------- nf_inq_varids -------------------------------
 Function nf_inq_varids( ncid, nvars, varids) RESULT (status)

! inquire number of vars and varids 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)    :: ncid
 Integer, Intent(OUT)   :: nvars 
 Integer, Intent(INOUT) :: varids(*)

 Integer                :: status

 Integer(KIND=C_INT) :: cncid, cnvars, cstatus
 
 cncid     = ncid
 varids(1) = 0
 
 cstatus = nc_inq_varids_f(cncid, cnvars, varids)

 If (cstatus == NC_NOERR) Then
    nvars  = cnvars 
 EndIf
 status = cstatus

 End Function nf_inq_varids
!-------------------------------- nf_inq_dimids -------------------------------
 Function nf_inq_dimids( ncid, ndims, dimids, parent) RESULT (status)

! inquire number of dimids 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)    :: ncid, parent
 Integer, Intent(OUT)   :: ndims
 Integer, Intent(INOUT) :: dimids(*)

 Integer                :: status

 Integer(KIND=C_INT) :: cncid, cndims, cparent, cstatus

 cncid     = ncid
 dimids(1) = 0
 
 cstatus = nc_inq_dimids_f(cncid, cndims, dimids, cparent)

 If (cstatus == NC_NOERR) Then
    ndims  = cndims
 EndIf
 status = cstatus

 End Function nf_inq_dimids
!-------------------------------- nf_inq_typeids ------------------------------
 Function nf_inq_typeids( ncid, ntypes, typeids) RESULT (status)

! inquire number of types and typeids 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)    :: ncid
 Integer, Intent(OUT)   :: ntypes
 Integer, Intent(INOUT) :: typeids(*)

 Integer                :: status

 Integer(KIND=C_INT) :: cncid, cntypes, cstatus
 Integer(KIND=C_INT) :: ctypeids(NC_MAX_DIMS)

 cncid      = ncid
 ctypeids   = 0
 typeids(1) = 0
 
 cstatus = nc_inq_typeids(cncid, cntypes, ctypeids)

 If (cstatus == NC_NOERR) Then
    ntypes            = cntypes
    typeids(1:ntypes) = ctypeids(1:ntypes)
 EndIf
 status  = cstatus

 End Function nf_inq_typeids
!-------------------------------- nf_inq_typeid -------------------------------
 Function nf_inq_typeid(ncid, name, typeid) RESULT (status)

! inquire typeid for name 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: typeid

 Integer                       :: status

 Integer(KIND=C_INT)        :: cncid, ctypeid, cstatus
 Character(LEN=LEN(name)+1) :: cname
 Integer                    :: ie

 cncid    = ncid
 ctypeid  = 0
 cname    = REPEAT(" ",LEN(cname))
 cname    = addCNullChar(name, ie)

 cstatus = nc_inq_typeid(cncid, cname(1:ie+1), ctypeid)

 If (cstatus == NC_NOERR) Then
    typeid = ctypeid
 EndIf
 status = cstatus

 End Function nf_inq_typeid
!-------------------------------- nf_def_grp ---------------------------------
 Function nf_def_grp( parent_ncid, name, new_ncid) RESULT (status)

! define new group given name 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: parent_ncid
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: new_ncid

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, cnew_ncid, cstatus
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid = parent_ncid
 cname = REPEAT(" ",LEN(cname))
 cname = addCNullChar(name, ie)

 cstatus = nc_def_grp(cncid, cname(1:ie+1), cnew_ncid)

 If (cstatus == NC_NOERR) Then
    new_ncid = cnew_ncid 
 EndIf
 status   = cstatus

 End Function nf_def_grp
!-------------------------------- nf_rename_grp -------------------------------
 Function nf_rename_grp( grpid, name) RESULT (status)

! rename previously defined group

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: grpid
 Character(LEN=*), Intent(IN)  :: name

 Integer                       :: status

 Integer(KIND=C_INT)          :: cgrpid, cstatus
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cgrpid = grpid
 cname  = REPEAT(" ",LEN(cname))
 cname  = addCNullChar(name, ie)

 cstatus = nc_rename_grp(cgrpid, cname(1:ie+1))

 status   = cstatus

 End Function nf_rename_grp
!-------------------------------- nf_def_compound -----------------------------
 Function nf_def_compound( ncid, isize, name, typeid) RESULT (status)

! define new group given name 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, isize
 Integer,          Intent(OUT) :: typeid 
 Character(LEN=*), Intent(IN)  :: name

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, ctypeid, cstatus
 Integer(KIND=C_SIZE_T)       :: csize
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid = ncid
 csize = isize
 cname = REPEAT(" ",LEN(cname))
 cname = addCNullChar(name, ie)

 cstatus = nc_def_compound(cncid, csize, cname(1:ie+1), ctypeid)

 If (cstatus == NC_NOERR) Then
    typeid = ctypeid
 EndIf
 status = cstatus

 End Function nf_def_compound
!-------------------------------- nf_insert_compound --------------------------
 Function nf_insert_compound( ncid, xtype, name, offset, field_typeid) &
                              RESULT (status)

! define new group given name 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN) :: ncid, xtype, field_typeid, offset 
 Character(LEN=*), Intent(IN) :: name

 Integer                      :: status

 Integer(KIND=C_INT)          :: cncid, cxtype, ctypeid, cstatus
 Integer(KIND=C_SIZE_T)       :: coffset
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid   = ncid
 cxtype  = xtype
 ctypeid = field_typeid
 coffset = offset
 cname   = REPEAT(" ",LEN(cname))
 cname   = addCNullChar(name, ie)

 cstatus = nc_insert_compound(cncid, cxtype, cname(1:ie+1), &
                              coffset, ctypeid)

 status = cstatus

 End Function nf_insert_compound
!-------------------------------- nf_insert_array_compound --------------------
 Function nf_insert_array_compound( ncid, xtype, name, offset, field_typeid, &
                                    ndims, dim_sizes) RESULT (status)

! define new group given name 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)    :: ncid, xtype, field_typeid, offset, ndims
 Character(LEN=*), Intent(IN)    :: name
 Integer,          Intent(INOUT) :: dim_sizes(*)

 Integer                         :: status

 Integer(KIND=C_INT)          :: cncid, cxtype, ctypeid, cndims, cstatus
 Integer(KIND=C_SIZE_T)       :: coffset
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid   = ncid
 cxtype  = xtype
 ctypeid = field_typeid
 coffset = offset
 cndims  = ndims
 cname   = REPEAT(" ",LEN(cname))
 cname   = addCNullChar(name, ie)

 cstatus = nc_insert_array_compound_f(cncid, cxtype, cname(1:ie+1), &
                                      coffset, ctypeid, cndims, dim_sizes)

 status = cstatus

 End Function nf_insert_array_compound
!-------------------------------- nf_inq_type ---------------------------------
 Function nf_inq_type( ncid, xtype, name, isize) RESULT (status)

! define new group given name 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, xtype
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: isize

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, cxtype, cstatus
 Integer(KIND=C_SIZE_T)       :: csize
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 cxtype = xtype
 cname  = REPEAT(" ",LEN(cname))
 cname  = addCNullChar(name, ie)

 cstatus = nc_inq_type(cncid, cxtype, cname(1:ie+1), csize)

 If (cstatus == NC_NOERR) Then
    isize  = csize
 EndIf
 status = cstatus

 End Function nf_inq_type
!-------------------------------- nf_inq_compound -----------------------------
 Function nf_inq_compound( ncid, xtype, name, isize, nfields) RESULT (status)

! return size and nfield for compound given ncid, xtype, and name

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)    :: ncid, xtype
 Character(LEN=*), Intent(INOUT) :: name
 Integer,          Intent(INOUT) :: isize, nfields

 Integer                         :: status

 Integer(KIND=C_INT)          :: cncid, cxtype, cstatus
 Integer(KIND=C_SIZE_T)       :: csize, cnfieldsp
 Character(LEN=NC_MAX_NAME+1) :: cname
 Integer                      :: nlen

 cncid  = ncid
 cxtype = xtype
 nlen   = LEN(name)
 name   = REPEAT(" ", nlen)
 cname  = REPEAT(" ", LEN(cname))

 cstatus = nc_inq_compound(cncid, cxtype, cname, csize, cnfieldsp)

 If (cstatus == NC_NOERR) Then
    ! Test for C Null character in path and strip trailing blanks
    name       = stripCNullChar(cname, nlen)
    isize      = csize
    nfields    = cnfieldsp
 EndIf
 status  = cstatus

 End Function nf_inq_compound
!-------------------------------- nf_inq_compound_name ------------------------
 Function nf_inq_compound_name( ncid, xtype, name) RESULT (status)

! inquire compound name 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, xtype
 Character(LEN=*), Intent(OUT) :: name

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, cxtype, cstatus
 Character(LEN=NC_MAX_NAME+1) :: cname
 Integer                      :: nlen

 cncid  = ncid
 cxtype = xtype
 nlen   = LEN(name)
 name   = REPEAT(" ",LEN(name))
 cname  = REPEAT(" ",LEN(cname))
 
 cstatus = nc_inq_compound_name(cncid, cxtype, cname)

 If (cstatus == NC_NOERR) Then
     name = stripCNullChar(cname, nlen)
 EndIf
 status = cstatus

 End Function nf_inq_compound_name
!-------------------------------- nf_inq_compound_size -------------------------
 Function nf_inq_compound_size( ncid, xtype, isize) RESULT (status)

! return size compound given ncid, xtype

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)    :: ncid, xtype
 Integer, Intent(INOUT) :: isize

 Integer                :: status

 Integer(KIND=C_INT)    :: cncid, cxtype, cstatus
 Integer(KIND=C_SIZE_T) :: csize

 cncid  = ncid
 cxtype = xtype

 cstatus = nc_inq_compound_size(cncid, cxtype, csize)

 If (cstatus == NC_NOERR) Then
    isize  = csize
 EndIf
 status = cstatus

 End Function nf_inq_compound_size
!-------------------------------- nf_inq_compound_nfields ----------------------
 Function nf_inq_compound_nfields( ncid, xtype, nfields) RESULT (status)

! return size compound given ncid, xtype

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)    :: ncid, xtype
 Integer, Intent(INOUT) :: nfields 

 Integer                :: status

 Integer(KIND=C_INT)    :: cncid, cxtype, cstatus
 Integer(KIND=C_SIZE_T) :: cnfields

 cncid  = ncid
 cxtype = xtype

 cstatus = nc_inq_compound_nfields(cncid, cxtype, cnfields)

 If (cstatus == NC_NOERR) Then
    nfields = cnfields
 EndIf
 status  = cstatus

 End Function nf_inq_compound_nfields
!-------------------------------- nf_inq_compound_field -----------------------
 Function nf_inq_compound_field( ncid, xtype, fieldid, name, offset, &
                                field_typeid, ndims, dim_sizes) RESULT (status)

! inquire compound name 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, xtype, fieldid
 Character(LEN=*), Intent(OUT) :: name
 Integer,          Intent(OUT) :: offset, field_typeid, ndims
 Integer,          Intent(OUT) :: dim_sizes(*)

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, cxtype, cfieldid, cfield_typeid, &
                                 cndims, cstatus
 Integer(KIND=C_INT)          :: cdim_sizes(NC_MAX_DIMS)
 Integer(KIND=C_SIZE_T)       :: coffset
 Character(LEN=NC_MAX_NAME+1) :: cname
 Integer                      :: nlen

 cncid    = ncid
 cxtype   = xtype
 cfieldid = fieldid-1
 nlen     = LEN(name)
 name     = REPEAT(" ",LEN(name))
 cname    = REPEAT(" ",LEN(cname))
 
 cstatus = nc_inq_compound_field_f(cncid, cxtype, cfieldid, cname, coffset, &
                                   cfield_typeid, cndims, cdim_sizes)

 If (cstatus == NC_NOERR) Then
    name               = stripCNullChar(cname, nlen)
    offset             = coffset
    field_typeid       = cfield_typeid
    ndims              = cndims
    dim_sizes(1:ndims) = cdim_sizes(1:ndims)
 EndIf
 status = cstatus

 End Function nf_inq_compound_field
!-------------------------------- nf_inq_compound_fieldname -------------------
 Function nf_inq_compound_fieldname(ncid, xtype, fieldid, name) RESULT(status)

! inquire compound field name 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, xtype, fieldid
 Character(LEN=*), Intent(OUT) :: name

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, cxtype, cfieldid, cstatus
 Character(LEN=NC_MAX_NAME+1) :: cname
 Integer                      :: nlen

 cncid    = ncid
 cxtype   = xtype
 cfieldid = fieldid - 1
 nlen     = LEN(name)
 name     = REPEAT(" ",LEN(name))
 cname    = REPEAT(" ",LEN(cname))
 
 cstatus = nc_inq_compound_fieldname(cncid, cxtype, cfieldid, cname)

 If (cstatus == NC_NOERR) Then
    name = stripCNullChar(cname, nlen)
 EndIf
 status = cstatus

 End Function nf_inq_compound_fieldname
!-------------------------------- nf_inq_compound_fieldindex ------------------
 Function nf_inq_compound_fieldindex( ncid, xtype, name, fieldid) RESULT (status)

! define new group given name 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, xtype
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: fieldid

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, cxtype, cfieldid, cstatus
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 cxtype = xtype
 cname  = REPEAT(" ",LEN(cname))
 cname  = addCNullChar(name, ie)

 cstatus = nc_inq_compound_fieldindex(cncid, cxtype, cname(1:ie+1), cfieldid)

 If (cstatus == NC_NOERR) Then
    fieldid = cfieldid + 1
 EndIf
 status  = cstatus

 End Function nf_inq_compound_fieldindex
!-------------------------------- nf_inq_compound_fieldoffset ----------------
 Function nf_inq_compound_fieldoffset( ncid, xtype, fieldid, offset)&
                                       RESULT (status)

! inquire compound field offset 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid, xtype, fieldid
 Integer, Intent(OUT) :: offset

 Integer              :: status

 Integer(KIND=C_INT)    :: cncid, cxtype, cfieldid, cstatus
 Integer(KIND=C_SIZE_T) :: coffset

 cncid    = ncid
 cxtype   = xtype
 cfieldid = fieldid - 1

 cstatus = nc_inq_compound_fieldoffset(cncid, cxtype, cfieldid, coffset)

 If (cstatus == NC_NOERR) Then
    offset = coffset
 EndIf
 status = cstatus

 End Function nf_inq_compound_fieldoffset
!-------------------------------- nf_inq_compound_fieldtype -------------------
 Function nf_inq_compound_fieldtype( ncid, xtype, fieldid, field_typeid) &
                                    RESULT (status)

! define new group given name 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid, xtype, fieldid
 Integer, Intent(OUT) :: field_typeid

 Integer              :: status

 Integer(KIND=C_INT) :: cncid, cxtype, cfieldid, cfield_typeid, cstatus

 cncid    = ncid
 cxtype   = xtype
 cfieldid = fieldid -1 

 cstatus = nc_inq_compound_fieldtype(cncid, cxtype, cfieldid, cfield_typeid)

 If (cstatus == NC_NOERR) Then
    field_typeid = cfield_typeid
 EndIf
 status  = cstatus

 End Function nf_inq_compound_fieldtype
!-------------------------------- nf_inq_compound_fieldndims ------------------
 Function nf_inq_compound_fieldndims( ncid, xtype, fieldid, ndims) RESULT (status)

! define new group given name 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid, xtype, fieldid
 Integer, Intent(OUT) :: ndims

 Integer              :: status

 Integer(KIND=C_INT) :: cncid, cxtype, cfieldid, cndims, cstatus

 cncid    = ncid
 cxtype   = xtype
 cfieldid = fieldid -1

 cstatus = nc_inq_compound_fieldndims(cncid, cxtype, cfieldid, cndims)

 If (cstatus == NC_NOERR) Then
    ndims = cndims 
 EndIf
 status = cstatus

 End Function nf_inq_compound_fieldndims
!-------------------------------- nf_inq_compound_fielddim_sizes --------------
 Function nf_inq_compound_fielddim_sizes( ncid, xtype, fieldid, dim_sizes) &
                                          RESULT (status)

! inq compound field dimension sizes 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)    :: ncid, xtype, fieldid
 Integer, Intent(INOUT) :: dim_sizes(*)

 Integer                :: status

 Integer(KIND=C_INT) :: cncid, cxtype, cfieldid, cstatus 

 cncid    = ncid
 cxtype   = xtype
 cfieldid = fieldid - 1 

 cstatus = nc_inq_compound_fielddim_sizes(cncid, cxtype, cfieldid, dim_sizes)

 status = cstatus

 End Function nf_inq_compound_fielddim_sizes
!-------------------------------- nf_def_vlen ---------------------------------
 Function nf_def_vlen( ncid, name, base_typeid, xtype) RESULT (status)

! define variable length data 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, base_typeid 
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: xtype

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, cxtype, cbase_typeid, cstatus
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid        = ncid
 cxtype       = xtype
 cbase_typeid = base_typeid
 cname        = REPEAT(" ",LEN(cname))
 cname        = addCNullChar(name, ie)

 cstatus = nc_def_vlen(cncid, cname(1:ie+1), cbase_typeid, cxtype)

 If (cstatus == NC_NOERR) Then
    xtype  = cxtype
 EndIf
 status = cstatus

 End Function nf_def_vlen
!-------------------------------- nf_inq_vlen ---------------------------------
 Function nf_inq_vlen( ncid, xtype, name, datum_size, base_type) RESULT(status) 

! inquire variable length array info 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, xtype
 Character(LEN=*), Intent(OUT) :: name
 Integer,          Intent(OUT) :: datum_size, base_type

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, cxtype, cbase_type, cstatus
 Integer(KIND=C_SIZE_T)       :: cdatum_size
 Character(LEN=NC_MAX_NAME+1) :: cname
 Integer                      :: nlen

 cncid  = ncid
 cxtype = xtype
 nlen   = LEN(name)
 name   = REPEAT(" ",LEN(name))
 cname  = REPEAT(" ",LEN(cname))
 
 cstatus = nc_inq_vlen(cncid, cxtype, cname, cdatum_size, cbase_type)

 If (cstatus == NC_NOERR) Then
    name       = stripCNullChar(cname, nlen)
    datum_size = cdatum_size 
    base_type  = cbase_type 
 EndIf
 status = cstatus

 End Function nf_inq_vlen
!-------------------------------- nf_inq_user_type ----------------------------
 Function nf_inq_user_type( ncid, xtype, name, isize, base_type, nfields, &
                            iclass) RESULT (status)

! return size and nfield, class, and base type for user type given 
! ncid, xtype, and name

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)    :: ncid, xtype
 Character(LEN=*), Intent(INOUT) :: name
 Integer,          Intent(OUT)   :: isize, nfields, base_type, iclass

 Integer                         :: status

 Integer(KIND=C_INT)          :: cncid, cxtype, cbase_type, cclass, cstatus
 Integer(KIND=C_SIZE_T)       :: csize, cnfields
 Character(LEN=NC_MAX_NAME+1) :: cname
 Integer                      :: nlen

 cncid  = ncid
 cxtype = xtype
 nlen   = LEN(name)
 name   = REPEAT(" ",LEN(name))
 cname  = REPEAT(" ",LEN(cname))
 

 cstatus = nc_inq_user_type(cncid, cxtype, cname, csize, cbase_type, cnfields, &
                           cclass)

 If (cstatus == NC_NOERR) Then
    ! Test for C Null character in path and strip trailing blanks
    name       = stripCNullChar(cname, nlen)
    isize      = csize
    nfields    = cnfields
    iclass     = cclass
    base_type  = cbase_type
 EndIf
 status = cstatus

 End Function nf_inq_user_type
!-------------------------------- nf_def_enum ---------------------------------
 Function nf_def_enum( ncid, base_typeid, name, typeid) RESULT (status)

! define new group given name 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, base_typeid 
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: typeid

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, cbase_typeid, ctypeid, cstatus
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid        = ncid
 cbase_typeid = base_typeid
 cname        = REPEAT(" ",LEN(cname))
 cname        = addCNullChar(name, ie)

 cstatus = nc_def_enum(cncid, cbase_typeid, cname(1:ie+1), ctypeid)

 If (cstatus == NC_NOERR) Then
    typeid = ctypeid
 EndIf
 status = cstatus

 End Function nf_def_enum
!-------------------------------- nf_insert_enum -------------------------------
 Function nf_insert_enum( ncid, xtype, name, value) RESULT (status)

! define a value for an enum. We used a C_CHAR string to pass the data
! into nf_insert_enum and a C_PTR type to pass the address of value
! into nc_insert_enum which is expecting a void pointer. Don't use
! an explicit interface to nf_insert_enum in the calling program
! for any data type other than character. Just declare it external

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,                Intent(IN)         :: ncid, xtype 
 Character(LEN=*),       Intent(IN)         :: name
 Character(KIND=C_CHAR), Intent(IN), TARGET :: value(*)

 Integer                                    :: status

 Integer(KIND=C_INT)          :: cncid, cxtype, cstatus
 Type(C_PTR)                  :: cvalueptr
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 cxtype = xtype
 cname  = REPEAT(" ",LEN(cname))
 cname  = addCNullChar(name, ie)

 cvalueptr = C_LOC(value)

 cstatus = nc_insert_enum(cncid, cxtype, cname(1:ie+1), cvalueptr)

 status = cstatus

 End Function nf_insert_enum
!-------------------------------- nf_inq_enum ------------------------------
 Function nf_inq_enum( ncid, xtype, name, base_nf_type, base_size, &
                       num_members) RESULT (status)

! get information about an enum. 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)    :: ncid, xtype
 Character(LEN=*), Intent(INOUT) :: name
 Integer,          Intent(INOUT) :: base_nf_type, base_size, num_members

 Integer                         :: status

 Integer(KIND=C_INT)          :: cncid, cxtype, c_base_nf_type, cstatus
 Integer(KIND=C_SIZE_T)       :: c_base_size, c_num_members
 Character(LEN=NC_MAX_NAME+1) :: cname
 Integer                      :: nlen

 cncid  = ncid
 cxtype = xtype
 nlen   = LEN(name)
 name   = REPEAT(" ",LEN(name))
 cname  = REPEAT(" ",LEN(cname))

 cstatus = nc_inq_enum (cncid, cxtype, cname, c_base_nf_type, c_base_size, &
                        c_num_members)

 If (cstatus == NC_NOERR) Then
    ! Test for C Null character in path and strip trailing blanks
    name         = stripCNullChar(cname, nlen)
    base_nf_type = c_base_nf_type
    base_size    = c_base_size
    num_members  = c_num_members
 EndIf
 status = cstatus

 End Function nf_inq_enum
!-------------------------------- nf_inq_enum_member ---------------------------
 Function nf_inq_enum_member( ncid, xtype, idx, name, value) RESULT (status)

! Get name and value for an enum. We use a C_CHAR string to pass data
! from nc_inq_enum_member to the calling routine. Value is a void
! pointer in nc_inq_enum_member. Don't use an explicit interface in
! the calling program. Declare nf_inq_enum_member external

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,                Intent(IN)  :: ncid, xtype, idx 
 Character(LEN=*),       Intent(OUT) :: name
 Character(KIND=C_CHAR), Intent(OUT) :: value(*)

 Integer                             :: status

 Integer(KIND=C_INT)          :: cncid, cxtype, cidx, cstatus
 Character(LEN=NC_MAX_NAME+1) :: cname
 Integer                      :: nlen

 cncid  = ncid
 cxtype = xtype
 cidx   = idx - 1
 nlen   = LEN(name)
 name  = REPEAT(" ",LEN(name))
 cname = REPEAT(" ",LEN(cname))

 cstatus = nc_inq_enum_member(cncid, cxtype, cidx, cname, value)

 If (cstatus == NC_NOERR) Then
    ! Test for C Null character in path and strip trailing blanks
    name = stripCNullChar(cname, nlen)
 EndIf
 status = cstatus

 End Function nf_inq_enum_member
!-------------------------------- nf_inq_enum_ident ---------------------------
 Function nf_inq_enum_ident( ncid, xtype, value, name) RESULT (status)

! get name of enum identifier given value, type.

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)    :: ncid, xtype, value
 Character(LEN=*), Intent(INOUT) :: name

 Integer                         :: status

 Integer(KIND=C_INT)          :: cncid, cxtype, cstatus
 Integer(KIND=C_LONG_LONG)    :: cvalue  
 Character(LEN=NC_MAX_NAME+1) :: cname
 Integer                      :: nlen

 cncid  = ncid
 cxtype = xtype
 cvalue = value
 nlen   = LEN(name)
 name   = REPEAT(" ",LEN(name))
 cname  = REPEAT(" ",LEN(cname))

 cstatus = nc_inq_enum_ident(cncid, cxtype, cvalue, cname)

 If (cstatus == NC_NOERR) Then
    ! Test for C Null character in path and strip trailing blanks
    name = stripCNullChar(cname, nlen)
 EndIf
 status = cstatus

 End Function nf_inq_enum_ident
!-------------------------------- nf_def_opaque -------------------------------
 Function nf_def_opaque( ncid, isize, name, xtype) RESULT (status)

! define new group given name 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, isize
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: xtype

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, cxtype, cstatus
 Integer(KIND=C_SIZE_T)       :: csize
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 csize  = isize
 cxtype = xtype
 cname  = REPEAT(" ",LEN(cname))
 cname  = addCNullChar(name, ie)

 cstatus = nc_def_opaque(cncid, csize, cname(1:ie+1), cxtype)

 If (cstatus == NC_NOERR) Then
    xtype  = cxtype 
 EndIf
 status = cstatus

 End Function nf_def_opaque
!-------------------------------- nf_inq_opaque -------------------------------
 Function nf_inq_opaque( ncid, xtype, name, isize) RESULT (status)


 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)    :: ncid, xtype
 Character(LEN=*), Intent(INOUT) :: name
 Integer,          Intent(OUT)   :: isize

 Integer                         :: status

 Integer(KIND=C_INT)          :: cncid, cxtype, cstatus
 Integer(KIND=C_SIZE_T)       :: csize
 Character(LEN=NC_MAX_NAME+1) :: cname
 Integer                      :: nlen

 cncid  = ncid
 cxtype = xtype
 nlen   = LEN(name)
 name   = REPEAT(" ",LEN(name))
 cname  = REPEAT(" ",LEN(cname))

 cstatus = nc_inq_opaque(cncid, cxtype, cname, csize)

 If (cstatus == NC_NOERR) Then
    ! Test for C Null character in path and strip trailing blanks
    name   = stripCNullChar(cname, nlen)
    isize  = csize
 EndIf
 status = cstatus

 End Function nf_inq_opaque
!-------------------------------- nf_def_var_chunking -------------------------
 Function nf_def_var_chunking( ncid, varid, contiguous, chunksizes) &
                               RESULT(status)

! define variable chunking

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)    :: ncid, varid, contiguous
 Integer, Intent(INOUT) :: chunksizes(*)

 Integer                :: status

 Integer(KIND=C_INT)         :: cncid, cvarid, ccontiguous, cstat1, cstatus, &
                                cndims
 Integer(KIND=C_INT), TARGET :: cchunksizes(NC_MAX_DIMS)
 Type(C_PTR)                 :: cchunksizeptr
 Integer                     :: i, ndims

 cncid       = ncid
 cvarid      = varid-1
 ccontiguous = contiguous

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 ndims         = cndims
 cchunksizeptr = C_NULL_PTR

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then 
     cchunksizes(1:ndims) = chunksizes(ndims:1:-1)
   EndIf
   cchunksizeptr = C_LOC(cchunksizes)
 EndIf

 cstatus = nc_def_var_chunking_ints(cncid, cvarid, ccontiguous, cchunksizeptr)

 status = cstatus

 End Function nf_def_var_chunking
!-------------------------------- nf_inq_var_chunking -------------------------
 Function nf_inq_var_chunking( ncid, varid, contiguous, chunksizes) RESULT(status)

! inquire variable chunking 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)    :: ncid, varid
 Integer, Intent(INOUT) :: contiguous
 Integer, Intent(INOUT) :: chunksizes(*)

 Integer                :: status

 Integer(KIND=C_INT) :: cncid, cvarid, ccontiguous, cstatus, cstat1, cndims
 Integer(KIND=C_INT) :: cchunksizes(NC_MAX_DIMS)
 Integer             :: ndims

 cncid         = ncid
 cvarid        = varid-1
 chunksizes(1) = 0

 cstatus = nc_inq_var_chunking_ints(cncid, cvarid, ccontiguous, cchunksizes) 

 cstat1  = nc_inq_varndims(cncid, cvarid, cndims)

 ndims = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then
     chunksizes(ndims:1:-1) = cchunksizes(1:ndims)
   EndIf
 EndIf 
   
 contiguous = ccontiguous
 status     = cstatus

 End Function nf_inq_var_chunking
!-------------------------------- nf_def_var_deflate --------------------------
 Function nf_def_var_deflate( ncid, varid, shuffle, deflate, deflate_level) &
                               RESULT (status)

! define variable deflation 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN) :: ncid, varid, shuffle, deflate, deflate_level

 Integer             :: status

 Integer(KIND=C_INT) :: cncid, cvarid, cshuffle, cdeflate, cdeflate_level, &
                        cstatus

 cncid          = ncid
 cvarid         = varid-1
 cshuffle       = shuffle
 cdeflate       = deflate
 cdeflate_level = deflate_level

 cstatus = nc_def_var_deflate(cncid, cvarid, cshuffle, cdeflate, cdeflate_level) 

 status = cstatus

 End Function nf_def_var_deflate
!-------------------------------- nf_inq_var_deflate -------------------------
 Function nf_inq_var_deflate( ncid, varid, shuffle, deflate, deflate_level) &
                               RESULT (status)

! inquire variable deflation 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid, varid
 Integer, Intent(OUT) :: shuffle, deflate, deflate_level

 Integer              :: status

 Integer(KIND=C_INT) :: cncid, cvarid, cshuffle, cdeflate, cdeflate_level, &
                        cstatus

 cncid  = ncid
 cvarid = varid-1

 cstatus = nc_inq_var_deflate(cncid, cvarid, cshuffle, cdeflate, cdeflate_level) 

 If (cstatus == NC_NOERR) Then
    shuffle       = cshuffle
    deflate       = cdeflate
    deflate_level = cdeflate_level
 EndIf
 status = cstatus
 
 End Function nf_inq_var_deflate

!-------------------------------- nf_inq_var_szip -----------------------------
 Function nf_inq_var_szip(ncid, varid, options_mask, pixels_per_block) RESULT(status)

! get szip variables
 
 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)    :: ncid, varid
 Integer, Intent(INOUT) :: options_mask, pixels_per_block

 Integer                :: status

 Integer(C_INT) :: cncid, cvarid, coptions_mask, cpixels_per_block, cstatus

 cncid  = ncid
 cvarid = varid-1

 cstatus = nc_inq_var_szip(cncid, cvarid, coptions_mask, cpixels_per_block)

 If (cstatus == NC_NOERR) Then
    options_mask     = coptions_mask
    pixels_per_block = cpixels_per_block
 EndIf
 status = cstatus

 End Function nf_inq_var_szip

!-------------------------------- nf_def_var_fletcher32 -----------------------
 Function nf_def_var_fletcher32( ncid, varid, fletcher32) RESULT(status)

! define var for fletcher32 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN) :: ncid, varid, fletcher32

 Integer             :: status

 Integer(KIND=C_INT) :: cncid, cvarid, cfletcher32, cstatus

 cncid       = ncid
 cvarid      = varid-1
 cfletcher32 = fletcher32 

 cstatus = nc_def_var_fletcher32(cncid, cvarid, cfletcher32)
 
 status = cstatus

 End Function nf_def_var_fletcher32
!-------------------------------- nf_inq_var_fletcher32 ------------------------
 Function nf_inq_var_fletcher32( ncid, varid, fletcher32) RESULT(status)

! get var for fletcher 32 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid, varid
 Integer, Intent(OUT) :: fletcher32

 Integer              :: status

 Integer(KIND=C_INT) :: cncid, cvarid, cfletcher32, cstatus

 cncid  = ncid
 cvarid = varid-1

 cstatus = nc_inq_var_fletcher32(cncid, cvarid, cfletcher32)

 If (cstatus == NC_NOERR) Then
    fletcher32 = cfletcher32 
 EndIf
 
 status = cstatus

 End Function nf_inq_var_fletcher32
!-------------------------------- nf_def_var_fill -----------------------------
 Function nf_def_var_fill( ncid, varid, no_fill, fill_value) RESULT(status)

! define fill variable 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)                        :: ncid, varid, no_fill
 Character(KIND=C_CHAR), Intent(IN), TARGET :: fill_value(*)

 Integer                                    :: status

 Integer(KIND=C_INT) :: cncid, cvarid, cno_fill, cstatus
 Type(C_PTR)         :: cfill_value_p

 cncid    = ncid
 cvarid   = varid-1
 cno_fill = no_fill

 cfill_value_p = C_LOC(fill_value)

 cstatus       = nc_def_var_fill(cncid, cvarid, cno_fill, cfill_value_p)

 status        = cstatus

 End Function nf_def_var_fill
!-------------------------------- nf_inq_var_fill -----------------------------
 Function nf_inq_var_fill( ncid, varid, no_fill, fill_value) RESULT(status)

! get fill variable 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)                   :: ncid, varid
 Integer, Intent(OUT)                  :: no_fill
 Character(KIND=C_CHAR), Intent(INOUT) :: fill_value(*)

 Integer                               :: status

 Integer(KIND=C_INT) :: cncid, cvarid, cno_fill, cstatus

 cncid  = ncid
 cvarid = varid-1

 cstatus = nc_inq_var_fill(cncid, cvarid, cno_fill, fill_value)

 If (cstatus == NC_NOERR) Then
    no_fill = cno_fill 
 EndIf
 status  = cstatus

 End Function nf_inq_var_fill
!-------------------------------- nf_def_var_endian ---------------------------
 Function nf_def_var_endian( ncid, varid, endiann) RESULT(status)

! define variable endian 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN) :: ncid, varid, endiann

 Integer             :: status

 Integer(KIND=C_INT) :: cncid, cvarid, cendiann, cstatus

 cncid    = ncid
 cvarid   = varid-1
 cendiann = endiann

 cstatus = nc_def_var_endian(cncid, cvarid, cendiann)

 status = cstatus

 End Function nf_def_var_endian
!-------------------------------- nf_inq_var_endian ---------------------------
 Function nf_inq_var_endian( ncid, varid, endiann) RESULT(status)

! get variable endian 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid, varid
 Integer, Intent(OUT) ::  endiann

 Integer              :: status

 Integer(KIND=C_INT) :: cncid, cvarid, cendiann, cstatus

 cncid  = ncid
 cvarid = varid-1

 cstatus = nc_inq_var_endian(cncid, cvarid, cendiann)

 If (cstatus == NC_NOERR) Then
    endiann = cendiann
 EndIf
 status  = cstatus

 End Function nf_inq_var_endian
!--------------------------------- nf_put_att --------------------------------
 Function nf_put_att(ncid, varid, name, xtype, nlen, value) RESULT(status)

! Write global attribute of any type. We use a C character
! string as the dummy arguments for the values 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,                Intent(IN)         :: ncid, varid, nlen, xtype
 Character(LEN=*),       Intent(IN)         :: name
 Character(KIND=C_CHAR), Intent(IN), TARGET :: value(*)

 Integer                                    :: status

 Integer(KIND=C_INT) :: cncid, cvarid, cstatus, cxtype

 Integer(KIND=C_SIZE_T)       :: cnlen
 Type(C_PTR)                  :: cvalueptr
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid     = ncid
 cvarid    = varid -1 ! Subtract 1 to get C varid
 cxtype    = xtype
 cnlen     = nlen
 cvalueptr = C_LOC(value)
 cname     = REPEAT(" ",LEN(cname))
 cname     = addCNullChar(name, ie)

 cstatus = nc_put_att(cncid, cvarid, cname(1:ie+1), cxtype, cnlen, cvalueptr)

 status = cstatus

 End Function nf_put_att
!--------------------------------- nf_get_att --------------------------------
 Function nf_get_att(ncid, varid, name, value) RESULT(status)

! Get global attribute of any type. We use a C character
! string as the dummy arguments for the values. Don't supply calling
! program with an explicit interface. Just use external

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,                Intent(IN)    :: ncid, varid
 Character(LEN=*),       Intent(IN)    :: name
 Character(KIND=C_CHAR), Intent(INOUT) :: value(*)

 Integer                               :: status

 Integer(KIND=C_INT)          :: cncid, cvarid, cstatus
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 cvarid = varid -1 ! Subtract 1 to get C varid
 cname  = REPEAT(" ",LEN(cname))
 cname = addCNullChar(name, ie)

 cstatus = nc_get_att(cncid, cvarid, cname(1:ie+1), value)

 status = cstatus

 End Function nf_get_att
!--------------------------------- nf_put_vlen_element ------------------------
 Function nf_put_vlen_element(ncid, xtype, vlen_element, nlen, value) &
                              RESULT(status)

! Put in a variable length array element element for Netcdf . We use a C
! character string as the dummy arguments for the values. Don't supply calling
! program with an explicit interface. Just use external

! Note Users manual defines vlen_element to be a character string. We
! use the same here but pass it as a C_PTR type.

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,                Intent(IN)            :: ncid, xtype, nlen
 Character(KIND=C_CHAR), Intent(INOUT)         :: vlen_element(*)
 Character(KIND=C_CHAR), Intent(IN),   TARGET  :: value(*)

 Integer                                       :: status

 Integer(KIND=C_INT)    :: cncid, cxtype, cstatus
 Integer(KIND=C_SIZE_T) :: cnlen
 Type(C_PTR)            :: cvalueptr

 cncid     = ncid
 cxtype    = xtype
 cnlen     = nlen 
 cvalueptr = C_LOC(value)

 cstatus = nc_put_vlen_element(cncid, cxtype, vlen_element, cnlen,&
                               cvalueptr)

 status = cstatus

 End Function nf_put_vlen_element
!--------------------------------- nf_get_vlen_element ------------------------
 Function nf_get_vlen_element(ncid, xtype, vlen_element, nlen, value) RESULT(status)

! Get a variable length array element element for Netcdf . We use a C
! character string as the dummy arguments for the values. Don't supply calling
! program with an explicit interface. Just use external

! Note Users manual defines vlen_element to be a character string. We
! use the same here but pass it as a C_PTR type.

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,                Intent(IN)            :: ncid, xtype
 Integer,                Intent(INOUT)         :: nlen
 Character(LEN=*),       Intent(INOUT), TARGET :: vlen_element
 Character(KIND=C_CHAR), Intent(INOUT)         :: value(*)

 Integer                                       :: status

 Integer(KIND=C_INT)    :: cncid, cxtype, cstatus
 Integer(KIND=C_SIZE_T) :: cnlen

 cncid  = ncid
 cxtype = xtype

 cstatus = nc_get_vlen_element(cncid, cxtype, vlen_element, cnlen,&
                               value)

 If (cstatus == NC_NOERR) Then
    nlen = cnlen 
 EndIf
 status = cstatus

 End Function nf_get_vlen_element
!--------------------------------- nf_free_vlen --------------------------------
 Function nf_free_vlen(vl) RESULT(status)

! Free memory for vlen array
! C_CHAR string is used as the dummy arguments for vl. Don't supply calling
! program with an explicit interface. Just use external

 USE netcdf4_nc_interfaces

 Implicit NONE

 Character(KIND=C_CHAR), Intent(IN), TARGET :: vl(*)

 Integer                                    :: status

 Integer(C_INT) :: cstatus
 Type(C_PTR)    :: cvl

 cvl = C_LOC(vl) !void pointer in C interface

 cstatus = nc_free_vlen(cvl)

 status = cstatus

End Function nf_free_vlen
!--------------------------------- nf_free_vlens ------------------------------
 Function nf_free_vlens(ilen, vl) RESULT(status)

! Free memory for vlens array
! C_CHAR string is used as the dummy arguments for vl. Don't supply calling
! program with an explicit interface. Just use external

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,                Intent(IN)         :: ilen
 Character(KIND=C_CHAR), Intent(IN), TARGET :: vl(*)

 Integer                                    :: status

 Integer(C_SIZE_T) :: clen
 Integer(C_INT)    :: cstatus
 Type(C_PTR)       :: cvl

 clen = ilen
 cvl  = C_LOC(vl) !void pointer in C interface

 cstatus = nc_free_vlens(clen, cvl)

 status = cstatus

End Function nf_free_vlens
!--------------------------------- nf_free_string -----------------------------
 Function nf_free_string(ilen, vl) RESULT(status)

! Free memory for string array 
! C_CHAR string is used as the dummy arguments for vl. Don't supply calling
! program with an explicit interface. Just use external

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,                Intent(IN)         :: ilen
 Character(KIND=C_CHAR), Intent(IN), TARGET :: vl(*)

 Integer                                    :: status

 Integer(C_SIZE_T) :: clen
 Integer(C_INT)    :: cstatus
 Type(C_PTR)       :: cvl

 clen = ilen
 cvl  = C_LOC(vl) !void pointer in C interface

 cstatus = nc_free_string(clen, cvl)

 status = cstatus

End Function nf_free_string

!--------------------------------- nf_put_var -------------------------------
 Function nf_put_var(ncid, varid, values) RESULT(status)

! Write out a variable of any type. We use a C_CHAR character string
! to hold values. Therefore, an explicit interface to nf_put_var should NOT 
! be used in the calling routine. Use an external instead. 
! Defined in  fort-vario.c but only used in 4.0.1 for NETCDF4 builds

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,                Intent(IN)         :: ncid, varid
 Character(KIND=C_CHAR), Intent(IN), TARGET :: values(*)

 Integer                                    :: status

 Integer(KIND=C_INT) :: cncid, cvarid,  cstatus
 Type(C_PTR)         :: cvaluesptr

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

 cvaluesptr = C_LOC(values)

 cstatus = nc_put_var(cncid, cvarid, cvaluesptr)

 status = cstatus

 End Function nf_put_var
!--------------------------------- nf_get_var ----------------------------
 Function nf_get_var(ncid, varid, values) RESULT(status)

! Read in a variable of any type. We use a C_CHAR character string
! to hold values. Therefore, an explicit interface to nf_get_var should NOT
! be used in the calling routine. Just use external 
! Defined in  fort-vario.c but only used in 4.0.1 for NETCDF4 builds
  
 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,                Intent(IN)    :: ncid, varid
 Character(KIND=C_CHAR), Intent(INOUT) :: values(*)

 Integer                               :: status

 Integer(KIND=C_INT) :: cncid, cvarid,  cstatus

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

 cstatus = nc_get_var(cncid, cvarid, values)

 status = cstatus

 End Function nf_get_var
!--------------------------------- nf_put_var1_int64 --------------------------
 Function nf_put_var1_int64(ncid, varid, ndex, ival) RESULT(status)

! Write out a 64 bit integer variable to location vector ndex to dataset
! Note that the default fort interfaces pass ival as an integer to
! nc_put_var1_longlong which is expecting a longlong. We chose to
! pass ival as an integer of type SELECTED_INT_KIND(18) which is
! consistent with the f90 interfaces that call these routines

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,           Intent(IN) :: ncid, varid
 Integer,           Intent(IN) :: ndex(*)
 Integer(KIND=IK8), Intent(IN) :: ival

 Integer                       :: status

 Integer(KIND=C_INT)            :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T), TARGET :: cndex(NC_MAX_DIMS)
 Integer(KIND=C_LONG_LONG)      :: cival
 Type(C_PTR)                    :: cndexptr
 Integer                        :: ndims

 cncid  = ncid
 cvarid = varid - 1 ! Subtract one to get C varid
 cndex  = 0
 cival  = ival

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cndexptr = C_NULL_PTR
 ndims    = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! reverse array order and subtract 1 to get C index 
     cndex(1:ndims) = ndex(ndims:1:-1)-1
   EndIf
   cndexptr = C_LOC(cndex)
 EndIf

 cstatus = nc_put_var1_longlong(cncid, cvarid, cndexptr, cival)

 status = cstatus

 End Function nf_put_var1_int64
!--------------------------------- nf_put_vara_int64 --------------------------
 Function nf_put_vara_int64(ncid, varid, start, counts, ivals) RESULT(status)

! Write out 64 bit integer array to dataset for given start and count vectors

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,           Intent(IN) :: ncid, varid
 Integer,           Intent(IN) :: start(*), counts(*)
 Integer(KIND=IK8), Intent(IN) :: ivals(*)

 Integer                       :: status

 Integer(KIND=C_INT)            :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1 ! Subtract 1 to get C varid
 cstart  = 0
 ccounts = 0

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! flip array order for C and subtract 1 from start
     cstart(1:ndims)  = start(ndims:1:-1)-1
     ccounts(1:ndims) = counts(ndims:1:-1)
   EndIf
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 EndIf

 cstatus = nc_put_vara_longlong(cncid, cvarid, cstartptr, ccountsptr, ivals)

 status = cstatus

 End Function nf_put_vara_int64
!--------------------------------- nf_put_vars_int64 --------------------------
 Function nf_put_vars_int64(ncid, varid, start, counts, strides, ivals) &
                             RESULT(status)

! Write out 64 bit integer array given start, count, and stride

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,           Intent(IN) :: ncid, varid
 Integer,           Intent(IN) :: start(*), counts(*), strides(*)
 Integer(KIND=IK8), Intent(IN) :: ivals(*)

 Integer                       :: status

 Integer(KIND=C_INT)               :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T),    TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Integer(KIND=C_PTRDIFF_T), TARGET :: cstrides(NC_MAX_DIMS)
 Type(C_PTR)                       :: cstartptr, ccountsptr, cstridesptr
 Integer                           :: ndims

 cncid    = ncid
 cvarid   = varid - 1 ! Subtract 1 to get C varid
 cstart   = 0
 ccounts  = 0
 cstrides = 1

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     cstart(1:ndims)   = start(ndims:1:-1)-1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
   EndIf
   cstartptr   = C_LOC(cstart)
   ccountsptr  = C_LOC(ccounts)
   cstridesptr = C_LOC(cstrides)
 EndIf

 cstatus = nc_put_vars_longlong(cncid, cvarid, cstartptr, ccountsptr, &
                                cstridesptr, ivals)

 status = cstatus

 End Function nf_put_vars_int64

!--------------------------------- nf_put_varm_int64 -------------------------
 Function nf_put_varm_int64(ncid, varid, start, counts, strides, maps, &
                            ivals) RESULT(status)

! Write out 64 bit integer array given start, count, stride and map

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,           Intent(IN) :: ncid, varid
 Integer,           Intent(IN) :: start(*), counts(*), strides(*), maps(*)
 Integer(KIND=IK8), Intent(IN) :: ivals(*)

 Integer                       :: status

 Integer(KIND=C_INT)               :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T),    TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Integer(KIND=C_PTRDIFF_T), TARGET :: cstrides(NC_MAX_DIMS), cmaps(NC_MAX_DIMS)
 Type(C_PTR)                       :: cstartptr, ccountsptr, cstridesptr, &
                                      cmapsptr
 Integer                           :: ndims

 cncid    = ncid
 cvarid   = varid -1 ! Subtract 1 to get C varid
 cstart   = 0
 ccounts  = 0
 cstrides = 1
 cmaps    = 0

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     cstart(1:ndims)   = start(ndims:1:-1)-1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cmaps(1:ndims)    = maps(ndims:1:-1)
   EndIf
   cstartptr   = C_LOC(cstart)
   ccountsptr  = C_LOC(ccounts)
   cstridesptr = C_LOC(cstrides)
   cmapsptr    = C_LOC(cmaps)
 EndIf

 cstatus = nc_put_varm_longlong(cncid, cvarid, cstartptr, ccountsptr, &
                                cstridesptr, cmapsptr, ivals)

 status = cstatus

 End Function nf_put_varm_int64
!--------------------------------- nf_put_var_int64 --------------------------
 Function nf_put_var_int64(ncid, varid, ivals) RESULT(status)

! Write out 64 bit integer array to dataset

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,           Intent(IN) :: ncid, varid
 Integer(KIND=IK8), Intent(IN) :: ivals(*)

 Integer                       :: status

 Integer(KIND=C_INT) :: cncid, cvarid,  cstatus

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

 cstatus = nc_put_var_longlong(cncid, cvarid, ivals)

 status = cstatus

 End Function nf_put_var_int64
!--------------------------------- nf_get_var1_int64 -------------------------
 Function nf_get_var1_int64(ncid, varid, ndex, ival) RESULT(status)

! Read in 64 bit integer variable from location vector ndex in dataset

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,           Intent(IN)  :: ncid, varid
 Integer,           Intent(IN)  :: ndex(*)
 Integer(KIND=IK8), Intent(OUT) :: ival

 Integer                        :: status

 Integer(KIND=C_INT)            :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T), TARGET :: cndex(NC_MAX_DIMS)
 Integer(KIND=C_LONG_LONG)      :: cival
 Type(C_PTR)                    :: cndexptr
 Integer                        :: ndims

 cncid  = ncid
 cvarid = varid - 1 ! Subtract one to get C varid
 cndex  = 0

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cndexptr = C_NULL_PTR
 ndims    = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! reverse array order and subtract 1 to get C index 
     cndex(1:ndims) = ndex(ndims:1:-1)-1
   EndIf
   cndexptr = C_LOC(cndex)
 EndIf

 cstatus = nc_get_var1_longlong(cncid, cvarid, cndexptr, cival)

 ival   = cival
 status = cstatus

 End Function nf_get_var1_int64
!--------------------------------- nf_get_vara_int -------------------------
 Function nf_get_vara_int64(ncid, varid, start, counts, ivals) RESULT(status)

! Read in 64 bit integer array from dataset for given start and count vectors 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,           Intent(IN)  :: ncid, varid
 Integer,           Intent(IN)  :: start(*), counts(*)
 Integer(KIND=IK8), Intent(OUT) :: ivals(*)

 Integer                        :: status

 Integer(KIND=C_INT)            :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1 ! Subtract 1 to get C varid
 cstart  = 0
 ccounts = 0

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! flip array order for C and subtract 1 from start
     cstart(1:ndims)  = start(ndims:1:-1)-1
     ccounts(1:ndims) = counts(ndims:1:-1)
   EndIf
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 EndIf

 cstatus = nc_get_vara_longlong(cncid, cvarid, cstartptr, ccountsptr, ivals)

 status = cstatus

 End Function nf_get_vara_int64

!--------------------------------- nf_get_vars_int64 --------------------------
 Function nf_get_vars_int64(ncid, varid, start, counts, strides, ivals) &
                             RESULT(status)

! Read in 64 bit integer array given start, count, and stride

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,           Intent(IN)  :: ncid, varid
 Integer,           Intent(IN)  :: start(*), counts(*), strides(*)
 Integer(KIND=IK8), Intent(OUT) :: ivals(*)

 Integer                        :: status

 Integer(KIND=C_INT)               :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T),    TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Integer(KIND=C_PTRDIFF_T), TARGET :: cstrides(NC_MAX_DIMS)
 Type(C_PTR)                       :: cstartptr, ccountsptr, cstridesptr
 Integer                           :: ndims

 cncid    = ncid
 cvarid   = varid - 1 ! Subtract 1 to get C varid
 cstart   = 0
 ccounts  = 0
 cstrides = 1

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     cstart(1:ndims)   = start(ndims:1:-1)-1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
   EndIf
   cstartptr   = C_LOC(cstart)
   ccountsptr  = C_LOC(ccounts)
   cstridesptr = C_LOC(cstrides)
 EndIf

 cstatus = nc_get_vars_longlong(cncid, cvarid, cstartptr, ccountsptr, &
                                cstridesptr, ivals)
 status = cstatus

 End Function nf_get_vars_int64
!--------------------------------- nf_get_varm_int64 -------------------------
 Function nf_get_varm_int64(ncid, varid, start, counts, strides, maps, &
                            ivals) RESULT(status)

! Read in 64 bit integer array given start, count, stride and map

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,           Intent(IN)  :: ncid, varid
 Integer,           Intent(IN)  :: start(*), counts(*), strides(*), maps(*)
 Integer(KIND=IK8), Intent(OUT) :: ivals(*)

 Integer                        :: status

 Integer(KIND=C_INT)               :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(KIND=C_SIZE_T),    TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Integer(KIND=C_PTRDIFF_T), TARGET :: cstrides(NC_MAX_DIMS), cmaps(NC_MAX_DIMS)
 Type(C_PTR)                       :: cstartptr, ccountsptr, cstridesptr, &
                                      cmapsptr
 Integer                           :: ndims

 cncid    = ncid
 cvarid   = varid -1 ! Subtract 1 to get C varid
 cstart   = 0
 ccounts  = 0
 cstrides = 1
 cmaps    = 0

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     cstart(1:ndims)   = start(ndims:1:-1)-1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cmaps(1:ndims)    = maps(ndims:1:-1)
   EndIf
   cstartptr   = C_LOC(cstart)
   ccountsptr  = C_LOC(ccounts)
   cstridesptr = C_LOC(cstrides)
   cmapsptr    = C_LOC(cmaps)
 EndIf

 cstatus = nc_get_varm_longlong(cncid, cvarid, cstartptr, ccountsptr, &
                                cstridesptr, cmapsptr, ivals)

 status = cstatus

 End Function nf_get_varm_int64
!--------------------------------- nf_get_var_int64 --------------------------
 Function nf_get_var_int64(ncid, varid, ivals) RESULT(status)

! Read in 64 bit integer array from dataset

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,           Intent(IN)  :: ncid, varid
 Integer(KIND=IK8), Intent(OUT) :: ivals(*)

 Integer                        :: status

 Integer(KIND=C_INT) :: cncid, cvarid,  cstatus

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

 cstatus = nc_get_var_longlong(cncid, cvarid, ivals)

 status = cstatus

 End Function nf_get_var_int64
!--------------------------------- nf_set_chunk_cache ------------------------
 Function nf_set_chunk_cache(chunk_size, nelems, preemption) RESULT(status)

! Set chunk cache size. Note this follows the fort-nc4 version which uses
! uses nc_set_chunk_cache_ints to avoid size_t issues with fortran. F03
! does not have these issues so we could call nc_set_chunk_cache

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN) :: chunk_size, nelems, preemption 

 Integer             :: status

 Integer(KIND=C_INT) :: cchunk_size, cnelems, cpreemption, cstatus

 cchunk_size = chunk_size
 cnelems     = nelems
 cpreemption = preemption

 cstatus = nc_set_chunk_cache_ints(cchunk_size, cnelems, cpreemption)

 status = cstatus

 End Function nf_set_chunk_cache
!--------------------------------- nf_get_chunk_cache -------------------------
 Function nf_get_chunk_cache(chunk_size, nelems, preemption) RESULT(status)

! get chunk cache size. Note this follows the fort-nc4 version which uses
! uses nc_get_chunk_cache_ints to avoid size_t issues with fortran. F03
! does not have these issues so we could call nc_set_chunk_cache

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(INOUT) :: chunk_size, nelems, preemption 

 Integer                :: status

 Integer(KIND=C_INT) :: cchunk_size, cnelems, cpreemption, cstatus

 cstatus = nc_get_chunk_cache_ints(cchunk_size, cnelems, cpreemption)

 If (cstatus == NC_NOERR) Then
    chunk_size = cchunk_size
    nelems     = cnelems
    preemption = cpreemption
 EndIf
 status = cstatus

 End Function nf_get_chunk_cache
!--------------------------------- nf_set_var_chunk_cache ---------------------
 Function nf_set_var_chunk_cache(ncid, varid, chunk_size, nelems, preemption) RESULT(status)

! Set chunk cache size. Note this follows the fort-nc4 version which uses
! uses nc_set_var_chunk_cache_ints to avoid size_t issues with fortran.

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN) :: ncid, varid, chunk_size, nelems, preemption 

 Integer             :: status

 Integer(KIND=C_INT) :: cncid, cvarid, cchunk_size, cnelems, cpreemption, &
                        cstatus

 cncid       = ncid
 cvarid      = varid-1
 cchunk_size = chunk_size
 cnelems     = nelems
 cpreemption = preemption

 cstatus = nc_set_var_chunk_cache_ints(cncid, cvarid, cchunk_size, cnelems, &
                                       cpreemption)

 status = cstatus

 End Function nf_set_var_chunk_cache
!--------------------------------- nf_get_var_chunk_cache ---------------------
 Function nf_get_var_chunk_cache(ncid, varid, chunk_size, nelems, preemption) RESULT(status)

! get chunk cache size. Note this follows the fort-nc4 version which uses
! uses nc_get_var_chunk_cache_ints to avoid size_t issues with fortran. 

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)    :: ncid, varid 
 Integer, Intent(INOUT) :: chunk_size, nelems, preemption 

 Integer                :: status

 Integer(KIND=C_INT) :: cncid, cvarid, cchunk_size, cnelems, cpreemption, &
                        cstatus

 cncid  = ncid
 cvarid = varid-1

 cstatus = nc_get_var_chunk_cache_ints(cncid, cvarid, cchunk_size, cnelems, &
                                       cpreemption)

 If (cstatus == NC_NOERR) Then
    chunk_size = cchunk_size
    nelems     = cnelems
    preemption = cpreemption
 EndIf
 status = cstatus

 End Function nf_get_var_chunk_cache

   function nf90_put_var_text(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     character (len = *),             intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_text

     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride
 
     ! Set local arguments to default values
     localStart (:)  = 1
     localCount (1)  = len(values); localCount (2:) = 1
     localStride(:)  = 1
          
     if(present(start))  localStart (:size(start) ) = start(:)
     if(present(count))  localCount (:size(count) ) = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)

     nf90_put_var_text = nf_put_vars_text(ncid, varid, localStart, localCount, localStride, values)
   end function nf90_put_var_text

   function nf90_get_var_text(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     character (len = *),             intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_text
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride

     ! Set local arguments to default values
     localStart (:)  = 1
     localCount (1)  = len(values); localCount (2:) = 1
     localStride(:)  = 1
     
     if(present(start))  localStart (:size(start) ) = start(:)
     if(present(count))  localCount (:size(count) ) = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)

     nf90_get_var_text = nf_get_vars_text(ncid, varid, localStart, localCount, localStride, values)
   end function nf90_get_var_text


   function nf90_put_var_1D_text(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     character (len = *), dimension(:), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_1D_text
 
     integer, parameter                    :: numDims = 1
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: counter
 
     ! Set local arguments to default values
     localStart (:         ) = 1
     localCount ( :numDims+1) = (/ len(values(1)), shape(values) /)
     localCount (numDims+2:) = 0
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start))  = start(:)
     if(present(count))  localCount (:size(count))  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_1D_text = &
          nf_put_varm_text(ncid, varid, localStart, localCount, localStride, localMap, values(1))
     else
       nf90_put_var_1D_text = &
          nf_put_vars_text(ncid, varid, localStart, localCount, localStride, values(1))
     end if
   end function nf90_put_var_1D_text


   function nf90_put_var_2D_text(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     character (len = *), dimension(:, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_2D_text
 
     integer, parameter                    :: numDims = 2
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: counter
 
     ! Set local arguments to default values
     localStart (:         ) = 1
     localCount ( :numDims+1) = (/ len(values(1, 1)), shape(values) /)
     localCount (numDims+2:) = 0
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start))  = start(:)
     if(present(count))  localCount (:size(count))  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_2D_text = &
          nf_put_varm_text(ncid, varid, localStart, localCount, localStride, localMap, values(1,1))
     else
       nf90_put_var_2D_text = &
          nf_put_vars_text(ncid, varid, localStart, localCount, localStride, values(1,1))
     end if
   end function nf90_put_var_2D_text


   function nf90_put_var_3D_text(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     character (len = *), dimension(:, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_3D_text
 
     integer, parameter                    :: numDims = 3
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: counter
 
     ! Set local arguments to default values
     localStart (:         ) = 1
     localCount ( :numDims+1) = (/ len(values(1, 1, 1)), shape(values) /)
     localCount (numDims+2:) = 0
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start))  = start(:)
     if(present(count))  localCount (:size(count))  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_3D_text = &
          nf_put_varm_text(ncid, varid, localStart, localCount, localStride, localMap, values(1,1,1))
     else
       nf90_put_var_3D_text = &
          nf_put_vars_text(ncid, varid, localStart, localCount, localStride, values(1,1,1))
     end if
   end function nf90_put_var_3D_text


   function nf90_put_var_4D_text(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     character (len = *), dimension(:, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_4D_text
 
     integer, parameter                    :: numDims = 4
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: counter
 
     ! Set local arguments to default values
     localStart (:         ) = 1
     localCount ( :numDims+1) = (/ len(values(1, 1, 1, 1)), shape(values) /)
     localCount (numDims+2:) = 0
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start))  = start(:)
     if(present(count))  localCount (:size(count))  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_4D_text = &
          nf_put_varm_text(ncid, varid, localStart, localCount, localStride, localMap, values(1,1,1,1))
     else
       nf90_put_var_4D_text = &
          nf_put_vars_text(ncid, varid, localStart, localCount, localStride, values(1,1,1,1))
     end if
   end function nf90_put_var_4D_text


   function nf90_put_var_5D_text(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     character (len = *), dimension(:, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_5D_text
 
     integer, parameter                    :: numDims = 5
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: counter
 
     ! Set local arguments to default values
     localStart (:         ) = 1
     localCount ( :numDims+1) = (/ len(values(1, 1, 1, 1, 1)), shape(values) /)
     localCount (numDims+2:) = 0
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start))  = start(:)
     if(present(count))  localCount (:size(count))  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_5D_text = &
          nf_put_varm_text(ncid, varid, localStart, localCount, localStride, localMap, values(1,1,1,1,1))
     else
       nf90_put_var_5D_text = &
          nf_put_vars_text(ncid, varid, localStart, localCount, localStride, values(1,1,1,1,1))
     end if
   end function nf90_put_var_5D_text


   function nf90_put_var_6D_text(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     character (len = *), dimension(:, :, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_6D_text
 
     integer, parameter                    :: numDims = 6
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: counter

     ! Set local arguments to default values
     localStart (:         ) = 1
     localCount ( :numDims+1) = (/ len(values(1, 1, 1, 1, 1, 1)), shape(values) /)
     localCount (numDims+2:) = 0
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start))  = start(:)
     if(present(count))  localCount (:size(count))  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_6D_text = &
          nf_put_varm_text(ncid, varid, localStart, localCount, localStride, localMap, values(1,1,1,1,1,1))
     else
       nf90_put_var_6D_text = &
          nf_put_vars_text(ncid, varid, localStart, localCount, localStride, values(1,1,1,1,1,1))
     end if
   end function nf90_put_var_6D_text


   function nf90_put_var_7D_text(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     character (len = *), dimension(:, :, :, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_7D_text
 
     integer, parameter                  :: numDims = 7
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                             :: counter
 
     ! Set local arguments to default values
     localStart (:         ) = 1
     localCount ( :numDims+1) = (/ len(values(1, 1, 1, 1, 1, 1, 1)), shape(values) /)
     localCount (numDims+2:) = 0
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start))  = start(:)
     if(present(count))  localCount (:size(count))  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_7D_text = &
          nf_put_varm_text(ncid, varid, localStart, localCount, localStride, localMap, values(1,1,1,1,1,1,1))
     else
       nf90_put_var_7D_text = &
          nf_put_vars_text(ncid, varid, localStart, localCount, localStride, values(1,1,1,1,1,1,1))
     end if
   end function nf90_put_var_7D_text


   function nf90_get_var_1D_text(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     character (len = *), dimension(:), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_1D_text
 
     integer, parameter                  :: numDims = 1
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap

     ! Set local arguments to default values
     localStart (:         ) = 1
     localCount (:numDims+1) = (/ len(values(1)), shape(values) /)
     localCount (numDims+2:) = 0
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1/)
 
     if(present(start))  localStart (:size(start))  = start(:)
     if(present(count))  localCount (:size(count))  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_1D_text = &
          nf_get_varm_text(ncid, varid, localStart, localCount, localStride, localMap, values(1))
     else
       nf90_get_var_1D_text = &
          nf_get_vars_text(ncid, varid, localStart, localCount, localStride, values(1))
     end if
   end function nf90_get_var_1D_text


   function nf90_get_var_2D_text(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     character (len = *), dimension(:, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_2D_text
 
     integer, parameter                  :: numDims = 2
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                             :: counter
 
     ! Set local arguments to default values
     localStart (:         ) = 1
     localCount (:numDims+1) = (/ len(values(1, 1)), shape(values) /)
     localCount (numDims+2:) = 0
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start))  = start(:)
     if(present(count))  localCount (:size(count))  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_2D_text = &
          nf_get_varm_text(ncid, varid, localStart, localCount, localStride, localMap, values(1,1))
     else
       nf90_get_var_2D_text = &
          nf_get_vars_text(ncid, varid, localStart, localCount, localStride, values(1,1))
     end if
   end function nf90_get_var_2D_text


   function nf90_get_var_3D_text(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     character (len = *), dimension(:, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_3D_text
 
     integer, parameter                  :: numDims = 3
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                             :: counter
 
     ! Set local arguments to default values
     localStart (:         ) = 1
     localCount (:numDims+1) = (/ len(values(1, 1, 1)), shape(values) /)
     localCount (numDims+2:) = 0
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start))  = start(:)
     if(present(count))  localCount (:size(count))  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_3D_text = &
          nf_get_varm_text(ncid, varid, localStart, localCount, localStride, localMap, values(1,1,1))
     else
       nf90_get_var_3D_text = &
          nf_get_vars_text(ncid, varid, localStart, localCount, localStride, values(1,1,1))
     end if
   end function nf90_get_var_3D_text


   function nf90_get_var_4D_text(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     character (len = *), dimension(:, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_4D_text
 
     integer, parameter                  :: numDims = 4
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                             :: counter
 
     ! Set local arguments to default values
     localStart (:         ) = 1
     localCount (:numDims+1) = (/ len(values(1, 1, 1, 1)), shape(values) /)
     localCount (numDims+2:) = 0
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start))  = start(:)
     if(present(count))  localCount (:size(count))  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_4D_text = &
          nf_get_varm_text(ncid, varid, localStart, localCount, localStride, localMap, values(1,1,1,1))
     else
       nf90_get_var_4D_text = &
          nf_get_vars_text(ncid, varid, localStart, localCount, localStride, values(1,1,1,1))
     end if
   end function nf90_get_var_4D_text


   function nf90_get_var_5D_text(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     character (len = *), dimension(:, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_5D_text
 
     integer, parameter                  :: numDims = 5
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                             :: counter
 
     ! Set local arguments to default values
     localStart (:         ) = 1
     localCount (:numDims+1) = (/ len(values(1, 1, 1, 1, 1)), shape(values) /)
     localCount (numDims+2:) = 0
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start))  = start(:)
     if(present(count))  localCount (:size(count))  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_5D_text = &
          nf_get_varm_text(ncid, varid, localStart, localCount, localStride, localMap, values(1,1,1,1,1))
     else
       nf90_get_var_5D_text = &
          nf_get_vars_text(ncid, varid, localStart, localCount, localStride, values(1,1,1,1,1))
     end if
   end function nf90_get_var_5D_text


   function nf90_get_var_6D_text(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     character (len = *), dimension(:, :, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_6D_text
 
     integer, parameter                  :: numDims = 6
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                             :: counter
 
     ! Set local arguments to default values
     localStart (:         ) = 1
     localCount (:numDims+1) = (/ len(values(1, 1, 1, 1, 1, 1)), shape(values) /)
     localCount (numDims+2:) = 0
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start))  = start(:)
     if(present(count))  localCount (:size(count))  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_6D_text = &
          nf_get_varm_text(ncid, varid, localStart, localCount, localStride, localMap, values(1,1,1,1,1,1))
     else
       nf90_get_var_6D_text = &
          nf_get_vars_text(ncid, varid, localStart, localCount, localStride, values(1,1,1,1,1,1))
     end if
   end function nf90_get_var_6D_text


   function nf90_get_var_7D_text(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     character (len = *), dimension(:, :, :, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_7D_text
 
     integer, parameter                  :: numDims = 7
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                             :: counter
 
     ! Set local arguments to default values
     localStart (:         ) = 1
     localCount (:numDims+1) = (/ len(values(1, 1, 1, 1, 1, 1, 1)), shape(values) /)
     localCount (numDims+2:) = 0
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start))  = start(:)
     if(present(count))  localCount (:size(count))  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_7D_text = &
          nf_get_varm_text(ncid, varid, localStart, localCount, localStride, localMap, values(1,1,1,1,1,1,1))
     else
       nf90_get_var_7D_text = &
          nf_get_vars_text(ncid, varid, localStart, localCount, localStride, values(1,1,1,1,1,1,1))
     end if
   end function nf90_get_var_7D_text

! This is part of the netCDF F90 API, or. Copyright 2006 UCAR. See COPYRIGHT file
! for details.

! This file contains the netcdf file functions that are shared by
! netcdf-3 and netcdf-4.

! $Id: netcdf4_constants.f90,v 1.14 2010/05/25 13:53:00 ed Exp $
! -------
function nf90_inq_libvers()
  character(len = 80) :: nf90_inq_libvers

  nf90_inq_libvers = nf_inq_libvers()
end function nf90_inq_libvers
! -------
function nf90_strerror(ncerr)
  integer, intent( in) :: ncerr
  character(len = 80)  :: nf90_strerror

  nf90_strerror = nf_strerror(ncerr)
end function nf90_strerror
! -------
!
! File level control routines:
!
function nf90_inq_base_pe(ncid, pe)
  integer, intent( in) :: ncid
  integer, intent(out) :: pe
  integer              :: nf90_inq_base_pe

  nf90_inq_base_pe = nf_inq_base_pe(ncid, pe)
end function nf90_inq_base_pe
! -------
function nf90_set_base_pe(ncid, pe)
  integer, intent( in) :: ncid, pe
  integer              :: nf90_set_base_pe

  nf90_set_base_pe = nf_set_base_pe(ncid, pe)
end function nf90_set_base_pe
! -------
function nf90_create_mp(path, cmode, initalsz, basepe, chunksizehint, ncid)
  character (len = *), intent( in) :: path
  integer,             intent( in) :: cmode, initalsz, basepe, chunksizehint
  integer,             intent(out) :: ncid
  integer                          :: nf90_create_mp

  nf90_create_mp = nf__create_mp(path, cmode, initalsz, basepe, chunksizehint, ncid)
end function nf90_create_mp
! -------
function nf90_open_mp(path, mode, basepe, chunksizeint, ncid)
  character (len = *), intent( in) :: path
  integer,             intent( in) :: mode, basepe, chunksizeint
  integer,             intent(out) :: ncid
  integer                          :: nf90_open_mp

  nf90_open_mp = nf__open_mp(path, mode, basepe, chunksizeint, ncid)
end function nf90_open_mp
! -------
function nf90_set_fill(ncid, fillmode, old_mode)
  integer, intent( in) :: ncid, fillmode 
  integer, intent(out) :: old_mode
  integer              :: nf90_set_fill

  nf90_set_fill = nf_set_fill(ncid, fillmode, old_mode)
end function nf90_set_fill
! -------
function nf90_redef(ncid)
  integer, intent( in) :: ncid
  integer              :: nf90_redef

  nf90_redef = nf_redef(ncid)
end function nf90_redef
! -------
function nf90_enddef(ncid, h_minfree, v_align, v_minfree, r_align)
  integer,           intent( in) :: ncid
  integer, optional, intent( in) :: h_minfree, v_align, v_minfree, r_align
  integer                        :: nf90_enddef

  integer :: hMinFree, VAlign, VMinFree, RAlign

  if(.not. any( (/ present(h_minfree), present(v_align), &
       present(v_minfree), present(r_align) /) ) )then
     nf90_enddef = nf_enddef(ncid)
  else 
     ! Default values per the man page
     hMinFree = 0; VMinFree = 0
     VAlign   = 4; RAlign   = 4
     if(present(h_minfree)) HMinFree = h_minfree
     if(present(v_align  )) VAlign   = v_align
     if(present(v_minfree)) VMinFree = v_minfree
     if(present(r_align  )) RAlign   = r_align
     nf90_enddef = nf__enddef(ncid, hMinFree, VAlign, VMinFree, RAlign)
  end if
end function nf90_enddef
! -------
function nf90_sync(ncid)
  integer, intent( in) :: ncid
  integer              :: nf90_sync

  nf90_sync = nf_sync(ncid)
end function nf90_sync
! -------
function nf90_abort(ncid)
  integer, intent( in) :: ncid
  integer              :: nf90_abort

  nf90_abort = nf_abort(ncid)
end function nf90_abort
! -------
function nf90_close(ncid)
  integer, intent( in) :: ncid
  integer              :: nf90_close

  nf90_close = nf_close(ncid)
end function nf90_close
! -------
function nf90_delete(name)
  character(len = *), intent( in) :: name
  integer                         :: nf90_delete

  nf90_delete = nf_delete(name)
end function nf90_delete

!
! A single file level inquiry routine 
! 
function nf90_inquire(ncid, nDimensions, nVariables, nAttributes, unlimitedDimId, formatNum)
  integer,           intent( in) :: ncid
  integer, optional, intent(out) :: nDimensions, nVariables, nAttributes, unlimitedDimId, formatNum
  integer                        :: nf90_inquire

  integer :: nDims, nVars, nGAtts, unlimDimId, frmt

  nf90_inquire = nf_inq(ncid, nDims, nVars, nGAtts, unlimDimId)
  if(present(nDimensions))    nDimensions    = nDims 
  if(present(nVariables))     nVariables     = nVars
  if(present(nAttributes))    nAttributes    = nGAtts
  if(present(unlimitedDimId)) unlimitedDimId = unlimDimId
  if(present(formatNum)) then
     nf90_inquire = nf_inq_format(ncid, frmt)
     formatNum = frmt
  endif
end function nf90_inquire

function nf90_inq_path(ncid, pathlen, path)

  integer,            intent(in)    :: ncid
  integer,            intent(inout) :: pathlen
  character(len = *), intent(inout) :: path

  integer                           :: nf90_inq_path

  nf90_inq_path = nf_inq_path(ncid, pathlen, path)

end function nf90_inq_path

#ifdef LOGGING
! Function to turn on logging

! Written by: Richard Weed, Ph.D.
!             Center for Advanced Vehicular Systems
!             Mississippi State University
!             rweed@cavs.msstate.edu


! License (and other Lawyer Language)

! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Corporation for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1. May 2014 - initial implemenation
! Version 2. Jan 2016 - Fixed hanging comma in status definition

!-------------------------------- nf_set_log_level ----------------------------
 Function nf_set_log_level(new_level) Result(status)

 USE ISO_C_BINDING, ONLY: C_INT

 Implicit NONE

 Integer, Intent(IN) :: new_level

 Integer             :: status

 Integer(C_INT) :: cnew_level, cstatus

 Interface  ! define binding here instead of nc_interfaces since its conditional
  Function nc_set_log_level(new_level) BIND(C)
   USE ISO_C_BINDING, ONLY: C_INT

   Integer(C_INT), VALUE :: new_level
   Integer(C_INT)        :: nc_set_log_level
 End Function nc_set_log_level
End Interface

 cnew_level = new_level
 cstatus    = nc_set_log_level(cnew_level)

 status = cstatus

End Function nf_set_log_level

#endif

! ------------ Routines to create/open/close/redefine netcdf files ------------ 

! Replacement for fort-control.c

! Written by: Richard Weed, Ph.D.
!             Center for Advanced Vehicular Systems 
!             Mississippi State University
!             rweed@cavs.msstate.edu


! License (and other Lawyer Language)
 
! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Corporation for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1.: Sept.  2005 - Initial Cray X1 version
! Version 2.: May,   2006 - Updated to support g95
! Version 3.: April, 2009 - Updated for netcdf 4.0.1
! Version 4.: April, 2010 - Updated for netcdf 4.1.1
! Version 5.: Feb.   2013 - Added nf_inq_path support for fortran 4.4
! Vertion 6.: Nov.   2013 - Added nf_set_log_level support
! Version 7.: May,   2014 - Ensure return error status checked from C API calls
! Version 8.: Jan.,  2016 - General code cleanup. Changed name processing to
!                           reflect change in addCNullChar function. Added
!                           support for nc_open_mem
 
!-------------------------------- nf_create --------------------------------
 Function nf_create(path, cmode, ncid) RESULT (status)

! Creates a new NetCDF file given a file name and a creation mode and returns
! the file id and a status flag

 USE netcdf_nc_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN)  :: path
 Integer,          Intent(IN)  :: cmode
 Integer,          Intent(OUT) :: ncid
 
 Integer                       :: status

 Integer(C_INT)               :: ccmode, cncid, cstatus
 Character(LEN=(LEN(path)+1)) :: cpath
 Integer                      :: ie

 ccmode = cmode
 cncid  = 0
 
! Check for C null character on path and add one if not present.

 cpath = addCNullChar(path, ie)
 
! Call nc_create to create file

 cstatus = nc_create(cpath(1:ie), ccmode, cncid)
 
 If (cstatus == NC_NOERR) Then
    ncid   = cncid 
 EndIf
 status = cstatus

 End Function nf_create
!-------------------------------- nf__create -------------------------------
 Function nf__create(path, cmode, initialsz, chunksizehintp, ncid) &
                        RESULT(status)

! Creates a new NetCDF file and returns the file id and a status flag
! This is an alternate form of nf_create that allows user to input
! two additional tuning parameters

 USE netcdf_nc_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN)  :: path
 Integer,          Intent(IN)  :: cmode, initialsz, chunksizehintp
 Integer,          Intent(OUT) :: ncid
 
 Integer                       :: status

 Integer(C_INT)               :: ccmode, cncid, cstatus
 Integer(C_SIZE_T)            :: cinit, cchunk
 Character(LEN=(LEN(path)+1)) :: cpath
 Integer                      :: ie

 ccmode = cmode
 cchunk = chunksizehintp
 cinit  = initialsz
 cncid  = 0
 
! Check for C null character on path and add one if not present.

 cpath = addCNullChar(path, ie)
 
! Call nc_create to create file

 cstatus = nc__create(cpath(1:ie), ccmode, cinit, cchunk, cncid)
 
 If (cstatus == NC_NOERR) Then
    ncid   = cncid 
 EndIf
 status = cstatus

 End Function nf__create
!-------------------------------- nf__create_mp ------------------------------
 Function nf__create_mp(path, cmode, initialsz, basepe, chunksizehintp, ncid) &
                        RESULT(status)

! Creates a new NetCDF file and returns the file id and a status flag
! This is an alternate form of nf__create for shared memory MPP systems 
! plus two additional tuning parameters

 USE netcdf_nc_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN)  :: path
 Integer,          Intent(IN)  :: cmode, initialsz, chunksizehintp, basepe
 Integer,          Intent(OUT) :: ncid
 
 Integer                       :: status

 Integer(C_INT)               :: ccmode, cncid, cstatus
 Integer(C_INT), TARGET       :: cbasepe
 Integer(C_SIZE_T)            :: cinit, cchunk
 Type(C_PTR)                  :: cbasepeptr
 Character(LEN=(LEN(path)+1)) :: cpath
 Integer                      :: ie

 ccmode     = cmode
 cchunk     = chunksizehintp
 cinit      = initialsz
 cncid      = 0
 cbasepe    = basepe
 cbasepeptr = C_LOC(cbasepe)

! Check for C null character on path and add one if not present.

 cpath = addCNullChar(path, ie)
 
! Call nc_create_mp to create file for base pe

 cstatus = nc__create_mp(cpath(1:ie), ccmode, cinit, cbasepeptr, &
                         cchunk, cncid)
 
 If (cstatus == NC_NOERR) Then
    ncid   = cncid 
 EndIf
 status = cstatus

 End Function nf__create_mp
!-------------------------------- nf_open ----------------------------------
 Function nf_open(path, mode, ncid) RESULT (status)

! Open an existing NetCDF file and return file id and a status flag

 USE netcdf_nc_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN)    :: path
 Integer,          Intent(IN)    :: mode
 Integer,          Intent(INOUT) :: ncid
 
 Integer                         :: status

 Integer(C_INT)               :: cmode, cncid, cstatus
 Character(LEN=(LEN(path)+1)) :: cpath
 Integer                      :: ie

 cmode = mode
 cncid = 0
 
! Check for C null character on path and add one if not present.

 cpath = addCNullChar(path, ie) 
 
! Call nc_create to create file

 cstatus = nc_open(cpath(1:ie), cmode, cncid)
 
 If (cstatus == NC_NOERR) Then
    ncid   = cncid
 EndIf
 status = cstatus

 End Function nf_open
!-------------------------------- nf__open ---------------------------------
 Function nf__open(path, mode, chunksizehintp, ncid) RESULT (status)

! Open an existing NetCDF file and return file id and a status flag
! Alternate form of nf_open with extra tuning parameter

 USE netcdf_nc_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN)    :: path
 Integer,          Intent(IN)    :: mode, chunksizehintp
 Integer,          Intent(INOUT) :: ncid
 
 Integer                         :: status

 Integer(C_INT)               :: cmode, cncid, cstatus
 Integer(C_SIZE_T)            :: cchunk
 Character(LEN=(LEN(path)+1)) :: cpath
 Integer                      :: ie

 cmode  = mode
 cchunk = chunksizehintp
 cncid  = 0
 
! Check for C null character on path and add one if not present.

 cpath = addCNullChar(path,ie)
 
! Call nc_create to create file

 cstatus = nc__open(cpath(1:ie), cmode, cchunk, cncid)
 
 If (cstatus == NC_NOERR) Then
    ncid   = cncid
 EndIf
 status = cstatus

 End Function nf__open
!-------------------------------- nf__open_mp --------------------------------
 Function nf__open_mp(path, mode, basepe, chunksizehintp, ncid) RESULT (status)

! Open an existing NetCDF file and return file id and a status flag
! Alternate form of nf__open with parameter to designate basepe on
! shared memory MPP systems. 

 USE netcdf_nc_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN)    :: path
 Integer,          Intent(IN)    :: mode, chunksizehintp, basepe
 Integer,          Intent(INOUT) :: ncid
 
 Integer                         :: status

 Integer(C_INT)               :: cmode, cncid, cstatus
 Integer(C_INT), TARGET       :: cbasepe
 Integer(C_SIZE_T)            :: cchunk
 Type(C_PTR)                  :: cbasepeptr
 Character(LEN=(LEN(path)+1)) :: cpath
 Integer                      :: ie

 cmode      = mode
 cchunk     = chunksizehintp
 cncid      = 0
 cbasepe    = basepe
 cbasepeptr = C_LOC(cbasepe)
 
! Check for C null character on path and add one if not present.

 cpath = addCNullChar(path, ie)
 
! Call nc_create to create file

 cstatus = nc__open_mp(cpath(1:ie), cmode, cbasepeptr, cchunk, &
                       cncid)
 
 If (cstatus == NC_NOERR) Then
    ncid   = cncid
 EndIf
 status = cstatus

 End Function nf__open_mp
!-------------------------------- nf_open_mem --------------------------------
 Function nf_open_mem(path, mode, size, memory, ncid) RESULT(status)

! Open a block of memory passed as an array of C_CHAR bytes as a
! netcdf file. Note the file can only be opened as read-only

   USE netcdf_nc_interfaces

   Implicit NONE

   Character(LEN=*),       Intent(IN)           :: path
   Integer,                Intent(IN)           :: mode
   Integer,                Intent(IN)           :: size
   Character(KIND=C_CHAR), Intent(IN),   TARGET :: memory(*)
   Integer,                Intent(INOUT)        :: ncid

   Integer                            :: status
 
   Integer(C_INT)             :: cstatus, cmode, cncid
   Character(LEN=LEN(path)+1) :: cpath
   Integer(C_SIZE_T)          :: csize
   Type(C_PTR)                :: cmemoryptr

   Integer :: ie

   cpath = addCNullChar(path, ie)
   cmode = mode
   csize = size

   cmemoryptr = C_LOC(memory)

   cstatus = nc_open_mem(cpath(1:ie), cmode, csize, cmemoryptr, cncid)

   ncid = cncid

   status = cstatus
 
 End Function nf_open_mem
!-------------------------------- nf_inq_path ------------------------------
 Function nf_inq_path(ncid, pathlen, path) RESULT(status)

! Inquire about file pathname and name length

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)    :: ncid
 Integer,          Intent(INOUT) :: pathlen
 Character(LEN=*), Intent(INOUT) :: path

 Integer                         :: status

 Integer(C_INT)             :: cncid, cstatus
 Integer(C_SIZE_T)          :: cpathlen
 Character(LEN=LEN(path)+1) :: tmppath

 cncid   = ncid
 path    = REPEAT(" ", LEN(path))
 tmppath = REPEAT(" ", LEN(tmppath))

 cstatus = nc_inq_path(cncid, cpathlen, tmppath)

 If (cstatus == NC_NOERR) Then
    pathlen = int(cpathlen)
    If (pathlen > LEN(path)) pathlen = LEN(path)
    path = stripCNullchar(tmppath, pathlen)
 EndIf
 status = cstatus

 End Function nf_inq_path
!-------------------------------- nf_set_fill ------------------------------
 Function nf_set_fill(ncid, fillmode, old_mode) RESULT(status)
 
! Sets fill mode for given netcdf file returns old mode if present

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid, fillmode
 Integer, Intent(OUT) :: old_mode

 Integer              :: status

 Integer(C_INT) :: cncid, cfill, coldmode, cstatus

 cncid    = ncid
 cfill    = fillmode
 coldmode = 0

 cstatus = nc_set_fill(cncid, cfill, coldmode)

 If (cstatus == NC_NOERR) Then
    old_mode = coldmode
 EndIf
 status   = cstatus

 End Function nf_set_fill
!-------------------------------- nf_set_default_format --------------------
 Function nf_set_default_format(newform, old_format) RESULT(status)
 
! Sets new default data format. Used to toggle between 64 bit offset and
! classic mode 

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: newform 
 Integer, Intent(OUT) :: old_format

 Integer              :: status

 Integer(C_INT) :: cnew, cold, cstatus

 cnew = newform

 cstatus = nc_set_default_format(cnew,cold)

 If (cstatus == NC_NOERR) Then
    old_format = cold
 EndIf
 status     = cstatus

 End Function nf_set_default_format
!-------------------------------- nf_redef ---------------------------------
 Function nf_redef(ncid) RESULT(status)
 
! Reenter definition mode for NetCDF file id ncid 

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN) :: ncid

 Integer             :: status

 Integer(C_INT) :: cncid, cstatus

 cncid = ncid

 cstatus = nc_redef(cncid)

 status = cstatus

 End Function nf_redef
!-------------------------------- nf_enddef --------------------------------
 Function nf_enddef(ncid) RESULT(status)
 
! Exit definition mode for NetCDF file id ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN) :: ncid

 Integer             :: status

 Integer(C_INT) :: cncid, cstatus

 cncid = ncid

 cstatus = nc_enddef(cncid)

 status = cstatus

 End Function nf_enddef
!-------------------------------- nf__enddef -------------------------------
 Function nf__enddef(ncid, h_minfree, v_align, v_minfree, r_align) &
                     RESULT(status)
 
! Exit definition mode for NetCDF file id ncid. Alternate version
! with additional tuning parameters

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN) :: ncid, h_minfree, v_align, v_minfree, r_align

 Integer             :: status

 Integer(C_INT)    :: cncid, cstatus
 Integer(C_SIZE_T) :: chminfree, cvalign, cvminfree, cralign

 cncid     = ncid
 chminfree = h_minfree
 cvalign   = v_align
 cvminfree = v_minfree
 cralign   = r_align

 cstatus = nc__enddef(cncid, chminfree, cvalign, cvminfree, cralign)

 status = cstatus

 End Function nf__enddef
!-------------------------------- nf_sync ----------------------------------
 Function nf_sync(ncid) RESULT(status)
 
! synch up all open NetCDF files 

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN) :: ncid

 Integer             :: status

 Integer(C_INT) :: cncid, cstatus

 cncid = ncid

 cstatus = nc_sync(cncid)

 status = cstatus

 End Function nf_sync
!-------------------------------- nf_abort ---------------------------------
 Function nf_abort(ncid) RESULT(status)
 
! Abort netCDF file creation and exit 

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN) :: ncid

 Integer             :: status

 Integer(C_INT) :: cncid, cstatus

 cncid = ncid

 cstatus = nc_abort(cncid)

 status = cstatus

 End Function nf_abort
!-------------------------------- nf_close ---------------------------------
 Function nf_close(ncid) RESULT(status)
 
! Close netCDF file id ncid 

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN) :: ncid

 Integer             :: status

 Integer(C_INT) :: cncid, cstatus

 cncid   = ncid

 cstatus = nc_close(cncid)

 status  = cstatus

 End Function nf_close
!-------------------------------- nf_delete --------------------------------
 Function nf_delete(path) RESULT(status)
 
! Delete netCDF file id ncid 

 USE netcdf_nc_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN) :: path

 Integer                      :: status

 Integer(C_INT)               :: cstatus
 Character(LEN=(LEN(path)+1)) :: cpath
 Integer                      :: ie

! Check for C null character on path and add one if not present.

 cpath = addCNullChar(path,ie)
 
 cstatus = nc_delete(cpath(1:ie))

 status = cstatus

 End Function nf_delete
!-------------------------------- nf_delete_mp -------------------------------
 Function nf_delete_mp(path, pe) RESULT(status)
 
! Delete netCDF file id ncid. Alternate form of nf_delete for shared memory
! MPP systems.

 USE netcdf_nc_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN) :: path
 Integer,          Intent(IN) :: pe

 Integer                      :: status

 Integer(C_INT)               :: cstatus, cpe
 Character(LEN=(LEN(path)+1)) :: cpath
 Integer                      :: ie

 cpe = pe

! Check for C null character on path and add one if not present.

 cpath = addCNullChar(path,ie)
 
 cstatus = nc_delete_mp(cpath(1:ie), cpe)

 status = cstatus

 End Function nf_delete_mp
!-------------------------------- nf_set_base_pe ------------------------------
 Function nf_set_base_pe(ncid, pe) RESULT(status)

! Sets base pe number on shared memory MPP systems

 Use netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN) :: ncid, pe

 Integer             :: status

 Integer(C_INT) :: cncid, cpe, cstatus

 cncid = ncid
 cpe   = pe

 cstatus = nc_set_base_pe(cncid, cpe)

 status = cstatus

 End Function nf_set_base_pe
!-------------------------------- nf_inq_base_pe ------------------------------
 Function nf_inq_base_pe(ncid, pe) RESULT(status)

! Gets previously set base pe number on shared memory MPP systems

 Use netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid
 Integer, Intent(OUT) :: pe

 Integer              :: status

 Integer(C_INT) :: cncid, cpe, cstatus

 cncid = ncid

 cstatus = nc_inq_base_pe(cncid, cpe)

 If (cstatus == NC_NOERR) Then
    pe     = cpe
 EndIf
 status = cstatus

End Function nf_inq_base_pe

   function nf90_put_var_OneByteInt(ncid, varid, values, start)
     integer,                         intent( in) :: ncid, varid
     integer (kind = OneByteInt), intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start
     integer                                      :: nf90_put_var_OneByteInt
 
     integer, dimension(nf90_max_var_dims) :: localIndex

     ! Set local arguments to default values
     localIndex(:) = 1
     if(present(start)) localIndex(:size(start)) = start(:)
 
     nf90_put_var_OneByteInt = nf_put_var1_int1(ncid, varid, localIndex, values)
   end function nf90_put_var_OneByteInt


   function nf90_put_var_TwoByteInt(ncid, varid, values, start)
     integer,                         intent( in) :: ncid, varid
     integer (kind = TwoByteInt), intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start
     integer                                      :: nf90_put_var_TwoByteInt
 
     integer, dimension(nf90_max_var_dims) :: localIndex

     ! Set local arguments to default values
     localIndex(:) = 1
     if(present(start)) localIndex(:size(start)) = start(:)
 
     nf90_put_var_TwoByteInt = nf_put_var1_int2(ncid, varid, localIndex, values)
   end function nf90_put_var_TwoByteInt


   function nf90_put_var_FourByteInt(ncid, varid, values, start)
     integer,                         intent( in) :: ncid, varid
     integer (kind = FourByteInt), intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start
     integer                                      :: nf90_put_var_FourByteInt
 
     integer, dimension(nf90_max_var_dims) :: localIndex

     ! Set local arguments to default values
     localIndex(:) = 1
     if(present(start)) localIndex(:size(start)) = start(:)
 
     nf90_put_var_FourByteInt = nf_put_var1_int(ncid, varid, localIndex, int(values))
   end function nf90_put_var_FourByteInt


   function nf90_put_var_FourByteReal(ncid, varid, values, start)
     integer,                         intent( in) :: ncid, varid
     real (kind = FourByteReal), intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start
     integer                                      :: nf90_put_var_FourByteReal
 
     integer, dimension(nf90_max_var_dims) :: localIndex

     ! Set local arguments to default values
     localIndex(:) = 1
     if(present(start)) localIndex(:size(start)) = start(:)
 
     nf90_put_var_FourByteReal = nf_put_var1_real(ncid, varid, localIndex, values)
   end function nf90_put_var_FourByteReal


   function nf90_put_var_EightByteReal(ncid, varid, values, start)
     integer,                         intent( in) :: ncid, varid
     real (kind = EightByteReal), intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start
     integer                                      :: nf90_put_var_EightByteReal
 
     integer, dimension(nf90_max_var_dims) :: localIndex

     ! Set local arguments to default values
     localIndex(:) = 1
     if(present(start)) localIndex(:size(start)) = start(:)
 
     nf90_put_var_EightByteReal = nf_put_var1_double(ncid, varid, localIndex, values)
   end function nf90_put_var_EightByteReal


   function nf90_get_var_OneByteInt(ncid, varid, values, start)
     integer,                         intent( in) :: ncid, varid
     integer (kind = OneByteInt), intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start
     integer                                      :: nf90_get_var_OneByteInt
 
     integer, dimension(nf90_max_var_dims) :: localIndex

     ! Set local arguments to default values
     localIndex(:) = 1
     if(present(start)) localIndex(:size(start)) = start(:)
 
     nf90_get_var_OneByteInt = nf_get_var1_int1(ncid, varid, localIndex, values)
   end function nf90_get_var_OneByteInt


   function nf90_get_var_TwoByteInt(ncid, varid, values, start)
     integer,                         intent( in) :: ncid, varid
     integer (kind = TwoByteInt), intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start
     integer                                      :: nf90_get_var_TwoByteInt
 
     integer, dimension(nf90_max_var_dims) :: localIndex

     ! Set local arguments to default values
     localIndex(:) = 1
     if(present(start)) localIndex(:size(start)) = start(:)
 
     nf90_get_var_TwoByteInt = nf_get_var1_int2(ncid, varid, localIndex, values)
   end function nf90_get_var_TwoByteInt


   function nf90_get_var_FourByteInt(ncid, varid, values, start)
     integer,                         intent( in) :: ncid, varid
     integer (kind = FourByteInt), intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start
     integer                                      :: nf90_get_var_FourByteInt
 
     integer, dimension(nf90_max_var_dims) :: localIndex
     integer                               :: defaultInteger
     
     ! Set local arguments to default values
     localIndex(:) = 1
     if(present(start)) localIndex(:size(start)) = start(:)
 
     nf90_get_var_FourByteInt = nf_get_var1_int(ncid, varid, localIndex, defaultInteger)
     values = defaultInteger
   end function nf90_get_var_FourByteInt


   function nf90_get_var_FourByteReal(ncid, varid, values, start)
     integer,                         intent( in) :: ncid, varid
     real (kind = FourByteReal), intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start
     integer                                      :: nf90_get_var_FourByteReal
 
     integer, dimension(nf90_max_var_dims) :: localIndex

     ! Set local arguments to default values
     localIndex(:) = 1
     if(present(start)) localIndex(:size(start)) = start(:)
 
     nf90_get_var_FourByteReal = nf_get_var1_real(ncid, varid, localIndex, values)
   end function nf90_get_var_FourByteReal


   function nf90_get_var_EightByteReal(ncid, varid, values, start)
     integer,                         intent( in) :: ncid, varid
     real (kind = EightByteReal), intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start
     integer                                      :: nf90_get_var_EightByteReal
 
     integer, dimension(nf90_max_var_dims) :: localIndex

     ! Set local arguments to default values
     localIndex(:) = 1
     if(present(start)) localIndex(:size(start)) = start(:)
 
     nf90_get_var_EightByteReal = nf_get_var1_double(ncid, varid, localIndex, values)
   end function nf90_get_var_EightByteReal



   function nf90_put_var_1D_OneByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = OneByteInt), dimension(:), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_1D_OneByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_1D_OneByteInt = &
          nf_put_varm_int1(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_1D_OneByteInt = &
          nf_put_vars_int1(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_1D_OneByteInt = &
          nf_put_vara_int1(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_1D_OneByteInt


   function nf90_put_var_2D_OneByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = OneByteInt), dimension(:, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_2D_OneByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_2D_OneByteInt = &
          nf_put_varm_int1(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_2D_OneByteInt = &
          nf_put_vars_int1(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_2D_OneByteInt = &
          nf_put_vara_int1(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_2D_OneByteInt


   function nf90_put_var_3D_OneByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = OneByteInt), dimension(:, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_3D_OneByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_3D_OneByteInt = &
          nf_put_varm_int1(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_3D_OneByteInt = &
          nf_put_vars_int1(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_3D_OneByteInt = &
          nf_put_vara_int1(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_3D_OneByteInt


   function nf90_put_var_4D_OneByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = OneByteInt), dimension(:, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_4D_OneByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_4D_OneByteInt = &
          nf_put_varm_int1(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_4D_OneByteInt = &
          nf_put_vars_int1(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_4D_OneByteInt = &
          nf_put_vara_int1(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_4D_OneByteInt


   function nf90_put_var_5D_OneByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = OneByteInt), dimension(:, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_5D_OneByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_5D_OneByteInt = &
          nf_put_varm_int1(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_5D_OneByteInt = &
          nf_put_vars_int1(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_5D_OneByteInt = &
          nf_put_vara_int1(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_5D_OneByteInt


   function nf90_put_var_6D_OneByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = OneByteInt), dimension(:, :, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_6D_OneByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_6D_OneByteInt = &
          nf_put_varm_int1(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_6D_OneByteInt = &
          nf_put_vars_int1(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_6D_OneByteInt = &
          nf_put_vara_int1(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_6D_OneByteInt


   function nf90_put_var_7D_OneByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = OneByteInt), dimension(:, :, :, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_7D_OneByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_7D_OneByteInt = &
          nf_put_varm_int1(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_7D_OneByteInt = &
          nf_put_vars_int1(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_7D_OneByteInt = &
          nf_put_vara_int1(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_7D_OneByteInt


   function nf90_put_var_1D_TwoByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = TwoByteInt), dimension(:), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_1D_TwoByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_1D_TwoByteInt = &
          nf_put_varm_int2(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_1D_TwoByteInt = &
          nf_put_vars_int2(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_1D_TwoByteInt = &
          nf_put_vara_int2(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_1D_TwoByteInt


   function nf90_put_var_2D_TwoByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = TwoByteInt), dimension(:, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_2D_TwoByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_2D_TwoByteInt = &
          nf_put_varm_int2(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_2D_TwoByteInt = &
          nf_put_vars_int2(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_2D_TwoByteInt = &
          nf_put_vara_int2(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_2D_TwoByteInt


   function nf90_put_var_3D_TwoByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = TwoByteInt), dimension(:, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_3D_TwoByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_3D_TwoByteInt = &
          nf_put_varm_int2(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_3D_TwoByteInt = &
          nf_put_vars_int2(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_3D_TwoByteInt = &
          nf_put_vara_int2(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_3D_TwoByteInt


   function nf90_put_var_4D_TwoByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = TwoByteInt), dimension(:, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_4D_TwoByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_4D_TwoByteInt = &
          nf_put_varm_int2(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_4D_TwoByteInt = &
          nf_put_vars_int2(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_4D_TwoByteInt = &
          nf_put_vara_int2(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_4D_TwoByteInt


   function nf90_put_var_5D_TwoByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = TwoByteInt), dimension(:, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_5D_TwoByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_5D_TwoByteInt = &
          nf_put_varm_int2(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_5D_TwoByteInt = &
          nf_put_vars_int2(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_5D_TwoByteInt = &
          nf_put_vara_int2(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_5D_TwoByteInt


   function nf90_put_var_6D_TwoByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = TwoByteInt), dimension(:, :, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_6D_TwoByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_6D_TwoByteInt = &
          nf_put_varm_int2(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_6D_TwoByteInt = &
          nf_put_vars_int2(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_6D_TwoByteInt = &
          nf_put_vara_int2(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_6D_TwoByteInt


   function nf90_put_var_7D_TwoByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = TwoByteInt), dimension(:, :, :, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_7D_TwoByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_7D_TwoByteInt = &
          nf_put_varm_int2(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_7D_TwoByteInt = &
          nf_put_vars_int2(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_7D_TwoByteInt = &
          nf_put_vara_int2(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_7D_TwoByteInt


   function nf90_put_var_1D_FourByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = FourByteInt), dimension(:), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_1D_FourByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_1D_FourByteInt = &
          nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
       nf90_put_var_1D_FourByteInt = &
          nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
       nf90_put_var_1D_FourByteInt = &
          nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
     end if
   end function nf90_put_var_1D_FourByteInt


   function nf90_put_var_2D_FourByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = FourByteInt), dimension(:, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_2D_FourByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
        localMap   (:size(map))    = map(:)
        nf90_put_var_2D_FourByteInt = &
             nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
        nf90_put_var_2D_FourByteInt = &
             nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
        nf90_put_var_2D_FourByteInt = &
             nf_put_vara_int(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_2D_FourByteInt


   function nf90_put_var_3D_FourByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = FourByteInt), dimension(:, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_3D_FourByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_3D_FourByteInt = &
          nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
       nf90_put_var_3D_FourByteInt = &
          nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
       nf90_put_var_3D_FourByteInt = &
          nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
     end if
   end function nf90_put_var_3D_FourByteInt


   function nf90_put_var_4D_FourByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = FourByteInt), dimension(:, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_4D_FourByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_4D_FourByteInt = &
          nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
       nf90_put_var_4D_FourByteInt = &
          nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
       nf90_put_var_4D_FourByteInt = &
          nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
     end if
   end function nf90_put_var_4D_FourByteInt


   function nf90_put_var_5D_FourByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = FourByteInt), dimension(:, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_5D_FourByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_5D_FourByteInt = &
          nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
       nf90_put_var_5D_FourByteInt = &
          nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
       nf90_put_var_5D_FourByteInt = &
          nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
     end if
   end function nf90_put_var_5D_FourByteInt


   function nf90_put_var_6D_FourByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = FourByteInt), dimension(:, :, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_6D_FourByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_6D_FourByteInt = &
          nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
       nf90_put_var_6D_FourByteInt = &
          nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
       nf90_put_var_6D_FourByteInt = &
          nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
     end if
   end function nf90_put_var_6D_FourByteInt


   function nf90_put_var_7D_FourByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = FourByteInt), dimension(:, :, :, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_7D_FourByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_7D_FourByteInt = &
          nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
       nf90_put_var_7D_FourByteInt = &
          nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
       nf90_put_var_7D_FourByteInt = &
          nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
     end if
   end function nf90_put_var_7D_FourByteInt


    function nf90_put_var_1D_FourByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = FourByteReal), dimension(:), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_1D_FourByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_1D_FourByteReal = &
          nf_put_varm_real(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_1D_FourByteReal = &
          nf_put_vars_real(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_1D_FourByteReal = &
          nf_put_vara_real(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_1D_FourByteReal


   function nf90_put_var_2D_FourByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = FourByteReal), dimension(:, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_2D_FourByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_2D_FourByteReal = &
          nf_put_varm_real(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_2D_FourByteReal = &
          nf_put_vars_real(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_2D_FourByteReal = &
          nf_put_vara_real(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_2D_FourByteReal


   function nf90_put_var_3D_FourByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = FourByteReal), dimension(:, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_3D_FourByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_3D_FourByteReal = &
          nf_put_varm_real(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_3D_FourByteReal = &
          nf_put_vars_real(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_3D_FourByteReal = &
          nf_put_vara_real(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_3D_FourByteReal


   function nf90_put_var_4D_FourByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = FourByteReal), dimension(:, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_4D_FourByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_4D_FourByteReal = &
          nf_put_varm_real(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_4D_FourByteReal = &
          nf_put_vars_real(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_4D_FourByteReal = &
          nf_put_vara_real(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_4D_FourByteReal


   function nf90_put_var_5D_FourByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = FourByteReal), dimension(:, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_5D_FourByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_5D_FourByteReal = &
          nf_put_varm_real(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_5D_FourByteReal = &
          nf_put_vars_real(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_5D_FourByteReal = &
          nf_put_vara_real(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_5D_FourByteReal


   function nf90_put_var_6D_FourByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = FourByteReal), dimension(:, :, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_6D_FourByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_6D_FourByteReal = &
          nf_put_varm_real(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_6D_FourByteReal = &
          nf_put_vars_real(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_6D_FourByteReal = &
          nf_put_vara_real(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_6D_FourByteReal


   function nf90_put_var_7D_FourByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = FourByteReal), dimension(:, :, :, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_7D_FourByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_7D_FourByteReal = &
          nf_put_varm_real(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_7D_FourByteReal = &
          nf_put_vars_real(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_7D_FourByteReal = &
          nf_put_vara_real(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_7D_FourByteReal


   function nf90_put_var_1D_EightByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = EightByteReal), dimension(:), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_1D_EightByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_1D_EightByteReal = &
          nf_put_varm_double(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_1D_EightByteReal = &
          nf_put_vars_double(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_1D_EightByteReal = &
          nf_put_vara_double(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_1D_EightByteReal


   function nf90_put_var_2D_EightByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = EightByteReal), dimension(:, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_2D_EightByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_2D_EightByteReal = &
          nf_put_varm_double(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_2D_EightByteReal = &
          nf_put_vars_double(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_2D_EightByteReal = &
          nf_put_vara_double(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_2D_EightByteReal


   function nf90_put_var_3D_EightByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = EightByteReal), dimension(:, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_3D_EightByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_3D_EightByteReal = &
          nf_put_varm_double(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_3D_EightByteReal = &
          nf_put_vars_double(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_3D_EightByteReal = &
          nf_put_vara_double(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_3D_EightByteReal


   function nf90_put_var_4D_EightByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = EightByteReal), dimension(:, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_4D_EightByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_4D_EightByteReal = &
          nf_put_varm_double(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_4D_EightByteReal = &
          nf_put_vars_double(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_4D_EightByteReal = &
          nf_put_vara_double(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_4D_EightByteReal


   function nf90_put_var_5D_EightByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = EightByteReal), dimension(:, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_5D_EightByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_5D_EightByteReal = &
          nf_put_varm_double(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_5D_EightByteReal = &
          nf_put_vars_double(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_5D_EightByteReal = &
          nf_put_vara_double(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_5D_EightByteReal


   function nf90_put_var_6D_EightByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = EightByteReal), dimension(:, :, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_6D_EightByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_6D_EightByteReal = &
          nf_put_varm_double(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_6D_EightByteReal = &
          nf_put_vars_double(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_6D_EightByteReal = &
          nf_put_vara_double(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_6D_EightByteReal


   function nf90_put_var_7D_EightByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = EightByteReal), dimension(:, :, :, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_7D_EightByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_7D_EightByteReal = &
          nf_put_varm_double(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_put_var_7D_EightByteReal = &
          nf_put_vars_double(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_put_var_7D_EightByteReal = &
          nf_put_vara_double(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_put_var_7D_EightByteReal


   function nf90_get_var_1D_OneByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = OneByteInt), dimension(:), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_1D_OneByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_1D_OneByteInt = &
          nf_get_varm_int1(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_1D_OneByteInt = &
          nf_get_vars_int1(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_1D_OneByteInt = &
          nf_get_vara_int1(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_1D_OneByteInt


   function nf90_get_var_2D_OneByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = OneByteInt), dimension(:, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_2D_OneByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_2D_OneByteInt = &
          nf_get_varm_int1(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_2D_OneByteInt = &
          nf_get_vars_int1(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_2D_OneByteInt = &
          nf_get_vara_int1(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_2D_OneByteInt


   function nf90_get_var_3D_OneByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = OneByteInt), dimension(:, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_3D_OneByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_3D_OneByteInt = &
          nf_get_varm_int1(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_3D_OneByteInt = &
          nf_get_vars_int1(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_3D_OneByteInt = &
          nf_get_vara_int1(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_3D_OneByteInt


   function nf90_get_var_4D_OneByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = OneByteInt), dimension(:, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_4D_OneByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_4D_OneByteInt = &
          nf_get_varm_int1(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_4D_OneByteInt = &
          nf_get_vars_int1(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_4D_OneByteInt = &
          nf_get_vara_int1(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_4D_OneByteInt


   function nf90_get_var_5D_OneByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = OneByteInt), dimension(:, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_5D_OneByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_5D_OneByteInt = &
          nf_get_varm_int1(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_5D_OneByteInt = &
          nf_get_vars_int1(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_5D_OneByteInt = &
          nf_get_vara_int1(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_5D_OneByteInt


   function nf90_get_var_6D_OneByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = OneByteInt), dimension(:, :, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_6D_OneByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_6D_OneByteInt = &
          nf_get_varm_int1(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_6D_OneByteInt = &
          nf_get_vars_int1(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_6D_OneByteInt = &
          nf_get_vara_int1(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_6D_OneByteInt


   function nf90_get_var_7D_OneByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = OneByteInt), dimension(:, :, :, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_7D_OneByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_7D_OneByteInt = &
          nf_get_varm_int1(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_7D_OneByteInt = &
          nf_get_vars_int1(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_7D_OneByteInt = &
          nf_get_vara_int1(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_7D_OneByteInt


   function nf90_get_var_1D_TwoByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = TwoByteInt), dimension(:), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_1D_TwoByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_1D_TwoByteInt = &
          nf_get_varm_int2(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_1D_TwoByteInt = &
          nf_get_vars_int2(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_1D_TwoByteInt = &
          nf_get_vara_int2(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_1D_TwoByteInt


   function nf90_get_var_2D_TwoByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = TwoByteInt), dimension(:, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_2D_TwoByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_2D_TwoByteInt = &
          nf_get_varm_int2(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_2D_TwoByteInt = &
          nf_get_vars_int2(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_2D_TwoByteInt = &
          nf_get_vara_int2(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_2D_TwoByteInt


   function nf90_get_var_3D_TwoByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = TwoByteInt), dimension(:, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_3D_TwoByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_3D_TwoByteInt = &
          nf_get_varm_int2(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_3D_TwoByteInt = &
          nf_get_vars_int2(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_3D_TwoByteInt = &
          nf_get_vara_int2(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_3D_TwoByteInt


   function nf90_get_var_4D_TwoByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = TwoByteInt), dimension(:, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_4D_TwoByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_4D_TwoByteInt = &
          nf_get_varm_int2(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_4D_TwoByteInt = &
          nf_get_vars_int2(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_4D_TwoByteInt = &
          nf_get_vara_int2(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_4D_TwoByteInt


   function nf90_get_var_5D_TwoByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = TwoByteInt), dimension(:, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_5D_TwoByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_5D_TwoByteInt = &
          nf_get_varm_int2(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_5D_TwoByteInt = &
          nf_get_vars_int2(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_5D_TwoByteInt = &
          nf_get_vara_int2(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_5D_TwoByteInt


   function nf90_get_var_6D_TwoByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = TwoByteInt), dimension(:, :, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_6D_TwoByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_6D_TwoByteInt = &
          nf_get_varm_int2(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_6D_TwoByteInt = &
          nf_get_vars_int2(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_6D_TwoByteInt = &
          nf_get_vara_int2(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_6D_TwoByteInt


   function nf90_get_var_7D_TwoByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = TwoByteInt), dimension(:, :, :, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_7D_TwoByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_7D_TwoByteInt = &
          nf_get_varm_int2(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_7D_TwoByteInt = &
          nf_get_vars_int2(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_7D_TwoByteInt = &
          nf_get_vara_int2(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_7D_TwoByteInt


   function nf90_get_var_1D_FourByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = FourByteInt), dimension(:), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_1D_FourByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
     integer, dimension(size(values))      :: defaultIntArray
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_1D_FourByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_1D_FourByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_1D_FourByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:) = reshape(defaultIntArray(:), shape(values))
   end function nf90_get_var_1D_FourByteInt


   function nf90_get_var_2D_FourByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = FourByteInt), dimension(:, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_2D_FourByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
     integer, dimension(size(values))      :: defaultIntArray
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_2D_FourByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_2D_FourByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_2D_FourByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:, :) = reshape(defaultIntArray(:), shape(values))
   end function nf90_get_var_2D_FourByteInt


   function nf90_get_var_3D_FourByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = FourByteInt), dimension(:, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_3D_FourByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
     integer, dimension(size(values))      :: defaultIntArray
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_3D_FourByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_3D_FourByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_3D_FourByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:, :, :) = reshape(defaultIntArray(:), shape(values))
   end function nf90_get_var_3D_FourByteInt


   function nf90_get_var_4D_FourByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = FourByteInt), dimension(:, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_4D_FourByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
     integer, dimension(size(values))      :: defaultIntArray
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_4D_FourByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_4D_FourByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_4D_FourByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:, :, :, :) = reshape(defaultIntArray(:), shape(values))
   end function nf90_get_var_4D_FourByteInt


   function nf90_get_var_5D_FourByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = FourByteInt), dimension(:, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_5D_FourByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
     integer, dimension(size(values))      :: defaultIntArray
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_5D_FourByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_5D_FourByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_5D_FourByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:, :, :, :, :) = reshape(defaultIntArray(:), shape(values))
   end function nf90_get_var_5D_FourByteInt


   function nf90_get_var_6D_FourByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = FourByteInt), dimension(:, :, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_6D_FourByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
     integer, dimension(size(values))      :: defaultIntArray
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_6D_FourByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_6D_FourByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_6D_FourByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:, :, :, :, :, :) = reshape(defaultIntArray(:), shape(values))
   end function nf90_get_var_6D_FourByteInt


   function nf90_get_var_7D_FourByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = FourByteInt), dimension(:, :, :, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_7D_FourByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
     integer, dimension(size(values))      :: defaultIntArray
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_7D_FourByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_7D_FourByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_7D_FourByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:, :, :, :, :, :, :) = reshape(defaultIntArray(:), shape(values))
   end function nf90_get_var_7D_FourByteInt


   function nf90_get_var_1D_FourByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = FourByteReal), dimension(:), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_1D_FourByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_1D_FourByteReal = &
          nf_get_varm_real(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_1D_FourByteReal = &
          nf_get_vars_real(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_1D_FourByteReal = &
          nf_get_vara_real(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_1D_FourByteReal


   function nf90_get_var_2D_FourByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = FourByteReal), dimension(:, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_2D_FourByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_2D_FourByteReal = &
          nf_get_varm_real(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_2D_FourByteReal = &
          nf_get_vars_real(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_2D_FourByteReal = &
          nf_get_vara_real(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_2D_FourByteReal


   function nf90_get_var_3D_FourByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = FourByteReal), dimension(:, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_3D_FourByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_3D_FourByteReal = &
          nf_get_varm_real(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_3D_FourByteReal = &
          nf_get_vars_real(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_3D_FourByteReal = &
          nf_get_vara_real(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_3D_FourByteReal


   function nf90_get_var_4D_FourByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = FourByteReal), dimension(:, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_4D_FourByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_4D_FourByteReal = &
          nf_get_varm_real(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_4D_FourByteReal = &
          nf_get_vars_real(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_4D_FourByteReal = &
          nf_get_vara_real(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_4D_FourByteReal


   function nf90_get_var_5D_FourByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = FourByteReal), dimension(:, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_5D_FourByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_5D_FourByteReal = &
          nf_get_varm_real(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_5D_FourByteReal = &
          nf_get_vars_real(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_5D_FourByteReal = &
          nf_get_vara_real(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_5D_FourByteReal


   function nf90_get_var_6D_FourByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = FourByteReal), dimension(:, :, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_6D_FourByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_6D_FourByteReal = &
          nf_get_varm_real(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_6D_FourByteReal = &
          nf_get_vars_real(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_6D_FourByteReal = &
          nf_get_vara_real(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_6D_FourByteReal


   function nf90_get_var_7D_FourByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = FourByteReal), dimension(:, :, :, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_7D_FourByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_7D_FourByteReal = &
          nf_get_varm_real(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_7D_FourByteReal = &
          nf_get_vars_real(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_7D_FourByteReal = &
          nf_get_vara_real(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_7D_FourByteReal


   function nf90_get_var_1D_EightByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = EightByteReal), dimension(:), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_1D_EightByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_1D_EightByteReal = &
          nf_get_varm_double(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_1D_EightByteReal = &
          nf_get_vars_double(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_1D_EightByteReal = &
          nf_get_vara_double(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_1D_EightByteReal


   function nf90_get_var_2D_EightByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = EightByteReal), dimension(:, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_2D_EightByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_2D_EightByteReal = &
          nf_get_varm_double(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_2D_EightByteReal = &
          nf_get_vars_double(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_2D_EightByteReal = &
          nf_get_vara_double(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_2D_EightByteReal


   function nf90_get_var_3D_EightByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = EightByteReal), dimension(:, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_3D_EightByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_3D_EightByteReal = &
          nf_get_varm_double(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_3D_EightByteReal = &
          nf_get_vars_double(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_3D_EightByteReal = &
          nf_get_vara_double(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_3D_EightByteReal


   function nf90_get_var_4D_EightByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = EightByteReal), dimension(:, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_4D_EightByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_4D_EightByteReal = &
          nf_get_varm_double(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_4D_EightByteReal = &
          nf_get_vars_double(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_4D_EightByteReal = &
          nf_get_vara_double(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_4D_EightByteReal


   function nf90_get_var_5D_EightByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = EightByteReal), dimension(:, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_5D_EightByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_5D_EightByteReal = &
          nf_get_varm_double(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_5D_EightByteReal = &
          nf_get_vars_double(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_5D_EightByteReal = &
          nf_get_vara_double(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_5D_EightByteReal


   function nf90_get_var_6D_EightByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = EightByteReal), dimension(:, :, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_6D_EightByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_6D_EightByteReal = &
          nf_get_varm_double(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_6D_EightByteReal = &
          nf_get_vars_double(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_6D_EightByteReal = &
          nf_get_vara_double(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_6D_EightByteReal


   function nf90_get_var_7D_EightByteReal(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     real (kind = EightByteReal), dimension(:, :, :, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_7D_EightByteReal
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_7D_EightByteReal = &
          nf_get_varm_double(ncid, varid, localStart, localCount, localStride, localMap, values)
     else if(present(stride)) then
       nf90_get_var_7D_EightByteReal = &
          nf_get_vars_double(ncid, varid, localStart, localCount, localStride, values)
     else
       nf90_get_var_7D_EightByteReal = &
          nf_get_vara_double(ncid, varid, localStart, localCount, values)
     end if
   end function nf90_get_var_7D_EightByteReal

!---------- Routines for defining and obtaining info about attributes --------

! Replacement for fort-genatt.c

! Written by: Richard Weed, Ph.D.
!             Center for Advanced Vehicular Systems 
!             Mississippi State University
!             rweed@cavs.msstate.edu

! License (and other Lawyer Language)
 
! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Corporation for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1.: Sept. 2005 - Initial Cray X1 version
! Version 2.: May   2006 - Updated to support g95
! Version 3.: April 2009 - Updated for netCDF 4.0.1
! Version 4.: April 2010 - Updated for netCDF 4.1.1
! Version 5.: May   2014 - Ensure return error status checked from C API calls          
         
!-------------------------------- nf_inq_att ---------------------------------
 Function nf_inq_att(ncid, varid, name, xtype, nlen) RESULT(status)

! Get attribute data type and length for a given varid and name

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: nlen, xtype

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, cstatus, cvarid
 Integer(KIND=C_SIZE_T)       :: cnlen
 Integer(KIND=C_INT)          :: cxtype
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

! Check to see if a C null character was added to name in calling program

 cname = addCNullChar(name, ie)

 cstatus = nc_inq_att(cncid, cvarid, cname(1:ie+1), cxtype, cnlen)

 If (cstatus == NC_NOERR) Then
    xtype = cxtype
    nlen  = cnlen
 EndIf
 status = cstatus

 End Function nf_inq_att
!-------------------------------- nf_inq_atttype ---------------------------
 Function nf_inq_atttype(ncid, varid, name, xtype) RESULT(status)

! Get attribute type for a given varid and name

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: xtype

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, cstatus, cvarid
 Integer(KIND=C_INT)          :: cxtype
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

! Check to see if a C null character was added to name in calling program

 cname = addCNullChar(name, ie)

 cstatus = nc_inq_atttype(cncid, cvarid, cname(1:ie+1), cxtype)

 If (cstatus == NC_NOERR) Then
    xtype = cxtype
 EndIf
 status = cstatus

 End Function nf_inq_atttype
!-------------------------------- nf_inq_attlen ----------------------------
 Function nf_inq_attlen(ncid, varid, name, nlen) RESULT(status)

! Get attribute length for a given varid and name

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: nlen

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, cstatus, cvarid
 Integer(KIND=C_SIZE_T)       :: cnlen
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

! Check to see if a C null character was added to name in calling program

 cname = addCNullChar(name, ie)

 cstatus = nc_inq_attlen(cncid, cvarid, cname(1:ie+1), cnlen)

 If (cstatus == NC_NOERR) Then
    nlen = cnlen
 EndIf
 status = cstatus

 End Function nf_inq_attlen
!-------------------------------- nf_inq_attid -----------------------------
 Function nf_inq_attid(ncid, varid, name, attnum) RESULT(status)

! Get attribute id for a given varid and name

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: attnum

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, cstatus, cattnum, cvarid
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

! Check to see if a C null character was added to name in calling program

 cname = addCNullChar(name, ie)

 cstatus = nc_inq_attid(cncid, cvarid, cname(1:ie+1), cattnum)
 
 If (cstatus == NC_NOERR) Then
    attnum = cattnum + 1 ! add 1 to get FORTRAN att id
 EndIf
 status = cstatus

 End Function nf_inq_attid
!-------------------------------- nf_inq_attname ---------------------------
 Function nf_inq_attname(ncid, varid, attnum, name) RESULT(status)

! Get attribute name for a given varid and attribute number

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid, attnum
 Character(LEN=*), Intent(OUT) :: name

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, cstatus, cattnum, cvarid
 Character(LEN=(LEN(name)+1)) :: tmpname
 Integer                      :: nlen

 cncid   = ncid
 cvarid  = varid - 1 ! Subtract 1 to get C varid and att num
 cattnum = attnum - 1
 nlen    = LEN(name)
 name    = REPEAT(" ",nlen)
 tmpname = REPEAT(" ",LEN(tmpname)) ! init to blanks

 cstatus = nc_inq_attname(cncid, cvarid, cattnum, tmpname)

 If (cstatus == NC_NOERR) Then
    ! Strip of any C null characters and load only the part
    ! of tmpname that will fit in name

    name = stripCNullChar(tmpname, nlen)
 EndIf
 status = cstatus

 End Function nf_inq_attname
!-------------------------------- nf_copy_att ------------------------------
 Function nf_copy_att(ncid_in, varid_in, name, ncid_out, varid_out) &
                      RESULT(status)

! Copy attribute name with varid_in from one netcdf file to another
! with new varid_out 

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN) :: ncid_in, varid_in, ncid_out, varid_out 
 Character(LEN=*), Intent(IN) :: name

 Integer                      :: status

 Integer(KIND=C_INT)          :: cncidin, cncidout,cvaridin, cvaridout, cstatus
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncidin   = ncid_in
 cvaridin  = varid_in - 1
 cncidout  = ncid_out
 cvaridout = varid_out - 1

! Check to see if a C null character was added to name in calling program

 cname = addCNullChar(name, ie)

 cstatus = nc_copy_att(cncidin, cvaridin, cname(1:ie+1), &
                       cncidout, cvaridout)

 status = cstatus

 End Function nf_copy_att
!-------------------------------- nf_rename_att ----------------------------
 Function nf_rename_att(ncid, varid, name, newname) RESULT(status)

! Rename an attribute to newname givin varid 

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN) :: ncid, varid
 Character(LEN=*), Intent(IN) :: name, newname

 Integer                      :: status

 Integer(KIND=C_INT)             :: cncid, cvarid, cstatus
 Character(LEN=(LEN(name)+1))    :: cname 
 Character(LEN=(LEN(newname)+1)) :: cnewname 
 Integer                         :: ie1, ie2, inull

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

! Check to see if a C null character was added to name and newname 
! in calling program

 cname = addCNullChar(name, ie1)

 cnewname = addCNullChar(newname, ie2)

 cstatus = nc_rename_att(cncid, cvarid, cname(1:ie1+1), cnewname(1:ie2+1))

 status = cstatus

 End Function nf_rename_att
!-------------------------------- nf_del_att -------------------------------
 Function nf_del_att(ncid, varid, name) RESULT(status)

! Delete an attribute givne varid and name 

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN) :: ncid, varid
 Character(LEN=*), Intent(IN) :: name

 Integer                      :: status

 Integer(KIND=C_INT)          :: cncid, cvarid, cstatus
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

! Check to see if a C null character was added to name in calling program

 cname = addCNullChar(name, ie)

 cstatus = nc_del_att(cncid, cvarid, cname(1:ie+1))

 status = cstatus

 End Function nf_del_att

! Description:
!  
! Input Parameters:
!   None.
!
! Output Parameters:
!   Many public constants are defined in "netcdf_constants.f90". The names follow 
!     the Fortran 77 names, with nf90_ used as a prefix instead of nf_77. 
!   Functions are made accessable through PUBLIC:: statements in "netcdf_visibility.f90". 
!     Only the functions listed in this file are available in the interface. 
!
! References and Credits:
!   Written by
!    Robert Pincus
!    Cooperative Institue for Meteorological Satellite Studies
!    University of Wisconsin - Madison
!    1225 W. Dayton St. 
!    Madison, Wisconsin 53706
!    Robert.Pincus@ssec.wisc.edu
!
! Design Notes:
!   Module elements are private by default. 
!   Many functions have optional arguments. In order to keep the interface easy to use, 
!     we've reordered the arguments (relative to the F77 interface) in some functions. 
!   The external datatype of attributes is the same as the internal type. 
!   By default, data is read from or put into the lowest part of the netCDF array with stride 1. 
!   We've made heavy use of overloading, especially in the variable put and get routines. 
!     A single function exists for putting all variables; a single function exists for getting 
!     variables. 
!   Text variables must be treated somewhat differently. When a character variable is defined, the
!     fastest-varying index (first index in Fortran) must be the maxiumu length of the character 
!     string. N dimensional arrays of strings passed to the put or get functions are written/read
!     from dimensions 2:N+1. The number of values along the first dimension is determined by the
!     length of the argument character string. 
!
! NOTE: The netcdf4.f90 version of this file was created by Ed
! Hartnett in 2006 to support the netCDF-4 API.
!
 module netcdf
  use typesizes, only: OneByteInt, TwoByteInt, FourByteInt, EightByteInt, &
                       FourByteReal, EightByteReal
  implicit none
  private
  
  ! as of version 4.4, the following are merged:
  ! - netcdf_constants.f90 and netcdf4_constants.f90
  !
  ! Update the dependencies in the Makefile.am when modifying the list of
  !     included files.
  include "netcdf_constants.f90"
  include "netcdf_externals.f90"
  include "netcdf4_externals.f90"
  include "netcdf_overloads.f90"
  include "netcdf4_overloads.f90"
  include "netcdf_visibility.f90"
  include "netcdf4_visibility.f90"
contains
  include "netcdf_file.f90"
  include "netcdf4_file.f90"
  include "netcdf_dims.f90"
  include "netcdf_attributes.f90"
  include "netcdf4_variables.f90"
  include "netcdf_text_variables.f90"
  include "netcdf_expanded.f90"
  include "netcdf4_eightbyte.f90"
  include "netcdf4_func.f90"
end module netcdf

!                  Netcdf Version 2 Fortran API 

! These routines replace the cfortran.h defined functions from fort-v2compat.c
! C_CHAR strings and C_PTR types are used as pass-through variables for
! functions that support multiple data types as void pointers in the C routines
!

! Written by: Richard Weed, Ph.D.
!             Center for Advanced Vehicular Systems
!             Mississippi State University
!             rweed@cavs.msstate.edu


! License (and other Lawyer Language)
 
! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Corporation for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1: May   2006 - Initial version 2 interfaces
! Version 2: April 2009 - Refactored to pass value data using C_CHAR and C_PTR
!                         strings and pointers and updated for NetCDF 4.0.1
! Version 3: April 2010 - updated for NetCDF 4.1.1

! ------------------------------- ncpopt -------------------------------------- 
 Subroutine ncpopt(ncopts)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer, Intent(IN) :: ncopts
 
 Integer(KIND=C_INT) :: cncopts

 cncopts = ncopts

 Call c_ncpopt(cncopts)

 End Subroutine ncpopt 
! ------------------------------- ncgopt -------------------------------------- 
 Subroutine ncgopt(ncopts)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer, Intent(INOUT) :: ncopts

 Integer(KIND=C_INT)    :: cncopts

 cncopts = 0 

 Call c_ncgopt(cncopts)

 ncopts = cncopts

 End Subroutine ncgopt 
! ------------------------------- nccre --------------------------------------- 
 Function nccre(filename, cmode, rcode) RESULT(ncid)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN)  :: filename
 Integer,          Intent(IN)  :: cmode
 Integer,          Intent(OUT) :: rcode

 Integer                       :: ncid

 Character(LEN=(LEN(filename)+1)) :: cfilename
 Integer                          :: ilen
 Integer(KIND=C_INT)              :: ccmode, crcode, cncid 

 ccmode = cmode
 cncid  = 0
 rcode  = 0
 crcode = 0

! check for a null character on end of filename

 cfilename = addCNullChar(filename, ilen)
 
 cncid = c_nccre(cfilename(1:ilen+1), ccmode, crcode )

 rcode = crcode 
 ncid  = cncid

 End Function nccre
! ------------------------------- ncopn --------------------------------------- 
 Function ncopn(filename, rwmode, rcode) RESULT(ncid)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN)  :: filename
 Integer,          Intent(IN)  :: rwmode
 Integer,          Intent(OUT) :: rcode

 Integer                       :: ncid

 Character(LEN=(LEN(filename)+1)) :: cfilename
 Integer                          :: ilen
 Integer(KIND=C_INT)              :: crwmode, crcode, cncid 

 crwmode = rwmode
 rcode   = 0
 crcode  = 0
 cncid   = 0

! check for a null character on end of filename

 cfilename = addCNullChar(filename, ilen)
 
 cncid = c_ncopn(cfilename(1:ilen+1), crwmode, crcode )

 rcode = crcode 
 ncid  = cncid

 End Function ncopn
! ------------------------------- ncddef -------------------------------------- 
 Function ncddef(ncid, dimname, dimlen, rcode) RESULT(ndimid)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN)  :: dimname 
 Integer,          Intent(IN)  :: ncid, dimlen
 Integer,          Intent(OUT) :: rcode

 Integer                       :: ndimid

 Character(LEN=(LEN(dimname)+1)) :: cdimname
 Integer                         :: ilen
 Integer(KIND=C_INT)             :: cncid, cdimlen, cndimid, crcode

 cncid   = ncid
 cdimlen = dimlen
 cndimid = 0
 rcode   = 0
 ndimid  = 0

! check for a null character on end of dimname

 cdimname = addCNullChar(dimname, ilen)
 
 cndimid = c_ncddef(cncid, cdimname(1:ilen+1), cdimlen, crcode )
 
 rcode  = crcode 
 ndimid = cndimid

 End Function ncddef
! ------------------------------- ncdid --------------------------------------- 
 Function ncdid(ncid, dimname, rcode) RESULT(ndimid)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN)  :: dimname 
 Integer,          Intent(IN)  :: ncid
 Integer,          Intent(OUT) :: rcode

 Integer                       :: ndimid

 Character(LEN=(LEN(dimname)+1)) :: cdimname
 Integer                         :: ilen
 Integer(KIND=C_INT)             :: cncid, crcode, cndimid

 cncid   = ncid
 cndimid = 0
 rcode   = 0
 ndimid  = 0

! check for a null character on end of dimname

 cdimname = addCNullChar(dimname, ilen)
 
 cndimid = c_ncdid(cncid, cdimname(1:ilen+1), crcode )

 rcode  = crcode 
 ndimid = cndimid

 End Function ncdid
! ------------------------------- ncvdef -------------------------------------- 
 Function ncvdef(ncid, varname, vartype, nvdims, vdims, rcode) RESULT(nvarid)

 USE netcdf_nc_interfaces, ONLY : NC_MAX_DIMS
 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN)  :: varname 
 Integer,          Intent(IN)  :: ncid, vartype, nvdims
 Integer,          Intent(IN)  :: vdims(*)
 Integer,          Intent(OUT) :: rcode

 Integer                       :: nvarid

 Character(LEN=(LEN(varname)+1)) :: cvarname
 Integer                         :: ilen
 Integer(KIND=C_INT)             :: cncid, crcode, cnvdims, cvartype, cnvarid
 Integer(KIND=C_INT)             :: cvdims(NC_MAX_DIMS)

 cncid    = ncid
 cnvdims  = nvdims 
 cvartype = vartype
 crcode   = 0
 rcode    = 0
 nvarid   = 0
 cnvarid  = 0
 
! check for a null character on end of varname

 cvarname = addCNullChar(varname, ilen)
 
 ! mimic f2c_dimids

 cvdims = 0
 If (nvdims > 0) Then
   cvdims(1:nvdims) = vdims(nvdims:1:-1) - 1
 EndIf

 cnvarid = c_ncvdef(cncid, cvarname(1:ilen+1), cvartype, &
                    cnvdims, cvdims, crcode )

 rcode  = crcode 
 nvarid = cnvarid

 End Function ncvdef
! ------------------------------- ncvid --------------------------------------- 
 Function ncvid(ncid, varname, rcode) RESULT(nvarid)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN)  :: varname 
 Integer,          Intent(IN)  :: ncid
 Integer,          Intent(OUT) :: rcode

 Integer                       :: nvarid

 Character(LEN=(LEN(varname)+1)) :: cvarname
 Integer                         :: ilen
 Integer(KIND=C_INT)             :: cncid, crcode, cnvarid

 cncid   = ncid
 crcode  = 0
 rcode   = 0
 nvarid  = 0
 cnvarid = 0
 
! check for a null character on end of varname

 cvarname = addCNullChar(varname, ilen)
 
 cnvarid = c_ncvid(cncid, cvarname(1:ilen+1), crcode)

 rcode  = crcode 
 nvarid = cnvarid

 End Function ncvid
! ------------------------------- nctlen -------------------------------------- 
 Function nctlen(datatype, rcode) RESULT(nvarlen)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: datatype 
 Integer, Intent(OUT) :: rcode

 Integer              :: nvarlen

 Integer(KIND=C_INT) :: crcode, cnvarlen, cdtype

 cdtype   = datatype
 crcode   = 0
 rcode    = 0
 nvarlen  = 0
 cnvarlen = 0
 
 cnvarlen = c_nctlen(cdtype, crcode)

 rcode   = crcode 
 nvarlen = cnvarlen

 End Function nctlen
! ------------------------------- ncclos ------------------------------------- 
 Subroutine ncclos(ncid, rcode)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid 
 Integer, Intent(OUT) :: rcode

 Integer(KIND=C_INT) :: crcode, cncid

 cncid   = ncid
 crcode  = 0
 rcode   = 0
 
 Call c_ncclos(cncid, crcode)

 rcode = crcode 

 End Subroutine ncclos 
! ------------------------------- ncredf ------------------------------------- 
 Subroutine ncredf(ncid, rcode)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid 
 Integer, Intent(OUT) :: rcode

 Integer(KIND=C_INT) :: crcode, cncid

 cncid   = ncid
 crcode  = 0
 rcode   = 0
 
 Call c_ncredf(cncid, crcode)

 rcode = crcode 

 End Subroutine ncredf
! ------------------------------- ncendf -------------------------------------- 
 Subroutine ncendf(ncid, rcode)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid 
 Integer, Intent(OUT) :: rcode

 Integer(KIND=C_INT) :: crcode, cncid

 cncid   = ncid
 crcode  = 0
 rcode   = 0
 
 Call c_ncendf(cncid, crcode)

 rcode = crcode 

 End Subroutine ncendf
! ------------------------------- ncinq --------------------------------------- 
 Subroutine ncinq(ncid, ndims, nvars, natts, recdim, rcode)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid 
 Integer, Intent(OUT) :: ndims, nvars, natts, recdim, rcode

 Integer(KIND=C_INT) :: crcode, cncid, cndims, cnvars, cnatts, crecdim

 cncid   = ncid
 crcode  = 0
 rcode   = 0
 cndims  = 0
 cnvars  = 0
 cnatts  = 0
 ndims   = 0
 nvars   = 0
 natts   = 0
  
 Call c_ncinq(cncid, cndims, cnvars, cnatts, crecdim, crcode)

 ndims = cndims
 nvars = cnvars
 natts = cnatts
 If (crecdim == -1) Then ! no unlimited dimension
   recdim = -1
 Else
   recdim = crecdim + 1  ! shift by plus one for FORTRAN
 EndIf 

 rcode = crcode 

 End Subroutine ncinq
! ------------------------------- ncsnc --------------------------------------- 
 Subroutine ncsnc(ncid, rcode)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid 
 Integer, Intent(OUT) :: rcode

 Integer(KIND=C_INT) :: crcode, cncid

 cncid   = ncid
 crcode  = 0
 rcode   = 0
 
 Call c_ncsnc(cncid, crcode)

 rcode = crcode 

 End Subroutine ncsnc
! ------------------------------- ncabor -------------------------------------- 
 Subroutine ncabor(ncid, rcode)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid 
 Integer, Intent(OUT) :: rcode

 Integer(KIND=C_INT) :: crcode, cncid

 cncid   = ncid
 crcode  = 0
 rcode   = 0
 
 Call c_ncabor(cncid, crcode)

 rcode = crcode 

 End Subroutine ncabor
! ------------------------------- ncdinq -------------------------------------- 
 Subroutine ncdinq(ncid, dimid, dimname, dimlen, rcode)

 USE netcdf_nc_interfaces, ONLY: NC_MAX_NAME
 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, dimid
 Character(LEN=*), Intent(OUT) :: dimname
 Integer,          Intent(OUT) :: dimlen, rcode

 Integer(KIND=C_INT)            :: cncid, crcode, cdimlen, cdimid
 Character(LEN=(NC_MAX_NAME+1)) :: cdimname
 Integer                        :: ilen

 cncid    = ncid
 cdimid   = dimid - 1
 crcode   = 0
 rcode    = 0
 cdimlen  = 0
 cdimname = REPEAT(" ", LEN(cdimname))
 ilen = LEN(dimname)
 
 Call c_ncdinq(cncid, cdimid, cdimname, cdimlen, crcode)

! check for a null character on end of cdimname

 dimname = stripCNullChar(cdimname, ilen)
 
 dimlen          = cdimlen
 rcode           = crcode

 End Subroutine ncdinq
! ------------------------------- ncdren -------------------------------------- 
 Subroutine ncdren(ncid, dimid, dimname, rcode)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN)  :: dimname
 Integer,          Intent(IN)  :: ncid, dimid
 Integer,          Intent(OUT) :: rcode

 Character(LEN=(LEN(dimname)+1)) :: cdimname
 Integer(KIND=C_INT)             :: cncid, crcode, cdimid
 Integer                         :: ilen

 cncid  = ncid
 cdimid = dimid - 1
 crcode = 0
 rcode  = 0

! check for a null character on end of dimname

 cdimname = addCNullChar(dimname, ilen)
 
 Call c_ncdren(cncid, cdimid, cdimname(1:ilen+1), crcode)

 rcode = crcode 

 End Subroutine ncdren
! ------------------------------- ncvinq -------------------------------------- 
 Subroutine ncvinq(ncid, varid, varname, vartype, nvdims, vdims, &
                   nvatts, rcode)

 USE netcdf_nc_interfaces, ONLY: NC_MAX_DIMS, NC_MAX_NAME
 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer,          Intent(IN)    :: ncid, varid
 Character(LEN=*), Intent(INOUT) :: varname
 Integer,          Intent(OUT)   :: vartype, nvdims, nvatts, rcode
 Integer,          Intent(INOUT) :: vdims(*)

 Integer(KIND=C_INT)          :: cncid, crcode, cvarid, cvartype, cnvdims, &
                                 cnvatts
 Integer(KIND=C_INT)          :: cvdims(NC_MAX_DIMS)
 Character(LEN=NC_MAX_NAME+1) :: cvarname
 Integer                      :: ilen

 cncid    = ncid
 cvarid   = varid - 1
 crcode   = 0
 rcode    = 0
 cvdims   = 0
 cvdims   = 0
 vartype  = 0
 nvdims   = 0
 nvatts   = 0
 cnvdims  = 0
 cvdims   = 0
 cnvatts  = 0
 cvartype = 0
 cvarname = REPEAT(" ", LEN(cvarname))
 ilen = LEN(varname)

 Call c_ncvinq(cncid, cvarid, cvarname, cvartype, cnvdims, cvdims, cnvatts, &
               crcode)      

 nvdims  = cnvdims
 vartype = cvartype
 nvatts  = cnvatts 
 rcode   = crcode 

! strip C null character from cvarname
   
 varname = stripCNullChar(cvarname, ilen)
 
! convert C dimids to FORTRAN order and rank
! Replaces call to c2f_dimids in C code

 If (nvdims > 0) Then
   vdims(1:nvdims) = cvdims(nvdims:1:-1) + 1
 End If

 End Subroutine ncvinq
! ------------------------------- ncvpt1 -------------------------------------- 
 Subroutine ncvpt1(ncid, varid, mindex, values, rcode) 

 USE netcdf_nc_interfaces, ONLY: NC_MAX_DIMS, NC_NOERR, nc_inq_varndims
 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer,                Intent(IN)          :: ncid, varid
 Integer,                Intent(IN)          :: mindex(*)
 Character(KIND=C_CHAR), Intent(IN), TARGET  :: values(*)
 Integer,                Intent(OUT)         :: rcode

 Integer(KIND=C_INT)            :: cncid, crcode, cvarid, cstatus, cndims
 Integer(KIND=C_SIZE_T), TARGET :: cmindex(NC_MAX_DIMS)
 Type(C_PTR)                    :: cmindexptr
 Type(C_PTR)                    :: cvaluesptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1
 crcode  = 0
 rcode   = 0
 cmindex = 0
 cndims  = 0
 ndims   = 0

 cstatus = nc_inq_varndims(cncid, cvarid, cndims)

 cmindexptr = C_NULL_PTR
 ndims      = cndims
 
 If (cstatus == NC_NOERR) Then ! mimic f2c_coords in C code
   If (ndims > 0) Then
     cmindex(1:ndims) = mindex(ndims:1:-1) - 1
   Endif
   cmindexptr = C_LOC(cmindex)
 Endif
 
 cvaluesptr = C_LOC(values)

 Call c_ncvpt1(cncid, cvarid, cmindexptr, cvaluesptr, crcode)

 rcode = crcode

 End Subroutine ncvpt1
! ------------------------------- ncvp1c -------------------------------------- 
 Subroutine ncvp1c(ncid, varid, mindex, strings, rcode) 

 USE netcdf_nc_interfaces, ONLY: NC_MAX_DIMS, NC_NOERR, nc_inq_varndims
 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(IN)  :: mindex(*)
 Character(LEN=*), Intent(IN)  :: strings
 Integer,          Intent(OUT) :: rcode

 Integer(KIND=C_INT)            :: cncid, crcode, cvarid, cstatus, cndims
 Integer(KIND=C_SIZE_T), TARGET :: cmindex(NC_MAX_DIMS)
 Type(C_PTR)                    :: cmindexptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1
 crcode  = 0
 rcode   = 0
 cmindex = 0
 cndims  = 0
 ndims   = 0

 cstatus = nc_inq_varndims(cncid, cvarid, cndims)

 cmindexptr = C_NULL_PTR
 ndims     = cndims 

 If (cstatus == NC_NOERR) Then ! mimic f2c_coords in C code
   If (ndims > 0) Then
     cmindex(1:ndims) = mindex(ndims:1:-1) - 1
   Endif
   cmindexptr = C_LOC(cmindex)
 Endif

 Call c_ncvp1c(cncid, cvarid, cmindexptr, strings, crcode)

 rcode = crcode

 End Subroutine ncvp1c
! ------------------------------- ncvpt --------------------------------------- 
 Subroutine ncvpt(ncid, varid, start, counts, values, rcode) 

 USE netcdf_nc_interfaces, ONLY: NC_MAX_DIMS, NC_NOERR, nc_inq_varndims
 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer,                Intent(IN)          :: ncid, varid
 Integer,                Intent(IN)          :: start(*), counts(*)
 Character(KIND=C_CHAR), Intent(IN), TARGET  :: values(*)
 Integer,                Intent(OUT)         :: rcode

 Integer(KIND=C_INT)            :: cncid, crcode, cvarid, cstatus, cndims
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Type(C_PTR)                    :: cvaluesptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1
 crcode  = 0
 rcode   = 0
 cstart  = 0
 ccounts = 0
 cndims  = 0
 ndims   = 0

 cstatus = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims 

 If (cstatus == NC_NOERR) Then ! mimic f2c_coords, etc. in C code
   If (ndims > 0) Then
     cstart(1:ndims)  = start(ndims:1:-1) - 1
     ccounts(1:ndims) = counts(ndims:1:-1)
   Endif
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts) 
 Endif

 cvaluesptr = C_LOC(values)

 Call c_ncvpt(cncid, cvarid, cstartptr, ccountsptr, cvaluesptr, crcode)

 rcode = crcode

 End Subroutine ncvpt
! ------------------------------- ncvptc--------------------------------------- 
 Subroutine ncvptc(ncid, varid, start, counts, strings, lenstr, rcode) 

 USE netcdf_nc_interfaces, ONLY: NC_MAX_DIMS, NC_NOERR, nc_inq_varndims
 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer,          Intent(IN)    :: ncid, varid, lenstr
 Integer,          Intent(IN)    :: start(*), counts(*)
 Character(LEN=*), Intent(INOUT) :: strings
 Integer,          Intent(OUT)   :: rcode

 Integer(KIND=C_INT)            :: cncid, crcode, cvarid, cstatus, cndims, &
                                   clenstr
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1
 clenstr = lenstr
 crcode  = 0
 rcode   = 0
 cstart  = 0
 ccounts = 0
 cndims  = 0
 ndims   = 0

 cstatus = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims
 
 If (cstatus == NC_NOERR) Then ! mimic f2c_coords, etc. in C code
   If (ndims > 0) Then
     cstart(1:ndims)  = start(ndims:1:-1) - 1
     ccounts(1:ndims) = counts(ndims:1:-1)
   Endif
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 Endif

 Call c_ncvptc(cncid, cvarid, cstartptr, ccountsptr, strings(1:lenstr),&
               clenstr, crcode)

 rcode = crcode

 End Subroutine ncvptc
! ------------------------------- ncvptg -------------------------------------- 
 Subroutine ncvptg(ncid, varid, start, counts, strides, imap, values, &
                   rcode) 

 USE netcdf_nc_interfaces, ONLY: NC_MAX_DIMS, NC_NOERR, nc_inq_varndims
 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer,                Intent(IN)          :: ncid, varid
 Integer,                Intent(IN)          :: start(*), counts(*), &
                                                strides(*), imap(*)
 Character(KIND=C_CHAR), Intent(IN), TARGET  :: values(*)
 Integer,                Intent(OUT)         :: rcode

 Integer(KIND=C_INT)               :: cncid, crcode, cvarid, cstatus, cndims
 Integer(KIND=C_SIZE_T),    TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Integer(KIND=C_PTRDIFF_T), TARGET :: cstrides(NC_MAX_DIMS), cimap(NC_MAX_DIMS)
 Type(C_PTR)                       :: cstartptr, ccountsptr, cimapptr, &
                                      cstridesptr
 Type(C_PTR)                       :: cvaluesptr
 Integer                           :: ndims, inullp

 cncid   = ncid
 cvarid  = varid - 1
 crcode  = 0
 rcode   = 0
 cstart  = 0
 ccounts = 0
 cndims  = 0
 ndims   = 0
 inullp  = 0

 Call convert_v2_imap(cncid, cvarid, imap, cimap, inullp)
 
 cstatus = nc_inq_varndims(cncid, cvarid, cndims)

 ndims       = cndims 
 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cimapptr    = C_LOC(cimap)
 If (inullp /= 0) cimapptr = C_NULL_PTR
 
 If (cstatus == NC_NOERR) Then ! mimic f2c_coords, etc. in C code
   If (ndims > 0) Then
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1) - 1
   Endif
   cstartptr   = C_LOC(cstart)
   ccountsptr  = C_LOC(ccounts)
   cstridesptr = C_LOC(cstrides)
 Endif

 cvaluesptr = C_LOC(values)

 Call c_ncvptg(cncid, cvarid, cstartptr, ccountsptr, cstridesptr, &
               cimapptr, cvaluesptr, crcode)

 rcode = crcode

 End Subroutine ncvptg
! ------------------------------- ncvpgc -------------------------------------- 
 Subroutine ncvpgc(ncid, varid, start, counts, strides, imap, string, rcode) 

 USE netcdf_nc_interfaces, ONLY: NC_MAX_DIMS, NC_NOERR, nc_inq_varndims
 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(IN)  :: start(*), counts(*), strides(*), imap(*)
 Character(LEN=*), Intent(IN)  :: string
 Integer,          Intent(OUT) :: rcode

 Integer(KIND=C_INT)               :: cncid, crcode, cvarid, cstatus, cndims
 Integer(KIND=C_SIZE_T),    TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Integer(KIND=C_PTRDIFF_T), TARGET :: cstrides(NC_MAX_DIMS), cimap(NC_MAX_DIMS)
 Type(C_PTR)                       :: cstartptr, ccountsptr, cstridesptr, &
                                      cimapptr
 Integer                           :: ndims, inullp

 cncid   = ncid
 cvarid  = varid - 1
 crcode  = 0
 rcode   = 0
 cstart  = 0
 ccounts = 0
 cndims  = 0
 ndims   = 0
 inullp  = 0

 Call convert_v2_imap(cncid, cvarid, imap, cimap, inullp)

 cstatus = nc_inq_varndims(cncid, cvarid, cndims)

 ndims       = cndims 
 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cimapptr    = C_LOC(cimap)
 If (inullp /= 0) cimapptr = C_NULL_PTR

 If (cstatus == NC_NOERR) Then ! mimic f2c_coords, etc. in C code
   If (ndims > 0) Then
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1) - 1
   Endif
   cstartptr   = C_LOC(cstart)
   ccountsptr  = C_LOC(ccounts)
   cstridesptr = C_LOC(cstrides)
 Endif

 Call c_ncvpgc(cncid, cvarid, cstartptr, ccountsptr, cstridesptr, &
               cimapptr, string, crcode)

 rcode = crcode

 End Subroutine ncvpgc
! ------------------------------- ncvgt1 -------------------------------------- 
 Subroutine ncvgt1(ncid, varid, mindex, values, rcode) 

 USE netcdf_nc_interfaces, ONLY: NC_MAX_DIMS, NC_NOERR, nc_inq_varndims
 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer,                Intent(IN)  :: ncid, varid
 Integer,                Intent(IN)  :: mindex(*)
 Character(KIND=C_CHAR), Intent(OUT) :: values(*)
 Integer,                Intent(OUT) :: rcode

 Integer(KIND=C_INT)            :: cncid, crcode, cvarid, cstatus, cndims
 Integer(KIND=C_SIZE_T), TARGET :: cmindex(NC_MAX_DIMS)
 Type(C_PTR)                    :: cmindexptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1
 crcode  = 0
 rcode   = 0
 cmindex = 0
 cndims  = 0
 ndims   = 0

 cstatus = nc_inq_varndims(cncid, cvarid, cndims)

 cmindexptr = C_NULL_PTR
 ndims      = cndims
 
 If (cstatus == NC_NOERR) Then ! mimic f2c_coords in C code
   If (ndims > 0) Then
     cmindex(1:ndims) = mindex(ndims:1:-1) - 1
   Endif
   cmindexptr = C_LOC(cmindex)
 Endif

 Call c_ncvgt1(cncid, cvarid, cmindexptr, values, crcode)

 rcode = crcode

 End Subroutine ncvgt1
! ------------------------------- ncvg1c -------------------------------------- 
 Subroutine ncvg1c(ncid, varid, mindex, string, rcode) 

 USE netcdf_nc_interfaces, ONLY: NC_MAX_DIMS, NC_NOERR, nc_inq_varndims
 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer,          Intent(IN)    :: ncid, varid
 Integer,          Intent(IN)    :: mindex(*)
 Character(LEN=*), Intent(INOUT) :: string
 Integer,          Intent(OUT)   :: rcode

 Integer(KIND=C_INT)            :: cncid, crcode, cvarid, cstatus, cndims
 Integer(KIND=C_SIZE_T), TARGET :: cmindex(NC_MAX_DIMS)
 Type(C_PTR)                    :: cmindexptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1
 crcode  = 0
 rcode   = 0
 cmindex = 0
 cndims  = 0
 ndims   = 0

 cstatus = nc_inq_varndims(cncid, cvarid, cndims)

 cmindexptr = C_NULL_PTR
 ndims      = cndims
 
 If (cstatus == NC_NOERR) Then ! mimic f2c_coords in C code
   If (ndims > 0) Then
     cmindex(1:ndims) = mindex(ndims:1:-1) - 1
   Endif
   cmindexptr = C_LOC(cmindex)
 Endif

 Call c_ncvg1c(cncid, cvarid, cmindexptr, string, crcode)

 rcode = crcode

 End Subroutine ncvg1c
! ------------------------------- ncvgt --------------------------------------- 
 Subroutine ncvgt(ncid, varid, start, counts, values, rcode) 

 USE netcdf_nc_interfaces, ONLY: NC_MAX_DIMS, NC_NOERR, nc_inq_varndims
 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer,                Intent(IN)  :: ncid, varid
 Integer,                Intent(IN)  :: start(*), counts(*)
 Character(KIND=C_CHAR), Intent(OUT) :: values(*)
 Integer,                Intent(OUT) :: rcode

 Integer(KIND=C_INT)            :: cncid, crcode, cvarid, cstatus, cndims
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Integer                        :: ndims

 cncid   = ncid
 cvarid  = varid - 1
 crcode  = 0
 rcode   = 0
 cstart  = 0
 ccounts = 0
 cndims  = 0
 ndims   = 0

 cstatus = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims
 
 If (cstatus == NC_NOERR) Then ! mimic f2c_coords, etc. in C code
   If (ndims > 0) Then
     cstart(1:ndims)  = start(ndims:1:-1) - 1
     ccounts(1:ndims) = counts(ndims:1:-1)
   Endif
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 Endif

 Call c_ncvgt(cncid, cvarid, cstartptr, ccountsptr, values, crcode)

 rcode = crcode

 End Subroutine ncvgt
! ------------------------------- ncvgtc -------------------------------------- 
 Subroutine ncvgtc(ncid, varid, start, counts, string, lenstr, rcode) 

 USE netcdf_nc_interfaces, ONLY: NC_MAX_DIMS, NC_NOERR, nc_inq_varndims
 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer,          Intent(IN)    :: ncid, varid, lenstr
 Integer,          Intent(IN)    :: start(*), counts(*)
 Character(LEN=*), Intent(INOUT) :: string
 Integer,          Intent(OUT)   :: rcode

 Integer(KIND=C_INT)            :: cncid, crcode, cvarid, cstatus, cndims, &
                                   clenstr
 Integer(KIND=C_SIZE_T), TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Type(C_PTR)                    :: cstartptr, ccountsptr
 Character(LEN=lenstr+1)        :: cstring
 Integer                        :: ndims, slen

 cncid   = ncid
 cvarid  = varid - 1
 clenstr = lenstr
 crcode  = 0
 rcode   = 0
 cstart  = 0
 ccounts = 0
 cndims  = 0
 ndims   = 0
 string  = REPEAT(" ", LEN(string))
 cstring = REPEAT(" ", LEN(cstring))

 cstatus = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr  = C_NULL_PTR
 ccountsptr = C_NULL_PTR
 ndims      = cndims
 
 If (cstatus == NC_NOERR) Then ! mimic f2c_coords, etc. in C code
   If (ndims > 0) Then
     cstart(1:ndims)  = start(ndims:1:-1) - 1
     ccounts(1:ndims) = counts(ndims:1:-1)
   Endif
   cstartptr  = C_LOC(cstart)
   ccountsptr = C_LOC(ccounts)
 Endif

 Call c_ncvgtc(cncid, cvarid, cstartptr, ccountsptr, cstring, clenstr, crcode)

 If (LEN(string) >= lenstr) Then
   string(1:lenstr) = cstring(1:lenstr)
 Else
   slen           = LEN(string)
   string(1:slen) = cstring(1:slen)
 EndIf

 rcode = crcode

 End Subroutine ncvgtc
! ------------------------------- ncvgtg -------------------------------------- 
 Subroutine ncvgtg(ncid, varid, start, counts, strides, imap, values, &
                   rcode) 

 USE netcdf_nc_interfaces, ONLY: NC_MAX_DIMS, NC_NOERR, nc_inq_varndims
 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer,                Intent(IN)  :: ncid, varid
 Integer,                Intent(IN)  :: start(*), counts(*), strides(*), imap(*)
 Character(KIND=C_CHAR), Intent(OUT) :: values(*)
 Integer,                Intent(OUT) :: rcode

 Integer(KIND=C_INT)               :: cncid, crcode, cvarid, cstatus, cndims
 Integer(KIND=C_SIZE_T),    TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Integer(KIND=C_PTRDIFF_T), TARGET :: cstrides(NC_MAX_DIMS), cimap(NC_MAX_DIMS)
 Type(C_PTR)                       :: cstartptr, ccountsptr, cimapptr, &
                                      cstridesptr
 Integer                           :: ndims, inullp

 cncid   = ncid
 cvarid  = varid - 1
 crcode  = 0
 rcode   = 0
 cstart  = 0
 ccounts = 0
 cndims  = 0
 inullp  = 0

 Call convert_v2_imap(cncid, cvarid, imap, cimap, inullp)
 cstatus = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cimapptr    = C_LOC(cimap)
 ndims       = cndims 
 If (inullp /= 0) cimapptr = C_NULL_PTR

 If (cstatus == NC_NOERR) Then ! mimic f2c_coords, etc. in C code
   If (ndims > 0) Then
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1) - 1
   Endif
   cstartptr   = C_LOC(cstart)
   ccountsptr  = C_LOC(ccounts)
   cstridesptr = C_LOC(cstrides)
 Endif

 Call c_ncvgtg(cncid, cvarid, cstartptr, ccountsptr, cstridesptr, &
               cimapptr, values, crcode)

 rcode = crcode

 End Subroutine ncvgtg
! ------------------------------- ncvggc -------------------------------------- 
 Subroutine ncvggc(ncid, varid, start, counts, strides, imap, string, rcode) 

 USE netcdf_nc_interfaces, ONLY: NC_MAX_DIMS, NC_NOERR, nc_inq_varndims
 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer,          Intent(IN)    :: ncid, varid
 Integer,          Intent(IN)    :: start(*), counts(*), strides(*), imap(*)
 Character(LEN=*), Intent(INOUT) :: string
 Integer,          Intent(OUT)   :: rcode

 Integer(KIND=C_INT)               :: cncid, crcode, cvarid, cstatus, cndims
 Integer(KIND=C_SIZE_T),    TARGET :: cstart(NC_MAX_DIMS), ccounts(NC_MAX_DIMS)
 Integer(KIND=C_PTRDIFF_T), TARGET :: cstrides(NC_MAX_DIMS), cimap(NC_MAX_DIMS)
 Character(LEN=(LEN(string)+1))    :: cstring
 Type(C_PTR)                       :: cstartptr, ccountsptr, cstridesptr, &
                                      cimapptr
 Integer                           :: ndims, inullp,slen

 cncid   = ncid
 cvarid  = varid - 1
 crcode  = 0
 rcode   = 0
 cstart  = 0
 ccounts = 0
 cndims  = 0
 ndims   = 0
 inullp  = 0
 string  = REPEAT(" ", LEN(string))
 cstring = REPEAT(" ", LEN(cstring)) 

 Call convert_v2_imap(cncid, cvarid, imap, cimap, inullp)

 cstatus = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cimapptr    = C_LOC(cimap)
 ndims       = cndims 
 If (inullp /= 0) cimapptr = C_NULL_PTR

 If (cstatus == NC_NOERR) Then ! mimic f2c_coords, etc. in C code
   If (ndims > 0) Then
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1) - 1
   Endif
   cstartptr   = C_LOC(cstart)
   ccountsptr  = C_LOC(ccounts)
   cstridesptr = C_LOC(cstrides)
 Endif

 Call c_ncvggc(cncid, cvarid, cstartptr, ccountsptr, cstridesptr, &
               cimapptr, cstring, crcode)

 slen           = LEN(string)
 string(1:slen) = cstring(1:slen)

 rcode = crcode

 End Subroutine ncvggc
!-------------------------------- ncvren --------------------------------------
 Subroutine ncvren(ncid, varid, newnam, rcode)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN)  :: newnam
 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(OUT) :: rcode

 Character(LEN=(LEN(newnam)+1)) :: cnewnam
 Integer(KIND=C_INT)            :: cncid, cvarid, crcode
 Integer                        :: ilen

 cncid  = ncid
 cvarid = varid - 1
 rcode  = 0

! check for a null character on end of newnam

 cnewnam = addCNullChar(newnam, ilen)
 
 Call c_ncvren(cncid, cvarid, cnewnam(1:ilen+1), crcode )

 rcode = crcode 

 End Subroutine ncvren
!-------------------------------- ncapt ---------------------------------------
 Subroutine ncapt(ncid, varid, attnam, attype, attlen, value, rcode)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Character(LEN=*),       Intent(IN)          :: attnam
 Integer,                Intent(IN)          :: ncid, varid, attype, attlen
 Character(KIND=C_CHAR), Intent(IN), TARGET  :: value(*)
 Integer,                Intent(OUT)         :: rcode

 Integer(KIND=C_INT)            :: cncid, cvarid, cattype, crcode
 Integer(KIND=C_SIZE_T)         :: cattlen
 Type(C_PTR)                    :: cvalueptr
 Character(LEN=(LEN(attnam)+1)) :: cattnam
 Integer                        :: ilen

 cncid   = ncid
 cvarid  = varid - 1
 cattype = attype
 cattlen = attlen
 rcode   = 0

! check for a null character on end of attname

 cattnam = addCNullChar(attnam, ilen)
 
 cvalueptr = C_LOC(value)
 
 Call c_ncapt(cncid, cvarid, cattnam(1:ilen+1), cattype, &
              cattlen, cvalueptr, crcode )

 rcode = crcode 

 End Subroutine ncapt
!-------------------------------- ncaptc ------------------------------------
 Subroutine ncaptc(ncid, varid, attnam, attype, lenstr, string, rcode)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN)  :: attnam
 Integer,          Intent(IN)  :: ncid, varid, attype, lenstr
 Character(LEN=*), Intent(IN)  :: string 
 Integer,          Intent(OUT) :: rcode

 Integer(KIND=C_INT)            :: cncid, cvarid, cattype, crcode
 Integer(KIND=C_SIZE_T)         :: clenstr
 Character(LEN=(LEN(attnam)+1)) :: cattnam
 Integer                        :: ilen

 cncid   = ncid
 cvarid  = varid - 1
 cattype = attype
 clenstr = lenstr
 rcode   = 0

! check for a null character on end of attname

 cattnam = addCNullChar(attnam, ilen)
 
 Call c_ncaptc(cncid, cvarid, cattnam(1:ilen+1), cattype, &
               clenstr, string, crcode )

 rcode = crcode 

 End Subroutine ncaptc
!-------------------------------- ncainq --------------------------------------
 Subroutine ncainq(ncid, varid, attnam, attype, attlen, rcode)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN)  :: attnam
 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(OUT) :: attype, attlen, rcode

 Integer(KIND=C_INT)            :: cncid, cvarid, cattype, crcode, cattlen
 Character(LEN=(LEN(attnam)+1)) :: cattnam
 Integer                        :: ilen

 cncid   = ncid
 cvarid  = varid - 1
 cattype = 0
 cattlen = 0
 rcode   = 0

! check for a null character on end of attnam

 cattnam = addCNullChar(attnam, ilen)

 Call c_ncainq(cncid, cvarid, cattnam(1:ilen+1), cattype, &
             cattlen, crcode )

 attype = cattype
 attlen = cattlen
 rcode  = crcode

 End Subroutine ncainq
!-------------------------------- ncagt ---------------------------------------
 Subroutine ncagt(ncid, varid, attnam, values, rcode)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Character(LEN=*),       Intent(IN)  :: attnam
 Integer,                Intent(IN)  :: ncid, varid
 Character(KIND=C_CHAR), Intent(OUT) :: values(*)
 Integer,                Intent(OUT) :: rcode

 Integer(KIND=C_INT)            :: cncid, cvarid, crcode
 Character(LEN=(LEN(attnam)+1)) :: cattnam
 Integer                        :: ilen

 cncid  = ncid
 cvarid = varid - 1
 rcode  = 0

! check for a null character on end of attnam

 cattnam = addCNullChar(attnam, ilen)
 
 Call c_ncagt(cncid, cvarid, cattnam(1:ilen+1), values, crcode)

 rcode = crcode

 End Subroutine ncagt
!-------------------------------- ncagtc --------------------------------------
 Subroutine ncagtc(ncid, varid, attnam, string, lenstr, rcode)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN)    :: attnam
 Integer,          Intent(IN)    :: ncid, varid, lenstr
 Character(LEN=*), Intent(INOUT) :: string 
 Integer,          Intent(OUT)   :: rcode

 Integer(KIND=C_INT)            :: cncid, cvarid, crcode
 Character(LEN=(LEN(attnam)+1)) :: cattnam
 Character(LEN=(lenstr+1))      :: cstring
 Integer                        :: ilen

 cncid   = ncid
 cvarid  = varid - 1
 rcode   = 0
 string  = REPEAT(" ", LEN(string))
 cstring = REPEAT(" ", LEN(cstring))

! check for a null character on end of attnam

 cattnam = addCNullChar(attnam, ilen)
 
 Call c_ncagtc(cncid, cvarid, cattnam(1:ilen+1), cstring, lenstr, &
               crcode)

 string(1:lenstr) = cstring(1:lenstr)

 rcode = crcode

 End Subroutine ncagtc
!-------------------------------- ncacpy --------------------------------------
 Subroutine ncacpy(ncid, varid, attnam, outcdf, outvar, rcode)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN)  :: attnam
 Integer,          Intent(IN)  :: ncid, varid, outcdf, outvar
 Integer,          Intent(OUT) :: rcode

 Integer(KIND=C_INT)            :: cncid, cvarid, coutcdf, coutvar, crcode
 Character(LEN=(LEN(attnam)+1)) :: cattnam
 Integer                        :: ilen

 cncid   = ncid
 cvarid  = varid - 1
 coutcdf = outcdf
 coutvar = outvar-1
 rcode   = 0

! check for a null character on end of attnam

 cattnam = addCNullChar(attnam, ilen)
 
 Call c_ncacpy(cncid, cvarid, cattnam(1:ilen+1), coutcdf, &
               coutvar, crcode)

 rcode = crcode

 End Subroutine ncacpy
!-------------------------------- ncanam --------------------------------------
 Subroutine ncanam(ncid, varid, attnum, attnam, rcode)

 USE netcdf_nc_interfaces, ONLY: NC_MAX_NAME
 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Character(LEN=*), Intent(INOUT) :: attnam
 Integer,          Intent(IN)    :: ncid, varid, attnum
 Integer,          Intent(OUT)   :: rcode

 Integer                      :: ilen
 Integer(KIND=C_INT)          :: cncid, cvarid, cattnum, crcode
 Character(LEN=NC_MAX_NAME+1) :: cattnam

 cncid = ncid
 cvarid = varid - 1
 cattnum = attnum - 1
 rcode = 0
 cattnam = REPEAT(" ", LEN(cattnam))
 ilen = LEN(attnam)

 Call c_ncanam(cncid, cvarid, cattnum, cattnam, crcode)

! check for a null character on end of cattnam

 attnam = stripCNullChar(cattnam, ilen)
 
 rcode = crcode

 End Subroutine ncanam
!-------------------------------- ncaren --------------------------------------
 Subroutine ncaren(ncid, varid, attnam, newnam, rcode)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN)  :: attnam, newnam
 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(OUT) :: rcode

 Integer(KIND=C_INT)            :: cncid, cvarid, crcode
 Character(LEN=(LEN(attnam)+1)) :: cattnam
 Character(LEN=(LEN(newnam)+1)) :: cnewnam
 Integer                        :: ilen, ilen2

 cncid  = ncid
 cvarid = varid - 1
 rcode  = 0

! check for a null character on end of attnam and newnam

 cattnam = addCNullChar(attnam, ilen)
 
 cnewnam = addCNullChar(newnam, ilen2)
 
 Call c_ncaren(cncid, cvarid, cattnam(1:ilen+1), cnewnam(1:ilen2+1), crcode) 

 rcode = crcode

 End Subroutine ncaren
!-------------------------------- ncadel --------------------------------------
 Subroutine ncadel(ncid, varid, attnam, rcode)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Character(LEN=*), Intent(IN)  :: attnam
 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(OUT) :: rcode

 Integer(KIND=C_INT)            :: cncid, cvarid, crcode
 Character(LEN=(LEN(attnam)+1)) :: cattnam
 Integer                        :: ilen

 cncid  = ncid
 cvarid = varid - 1
 rcode  = 0

! check for a null character on end of attnam

 cattnam = addCNullChar(attnam, ilen)
 
 Call c_ncadel(cncid, cvarid, cattnam(1:ilen+1),crcode)

 rcode = crcode

 End Subroutine ncadel
!-------------------------------- ncsfil --------------------------------------
 Function ncsfil(ncid, fillmode, rcode) RESULT(currentmode)

 USE netcdf_fortv2_c_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid, fillmode
 Integer, Intent(OUT) :: rcode

 Integer              :: currentmode

 Integer(KIND=C_INT) :: cncid, cfillmode, crcode, cstatus  

 cncid     = ncid
 cfillmode = fillmode

 cstatus     = c_ncsfil(cncid, cfillmode, crcode)
 rcode       = crcode
 currentmode = cstatus

 End Function ncsfil

!-- Routines for processing error messages, obtaining version numbers, etc. --

! Replacement for fort-misc.c

! Written by: Richard Weed, Ph.D.
!             Center for Advanced Vehicular Systems
!             Mississippi State University
!             rweed@cavs.msstate.edu


! License (and other Lawyer Language)

! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Corporation for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1.: Sept. 2005 - Initial Cray X1 version
! Version 2.: May   2006 - Updated to support g95
! Version 3.: April 2009 - Updated for netCDF 4.0.1
! Version 4.: April 2010 - Updated for netCDF 4.1.1
! Version 5.: Jan   2016 - General code cleanup

!-------------------------------- nf_inq_libvers ---------------------------
Function nf_inq_libvers() RESULT(vermsg)

  ! Return string with current version of NetCDF library

  USE netcdf_nc_interfaces

  Implicit NONE

  Character(LEN=80) :: vermsg

  Character(LEN=81), Pointer :: fstrptr
  TYPE(C_PTR)                :: cstrptr
  Integer                    :: inull, ilen

  vermsg = REPEAT(" ", LEN(vermsg)) !initialize vermsg to blanks

  ! Get C character pointer returned by nc_inq_vers and associate it
  ! Fortran character pointer (fstrptr). Have to do this when the C
  ! routine allocates space for the pointer and/or knows where it lives
  ! not Fortran. This is also how you can pass character data back to
  ! FORTRAN from C using a C function that returns a character pointer
  ! instead using a void jacket function and passing the string as a hidden
  ! argument. At least this is how cfortran.h appears to do it.


  NULLIFY(fstrptr) ! Nullify fstrptr

  cstrptr = nc_inq_libvers()         ! Get C pointer to version string and

  Call C_F_POINTER(cstrptr, fstrptr) ! associate it with FORTRAN pointer

  ! Locate first C null character and then set it and remaining characters
  ! in string to blanks

  ilen  = LEN_TRIM(fstrptr)
  inull = SCAN(fstrptr,C_NULL_CHAR)
  If (inull /= 0) ilen = inull-1
  ilen = MAX(1, MIN(ilen,80)) ! Limit ilen to >=1 and <=80

  ! Load return value with trimmed fstrptr string

  vermsg(1:ilen) = fstrptr(1:ilen)

End Function nf_inq_libvers
!-------------------------------- nf_stderror ------------------------------
Function nf_strerror(ncerr) RESULT(errmsg)

  ! Returns an error message string given static error code ncerr

  USE netcdf_nc_interfaces

  Implicit NONE

  Integer(KIND=C_INT), Intent(IN) :: ncerr

  Character(LEN=80)               :: errmsg

  Character(LEN=81), Pointer :: fstrptr
  TYPE(C_PTR)                :: cstrptr
  Integer                    :: inull, ilen
  Integer(KIND=C_INT)        :: cncerr

  errmsg = REPEAT(" ", LEN(errmsg)) !initialize errmsg to blanks

  ! Get C character pointer returned by nc_stderror and associate it
  ! Fortran character pointer (fstrptr). Have to do this when the C
  ! routine allocates space for the pointer and/or knows where it lives
  ! not Fortran. This is also how you can pass character data back to
  ! FORTRAN from C using a C function that returns a character pointer
  ! instead using a void jacket function and passing the string as a hidden
  ! argument. At least this is how cfortran.h appears to do it.

  NULLIFY(fstrptr) ! Nullify fstrptr

  cncerr  = ncerr

  cstrptr = nc_strerror(cncerr)      ! Return C character pointer and
  Call C_F_POINTER(cstrptr, fstrptr) ! associate C ptr with FORTRAN pointer

  ! Locate first C null character and then set it and remaining characters
  ! in string to blanks

  ilen  = LEN_TRIM(fstrptr)
  inull = SCAN(fstrptr,C_NULL_CHAR)
  If (inull /= 0) ilen = inull-1
  ilen  = MAX(1, MIN(ilen,80)) ! Limit ilen to >=1 and <=80

  ! Load return value with trimmed fstrptr string

  errmsg(1:ilen) = fstrptr(1:ilen)

End Function nf_strerror
!-------------------------------- nf_issyserr ------------------------------
Function nf_issyserr(nerr) RESULT(status)

  ! Check to see if nerr is > 0

  Integer, Intent(IN) :: nerr

  Logical             :: status

  status = (nerr > 0)

End Function nf_issyserr

Module netcdf_fortv2_c_interfaces

! Fortran 20003 interfaces to C routines in fort_v2compat.c called by
! the V2 Fortran interfaces. Interface routine names are the same
! as the C routine names.

! Written by : Richard Weed, Ph.D.
!              Center for Advanced Vehicular Systems 
!              Mississipi State University
!              rweed@cavs.msstate.edu


! License (and other Lawyer Language)
 
! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Corporation for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1.: May,   2006 - Initial version 2 interfaces
! Version 2.; April, 2009 - Redone to reflect passing void data types
!                           in C with C_PTR and C_CHAR strings and 
!                           NetCDF 4.0.1
! Version 3.; April, 2010 - Updated to NetCDF 4.1.1

! USE ISO_C_BINDING

! USE NETCDF_NC_DATA,       ONLY: C_PTRDIFF_T
! USE NETCDF_NC_INTERFACES, ONLY: addCNullChar, stripCNullChar
 USE NETCDF_NC_INTERFACES

 Implicit NONE

! The following interfaces are for the netCDF V2 functions. Note that
! the actual C routines return a void pointer for arrays etc. This
! forced me to adopt a commonly used kludge for interfacing old Fortran
! 77 with C, namely, passing the void pointer to an array of C_CHARs.

! Also note that each interface has an explicit USE ISO_C_BINDING. A better
! solution is to use the F2003 IMPORT statement (I originally had it this way)
! However its best to leave the interfaces as is for now because there might
! be a few compilers out there that support most of the C-interop facility but
! for some reason haven't implemented IMPORT yet.

!  Begin fortv2 C interface definitions

!-------------------------------- c_ncpopt ------------------------------------
Interface
 Subroutine c_ncpopt(val) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE :: val

 End Subroutine c_ncpopt
End Interface
!-------------------------------- c_ncgopt ------------------------------------
Interface
 Subroutine c_ncgopt(val) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), Intent(OUT) :: val

 End Subroutine c_ncgopt
End Interface
!-------------------------------- c_nccre -------------------------------------
Interface
 Function c_nccre(pathname, clobmode, rcode) BIND(C)
 
 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Character(KIND=C_CHAR), Intent(IN)  :: pathname(*)
 Integer(KIND=C_INT),    VALUE       :: clobmode 
 Integer(KIND=C_INT),    Intent(OUT) :: rcode 
 
 Integer(KIND=C_INT)                 :: c_nccre

 End Function c_nccre
End Interface
!-------------------------------- c_ncopn -------------------------------------
Interface
 Function c_ncopn(pathname, rwmode, rcode) BIND(C)
 
 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Character(KIND=C_CHAR), Intent(IN)  :: pathname(*)
 Integer(KIND=C_INT),    VALUE       :: rwmode 
 Integer(KIND=C_INT),    Intent(OUT) :: rcode
 
 Integer(KIND=C_INT)                 :: c_ncopn

 End Function c_ncopn
End Interface
!-------------------------------- c_ncddef ------------------------------------
Interface
 Function c_ncddef(ncid, dimname, dimlen, rcode) BIND(C)
 
 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid, dimlen
 Character(KIND=C_CHAR), Intent(IN)  :: dimname(*)
 Integer(KIND=C_INT),    Intent(OUT) :: rcode
 
 Integer(KIND=C_INT)                 :: c_ncddef

 End Function c_ncddef
End Interface
!-------------------------------- c_ncdid -------------------------------------
Interface
 Function c_ncdid(ncid, dimname, rcode) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid
 Character(KIND=C_CHAR), Intent(IN)  :: dimname(*)
 Integer(KIND=C_INT),    Intent(OUT) :: rcode
 
 Integer(KIND=C_INT)                 :: c_ncdid

 End Function c_ncdid
End Interface
!-------------------------------- c_ncvdef ------------------------------------
Interface
 Function c_ncvdef(ncid, varname, datatype, ndims, dimids, rcode) BIND(C)
 
 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid
 Character(KIND=C_CHAR), Intent(IN)  :: varname(*)
 Integer(KIND=C_INT),    VALUE       :: datatype ! nc_type variable in C
 Integer(KIND=C_INT),    VALUE       :: ndims
 Integer(KIND=C_INT),    Intent(IN)  :: dimids(*)
 Integer(KIND=C_INT),    Intent(OUT) :: rcode

 Integer(KIND=C_INT)                 :: c_ncvdef

 End Function c_ncvdef
End Interface
!-------------------------------- c_ncvid -------------------------------------
Interface
 Function c_ncvid(ncid, varname, rcode) BIND(C)
 
 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid
 Character(KIND=C_CHAR), Intent(IN)  :: varname(*)
 Integer(KIND=C_INT),    Intent(OUT) :: rcode

 Integer(KIND=C_INT)                 :: c_ncvid

 End Function c_ncvid
End Interface
!-------------------------------- c_nctlen ------------------------------------
Interface
 Function c_nctlen(datatype, rcode) BIND(C)
 
 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: datatype ! nc_type var in C
 Integer(KIND=C_INT), Intent(OUT) :: rcode

 Integer(KIND=C_INT)              :: c_nctlen

 End Function c_nctlen
End Interface
!-------------------------------- c_ncclos ------------------------------------
Interface
 Subroutine c_ncclos(ncid, rcode) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: ncid 
 Integer(KIND=C_INT), Intent(OUT) :: rcode

 End Subroutine c_ncclos
End Interface
!-------------------------------- c_ncredf ------------------------------------
Interface
 Subroutine c_ncredf(ncid, rcode) BIND(C)
 
 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: ncid 
 Integer(KIND=C_INT), Intent(OUT) :: rcode

 End Subroutine c_ncredf
End Interface
!-------------------------------- c_ncendf ------------------------------------
Interface
 Subroutine c_ncendf(ncid, rcode) BIND(C)
 
 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: ncid 
 Integer(KIND=C_INT), Intent(OUT) :: rcode

 End Subroutine c_ncendf
End Interface
!-------------------------------- c_ncinq -------------------------------------
Interface
 Subroutine c_ncinq(ncid, indims, invars, inatts, irecdim, rcode) BIND(C)
 
 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: ncid
 Integer(KIND=C_INT), Intent(OUT) :: indims, invars, inatts, irecdim, rcode

 End Subroutine c_ncinq
End Interface
!-------------------------------- c_ncsnc -------------------------------------
Interface
 Subroutine c_ncsnc(ncid, rcode) BIND(C)
 
 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: ncid 
 Integer(KIND=C_INT), Intent(OUT) :: rcode

 End Subroutine c_ncsnc
End Interface
!-------------------------------- c_ncabor ------------------------------------
Interface
 Subroutine c_ncabor(ncid, rcode) BIND(C)
 
 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: ncid 
 Integer(KIND=C_INT), Intent(OUT) :: rcode

 End Subroutine c_ncabor
End Interface
!-------------------------------- c_ncdinq -----------------------------------
Interface
 Subroutine c_ncdinq(ncid, dimid, dimname, size, rcode) BIND(C)
 
 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid , dimid
 Character(KIND=C_CHAR), Intent(OUT) :: dimname(*)
 Integer(KIND=C_INT),    Intent(OUT) :: size, rcode

 End Subroutine c_ncdinq
End Interface
!-------------------------------- c_ncdren ------------------------------------
Interface
 Subroutine c_ncdren(ncid, dimid, dimname, rcode) BIND(C)
 
 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid , dimid
 Character(KIND=C_CHAR), Intent(IN)  :: dimname(*)
 Integer(KIND=C_INT),    Intent(OUT) :: rcode

 End Subroutine c_ncdren
End Interface
!-------------------------------- c_ncviq -------------------------------------
Interface
 Subroutine c_ncvinq(ncid, varid, varname, datatype, indims, dimarray, &
                      inatts, rcode) BIND(C)
 
 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE         :: ncid , varid
 Character(KIND=C_CHAR), Intent(INOUT) :: varname(*)
 Integer(KIND=C_INT),    Intent(OUT)   :: datatype ! nc_type var in C
 Integer(KIND=C_INT),    Intent(OUT)   :: dimarray(*)
 Integer(KIND=C_INT),    Intent(OUT)   :: indims, inatts, rcode

 End Subroutine c_ncvinq
End Interface
!-------------------------------- c_ncvpt1 ------------------------------------
Interface
 Subroutine c_ncvpt1(ncid, varid, indices, value, rcode) BIND(C) 
 
 USE ISO_C_BINDING, ONLY: C_INT, C_PTR

 Integer(KIND=C_INT), VALUE       :: ncid , varid
 TYPE(C_PTR),         VALUE       :: indices
 Type(C_PTR),         VALUE       :: value
 Integer(KIND=C_INT), Intent(OUT) :: rcode

 End Subroutine c_ncvpt1
End Interface
!-------------------------------- c_ncvp1c ------------------------------------
Interface
 Subroutine c_ncvp1c(ncid, varid, indices, value, rcode) BIND(C) 
 
 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid , varid
 TYPE(C_PTR),            VALUE       :: indices
 Character(KIND=C_CHAR), Intent(IN)  :: value(*) ! void in C
 Integer(KIND=C_INT),    Intent(OUT) :: rcode

 End Subroutine c_ncvp1c
End Interface
!-------------------------------- c_ncvpt -------------------------------------
Interface
 Subroutine c_ncvpt(ncid, varid, start, count, value, rcode) BIND(C) 
 
 USE ISO_C_BINDING, ONLY: C_INT, C_PTR

 Integer(KIND=C_INT), VALUE       :: ncid , varid
 Type(C_PTR),         VALUE       :: start, count
 Type(C_PTR),         VALUE       :: value
 Integer(KIND=C_INT), Intent(OUT) :: rcode

 End Subroutine c_ncvpt
End Interface
!-------------------------------- c_ncvptc ------------------------------------
Interface
 Subroutine c_ncvptc(ncid, varid, start, count, value, lenstr, rcode) BIND(C)
 
 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid , varid, lenstr
 Type(C_PTR),            VALUE       :: start, count
 Character(KIND=C_CHAR), Intent(IN)  :: value(*) ! char in C
 Integer(KIND=C_INT),    Intent(OUT) :: rcode

 End Subroutine c_ncvptc
End Interface
!-------------------------------- c_ncvptg ------------------------------------
Interface
 Subroutine c_ncvptg(ncid, varid, start, count, strides, imap, value, &
                      rcode) BIND(C)
 
 USE ISO_C_BINDING, ONLY: C_INT, C_PTR

 Integer(KIND=C_INT), VALUE       :: ncid , varid
 Type(C_PTR),         VALUE       :: start, count, strides, imap
 Type(C_PTR),         VALUE       :: value
 Integer(KIND=C_INT), Intent(OUT) :: rcode

 End Subroutine c_ncvptg
End Interface
!-------------------------------- c_ncvpgc ------------------------------------
Interface
 Subroutine c_ncvpgc(ncid, varid, start, count, strides, imap, value, &
                        rcode) BIND(C) 
 
 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid , varid
 Type(C_PTR),            VALUE       :: start, count, strides, imap
 Character(KIND=C_CHAR), Intent(IN)  :: value(*) ! char in C
 Integer(KIND=C_INT),    Intent(OUT) :: rcode

 End Subroutine c_ncvpgc
End Interface
!-------------------------------- c_ncvgt1 ------------------------------------
Interface
 Subroutine c_ncvgt1(ncid, varid, indices, value, rcode) BIND(C)
 
 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid , varid
 Type(C_PTR),            VALUE       :: indices
 Character(KIND=C_CHAR), Intent(OUT) :: value(*) ! void in C
 Integer(KIND=C_INT),    Intent(OUT) :: rcode

 End Subroutine c_ncvgt1
End Interface
!-------------------------------- c_ncvg1c ------------------------------------
Interface
 Subroutine c_ncvg1c(ncid, varid, indices, value, rcode) BIND(C)
 
 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT),    VALUE         :: ncid , varid
 Type(C_PTR),            VALUE         :: indices
 Character(KIND=C_CHAR), Intent(INOUT) :: value(*) ! char in C
 Integer(KIND=C_INT),    Intent(OUT)   :: rcode

 End Subroutine c_ncvg1c
End Interface
!-------------------------------- c_ncvgt -------------------------------------
Interface
 Subroutine c_ncvgt(ncid, varid, start, count, value, rcode) BIND(C)
 
 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid , varid
 Type(C_PTR),            VALUE       :: start, count
 Character(KIND=C_CHAR), Intent(OUT) :: value(*) ! void in C
 Integer(KIND=C_INT),    Intent(OUT) :: rcode

 End Subroutine c_ncvgt
End Interface
!-------------------------------- c_ncvgtc ------------------------------------
Interface
 Subroutine c_ncvgtc(ncid, varid, start, count, value, lenstr, rcode) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT),    VALUE         :: ncid , varid, lenstr
 Type(C_PTR),            VALUE         :: start, count
 Character(KIND=C_CHAR), Intent(INOUT) :: value(*) ! char in C
 Integer(KIND=C_INT),    Intent(OUT)   :: rcode

 End Subroutine c_ncvgtc
End Interface
!-------------------------------- c_ncvgtg ------------------------------------
Interface
 Subroutine c_ncvgtg(ncid, varid, start, count, strides, imap, value, &
                      rcode) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid , varid
 Type(C_PTR),            VALUE       :: start, count, strides,  imap
 Character(KIND=C_CHAR), Intent(OUT) :: value(*) ! void in C
 Integer(KIND=C_INT),    Intent(OUT) :: rcode

 End Subroutine c_ncvgtg
End Interface
!-------------------------------- c_ncvggc ------------------------------------
Interface
 Subroutine c_ncvggc(ncid, varid, start, count, strides, imap, value, &
                      rcode) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid , varid
 Type(C_PTR),            VALUE       :: start, count, strides, imap
 Character(KIND=C_CHAR), Intent(OUT) :: value(*) ! char in C
 Integer(KIND=C_INT),    Intent(OUT) :: rcode

 End Subroutine c_ncvggc
End Interface
!-------------------------------- c_ncvren ------------------------------------
Interface
 Subroutine c_ncvren(ncid, varid, varname, rcode) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid , varid
 Character(KIND=C_CHAR), Intent(IN)  :: varname(*)
 Integer(KIND=C_INT),    Intent(OUT) :: rcode

 End Subroutine c_ncvren
End Interface
!-------------------------------- c_ncapt -------------------------------------
Interface
 Subroutine c_ncapt(ncid, varid, attname, datatype, attlen, value, &
                     rcode) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_SIZE_T, C_CHAR, C_PTR

 Integer(KIND=C_INT),    VALUE       :: ncid , varid
 Character(KIND=C_CHAR), Intent(IN)  :: attname(*)
 Integer(KIND=C_INT),    VALUE       :: datatype ! nc_type var in C
 Integer(KIND=C_SIZE_T), VALUE       :: attlen
 Type(C_PTR),            VALUE       :: value ! void in C
 Integer(KIND=C_INT),    Intent(OUT) :: rcode

 End Subroutine c_ncapt
End Interface
!-------------------------------- c_ncaptc ------------------------------------
Interface
 Subroutine c_ncaptc(ncid, varid, attname, datatype, attlen, string, &
                      rcode) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_SIZE_T, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid , varid
 Character(KIND=C_CHAR), Intent(IN)  :: attname(*)
 Integer(KIND=C_INT),    VALUE       :: datatype ! nc_type var in C
 Integer(KIND=C_SIZE_T), VALUE       :: attlen
 Character(KIND=C_CHAR), Intent(IN)  :: string(*) ! char in C
 Integer(KIND=C_INT),    Intent(OUT) :: rcode

 End Subroutine c_ncaptc
End Interface
!-------------------------------- c_ncainq ------------------------------------
Interface
 Subroutine c_ncainq(ncid, varid, attname, datatype, attlen, rcode) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid , varid
 Character(KIND=C_CHAR), Intent(IN)  :: attname(*)
 Integer(KIND=C_INT),    Intent(OUT) :: datatype ! nc_type var in C
 Integer(KIND=C_INT),    Intent(OUT) :: attlen
 Integer(KIND=C_INT),    Intent(OUT) :: rcode

 End Subroutine c_ncainq
End Interface
!-------------------------------- c_ncagt -------------------------------------
Interface
 Subroutine c_ncagt(ncid, varid, attname, value, rcode) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid , varid
 Character(KIND=C_CHAR), Intent(IN)  :: attname(*)
 Character(KIND=C_CHAR), Intent(OUT) :: value(*) ! void in C
 Integer(KIND=C_INT),    Intent(OUT) :: rcode

 End Subroutine c_ncagt
End Interface
!-------------------------------- c_ncagtc ------------------------------------
Interface
 Subroutine c_ncagtc(ncid, varid, attname, value, attlen, rcode) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid , varid, attlen
 Character(KIND=C_CHAR), Intent(IN)  :: attname(*)
 Character(KIND=C_CHAR), Intent(OUT) :: value(*) ! char in C
 Integer(KIND=C_INT),    Intent(OUT) :: rcode

 End Subroutine c_ncagtc
End Interface
!-------------------------------- c_ncacpy ------------------------------------
Interface
 Subroutine c_ncacpy(inncid, invarid, attname, outncid, outvarid, &
                      rcode) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: inncid , invarid, outncid, outvarid 
 Character(KIND=C_CHAR), Intent(IN)  :: attname(*)
 Integer(KIND=C_INT),    Intent(OUT) :: rcode

 End Subroutine c_ncacpy
End Interface
!-------------------------------- c_ncanam ------------------------------------
Interface
 Subroutine c_ncanam(ncid, varid, attnum, newname, rcode) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE         :: ncid , varid, attnum
 Character(KIND=C_CHAR), Intent(INOUT) :: newname(*)
 Integer(KIND=C_INT),    Intent(OUT)   :: rcode

 End Subroutine c_ncanam
End Interface
!-------------------------------- c_ncaren ------------------------------------
Interface
 Subroutine c_ncaren(ncid, varid, attnam, newname, rcode) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid , varid
 Character(KIND=C_CHAR), Intent(IN)  :: attnam(*), newname(*)
 Integer(KIND=C_INT),    Intent(OUT) :: rcode

 End Subroutine c_ncaren
End Interface
!-------------------------------- c_ncadel ------------------------------------
Interface
 Subroutine c_ncadel(ncid, varid, attname, rcode) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid , varid
 Character(KIND=C_CHAR), Intent(IN)  :: attname(*)
 Integer(KIND=C_INT),    Intent(OUT) :: rcode

 End Subroutine c_ncadel
End Interface
!-------------------------------- c_ncsfil ------------------------------------
Interface
 Function c_ncsfil(ncid, fillmode, rcode) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: ncid , fillmode 
 Integer(KIND=C_INT), Intent(OUT) :: rcode

 Integer(KIND=C_INT)              :: c_ncsfil

 End Function c_ncsfil
End Interface
!---------------------------------v2data_size ---------------------------------
Interface
 Function v2data_size(datatype) BIND(C) 
!
! New function added to fort-v2compat.c
!
 USE ISO_C_BINDING, ONLY: C_INT, C_SIZE_T

 Integer(KIND=C_INT),   VALUE :: datatype
 Integer(KIND=C_SIZE_T)       :: v2data_size

 End Function v2data_size  
End Interface

CONTAINS

Subroutine convert_v2_imap(cncid, cvarid, fmap, cmap, inullp)

! Replacement for f2c_v2imap C function. Uses v2data_size to return
! data size defined for C code. A futher test will be made using
! C interop value.s for FORTRAN side
!
!   USE ISO_C_BINDING, ONLY: C_INT, C_SIZE_T
!   USE NETCDF_NC_DATA, ONLY: C_PTRDIFF_T
!   USE netcdf_nc_interfaces, ONLY: NC_CHAR, NC_SHORT, NC_INT, NC_FLOAT, &
!                                   NC_BYTE, NC_DOUBLE, NC_MAX_VAR_DIMS, &

! USE netcdf_nc_interfaces, ONLY: nc_inq_vartype, nc_inq_varndims,     &
!                                 nc_inq_vardimid, nc_inq_dimlen,      &
!                                 NC_NOERR , NC_MAX_VAR_DIMS
   
 Implicit NONE

 Integer(KIND=C_INT),       Intent(IN)    :: cncid, cvarid
 Integer(KIND=C_INT),       Intent(IN)    :: fmap(*)
 Integer(KIND=C_PTRDIFF_T), Intent(INOUT) :: cmap(*)
 Integer,                   Intent(OUT)   :: inullp

 Integer(KIND=C_INT)    :: rank, datatype, cstat1, cstat2, cstat3, cstat4
 Integer(KIND=C_SIZE_T) :: total, length, csize
 Integer(KIND=C_INT)    :: dimids(NC_MAX_VAR_DIMS)
 Integer                :: ii, idim

!
 inullp=0

 cstat1 = nc_inq_vartype(cncid, cvarid, datatype)
 cstat2 = nc_inq_varndims(cncid, cvarid, rank)

! Return if nc_inq_vartype or nc_inq_varndims returns an error
! code. Set inullp to trigger use of NULL pointer in calling 
! routine
 
 If (cstat1/=NC_NOERR) Then
   inullp=1
   Return
 EndIf
 If (cstat2/=NC_NOERR) Then
   inullp=1
   Return
 EndIf
 If (rank <= 0) Then
   inullp=1
   Return
 EndIf

 If (fmap(1)==0) Then ! Special Fortran version 2 sematics
   cstat3 = nc_inq_vardimid(cncid, cvarid, dimids)
   If (cstat3 /= NC_NOERR) Then
     inullp=1
     Return
   EndIf
!
   total = 1
   Loop1: Do ii=1, rank
     idim = rank-ii+1
     cmap(idim) = total
     cstat4 = nc_inq_dimlen(cncid, dimids(idim), length)
     If (cstat4 /= NC_NOERR) Then
       inullp=1
       Exit Loop1
     EndIf
     total = total*length
   EndDo Loop1
   If (inullp==1) Return

 Else ! Standard version 2 format - Use KIND parameters to set size

! Get C data type size using v2data_size. Unfortunately, the F03
! standard didn't specify a C_SIZEOF function. This will be
! remedied in the next upgrade to FORTRAN (2008) but for now
! we will rely on a C function to provide the value

   csize = v2data_size(datatype) 
   If (csize <= 0) Then
      inullp=1
      Return 
   EndIf

   cmap(1:rank) = fmap(rank:1:-1) / csize

 EndIf

End Subroutine convert_v2_imap

!-------------------- End module_netcdf_fortv2_c_interfaces -------------------
End Module netcdf_fortv2_c_interfaces

  !
  ! Dimension routines:
  !
  ! -----------
  function nf90_def_dim(ncid, name, len, dimid)
    integer,             intent( in) :: ncid
    character (len = *), intent( in) :: name
    integer,             intent( in) :: len
    integer,             intent(out) :: dimid
    integer                          :: nf90_def_dim
  
    nf90_def_dim = nf_def_dim(ncid, name, len, dimid)
  end function nf90_def_dim
  ! -----------
  function nf90_inq_dimid(ncid, name, dimid)
    integer,             intent( in) :: ncid
    character (len = *), intent( in) :: name
    integer,             intent(out) :: dimid
    integer                          :: nf90_inq_dimid
    
    nf90_inq_dimid = nf_inq_dimid(ncid, name, dimid)
  end function nf90_inq_dimid
  ! -----------
  function nf90_rename_dim(ncid, dimid, name)
    integer,             intent( in) :: ncid
    character (len = *), intent( in) :: name
    integer,             intent( in) :: dimid
    integer                          :: nf90_rename_dim

    nf90_rename_dim = nf_rename_dim(ncid, dimid, name)
  end function nf90_rename_dim
  ! -----------
  function nf90_inquire_dimension(ncid, dimid, name, len)
    integer,                       intent( in) :: ncid, dimid
    character (len = *), optional, intent(out) :: name
    integer,             optional, intent(out) :: len
    integer                                    :: nf90_inquire_dimension
    
    character (len = nf90_max_name) :: dimName
    integer                         :: length
    
    nf90_inquire_dimension = nf_inq_dim(ncid, dimid, dimName, length)
    if(present(name)) name = trim(dimName)
    if(present(len )) len  = length
  end function nf90_inquire_dimension
  ! -----------

!------------ Array/string put/get routines for a given varid ----------------

! Replacement for fort-vario.c

! Written by: Richard Weed, Ph.D.
!             Center For Advanced Vehicular Systems 
!             Mississippi State University
!             rweed@cavs.msstate.edu
  

! License (and other Lawyer Language)
 
! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Corporation for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1.: Sept. 2005 - Initial Cray X1 version
! Version 2.: May   2006 - Updated to support g95
! Version 3.: April 2009 - Updated for netCDF 4.0.1
! Version 4.: April 2010 - Updated for netCDF 4.1.1
!                          Added preprocessor tests for int and real types
! Version 5.: Jan.  2016 - Some minor code cleanup

!--------------------------------- nf_put_var_text -----------------------
 Function nf_put_var_text(ncid, varid, text) RESULT(status)

! Write out a character string to dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN) :: ncid, varid
 Character(LEN=*), Intent(IN) :: text

 Integer                      :: status

 Integer(C_INT) :: cncid, cvarid,  cstatus

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

 cstatus = nc_put_var_text(cncid, cvarid, text)

 status = cstatus

 End Function nf_put_var_text
!--------------------------------- nf_put_var_text_a -----------------------
 Function nf_put_var_text_a(ncid, varid, text) RESULT(status)

! Write out array of characters to dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN) :: ncid, varid
 Character(LEN=1), Intent(IN) :: text(*)

 Integer                      :: status

 Integer(C_INT) :: cncid, cvarid,  cstatus

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

 cstatus = nc_put_var_text(cncid, cvarid, text)

 status = cstatus

 End Function nf_put_var_text_a
!--------------------------------- nf_put_var_int1 -------------------------
 Function nf_put_var_int1(ncid, varid, i1vals) RESULT(status)

! Write out 8 bit integer array to dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,         Intent(IN) :: ncid, varid
 Integer(NFINT1), Intent(IN) :: i1vals(*)

 Integer                     :: status

 Integer(C_INT) :: cncid, cvarid,  cstatus

 If (C_SIGNED_CHAR < 0) Then ! schar not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

#if NF_INT1_IS_C_SIGNED_CHAR
 cstatus = nc_put_var_schar(cncid, cvarid, i1vals)
#elif NF_INT1_IS_C_SHORT
 cstatus = nc_put_var_short(cncid, cvarid, i1vals)
#elif NF_INT1_IS_C_INT
 cstatus = nc_put_var_int(cncid, cvarid, i1vals)
#elif NF_INT1_IS_C_LONG
 cstatus = nc_put_var_long(cncid, cvarid, i1vals)
#endif

 status = cstatus

 End Function nf_put_var_int1
!--------------------------------- nf_put_var_int2 -------------------------
 Function nf_put_var_int2(ncid, varid, i2vals) RESULT(status)

! Write out 16 bit integer array to dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,         Intent(IN) :: ncid, varid
 Integer(NFINT2), Intent(IN) :: i2vals(*)

 Integer                     :: status

 Integer(C_INT) :: cncid, cvarid,  cstatus

 If (C_SHORT < 0) Then ! short not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

#if NF_INT2_IS_C_SHORT
 cstatus = nc_put_var_short(cncid, cvarid, i2vals)
#elif NF_INT2_IS_C_INT
 cstatus = nc_put_var_int(cncid, cvarid, i2vals)
#elif NF_INT2_IS_C_LONG
 cstatus = nc_put_var_long(cncid, cvarid, i2vals)
#endif

 status = cstatus

 End Function nf_put_var_int2
!--------------------------------- nf_put_var_int --------------------------
 Function nf_put_var_int(ncid, varid, ivals) RESULT(status)

! Write out 32 bit integer array to dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,        Intent(IN) :: ncid, varid
 Integer(NFINT), Intent(IN) :: ivals(*)

 Integer                    :: status

 Integer(C_INT) :: cncid, cvarid,  cstatus

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

#if NF_INT_IS_C_INT
 cstatus = nc_put_var_int(cncid, cvarid, ivals)
#elif NF_INT_IS_C_LONG
 cstatus = nc_put_var_long(cncid, cvarid, ivals)
#endif

 status = cstatus

 End Function nf_put_var_int
!--------------------------------- nf_put_var_real -------------------------
 Function nf_put_var_real(ncid, varid, rvals) RESULT(status)

! Write out 32 bit real array to dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,         Intent(IN) :: ncid, varid
 Real(NFREAL),    Intent(IN) :: rvals(*)

 Integer                     :: status

 Integer(C_INT) :: cncid, cvarid,  cstatus

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

#if NF_REAL_IS_C_DOUBLE
 cstatus = nc_put_var_double(cncid, cvarid, rvals)
#else
 cstatus = nc_put_var_float(cncid, cvarid, rvals)
#endif

 status = cstatus

 End Function nf_put_var_real
!--------------------------------- nf_put_var_double -----------------------
 Function nf_put_var_double(ncid, varid, dvals) RESULT(status)

! Write out 64 bit real array to dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,   Intent(IN) :: ncid, varid
 Real(RK8), Intent(IN) :: dvals(*)

 Integer               :: status

 Integer(C_INT) :: cncid, cvarid,  cstatus

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

 cstatus = nc_put_var_double(cncid, cvarid, dvals)

 status = cstatus

 End Function nf_put_var_double
!--------------------------------- nf_put_var_int64 --------------------------
 Function nf_put_var_int64(ncid, varid, ivals) RESULT(status)

! Write out 64 bit integer array to dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,      Intent(IN) :: ncid, varid
 Integer(IK8), Intent(IN) :: ivals(*)

 Integer                       :: status

 Integer(C_INT) :: cncid, cvarid,  cstatus

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

 cstatus = nc_put_var_longlong(cncid, cvarid, ivals)

 status = cstatus

 End Function nf_put_var_int64
!--------------------------------- nf_get_var_text -----------------------
 Function nf_get_var_text(ncid, varid, text) RESULT(status)

! Read in a character string from dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(OUT) :: text

 Integer                       :: status

 Integer(C_INT) :: cncid, cvarid,  cstatus

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid
 text   = REPEAT(" ", LEN(text))

 cstatus = nc_get_var_text(cncid, cvarid, text)

 status = cstatus

 End Function nf_get_var_text
!--------------------------------- nf_get_var_text_a -----------------------
 Function nf_get_var_text_a(ncid, varid, text) RESULT(status)

! Read in array of characters from dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=1), Intent(OUT) :: text(*)

 Integer                       :: status

 Integer(C_INT) :: cncid, cvarid,  cstatus

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

 cstatus = nc_get_var_text(cncid, cvarid, text)

 status = cstatus

 End Function nf_get_var_text_a
!--------------------------------- nf_get_var_int1 -------------------------
 Function nf_get_var_int1(ncid, varid, i1vals) RESULT(status)

! Read in 8 bit integer array from dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,         Intent(IN)  :: ncid, varid
 Integer(NFINT1), Intent(OUT) :: i1vals(*)

 Integer                      :: status

 Integer(C_INT) :: cncid, cvarid,  cstatus

 If (C_SIGNED_CHAR < 0) Then ! schar not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

#if NF_INT1_IS_C_SIGNED_CHAR
 cstatus = nc_get_var_schar(cncid, cvarid, i1vals)
#elif NF_INT1_IS_C_SHORT
 cstatus = nc_get_var_short(cncid, cvarid, i1vals)
#elif NF_INT1_IS_C_INT
 cstatus = nc_get_var_int(cncid, cvarid, i1vals)
#elif NF_INT1_IS_C_LONG
 cstatus = nc_get_var_long(cncid, cvarid, i1vals)
#endif

 status = cstatus

 End Function nf_get_var_int1
!--------------------------------- nf_get_var_int2 -------------------------
 Function nf_get_var_int2(ncid, varid, i2vals) RESULT(status)

! Read in 16 bit integer array from dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,         Intent(IN)  :: ncid, varid
 Integer(NFINT2), Intent(OUT) :: i2vals(*)

 Integer                      :: status

 Integer(C_INT) :: cncid, cvarid,  cstatus

 If (C_SHORT < 0) Then ! short not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

#if NF_INT2_IS_C_SHORT
 cstatus = nc_get_var_short(cncid, cvarid, i2vals)
#elif NF_INT2_IS_C_INT
 cstatus = nc_get_var_int(cncid, cvarid, i2vals)
#elif NF_INT2_IS_C_LONG
 cstatus = nc_get_var_long(cncid, cvarid, i2vals)
#endif

 status = cstatus

 End Function nf_get_var_int2
!--------------------------------- nf_get_var_int --------------------------
 Function nf_get_var_int(ncid, varid, ivals) RESULT(status)

! Read in default integer array from dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,        Intent(IN)  :: ncid, varid
 Integer(NFINT), Intent(OUT) :: ivals(*)

 Integer                     :: status

 Integer(C_INT) :: cncid, cvarid,  cstatus

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

#if NF_INT_IS_C_INT
 cstatus = nc_get_var_int(cncid, cvarid, ivals)
#elif NF_INT_IS_C_LONG
 cstatus = nc_get_var_long(cncid, cvarid, ivals)
#endif

 status = cstatus

 End Function nf_get_var_int
!--------------------------------- nf_get_var_real -------------------------
 Function nf_get_var_real(ncid, varid, rvals) RESULT(status)

! Read in 32 bit real array from dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,      Intent(IN)  :: ncid, varid
 Real(NFREAL), Intent(OUT) :: rvals(*)

 Integer                   :: status

 Integer(C_INT) :: cncid, cvarid,  cstatus

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

#if NF_REAL_IS_C_DOUBLE
 cstatus = nc_get_var_double(cncid, cvarid, rvals)
#else
 cstatus = nc_get_var_float(cncid, cvarid, rvals)
#endif

 status = cstatus

 End Function nf_get_var_real
!--------------------------------- nf_get_var_double -----------------------
 Function nf_get_var_double(ncid, varid, dvals) RESULT(status)

! Read in 64 bit real array from dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,   Intent(IN)  :: ncid, varid
 Real(RK8), Intent(OUT) :: dvals(*)

 Integer                :: status

 Integer(C_INT) :: cncid, cvarid, cstatus

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

 cstatus = nc_get_var_double(cncid, cvarid, dvals)

 status = cstatus

 End Function nf_get_var_double
!--------------------------------- nf_get_var_int64 --------------------------
 Function nf_get_var_int64(ncid, varid, ivals) RESULT(status)

! Read in 64 bit integer array from dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,      Intent(IN)  :: ncid, varid
 Integer(IK8), Intent(OUT) :: ivals(*)

 Integer                   :: status

 Integer(C_INT) :: cncid, cvarid,  cstatus

 cncid  = ncid
 cvarid = varid - 1 ! Subtract 1 to get C varid

 cstatus = nc_get_var_longlong(cncid, cvarid, ivals)

 status = cstatus

 End Function nf_get_var_int64

#include "nfconfig.inc"
!---------- Routines to put/get attribute data of various data types ----------

! Replacement for fort-attio.c

! Written by: Richard Weed, Ph.D.
!             Center for Advanced Vehicular Systems 
!             Mississippi State University
!             rweed@cavs.msstate.edu


! License (and other Lawyer Language)
 
! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Center for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1.: Sept. 2005 - Initial Cray X1 version
! Version 2.: May 2006   - Updated to support g95
! Version 3.: April 2009 - Updated to Netcdf 4.0.1 
! Version 4.: April 2010 - Updated to Netcdf 4.1.1 
! Version 5.: Feb.  2013 - bug fixes for fortran 4.4
          
!--------------------------------- nf_put_att_text ---------------------------
 Function nf_put_att_text(ncid, varid, name, nlen, text) RESULT(status)

! Write variable or global attribute text string to dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN) :: ncid, varid, nlen
 Character(LEN=*), Intent(IN) :: name, text

 Integer                      :: status

 Integer(KIND=C_INT)          :: cncid, cvarid, cstatus
 Integer(KIND=C_SIZE_T)       :: cnlen
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 cvarid = varid -1 ! Subtract 1 to get C varid
 cnlen  = nlen

 cname = addCNullChar(name, ie)
 
 cstatus = nc_put_att_text(cncid, cvarid, cname(1:ie+1), cnlen, &
           text)

 status = cstatus

 End Function nf_put_att_text
!--------------------------------- nf_put_att_text_a ------------------------
 Function nf_put_att_text_a(ncid, varid, name, nlen, text) RESULT(status)

! New routine to support passing an array of single characters
! Write variable or global attribute array of characters to dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN) :: ncid, varid, nlen
 Character(LEN=*), Intent(IN) :: name
 Character(LEN=1), Intent(IN) :: text(*)

 Integer                      :: status

 Integer(KIND=C_INT)          :: cncid, cvarid, cstatus
 Integer(KIND=C_SIZE_T)       :: cnlen
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 cvarid = varid -1 ! Subtract 1 to get C varid
 cnlen  = nlen

 cname = addCNullChar(name, ie)
 
 cstatus = nc_put_att_text(cncid, cvarid, cname(1:ie+1), cnlen, &
                           text)

 status = cstatus

 End Function nf_put_att_text_a
!--------------------------------- nf_put_att_int1 -------------------------
 Function nf_put_att_int1(ncid, varid, name, xtype, nlen, i1vals) &
                          RESULT(status)

! Write variable or global attribute byte data to dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,              Intent(IN) :: ncid, varid, nlen, xtype

 Character(LEN=*),     Intent(IN) :: name
 Integer(KIND=NFINT1), Intent(IN) :: i1vals(*)

 Integer                          :: status

 Integer(KIND=C_INT)             :: cncid, cvarid, cstatus, cxtype
 Integer(KIND=C_SIZE_T)          :: cnlen
 Character(LEN=(LEN(name)+1))    :: cname
 Integer                         :: ie

 If (C_SIGNED_CHAR < 0) Then ! schar not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf
 
 cncid  = ncid
 cvarid = varid -1 ! Subtract 1 to get C varid
 cnlen  = nlen
 cxtype = xtype

! Check for C null char on name and add one
 
 cname = addCNullChar(name, ie)

#if NF_INT1_IS_C_SIGNED_CHAR 
 cstatus = nc_put_att_schar(cncid, cvarid, cname(1:ie+1), &
                           cxtype, cnlen, i1vals) 
#elif NF_INT1_IS_C_SHORT
 cstatus = nc_put_att_short(cncid, cvarid, cname(1:ie+1), &
                            cxtype, cnlen, i1vals)
#elif NF_INT1_IS_C_INT
 cstatus = nc_put_att_int(cncid, cvarid, cname(1:ie+1), &
                            cxtype, cnlen, i1vals)
#elif NF_INT1_IS_C_LONG
 cstatus = nc_put_att_long(cncid, cvarid, cname(1:ie+1), &
                           cxtype, cnlen, i1vals)
#endif
 status = cstatus

 End Function nf_put_att_int1
!--------------------------------- nf_put_att_int2 -------------------------
 Function nf_put_att_int2(ncid, varid, name, xtype, nlen, i2vals) &
                          RESULT(status)

! Write variable or global attribute 16 bit integer data to dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,              Intent(IN) :: ncid, varid, nlen, xtype

 Character(LEN=*),     Intent(IN) :: name
 Integer(KIND=NFINT2), Intent(IN) :: i2vals(*)

 Integer                          :: status

 Integer(KIND=C_INT)             :: cncid, cvarid, cstatus, cxtype
 Integer(KIND=C_SIZE_T)          :: cnlen
 Character(LEN=(LEN(name)+1))    :: cname
 Integer                         :: ie

 If (C_SHORT < 0) Then ! short not supported by processor
   status = NC_EBADTYPE
   Return
 EndIf
 
 cncid  = ncid
 cvarid = varid -1 ! Subtract 1 to get C varid
 cnlen  = nlen
 cxtype = xtype

 cname = addCNullChar(name, ie)

#if NF_INT2_IS_C_SHORT 
 cstatus = nc_put_att_short(cncid, cvarid, cname(1:ie+1), &
                            cxtype, cnlen, i2vals) 
#elif NF_INT2_IS_C_INT 
 cstatus = nc_put_att_int(cncid, cvarid, cname(1:ie+1), &
                           cxtype, cnlen, i2vals)
#elif NF_INT2_IS_C_LONG 
 cstatus = nc_put_att_long(cncid, cvarid, cname(1:ie+1), &
                           cxtype, cnlen, i2vals)
#endif 
 status = cstatus

 End Function nf_put_att_int2
!--------------------------------- nf_put_att_int --------------------------
 Function nf_put_att_int(ncid, varid, name, xtype, nlen, ivals) &
                         RESULT(status)

! Write variable or global attribute default integer data to dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN) :: ncid, varid, nlen, xtype

 Character(LEN=*), Intent(IN) :: name
 Integer(NFINT),   Intent(IN) :: ivals(*)

 Integer                      :: status

 Integer(KIND=C_INT)          :: cncid, cvarid, cstatus, cxtype
 Integer(KIND=C_SIZE_T)       :: cnlen
 Character(LEN=(LEN(name)+1)) :: cname
 Integer :: ie

 cncid  = ncid
 cvarid = varid -1 ! Subtract 1 to get C varid
 cnlen  = nlen
 cxtype = xtype

! Check for C null char and add one if missing

 cname = addCNullChar(name, ie)

#if NF_INT_IS_C_INT 
 cstatus = nc_put_att_int(cncid, cvarid, cname(1:ie+1), &
                          cxtype, cnlen, ivals) 
#elif NF_INT_IS_C_LONG 
 cstatus = nc_put_att_long(cncid, cvarid, cname(1:ie+1), &
                          cxtype, cnlen, ivals) 
#endif
 status = cstatus

 End Function nf_put_att_int
!--------------------------------- nf_put_att_real -------------------------
 Function nf_put_att_real(ncid, varid, name, xtype, nlen, rvals) &
                          RESULT(status)

! Write variable or global attribute Real(RK4) data to dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN) :: ncid, varid, nlen, xtype

 Character(LEN=*), Intent(IN) :: name
 Real(NFREAL),     Intent(IN) :: rvals(*)

 Integer                      :: status

 Integer(KIND=C_INT)          :: cncid, cvarid, cstatus, cxtype
 Integer(KIND=C_SIZE_T)       :: cnlen
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 cvarid = varid -1 ! Subtract 1 to get C varid
 cnlen  = nlen
 cxtype = xtype

! Check for C null char and add one if missing
 
 cname = addCNullChar(name, ie)

#if NF_REAL_IS_C_DOUBLE 
 cstatus = nc_put_att_double(cncid, cvarid, cname(1:ie+1), &
                             cxtype, cnlen, rvals) 
#else
 cstatus = nc_put_att_float(cncid, cvarid, cname(1:ie+1), &
                            cxtype, cnlen, rvals) 
#endif
 status = cstatus

 End Function nf_put_att_real
!--------------------------------- nf_put_att_double -----------------------
 Function nf_put_att_double(ncid, varid, name, xtype, nlen, dvals) &
                               RESULT(status)

! Write variable or global attribute Real(RK8) to dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN) :: ncid, varid, nlen, xtype

 Character(LEN=*), Intent(IN) :: name
 Real(RK8),        Intent(IN) :: dvals(*)

 Integer                      :: status

 Integer(KIND=C_INT)          :: cncid, cvarid, cstatus, cxtype
 Integer(KIND=C_SIZE_T)       :: cnlen
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 cvarid = varid -1 ! Subtract 1 to get C varid
 cnlen  = nlen
 cxtype = xtype

! Check for C null char and add one if missing

 cname = addCNullChar(name, ie)
 
 cstatus = nc_put_att_double(cncid, cvarid, cname(1:ie+1), &
                             cxtype, cnlen, dvals) 

 status = cstatus

 End Function nf_put_att_double
!--------------------------------- nf_get_att_text -----------------------
 Function nf_get_att_text(ncid, varid, name, text) RESULT(status)

! Read variable or global attribute character string from dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(IN)  :: name
 Character(LEN=*), Intent(OUT) :: text

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, cvarid, cstatus
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 cvarid = varid -1 ! Subtract 1 to get C varid
 text   = REPEAT(" ", LEN(text))

! Check for C null char and add one if missing

 cname = addCNullChar(name, ie)
 
 cstatus = nc_get_att_text(cncid, cvarid, cname(1:ie+1), text)

 status = cstatus

 End Function nf_get_att_text
!--------------------------------- nf_get_att_text_a -----------------------
 Function nf_get_att_text_a(ncid, varid, name, text) RESULT(status)

! New routine to support passing an array of single characters
! Read variable or global attribute array of characters from dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(IN)  :: name
 Character(LEN=1), Intent(OUT) :: text(*)

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, cvarid, cstatus
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 cvarid = varid -1 ! Subtract 1 to get C varid

! Check for C null char and add one if missing

 cname = addCNullChar(name, ie)
 
 cstatus = nc_get_att_text(cncid, cvarid, cname(1:ie+1), text)

 status = cstatus

 End Function nf_get_att_text_a
!--------------------------------- nf_get_att_int1 -------------------------
 Function nf_get_att_int1(ncid, varid, name, i1vals) RESULT(status)

! Read variable or global attribute BYTE integer data from dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,              Intent(IN)  :: ncid, varid
 Character(LEN=*),     Intent(IN)  :: name
 Integer(KIND=NFINT1), Intent(OUT) :: i1vals(*)

 Integer                          :: status

 Integer(KIND=C_INT)          :: cncid, cvarid, cstatus
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 If (C_SIGNED_CHAR < 0) Then ! schar not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf
 
 cncid  = ncid
 cvarid = varid -1 ! Subtract 1 to get C varid

! Check for C null char and add one if missing

 cname = addCNullChar(name, ie)

#if NF_INT1_IS_C_SIGNED_CHAR 
 cstatus = nc_get_att_schar(cncid, cvarid, cname(1:ie+1), i1vals)
#elif NF_INT1_IS_C_SHORT
 cstatus = nc_get_att_short(cncid, cvarid, cname(1:ie+1), i1vals)
#elif NF_INT1_IS_C_INT
 cstatus = nc_get_att_int(cncid, cvarid, cname(1:ie+1), i1vals)
#elif NF_INT1_IS_C_LONG
 cstatus = nc_get_att_long(cncid, cvarid, cname(1:ie+1), i1vals)
#endif
 status = cstatus

 End Function nf_get_att_int1
!--------------------------------- nf_get_att_int2 --------------------------
 Function nf_get_att_int2(ncid, varid, name, i2vals) RESULT(status)

! Read variable or global attribute 16 bit integer data from dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,              Intent(IN)  :: ncid, varid
 Character(LEN=*),     Intent(IN)  :: name
 Integer(KIND=NFINT2), Intent(OUT) :: i2vals(*)

 Integer                           :: status

 Integer(KIND=C_INT)          :: cncid, cvarid, cstatus
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 If (C_SHORT < 0) Then ! short not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf
 
 cncid  = ncid
 cvarid = varid -1 ! Subtract 1 to get C varid

! Check for C null char and add one if missing

 cname = addCNullChar(name, ie)
 
#if NF_INT2_IS_C_SHORT
 cstatus = nc_get_att_short(cncid, cvarid, cname(1:ie+1), i2vals) 
#elif NF_INT2_IS_C_INT
 cstatus = nc_get_att_int(cncid, cvarid, cname(1:ie+1), i2vals) 
#elif NF_INT2_IS_C_LONG
 cstatus = nc_get_att_long(cncid, cvarid, cname(1:ie+1), i2vals) 
#endif
 status = cstatus

 End Function nf_get_att_int2
!--------------------------------- nf_get_att_int ---------------------------
 Function nf_get_att_int(ncid, varid, name, ivals) RESULT(status)

! Read variable or global attribute default Integer data from dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(IN)  :: name
 Integer(NFINT),   Intent(OUT) :: ivals(*)

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, cvarid, cstatus
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 cvarid = varid -1 ! Subtract 1 to get C varid

! Check for C null char and add one if missing

 cname = addCNullChar(name, ie)

#if NF_INT_IS_C_INT 
 cstatus = nc_get_att_int(cncid, cvarid, cname(1:ie+1), ivals)
#elif NF_INT_IS_C_LONG
 cstatus = nc_get_att_long(cncid, cvarid, cname(1:ie+1), ivals)
#endif
 status = cstatus

 End Function nf_get_att_int
!--------------------------------- nf_get_att_real -------------------------
 Function nf_get_att_real(ncid, varid, name, rvals) RESULT(status)

! Read variable or global attribute Real(RK4) data from dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(IN)  :: name
 Real(NFREAL),     Intent(OUT) :: rvals(*)

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, cvarid, cstatus
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 cvarid = varid -1 ! Subtract 1 to get C varid

! Check for C null char and add one if missing

 cname = addCNullChar(name, ie)

#if NF_REAL_IS_C_DOUBLE 
 cstatus = nc_get_att_double(cncid, cvarid, cname(1:ie+1), rvals) 
#else
 cstatus = nc_get_att_float(cncid, cvarid, cname(1:ie+1), rvals) 
#endif
 status = cstatus

 End Function nf_get_att_real
!--------------------------------- nf_get_att_double -----------------------
 Function nf_get_att_double(ncid, varid, name, dvals) RESULT(status)

! Read variable or global attribute Real(RK8) data from dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(IN)  :: name
 Real(RK8),        Intent(OUT) :: dvals(*)

 Integer                       :: status

 Integer(KIND=C_INT)          :: cncid, cvarid, cstatus
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 cvarid = varid -1 ! Subtract 1 to get C varid

! Check for C null char and add one if missing

 cname = addCNullChar(name, ie)
 
 cstatus = nc_get_att_double(cncid, cvarid, cname(1:ie+1), dvals)

 status = cstatus

 End Function nf_get_att_double

!- Array/string put/get routines given start, count, stride, and map vectors -

! Replacement for fort-varmio.c

! Written by: Richard Weed, Ph.D.
!             Center for Advanced Vehicular Systems
!             Mississippi State University
!             rweed@cavs.msstate.edu


! License (and other Lawyer Language)
 
! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Corporation for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1.: Sept. 2005 - Initial Cray X1 version
! Version 2.: May   2006 - Updated to support g95
!                          Updated to pass start, counts, strides, and
!                          maps as C_PTR variables
! Version 3.: April 2009 - Updated for netCDF 4.0.1
! Version 4.: April 2010 - Updated for netCDF 4.1.1
!                          Added preprocessor tests for int and real types
! Version 5.: Jan.  2016 - Replaced automatic arrays for cstart, ccounts,
!                          cstrides, and cmaps with allocatable arrays and
!                          general code cleanup

!--------------------------------- nf_put_varm_text ----------------------
 Function nf_put_varm_text(ncid, varid, start, counts, strides, maps, &
                           text) RESULT(status)

! Write out a character string to dataset given start, count, stride and map

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN) :: ncid, varid
 Integer,          Intent(IN) :: start(*), counts(*), strides(*), maps(*)
 Character(LEN=*), Intent(IN) :: text 

 Integer                      :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr, cmapsptr 
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:), cmaps(:)

 cncid    = ncid
 cvarid   = varid -1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(1:ndims))
     ALLOCATE(ccounts(1:ndims))
     ALLOCATE(cstrides(1:ndims))
     ALLOCATE(cmaps(1:ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cmaps(1:ndims)    = maps(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
     cmapsptr          = C_LOC(cmaps)
   EndIf
 EndIf

 cstatus = nc_put_varm_text(cncid, cvarid, cstartptr, ccountsptr, &
                            cstridesptr, cmapsptr, text)

 status = cstatus

! Make sure we don't leave any dangling pointers or allocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 If (ALLOCATED(cmaps))    DEALLOCATE(cmaps)
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_put_varm_text
!--------------------------------- nf_put_varm_text_a ----------------------
 Function nf_put_varm_text_a(ncid, varid, start, counts, strides, maps, &
                                text) RESULT(status)

! Write out array of characters to dataset given start, count, stride and map

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN) :: ncid, varid
 Integer,          Intent(IN) :: start(*), counts(*), strides(*), maps(*)
 Character(LEN=1), Intent(IN) :: text(*)

 Integer                      :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr, cmapsptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:), cmaps(:)

 cncid    = ncid
 cvarid   = varid -1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(1:ndims))
     ALLOCATE(ccounts(1:ndims))
     ALLOCATE(cstrides(1:ndims))
     ALLOCATE(cmaps(1:ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cmaps(1:ndims)    = maps(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
     cmapsptr          = C_LOC(cmaps)
   EndIf
 EndIf

 cstatus = nc_put_varm_text(cncid, cvarid, cstartptr, ccountsptr, &
                            cstridesptr, cmapsptr, text) 

 status = cstatus

! Make sure we don't leave any dangling pointers or allocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 If (ALLOCATED(cmaps))    DEALLOCATE(cmaps)
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_put_varm_text_a
!--------------------------------- nf_put_varm_int1 ------------------------
 Function nf_put_varm_int1(ncid, varid, start, counts, strides, maps, &
                           i1vals) RESULT(status)

! Write out 8 bit integer array given start, count, stride and map

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,         Intent(IN) :: ncid, varid
 Integer,         Intent(IN) :: start(*), counts(*), strides(*), maps(*)
 Integer(NFINT1), Intent(IN) :: i1vals(*)

 Integer                     :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr, cmapsptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:), cmaps(:)

 If (C_SIGNED_CHAR < 0) Then ! schar not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf

 cncid    = ncid
 cvarid   = varid -1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(1:ndims))
     ALLOCATE(ccounts(1:ndims))
     ALLOCATE(cstrides(1:ndims))
     ALLOCATE(cmaps(1:ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cmaps(1:ndims)    = maps(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
     cmapsptr          = C_LOC(cmaps)
   EndIf
 EndIf

#if NF_INT1_IS_C_SIGNED_CHAR
 cstatus = nc_put_varm_schar(cncid, cvarid, cstartptr, ccountsptr, &
                             cstridesptr, cmapsptr, i1vals) 
#elif NF_INT1_IS_C_SHORT
 cstatus = nc_put_varm_short(cncid, cvarid, cstartptr, ccountsptr, &
                             cstridesptr, cmapsptr, i1vals) 
#elif NF_INT1_IS_C_INT
 cstatus = nc_put_varm_int(cncid, cvarid, cstartptr, ccountsptr, &
                           cstridesptr, cmapsptr, i1vals) 
#elif NF_INT1_IS_C_LONG
 cstatus = nc_put_varm_long(cncid, cvarid, cstartptr, ccountsptr, &
                            cstridesptr, cmapsptr, i1vals) 
#endif

 status = cstatus

! Make sure we don't leave any dangling pointers or allocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 If (ALLOCATED(cmaps))    DEALLOCATE(cmaps)
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_put_varm_int1
!--------------------------------- nf_put_varm_int2 ------------------------
 Function nf_put_varm_int2(ncid, varid, start, counts, strides, maps, &
                           i2vals) RESULT(status)

! Write out 16 bit integer array given start, count, stride and map

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,         Intent(IN) :: ncid, varid
 Integer,         Intent(IN) :: start(*), counts(*), strides(*), maps(*)
 Integer(NFINT2), Intent(IN) :: i2vals(*)

 Integer                     :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr,  cmapsptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:), cmaps(:)

 If (C_SHORT < 0) Then ! short not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf

 cncid    = ncid
 cvarid   = varid -1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(1:ndims))
     ALLOCATE(ccounts(1:ndims))
     ALLOCATE(cstrides(1:ndims))
     ALLOCATE(cmaps(1:ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cmaps(1:ndims)    = maps(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
     cmapsptr          = C_LOC(cmaps)
   EndIf
 EndIf

#if NF_INT2_IS_C_SHORT
 cstatus = nc_put_varm_short(cncid, cvarid, cstartptr, ccountsptr, &
                             cstridesptr, cmapsptr, i2vals) 
#elif NF_INT2_IS_C_INT
 cstatus = nc_put_varm_int(cncid, cvarid, cstartptr, ccountsptr, &
                           cstridesptr, cmapsptr, i2vals) 
#elif NF_INT2_IS_C_LONG
 cstatus = nc_put_varm_long(cncid, cvarid, cstartptr, ccountsptr, &
                            cstridesptr, cmapsptr, i2vals)
#endif 

 status = cstatus

! Make sure we don't leave any dangling pointers or allocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 If (ALLOCATED(cmaps))    DEALLOCATE(cmaps)
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_put_varm_int2
!--------------------------------- nf_put_varm_int -------------------------
 Function nf_put_varm_int(ncid, varid, start, counts, strides, maps, &
                             ivals) RESULT(status)

! Write out default integer array given start, count, stride and map

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,        Intent(IN) :: ncid, varid
 Integer,        Intent(IN) :: start(*), counts(*), strides(*), maps(*)
 Integer(NFINT), Intent(IN) :: ivals(*)

 Integer                    :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr, cmapsptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:), cmaps(:)

 cncid    = ncid
 cvarid   = varid -1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(1:ndims))
     ALLOCATE(ccounts(1:ndims))
     ALLOCATE(cstrides(1:ndims))
     ALLOCATE(cmaps(1:ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cmaps(1:ndims)    = maps(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
     cmapsptr          = C_LOC(cmaps)
   EndIf
 EndIf

#if NF_INT_IS_C_INT
 cstatus = nc_put_varm_int(cncid, cvarid, cstartptr, ccountsptr, &
                           cstridesptr, cmapsptr, ivals) 
#elif NF_INT_IS_C_LONG
 cstatus = nc_put_varm_long(cncid, cvarid, cstartptr, ccountsptr, &
                            cstridesptr, cmapsptr, ivals) 
#endif

 status = cstatus

! Make sure we don't leave any dangling pointers or allocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 If (ALLOCATED(cmaps))    DEALLOCATE(cmaps)
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_put_varm_int
!--------------------------------- nf_put_varm_real ------------------------
 Function nf_put_varm_real(ncid, varid, start, counts, strides, maps, &
                              rvals) RESULT(status)

! Write out 32 bit real array given start, count, stride and map

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,      Intent(IN) :: ncid, varid
 Integer,      Intent(IN) :: start(*), counts(*), strides(*), maps(*)
 Real(NFREAL), Intent(IN) :: rvals(*)

 Integer                  :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr, cmapsptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:), cmaps(:)

 cncid    = ncid
 cvarid   = varid -1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(1:ndims))
     ALLOCATE(ccounts(1:ndims))
     ALLOCATE(cstrides(1:ndims))
     ALLOCATE(cmaps(1:ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cmaps(1:ndims)    = maps(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
     cmapsptr          = C_LOC(cmaps)
   EndIf
 EndIf

#if NF_REAL_IS_C_DOUBLE
 cstatus = nc_put_varm_double(cncid, cvarid, cstartptr, ccountsptr, &
                              cstridesptr, cmapsptr, rvals) 
#else
 cstatus = nc_put_varm_float(cncid, cvarid, cstartptr, ccountsptr, &
                             cstridesptr, cmapsptr, rvals) 
#endif

 status = cstatus

! Make sure we don't leave any dangling pointers or allocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 If (ALLOCATED(cmaps))    DEALLOCATE(cmaps)
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_put_varm_real
!--------------------------------- nf_put_varm_double ----------------------
 Function nf_put_varm_double(ncid, varid, start, counts, strides, maps, &
                                dvals) RESULT(status)

! Write out 64 bit real array given start, count, stride, and map

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,   Intent(IN) :: ncid, varid
 Integer,   Intent(IN) :: start(*), counts(*), strides(*), maps(*)
 Real(RK8), Intent(IN) :: dvals(*)

 Integer               :: status

 Integer(C_INT)  :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)     :: cstartptr, ccountsptr, cstridesptr, cmapsptr
 Integer         :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:), cmaps(:)

 cncid    = ncid
 cvarid   = varid -1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(1:ndims))
     ALLOCATE(ccounts(1:ndims))
     ALLOCATE(cstrides(1:ndims))
     ALLOCATE(cmaps(1:ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cmaps(1:ndims)    = maps(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
     cmapsptr          = C_LOC(cmaps)
   EndIf
 EndIf
  
 cstatus = nc_put_varm_double(cncid, cvarid, cstartptr, ccountsptr, &
                              cstridesptr, cmapsptr, dvals) 

 status = cstatus

! Make sure we don't leave any dangling pointers or allocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 If (ALLOCATED(cmaps))    DEALLOCATE(cmaps)
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_put_varm_double
!--------------------------------- nf_put_varm_int64 -------------------------
 Function nf_put_varm_int64(ncid, varid, start, counts, strides, maps, &
                            ivals) RESULT(status)

! Write out 64 bit integer array given start, count, stride and map

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,      Intent(IN) :: ncid, varid
 Integer,      Intent(IN) :: start(*), counts(*), strides(*), maps(*)
 Integer(IK8), Intent(IN) :: ivals(*)

 Integer                  :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr, cmapsptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:), cmaps(:)

 cncid    = ncid
 cvarid   = varid -1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(ndims))
     ALLOCATE(ccounts(ndims))
     ALLOCATE(cstrides(ndims))
     ALLOCATE(cmaps(ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cmaps(1:ndims)    = maps(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
     cmapsptr          = C_LOC(cmaps)
   EndIf
 EndIf

 cstatus = nc_put_varm_longlong(cncid, cvarid, cstartptr, ccountsptr, &
                                cstridesptr, cmapsptr, ivals)

 status = cstatus

! Make sure there are no dangling pointers or allocated values

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 If (ALLOCATED(cmaps))    DEALLOCATE(cmaps)
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_put_varm_int64
!--------------------------------- nf_get_varm_text ----------------------
 Function nf_get_varm_text(ncid, varid, start, counts, strides, maps, &
                           text) RESULT(status)

! Read in a character string to dataset given start, count, stride, and map

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(IN)  :: start(*), counts(*), strides(*), maps(*)
 Character(LEN=*), Intent(OUT) :: text 

 Integer                       :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr, cmapsptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:), cmaps(:)

 cncid    = ncid
 cvarid   = varid -1 ! Subtract 1 to get C varid
 text     = REPEAT(" ",LEN(text))

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(1:ndims))
     ALLOCATE(ccounts(1:ndims))
     ALLOCATE(cstrides(1:ndims))
     ALLOCATE(cmaps(1:ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cmaps(1:ndims)    = maps(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
     cmapsptr          = C_LOC(cmaps)
   EndIf
 EndIf

 cstatus = nc_get_varm_text(cncid, cvarid, cstartptr, ccountsptr, &
                            cstridesptr, cmapsptr, text) 

 status = cstatus

! Make sure we don't leave any dangling pointers or allocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 If (ALLOCATED(cmaps))    DEALLOCATE(cmaps)
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_get_varm_text
!--------------------------------- nf_get_varm_text_a ----------------------
 Function nf_get_varm_text_a(ncid, varid, start, counts, strides, maps, &
                             text) RESULT(status)

! Read in array of characters from dataset given start, count, stride and map

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(IN)  :: start(*), counts(*), strides(*), maps(*)
 Character(LEN=1), Intent(OUT) :: text(*) 

 Integer                       :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr, cmapsptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:), cmaps(:)

 cncid    = ncid
 cvarid   = varid -1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(1:ndims))
     ALLOCATE(ccounts(1:ndims))
     ALLOCATE(cstrides(1:ndims))
     ALLOCATE(cmaps(1:ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cmaps(1:ndims)    = maps(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
     cmapsptr          = C_LOC(cmaps)
   EndIf
 EndIf

 cstatus = nc_get_varm_text(cncid, cvarid, cstartptr, ccountsptr, &
                            cstridesptr, cmapsptr, text) 

 status = cstatus

! Make sure we don't leave any dangling pointers or allocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 If (ALLOCATED(cmaps))    DEALLOCATE(cmaps)
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_get_varm_text_a
!--------------------------------- nf_get_varm_int1 ------------------------
 Function nf_get_varm_int1(ncid, varid, start, counts, strides, maps, &
                           i1vals) RESULT(status)

! Read in 8 bit integer array given start, count, stride and map

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,         Intent(IN)  :: ncid, varid
 Integer,         Intent(IN)  :: start(*), counts(*), strides(*), maps(*)
 Integer(NFINT1), Intent(OUT) :: i1vals(*)

 Integer                      :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr, cmapsptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:), cmaps(:)

 If (C_SIGNED_CHAR < 0) Then ! schar not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf

 cncid    = ncid
 cvarid   = varid -1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(1:ndims))
     ALLOCATE(ccounts(1:ndims))
     ALLOCATE(cstrides(1:ndims))
     ALLOCATE(cmaps(1:ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cmaps(1:ndims)    = maps(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
     cmapsptr          = C_LOC(cmaps)
   EndIf
 EndIf

#if NF_INT1_IS_C_SIGNED_CHAR
 cstatus = nc_get_varm_schar(cncid, cvarid, cstartptr, ccountsptr, &
                             cstridesptr, cmapsptr, i1vals) 
#elif NF_INT1_IS_C_SHORT
 cstatus = nc_get_varm_short(cncid, cvarid, cstartptr, ccountsptr, &
                             cstridesptr, cmapsptr, i1vals) 
#elif NF_INT1_IS_C_INT
 cstatus = nc_get_varm_int(cncid, cvarid, cstartptr, ccountsptr, &
                           cstridesptr, cmapsptr, i1vals) 
#elif NF_INT1_IS_C_LONG
 cstatus = nc_get_varm_long(cncid, cvarid, cstartptr, ccountsptr, &
                            cstridesptr, cmapsptr, i1vals) 
#endif

 status = cstatus

! Make sure we don't leave any dangling pointers or allocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 If (ALLOCATED(cmaps))    DEALLOCATE(cmaps)
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_get_varm_int1
!--------------------------------- nf_get_varm_int2 ------------------------
 Function nf_get_varm_int2(ncid, varid, start, counts, strides, maps, &
                              i2vals) RESULT(status)

! Read in 16 bit integer array given start, count, stride and map

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,         Intent(IN)  :: ncid, varid
 Integer,         Intent(IN)  :: start(*), counts(*), strides(*), maps(*)
 Integer(NFINT2), Intent(OUT) :: i2vals(*)

 Integer                      :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr, cmapsptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:), cmaps(:)

 If (C_SHORT < 0) Then ! short not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf

 cncid    = ncid
 cvarid   = varid -1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(1:ndims))
     ALLOCATE(ccounts(1:ndims))
     ALLOCATE(cstrides(1:ndims))
     ALLOCATE(cmaps(1:ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cmaps(1:ndims)    = maps(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
     cmapsptr          = C_LOC(cmaps)
   EndIf
 EndIf

#if NF_INT2_IS_C_SHORT
 cstatus = nc_get_varm_short(cncid, cvarid, cstartptr, ccountsptr, &
                             cstridesptr, cmapsptr, i2vals) 
#elif NF_INT2_IS_C_INT
 cstatus = nc_get_varm_int(cncid, cvarid, cstartptr, ccountsptr, &
                           cstridesptr, cmapsptr, i2vals) 
#elif NF_INT2_IS_C_LONG
 cstatus = nc_get_varm_long(cncid, cvarid, cstartptr, ccountsptr, &
                            cstridesptr, cmapsptr, i2vals)
#endif 

 status = cstatus

! Make sure we don't leave any dangling pointers or allocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 If (ALLOCATED(cmaps))    DEALLOCATE(cmaps)
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_get_varm_int2
!--------------------------------- nf_get_varm_int -------------------------
 Function nf_get_varm_int(ncid, varid, start, counts, strides, maps, &
                             ivals) RESULT(status)

! Read in default integer array given start, count, stride and map

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,        Intent(IN)  :: ncid, varid
 Integer,        Intent(IN)  :: start(*), counts(*), strides(*), maps(*)
 Integer(NFINT), Intent(OUT) :: ivals(*)

 Integer                     :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr, cmapsptr 
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:), cmaps(:)

 cncid    = ncid
 cvarid   = varid -1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(1:ndims))
     ALLOCATE(ccounts(1:ndims))
     ALLOCATE(cstrides(1:ndims))
     ALLOCATE(cmaps(1:ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cmaps(1:ndims)    = maps(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
     cmapsptr          = C_LOC(cmaps)
   EndIf
 EndIf

#if NF_INT_IS_C_INT
 cstatus = nc_get_varm_int(cncid, cvarid, cstartptr, ccountsptr, &
                           cstridesptr, cmapsptr, ivals) 
#elif NF_INT_IS_C_LONG
 cstatus = nc_get_varm_long(cncid, cvarid, cstartptr, ccountsptr, &
                            cstridesptr, cmapsptr, ivals)
#endif 

 status = cstatus

! Make sure we don't leave any dangling pointers or allocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 If (ALLOCATED(cmaps))    DEALLOCATE(cmaps)
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_get_varm_int
!--------------------------------- nf_get_varm_real ------------------------
 Function nf_get_varm_real(ncid, varid, start, counts, strides, maps, &
                              rvals) RESULT(status)

! Read in 32 bit real array given start, count, stride and map

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,      Intent(IN)  :: ncid, varid
 Integer,      Intent(IN)  :: start(*), counts(*), strides(*), maps(*)
 Real(NFREAL), Intent(OUT) :: rvals(*)

 Integer                   :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr, cmapsptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:), cmaps(:)

 cncid    = ncid
 cvarid   = varid -1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(1:ndims))
     ALLOCATE(ccounts(1:ndims))
     ALLOCATE(cstrides(1:ndims))
     ALLOCATE(cmaps(1:ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cmaps(1:ndims)    = maps(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
     cmapsptr          = C_LOC(cmaps)
   EndIf
 EndIf

#if NF_REAL_IS_C_DOUBLE
 cstatus = nc_get_varm_double(cncid, cvarid, cstartptr, ccountsptr, &
                              cstridesptr, cmapsptr, rvals) 
#else
 cstatus = nc_get_varm_float(cncid, cvarid, cstartptr, ccountsptr, &
                             cstridesptr, cmapsptr, rvals) 
#endif

 status = cstatus

! Make sure we don't leave any dangling pointers or allocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 If (ALLOCATED(cmaps))    DEALLOCATE(cmaps)
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_get_varm_real
!--------------------------------- nf_get_varm_double ----------------------
 Function nf_get_varm_double(ncid, varid, start, counts, strides, maps, &
                             dvals) RESULT(status)

! Read in 64 bit real array given start, count, stride and map

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,   Intent(IN)  :: ncid, varid
 Integer,   Intent(IN)  :: start(*), counts(*), strides(*), maps(*)
 Real(RK8), Intent(OUT) :: dvals(*)

 Integer                :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr, cmapsptr 
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:), cmaps(:)

 cncid    = ncid
 cvarid   = varid -1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(1:ndims))
     ALLOCATE(ccounts(1:ndims))
     ALLOCATE(cstrides(1:ndims))
     ALLOCATE(cmaps(1:ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cmaps(1:ndims)    = maps(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
     cmapsptr          = C_LOC(cmaps)
   EndIf
 EndIf

 cstatus = nc_get_varm_double(cncid, cvarid, cstartptr, ccountsptr, &
                              cstridesptr, cmapsptr, dvals) 

 status = cstatus

! Make sure we don't leave any dangling pointers or allocated arrays

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 If (ALLOCATED(cmaps))    DEALLOCATE(cmaps)
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_get_varm_double
!--------------------------------- nf_get_varm_int64 -------------------------
 Function nf_get_varm_int64(ncid, varid, start, counts, strides, maps, &
                            ivals) RESULT(status)

! Read in 64 bit integer array given start, count, stride and map

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,      Intent(IN)  :: ncid, varid
 Integer,      Intent(IN)  :: start(*), counts(*), strides(*), maps(*)
 Integer(IK8), Intent(OUT) :: ivals(*)

 Integer                        :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cstartptr, ccountsptr, cstridesptr, cmapsptr
 Integer        :: ndims

 Integer(C_SIZE_T),    ALLOCATABLE, TARGET :: cstart(:), ccounts(:)
 Integer(C_PTRDIFF_T), ALLOCATABLE, TARGET :: cstrides(:), cmaps(:)

 cncid    = ncid
 cvarid   = varid -1 ! Subtract 1 to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 ndims       = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! Flip arrays to C order and subtract 1 from start
     ALLOCATE(cstart(ndims))
     ALLOCATE(ccounts(ndims))
     ALLOCATE(cstrides(ndims))
     ALLOCATE(cmaps(ndims))
     cstart(1:ndims)   = start(ndims:1:-1) - 1
     ccounts(1:ndims)  = counts(ndims:1:-1)
     cstrides(1:ndims) = strides(ndims:1:-1)
     cmaps(1:ndims)    = maps(ndims:1:-1)
     cstartptr         = C_LOC(cstart)
     ccountsptr        = C_LOC(ccounts)
     cstridesptr       = C_LOC(cstrides)
     cmapsptr          = C_LOC(cmaps)
   EndIf
 EndIf

 cstatus = nc_get_varm_longlong(cncid, cvarid, cstartptr, ccountsptr, &
                                cstridesptr, cmapsptr, ivals)

 status = cstatus

! Make sure there are no dangling pointers or allocated values

 cstartptr   = C_NULL_PTR
 ccountsptr  = C_NULL_PTR
 cstridesptr = C_NULL_PTR
 cmapsptr    = C_NULL_PTR
 If (ALLOCATED(cmaps))    DEALLOCATE(cmaps)
 If (ALLOCATED(cstrides)) DEALLOCATE(cstrides)
 If (ALLOCATED(ccounts))  DEALLOCATE(ccounts)
 If (ALLOCATED(cstart))   DEALLOCATE(cstart)

 End Function nf_get_varm_int64

!------- Routines for defining, obtaining, etc. global dimension info ------ 

! Replacement for fort-dim.c

! Written by: Richard Weed, Ph.D.
!             Center for Advanced Vehicular Systems 
!             Mississippi State University
!             rweed@cavs.msstate.edu
 

! License (and other Lawyer Language)
 
! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Corporation for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1.: Sept. 2005 - Initial Cray X1 version
! Version 2.: May   2006 - Updated to support g95
! Version 3.: April 2009 - Updated for netCDF 4.0.1
! Version 4.: April 2010 - Updated for netCDF 4.1.1
! Version 5.: May   2014 - Ensure return error status
!                          checked from C API calls
! Version 6.: Jan.  2016 - General code cleanup. Changed name
!                          processing to reflect change in addCNullChar

!-------------------------------- nf_def_dim -------------------------------
 Function nf_def_dim(ncid, name, dlen, dimid) RESULT (status)

! Adds new dimensions to the NetCDF dataset given dimension name,
! and length. Returns dimension id

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, dlen
 Integer,          Intent(OUT) :: dimid
 Character(LEN=*), Intent(IN)  :: name

 Integer                       :: status

 Integer(C_INT)               :: cncid, cdimid, cstatus
 Integer(C_SIZE_T)            :: cdlen
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid = ncid
 cdlen = dlen

 dimid  = -1
 cdimid = -1

! Check to see if a C null character was appended in FORTRAN

 cname = addCNullChar(name, ie)
 
 cstatus = nc_def_dim(cncid, cname(1:ie), cdlen, cdimid)

 If (cstatus == NC_EBADDIM) Then  ! Return dimid=-1
   dimid = -1
 Else                    ! Add 1 to get FORTRAN dimid
   dimid = cdimid+1
 EndIf
 status = cstatus

 End Function nf_def_dim
!-------------------------------- nf_inq_dim -------------------------------
 Function nf_inq_dim(ncid, dimid, name, dlen) RESULT (status)

! Get dimension name and length for a given dimid from NetCDF dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, dimid
 Integer,          Intent(OUT) :: dlen
 Character(LEN=*), Intent(OUT) :: name
 
 Integer                       :: status

 Integer(C_INT)             :: cncid, cdimid, cstatus
 Integer(C_SIZE_T)          :: cdlen
 Integer                    :: nlen
 Character(LEN=NC_MAX_NAME) :: tmpname 

 cncid   = ncid
 cdimid  = dimid - 1   ! Subtract 1 to get C dimid
 tmpname = REPEAT(" ", LEN(tmpname))
 name    = REPEAT(" ", LEN(name))
 nlen    = LEN(name)

! Get tmpname and cdlen from C interface

 cstatus = nc_inq_dim(cncid, cdimid, tmpname, cdlen)

 If (cstatus == NC_NOERR) Then
    ! Strip C null char from tmpname if present and set end of string
    name = stripCNullChar(tmpname, nlen)
    dlen   = int(cdlen)
 Endif

 status = cstatus

 End Function nf_inq_dim
!-------------------------------- nf_inq_dimid -----------------------------
 Function nf_inq_dimid(ncid, name, dimid) RESULT (status)

! Get dimension id for a given dimension name from dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid
 Integer,          Intent(OUT) :: dimid
 Character(LEN=*), Intent(IN)  :: name

 Integer                       :: status

 Integer(C_INT)               :: cncid, cdimid, cstatus
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid = ncid
 dimid  =  0 
 cdimid = -1

! Check to see if a C null character was appended in FORTRAN

 cname = addCNullChar(name, ie)
 
 cstatus = nc_inq_dimid(cncid, cname(1:ie), cdimid)

! add one to get FORTRAN dimid if not = -1

 If (cstatus == NC_EBADDIM) Then
   dimid = -1
 Else
   dimid = cdimid + 1
 EndIf
 status = cstatus

 End Function nf_inq_dimid
!-------------------------------- nf_inq_dimlen ----------------------------
 Function nf_inq_dimlen(ncid, dimid, dlen) RESULT (status)

! Get dimension length for a given dimid from NetCDF dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid, dimid
 Integer, Intent(OUT) :: dlen

 Integer              :: status

 Integer(C_INT)    :: cncid, cdimid, cstatus
 Integer(C_SIZE_T) :: cdlen

 cncid   = ncid
 cdimid  = dimid - 1 ! Subtract 1 to get C dimid
 dlen    = 0

 cstatus = nc_inq_dimlen(cncid, cdimid, cdlen)

 If (cstatus == NC_NOERR) Then
    dlen   = int(cdlen)
 Endif
 status = cstatus

 End Function nf_inq_dimlen
!-------------------------------- nf_inq_dimname ---------------------------
 Function nf_inq_dimname (ncid, dimid, name) RESULT (status)

! Get dimension name for a given dimid from NetCDF dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, dimid
 Character(LEN=*), Intent(OUT) :: name

 Integer                       :: status

 Integer(C_INT)             :: cncid, cdimid, cstatus
 Integer                    :: nlen
 Character(LEN=NC_MAX_NAME) :: tmpname 

 cncid   = ncid
 cdimid  = dimid - 1 ! Subtract 1 to get C dimid
 tmpname = REPEAT(" ", LEN(tmpname))
 name    = REPEAT(" ", LEN(name))
 nlen    = LEN(name)

! Get tmpname and cdlen from C interface

 cstatus = nc_inq_dimname(cncid, cdimid, tmpname)

 If (cstatus == NC_NOERR) Then
    ! Strip C null character in tmpname if present and set end of string
    name = stripCNullChar(tmpname, nlen)
 Endif

 status = cstatus

 End Function nf_inq_dimname
!-------------------------------- nf_rename_dim ----------------------------
 Function nf_rename_dim(ncid, dimid, name) RESULT (status)

! Rename dimension name for a given dimension id

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN) :: ncid, dimid
 Character(LEN=*), Intent(IN) :: name

 Integer                      :: status

 Integer(C_INT)               :: cncid, cdimid, cstatus
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 cdimid = dimid - 1 ! Subtract 1 to get C dimid

! Check to see if a C null character was appended in FORTRAN

 cname = addCNullChar(name, ie)

 cstatus = nc_rename_dim(cncid, cdimid, cname(1:ie))

 status = cstatus

 End Function nf_rename_dim

! This is part of netCDF-4. Copyright 2006 UCAR. See COPYRIGHT file
! for details.

! This file contains the netcdf-4 file open and create functions.

! @author Ed Hartnett
! -------
function nf90_open(path, mode, ncid, chunksize, cache_size, cache_nelems, &
     cache_preemption, comm, info)
  implicit none
  character (len = *), intent(in) :: path
  integer, intent(in) :: mode
  integer, intent(out) :: ncid
  integer, optional, intent(inout) :: chunksize
  integer, optional, intent(in) :: cache_size, cache_nelems
  real, optional, intent(in) :: cache_preemption
  integer, optional, intent(in) :: comm, info
  integer :: size_in, nelems_in, preemption_in
  integer :: size_out, nelems_out, preemption_out, ret
  integer :: nf90_open

  ! If using parallel, both comm and info must be provided.
  if (present(comm) .and. .not. present(info)) then
     nf90_open = NF90_EINVAL;
     return
  end if

  ! If the user specified chuck cache parameters, use them. But user
  ! may have specified one, two, or three settings. Leave the others
  ! unchanged.
  if (present(cache_size) .or. present(cache_nelems) .or. &
       present(cache_preemption)) then
     ret = nf_get_chunk_cache(size_in, nelems_in, preemption_in)
     if (ret .ne. nf90_noerr) then
        nf90_open = ret
        return
     end if
     if (present(cache_size)) then
        size_out = cache_size
     else
        size_out = size_in
     end if
     if (present(cache_nelems)) then
        nelems_out = cache_nelems
     else
        nelems_out = nelems_in
     end if
     if (present(cache_preemption)) then
        preemption_out = int(cache_preemption * 100)
     else
        preemption_out = preemption_in
     end if
     nf90_open = nf_set_chunk_cache(size_out, nelems_out, preemption_out)
     if (nf90_open .ne. nf90_noerr) return
  end if

  ! Do the open.
  if(present(chunksize)) then
     nf90_open = nf__open(path, mode, chunksize, ncid)
  else
     if (present(comm)) then
        nf90_open = nf_open_par(path, mode, comm, info, ncid)
     else
        nf90_open = nf_open(path, mode, ncid)
     end if
  end if
  if (nf90_open .ne. nf90_noerr) return

  ! If settings were changed, reset chunk chache to original settings.
  if (present(cache_size) .or. present(cache_nelems) .or. &
       present(cache_preemption)) then
     nf90_open = nf_set_chunk_cache(size_in, nelems_in, preemption_in)
  end if

end function nf90_open
! -------
function nf90_create(path, cmode, ncid, initialsize, chunksize, cache_size, &
     cache_nelems, cache_preemption, comm, info)
  implicit none
  character (len = *), intent(in) :: path
  integer, intent(in) :: cmode
  integer, intent(out) :: ncid
  integer, optional, intent(in) :: initialsize
  integer, optional, intent(inout) :: chunksize
  integer, optional, intent(in) :: cache_size, cache_nelems
  integer, optional, intent(in) :: cache_preemption
  integer, optional, intent(in) :: comm, info
  integer :: size_in, nelems_in, preemption_in
  integer :: size_out, nelems_out, preemption_out
  integer :: nf90_create
  integer :: fileSize, chunk

  ! Just ignore options netCDF-3 options for netCDF-4 files, or
  ! netCDF-4 options, for netCDF-3 files, so that the same user code
  ! can work for both cases.

  ! If using parallel, but comm and info must be provided.
  if (present(comm) .and. .not. present(info)) then
     nf90_create = NF90_EINVAL;
     return
  end if

  ! If the user specified chuck cache parameters, use them. But user
  ! may have specified one, two, or three settings. Leave the others
  ! unchanged.
  if (present(cache_size) .or. present(cache_nelems) .or. &
       present(cache_preemption)) then
     nf90_create = nf_get_chunk_cache(size_in, nelems_in, preemption_in)
     if (nf90_create .ne. nf90_noerr) return
     if (present(cache_size)) then
        size_out = cache_size
     else
        size_out = size_in
     end if
     if (present(cache_nelems)) then
        nelems_out = cache_nelems
     else
        nelems_out = nelems_in
     end if
     if (present(cache_preemption)) then
        preemption_out = cache_preemption
     else
        preemption_out = preemption_in
     end if
     nf90_create = nf_set_chunk_cache(size_out, nelems_out, preemption_out)
     if (nf90_create .ne. nf90_noerr) return
  end if

  ! Do the file create.
  if(.not. (present(initialsize) .or. present(chunksize)) ) then
     if (present(comm)) then
        nf90_create = nf_create_par(path, cmode, comm, info, ncid)
     else
        nf90_create = nf_create(path, cmode, ncid)
     end if
  else
     ! Default values per man page
     filesize = 0; chunk = nf90_sizehint_default
     if(present(initialsize)) filesize = initialsize
     if(present(chunksize  )) chunk    = chunksize
     nf90_create = nf__create(path, cmode, filesize, chunk, ncid)
     ! Pass back the value actually used
     if(present(chunksize  )) chunksize = chunk
  end if
  if (nf90_create .ne. nf90_noerr) return

  ! If settings were changed, reset chunk chache to original settings.
  if (present(cache_size) .or. present(cache_nelems) .or. &
       present(cache_preemption)) then
     nf90_create = nf_set_chunk_cache(size_in, nelems_in, preemption_in)
  end if


end function nf90_create

Module netcdf_nc_interfaces

! Fortran interfaces to netCDF C functions using FORTRAN 2003 C
! Interoperability features. These interfaces are for the base
! netCDF C routines in the libsrc directory

! Written by: Richard Weed, Ph.D.
!             Center for Advanced Vehicular Systems
!             Mississippi State University
!             rweed@cavs.msstate.edu


! License (and other Lawyer Language)

! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Corporation for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1.:  Sept. 2005 - Initial Cray X1 version
! Version 2.:  May   2006 - Updated to support g95
! Version 3.:  June  2006 - Updated to include netCDF 4 functions
! Version 4.:  April 2009 - Updated to match netCDF 4.0.1 release
! Version 5.:  April 2010 - Updated to match netCDF 4.1.1 release
! Version 6.:  April 2013 - Added nc_inq_path support for fortran 4.4 beta

 USE netcdf_nc_data

 Implicit NONE

!> module procedure interfaces for utility routines

 Interface addCNullChar
  module procedure addCNullChar
 End Interface

 Interface stripCNullChar
  module procedure stripCNullChar
 End Interface

!> Begin explicit interfaces for base nc_ functions. Note that some interfaces
!! expect data to be passed as C_PTR type variables. These data are arrays
!! that could have a NULL pointer passed instead of the array. All strings
!! are passed as C_CHAR interoperable strings. Most data in put routines
!! that map to a void pointer in C are passed as a Type(C_PTR) value.
!! Data from get routine that pass as a void pointer in C are passed as
!! a C_CHAR string.

!! Also note that each interface has an explicit USE ISO_C_BINDING. A better
!! solution is to use the F2003 IMPORT statement (I originally had it this way)
!! However its best to leave the interfaces as is for now because there might
!! be a few compilers out there that support most of the C-interop facility but
!! for some reason haven't implemented IMPORT yet.

!---------------------------------- nc_strerror -------------------------------
Interface
 Function nc_strerror(ncerr) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR

 Integer(KIND=C_INT), VALUE :: ncerr

 Type(C_PTR)                :: nc_strerror

 End Function nc_strerror
End Interface
!---------------------------------- nc_inq_libvers ----------------------------
Interface
 Function nc_inq_libvers() BIND(C)

 USE ISO_C_BINDING, ONLY: C_PTR

 Type(C_PTR) :: nc_inq_libvers

 End Function nc_inq_libvers
End Interface
!---------------------------------- nc_create ---------------------------------
Interface
 Function nc_create(path, cmode, ncidp) BIND(C)

 USE ISO_C_BINDING, ONLY: C_CHAR, C_INT

 Character(KIND=C_CHAR), Intent(IN)  :: path(*)
 Integer(KIND=C_INT),    VALUE       :: cmode
 Integer(KIND=C_INT),    Intent(OUT) :: ncidp

 Integer(KIND=C_INT)                 :: nc_create

 End Function nc_create
End Interface
!---------------------------------- nc__create --------------------------------
Interface
 Function nc__create(path, cmode, initialsz, chunksizehintp, ncidp) BIND(C)

 USE ISO_C_BINDING, ONLY: C_CHAR, C_INT, C_SIZE_T

 Character(KIND=C_CHAR), Intent(IN)  :: path(*)
 Integer(KIND=C_INT),    VALUE       :: cmode
 Integer(KIND=C_SIZE_T), VALUE       :: initialsz
 Integer(KIND=C_SIZE_T), Intent(IN)  :: chunksizehintp
 Integer(KIND=C_INT),    Intent(OUT) :: ncidp

 Integer(KIND=C_INT)                 :: nc__create

 End Function nc__create
End Interface
!---------------------------------- nc__create_mp -----------------------------
Interface
 Function nc__create_mp(path, cmode, initialsz, basepe, chunksizehintp, ncidp) &
                        BIND(C)

 USE ISO_C_BINDING, ONLY: C_CHAR, C_INT, C_SIZE_T, C_PTR

 Character(KIND=C_CHAR), Intent(IN)  :: path(*)
 Integer(KIND=C_INT),    VALUE       :: cmode
 Integer(KIND=C_SIZE_T), VALUE       :: initialsz
 Integer(KIND=C_SIZE_T), Intent(IN)  :: chunksizehintp
 Type(C_PTR),            VALUE       :: basepe
 Integer(KIND=C_INT),    Intent(OUT) :: ncidp

 Integer(KIND=C_INT)                 :: nc__create_mp

 End Function nc__create_mp
End Interface
!---------------------------------- nc_open -----------------------------------
Interface
 Function nc_open(path, mode, ncidp) BIND(C)

 USE ISO_C_BINDING, ONLY: C_CHAR, C_INT

 Character(KIND=C_CHAR), Intent(IN)  :: path(*)
 Integer(KIND=C_INT),    VALUE       :: mode
 Integer(KIND=C_INT),    Intent(OUT) :: ncidp

 Integer(KIND=C_INT)                 :: nc_open

 End Function nc_open
End Interface
!---------------------------------- nc__open ----------------------------------
Interface
 Function nc__open(path, mode, chunksizehintp, ncidp) BIND(C)

 USE ISO_C_BINDING, ONLY: C_CHAR, C_INT, C_SIZE_T

 Character(KIND=C_CHAR), Intent(IN)  :: path(*)
 Integer(KIND=C_INT),    VALUE       :: mode
 Integer(KIND=C_SIZE_T), Intent(IN)  :: chunksizehintp
 Integer(KIND=C_INT),    Intent(OUT) :: ncidp

 Integer(KIND=C_INT)                 :: nc__open

 End Function nc__open
End Interface
!---------------------------------- nc__open_mp -------------------------------
Interface
 Function nc__open_mp(path, mode, basepe, chunksizehintp, ncidp) BIND(C)

 USE ISO_C_BINDING, ONLY: C_CHAR, C_INT, C_SIZE_T, C_PTR

 Character(KIND=C_CHAR), Intent(IN)  :: path(*)
 Integer(KIND=C_INT),    VALUE       :: mode
 Integer(KIND=C_SIZE_T), Intent(IN)  :: chunksizehintp
 Integer(KIND=C_INT),    Intent(OUT) :: ncidp
 Type(C_PTR),            VALUE       :: basepe

 Integer(KIND=C_INT)                 :: nc__open_mp

 End Function nc__open_mp
End Interface
!---------------------------------- nc_inq_path -----------------------------
Interface
 Function nc_inq_path(ncid, pathlen, path) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_SIZE_T, C_CHAR

 Integer(KIND=C_INT),    VALUE         :: ncid
 Integer(KIND=C_SIZE_T), Intent(INOUT) :: pathlen
 Character(KIND=C_CHAR), Intent(INOUT) :: path(*)

 Integer(KIND=C_INT)                   :: nc_inq_path

 End Function nc_inq_path
End Interface
!---------------------------------- nc_set_fill -------------------------------
Interface
 Function nc_set_fill(ncid, fillmode, old_modep) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: ncid
 Integer(KIND=C_INT), VALUE       :: fillmode
 Integer(KIND=C_INT), Intent(OUT) :: old_modep

 Integer(KIND=C_INT)              :: nc_set_fill

 End Function nc_set_fill
End Interface
!---------------------------------- nc_redef ----------------------------------
Interface
 Function nc_redef(ncid) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE :: ncid

 Integer(KIND=C_INT)        :: nc_redef

 End Function nc_redef
End Interface
!---------------------------------- nc_enddef ---------------------------------
Interface
 Function nc_enddef(ncid) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE :: ncid

 Integer(KIND=C_INT)        :: nc_enddef

 End Function nc_enddef
End Interface
!---------------------------------- nc__enddef --------------------------------
Interface
 Function nc__enddef(ncid, h_minfree, v_align, v_minfree, r_align) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_SIZE_T

 Integer(KIND=C_INT),    VALUE :: ncid
 Integer(KIND=C_SIZE_T), VALUE :: h_minfree, v_align, v_minfree, r_align

 Integer(KIND=C_INT)           :: nc__enddef

 End Function nc__enddef
End Interface
!---------------------------------- nc_sync -----------------------------------
Interface
 Function nc_sync(ncid) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE :: ncid

 Integer(KIND=C_INT)        :: nc_sync

 End Function nc_sync
End Interface
!---------------------------------- nc_abort ----------------------------------
Interface
 Function nc_abort(ncid) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE :: ncid

 Integer(KIND=C_INT)        :: nc_abort

 End Function nc_abort
End Interface
!---------------------------------- nc_close ----------------------------------
Interface
 Function nc_close(ncid) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE :: ncid

 Integer(KIND=C_INT)        :: nc_close

 End Function nc_close
End Interface
!---------------------------------- nc_delete --------------------------------
Interface
 Function nc_delete(path) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Character(KIND=C_CHAR), Intent(IN) :: path(*)

 Integer(KIND=C_INT)                :: nc_delete

 End Function nc_delete
End Interface
!---------------------------------- nc_delete_mp -----------------------------
Interface
 Function nc_delete_mp(path, pe) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Character(KIND=C_CHAR), Intent(IN) :: path(*)
 Integer(KIND=C_INT),    VALUE      :: pe

 Integer(KIND=C_INT)                :: nc_delete_mp

 End Function nc_delete_mp
End Interface
!---------------------------------- nc_set_base_pe ----------------------------
Interface
 Function nc_set_base_pe(ncid, pe) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE :: ncid, pe

 Integer(KIND=C_INT)        :: nc_set_base_pe

 End Function nc_set_base_pe
End Interface
!---------------------------------- nc_inq_base_pe ----------------------------
Interface
 Function nc_inq_base_pe(ncid, pe) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: ncid
 Integer(KIND=C_INT), Intent(OUT) ::  pe

 Integer(KIND=C_INT)              :: nc_inq_base_pe

 End Function nc_inq_base_pe
End Interface
!---------------------------------- nc_inq ------------------------------------
Interface
 Function nc_inq(ncid, ndimsp, nvarsp, ngattsp, unlimdimidp) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: ncid
 Integer(KIND=C_INT), Intent(OUT) :: ndimsp, nvarsp, ngattsp, unlimdimidp

 Integer(KIND=C_INT)              :: nc_inq

 End Function nc_inq
End Interface
!---------------------------------- nc_inq_ndims ------------------------------
Interface
 Function nc_inq_ndims(ncid, ndimsp) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: ncid
 Integer(KIND=C_INT), Intent(OUT) ::  ndimsp

 Integer(KIND=C_INT)              :: nc_inq_ndims

 End Function nc_inq_ndims
End Interface
!---------------------------------- nc_inq_nvars ------------------------------
Interface
 Function nc_inq_nvars(ncid, nvarsp) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: ncid
 Integer(KIND=C_INT), Intent(OUT) ::  nvarsp

 Integer(KIND=C_INT)              :: nc_inq_nvars

 End Function nc_inq_nvars
End Interface
!---------------------------------- nc_inq_natts ------------------------------
Interface
 Function nc_inq_natts(ncid, ngattsp) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: ncid
 Integer(KIND=C_INT), Intent(OUT) :: ngattsp

 Integer(KIND=C_INT)              :: nc_inq_natts

 End Function nc_inq_natts
End Interface
!---------------------------------- nc_inq_unlimdim ---------------------------
Interface
 Function nc_inq_unlimdim(ncid, unlimdimidp) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: ncid
 Integer(KIND=C_INT), Intent(OUT) :: unlimdimidp

 Integer(KIND=C_INT)              :: nc_inq_unlimdim

 End Function nc_inq_unlimdim
End Interface
!---------------------------------- nc_inq_format -----------------------------
Interface
 Function nc_inq_format(ncid, formatp) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: ncid
 Integer(KIND=C_INT), Intent(OUT) :: formatp

 Integer(KIND=C_INT)              :: nc_inq_format

 End Function nc_inq_format
End Interface
!---------------------------------- nc_def_dim --------------------------------
Interface
 Function nc_def_dim(ncid, name, nlen, idp) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_SIZE_T, C_CHAR

 Integer(KIND=C_INT),    VALUE         :: ncid
 Character(KIND=C_CHAR), Intent(IN)    :: name(*)
 Integer(KIND=C_SIZE_T), VALUE         :: nlen
 Integer(KIND=C_INT),    Intent(INOUT) :: idp

 Integer(KIND=C_INT)                   :: nc_def_dim

 End Function nc_def_dim
End Interface
!---------------------------------- nc_inq_dimid ------------------------------
Interface
 Function nc_inq_dimid(ncid, name, idp) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE         :: ncid
 Character(KIND=C_CHAR), Intent(IN)    :: name(*)
 Integer(KIND=C_INT),    Intent(INOUT) :: idp

 Integer(KIND=C_INT)                   :: nc_inq_dimid

 End Function nc_inq_dimid
End Interface
!---------------------------------- nc_inq_dim --------------------------------
Interface
 Function nc_inq_dim(ncid, dimid, name, lenp) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_SIZE_T, C_CHAR

 Integer(KIND=C_INT),    VALUE         :: ncid
 Integer(KIND=C_INT),    VALUE         :: dimid
 Character(KIND=C_CHAR), Intent(INOUT) :: name(*)
 Integer(KIND=C_SIZE_T), Intent(OUT)   :: lenp

 Integer(KIND=C_INT)                   :: nc_inq_dim

 End Function nc_inq_dim
End Interface
!---------------------------------- nc_inq_dimname ----------------------------
Interface
 Function nc_inq_dimname(ncid, dimid, name) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE         :: ncid
 Integer(KIND=C_INT),    VALUE         :: dimid
 Character(KIND=C_CHAR), Intent(INOUT) :: name(*)

 Integer(KIND=C_INT)                   :: nc_inq_dimname

 End Function nc_inq_dimname
End Interface
!---------------------------------- nc_inq_dimlen -----------------------------
Interface
 Function nc_inq_dimlen(ncid, dimid, lenp) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_SIZE_T

 Integer(KIND=C_INT),    VALUE       :: ncid
 Integer(KIND=C_INT),    VALUE       :: dimid
 Integer(KIND=C_SIZE_T), Intent(OUT) :: lenp

 Integer(KIND=C_INT)                 :: nc_inq_dimlen

 End Function nc_inq_dimlen
End Interface
!---------------------------------- nc_rename_dim -----------------------------
Interface
 Function nc_rename_dim(ncid, dimid, name) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE      :: ncid
 Integer(KIND=C_INT),    VALUE      :: dimid
 Character(KIND=C_CHAR), Intent(IN) :: name(*)

 Integer(KIND=C_INT)                :: nc_rename_dim

 End Function nc_rename_dim
End Interface
!---------------------------------- nc_def_var --------------------------------
Interface
 Function nc_def_var(ncid, name, xtype, ndims, dimidsp, varidp) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid
 Character(KIND=C_CHAR), Intent(IN)  :: name(*)
 Integer(KIND=C_INT),    VALUE       :: xtype
 Integer(KIND=C_INT),    VALUE       :: ndims
 Integer(KIND=C_INT),    Intent(IN)  :: dimidsp(*)
 Integer(KIND=C_INT),    Intent(OUT) :: varidp

 Integer(KIND=C_INT)                 :: nc_def_var

 End Function nc_def_var
End Interface
!---------------------------------- nc_inq_var --------------------------------
Interface
 Function nc_inq_var(ncid, varid, name, xtypep, ndimsp, dimidsp, nattsp) &
                     BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid, varid
 Character(KIND=C_CHAR), Intent(OUT) :: name(*)
 Integer(KIND=C_INT),    Intent(OUT) :: xtypep
 Integer(KIND=C_INT),    Intent(OUT) :: ndimsp
 Integer(KIND=C_INT),    Intent(OUT) :: dimidsp(*)
 Integer(KIND=C_INT),    Intent(OUT) :: nattsp

 Integer(KIND=C_INT)                 :: nc_inq_var

 End Function nc_inq_var
End Interface
!---------------------------------- nc_inq_varid ------------------------------
Interface
 Function nc_inq_varid(ncid, name, varidp) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid
 Character(KIND=C_CHAR), Intent(IN)  :: name(*)
 Integer(KIND=C_INT),    Intent(OUT) :: varidp

 Integer(KIND=C_INT)                 :: nc_inq_varid

 End Function nc_inq_varid
End Interface
!---------------------------------- nc_inq_varname ----------------------------
Interface
 Function nc_inq_varname(ncid, varid, name) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid, varid
 Character(KIND=C_CHAR), Intent(OUT) :: name(*)

 Integer(KIND=C_INT)                 :: nc_inq_varname

 End Function nc_inq_varname
End Interface
!---------------------------------- nc_inq_vartype ----------------------------
Interface
 Function nc_inq_vartype(ncid, varid, xtypep) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Integer(KIND=C_INT), Intent(OUT) :: xtypep

 Integer(KIND=C_INT)              :: nc_inq_vartype

 End Function nc_inq_vartype
End Interface
!---------------------------------- nc_inq_varndims ---------------------------
Interface
 Function nc_inq_varndims(ncid, varid, ndimsp) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Integer(KIND=C_INT), Intent(OUT) :: ndimsp

 Integer(KIND=C_INT)              :: nc_inq_varndims

 End Function nc_inq_varndims
End Interface
!---------------------------------- nc_inq_vardimid ---------------------------
Interface
 Function nc_inq_vardimid(ncid, varid, dimidsp) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Integer(KIND=C_INT), Intent(OUT) :: dimidsp(*)

 Integer(KIND=C_INT)              :: nc_inq_vardimid

 End Function nc_inq_vardimid
End Interface
!---------------------------------- nc_inq_varnatts ---------------------------
Interface
 Function nc_inq_varnatts(ncid, varid, nattsp) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Integer(KIND=C_INT), Intent(OUT) :: nattsp

 Integer(KIND=C_INT)              :: nc_inq_varnatts

 End Function nc_inq_varnatts
End Interface
!---------------------------------- nc_rename_var -----------------------------
Interface
 Function nc_rename_var(ncid, varid, name) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE      :: ncid, varid
 Character(KIND=C_CHAR), Intent(IN) :: name(*)

 Integer(KIND=C_INT)                :: nc_rename_var

 End Function nc_rename_var
End Interface
!---------------------------------- nc_put_var_text ---------------------------
Interface
 Function nc_put_var_text(ncid, varid, op) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE      :: ncid, varid
 Character(KIND=C_CHAR), Intent(IN) :: op(*)

 Integer(KIND=C_INT)                :: nc_put_var_text

 End Function nc_put_var_text
End Interface
!---------------------------------- nc_get_var_text ---------------------------
Interface
 Function nc_get_var_text(ncid, varid, ip) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE         :: ncid, varid
 Character(KIND=C_CHAR), Intent(INOUT) :: ip(*)

 Integer(KIND=C_INT)                   :: nc_get_var_text

 End Function nc_get_var_text
End Interface
!---------------------------------- nc_put_var_uchar --------------------------
Interface
 Function nc_put_var_uchar(ncid, varid, op) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Integer(KIND=CINT1), Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_var_uchar

 End Function nc_put_var_uchar
End Interface
!---------------------------------- nc_get_var_uchar --------------------------
Interface
 Function nc_get_var_uchar(ncid, varid, ip) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Integer(KIND=CINT1), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_var_uchar

 End Function nc_get_var_uchar
End Interface
!---------------------------------- nc_put_var_schar --------------------------
Interface
 Function nc_put_var_schar(ncid, varid, op) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Integer(KIND=CINT1), Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_var_schar

 End Function nc_put_var_schar
End Interface
!---------------------------------- nc_get_var_schar --------------------------
Interface
 Function nc_get_var_schar(ncid, varid, ip) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT),  VALUE       :: ncid, varid
 Integer(KIND=CINT1),  Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)               :: nc_get_var_schar

 End Function nc_get_var_schar
End Interface
!---------------------------------- nc_put_var_short --------------------------
Interface
 Function nc_put_var_short(ncid, varid, op) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT
 USE NETCDF_NC_DATA, ONLY: CINT2

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Integer(KIND=CINT2), Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_var_short

 End Function nc_put_var_short
End Interface
!---------------------------------- nc_get_var_short --------------------------
Interface
 Function nc_get_var_short(ncid, varid, ip) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT
 USE NETCDF_NC_DATA, ONLY: CINT2

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Integer(KIND=CINT2), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_var_short

 End Function nc_get_var_short
End Interface
!---------------------------------- nc_put_var_int ----------------------------
Interface
 Function nc_put_var_int(ncid, varid, op) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT
 USE NETCDF_NC_DATA, ONLY: CINT

 Integer(KIND=C_INT), VALUE     :: ncid, varid
 Integer(KIND=CINT), Intent(IN) :: op(*)

 Integer(KIND=C_INT)            :: nc_put_var_int

 End Function nc_put_var_int
End Interface
!---------------------------------- nc_get_var_int ----------------------------
Interface
 Function nc_get_var_int(ncid, varid, ip) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT
 USE NETCDF_NC_DATA, ONLY: CINT

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Integer(KIND=CINT),  Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_var_int

 End Function nc_get_var_int
End Interface
!---------------------------------- nc_put_var_long ----------------------------
Interface
 Function nc_put_var_long(ncid, varid, op) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_LONG

 Integer(KIND=C_INT),  VALUE      :: ncid, varid
 Integer(KIND=C_LONG), Intent(IN) :: op(*)

 Integer(KIND=C_INT)              :: nc_put_var_long

 End Function nc_put_var_long
End Interface
!---------------------------------- nc_get_var_long ---------------------------
Interface
 Function nc_get_var_long(ncid, varid, ip) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_LONG

 Integer(KIND=C_INT),  VALUE       :: ncid, varid
 Integer(KIND=C_LONG), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)               :: nc_get_var_long

 End Function nc_get_var_long
End Interface
!---------------------------------- nc_put_var_float --------------------------
Interface
 Function nc_put_var_float(ncid, varid, op) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_FLOAT

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Real(KIND=C_FLOAT),  Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_var_float

 End Function nc_put_var_float
End Interface
!---------------------------------- nc_get_var_float --------------------------
Interface
 Function nc_get_var_float(ncid, varid, ip) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_FLOAT

 Implicit NONE

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Real(KIND=C_FLOAT),  Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_var_float

 End Function nc_get_var_float
End Interface
!---------------------------------- nc_put_var_double -------------------------
Interface
 Function nc_put_var_double(ncid, varid, op) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_DOUBLE

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Real(KIND=C_DOUBLE), Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_var_double

 End Function nc_put_var_double
End Interface
!---------------------------------- nc_get_var_double -------------------------
Interface
 Function nc_get_var_double(ncid, varid, ip) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_DOUBLE

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Real(KIND=C_DOUBLE), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_var_double

 End Function nc_get_var_double
End Interface
!---------------------------------- nc_put_var1_text --------------------------
Interface
 Function nc_put_var1_text(ncid, varid, indexp, op) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT),   VALUE      :: ncid, varid
 Type(C_PTR),           VALUE      :: indexp
 Character(LEN=C_CHAR), Intent(IN) :: op

 Integer(KIND=C_INT)               :: nc_put_var1_text

 End Function nc_put_var1_text
End Interface
!---------------------------------- nc_get_var1_test --------------------------
Interface
 Function nc_get_var1_text(ncid, varid, indexp, ip) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid, varid
 Type(C_PTR),            VALUE       :: indexp
 Character(KIND=C_CHAR), Intent(OUT) :: ip

 Integer(KIND=C_INT)                 :: nc_get_var1_text

 End Function nc_get_var1_text
End Interface
!---------------------------------- nc_put_var1_uchar -------------------------
Interface
 Function nc_put_var1_uchar(ncid, varid, indexp, op) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT),  VALUE      :: ncid, varid
 Type(C_PTR),          VALUE      :: indexp
 Integer(KIND=CINT1),  Intent(IN) :: op

 Integer(KIND=C_INT)              :: nc_put_var1_uchar

 End Function nc_put_var1_uchar
End Interface
!---------------------------------- nc_get_var1_uchar -------------------------
Interface
 Function nc_get_var1_uchar(ncid, varid, indexp, ip) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT),  VALUE       :: ncid, varid
 Type(C_PTR),          VALUE       :: indexp
 Integer(KIND=CINT1),  Intent(OUT) :: ip

 Integer(KIND=C_INT)               :: nc_get_var1_uchar

 End Function nc_get_var1_uchar
End Interface
!---------------------------------- nc_put_var1_schar -------------------------
Interface
 Function nc_put_var1_schar(ncid, varid, indexp, op) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT),  VALUE      :: ncid, varid
 Type(C_PTR),          VALUE      :: indexp
 Integer(KIND=CINT1),  Intent(IN) :: op

 Integer(KIND=C_INT)              :: nc_put_var1_schar

 End Function nc_put_var1_schar
End Interface
!---------------------------------- nc_get_var1_schar -------------------------
Interface
 Function nc_get_var1_schar(ncid, varid, indexp, ip) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT),  VALUE       :: ncid, varid
 Type(C_PTR),          VALUE       :: indexp
 Integer(KIND=CINT1),  Intent(OUT) :: ip

 Integer(KIND=C_INT)               :: nc_get_var1_schar

 End Function nc_get_var1_schar
End Interface
!---------------------------------- nc_put_var1_short -------------------------
Interface
 Function nc_put_var1_short(ncid, varid, indexp, op) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT2

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: indexp
 Integer(KIND=CINT2), Intent(IN) :: op

 Integer(KIND=C_INT)             :: nc_put_var1_short

 End Function nc_put_var1_short
End Interface
!---------------------------------- nc_get_var1_short -------------------------
Interface
 Function nc_get_var1_short(ncid, varid, indexp, ip) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT2

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: indexp
 Integer(KIND=CINT2), Intent(OUT) :: ip

 Integer(KIND=C_INT)              :: nc_get_var1_short

 End Function nc_get_var1_short
End Interface
!---------------------------------- nc_put_var1_int ---------------------------
Interface
 Function nc_put_var1_int(ncid, varid, indexp, op) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: indexp
 Integer(KIND=C_INT), Intent(IN) :: op

 Integer(KIND=C_INT)             :: nc_put_var1_int

 End Function nc_put_var1_int
End Interface
!---------------------------------- nc_get_var1_int ---------------------------
Interface
 Function nc_get_var1_int(ncid, varid, indexp, ip) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: indexp
 Integer(KIND=C_INT), Intent(OUT) :: ip

 Integer(KIND=C_INT)              :: nc_get_var1_int

 End Function nc_get_var1_int
End Interface
!---------------------------------- nc_put_var1_long --------------------------
Interface
 Function nc_put_var1_long(ncid, varid, indexp, op) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_LONG, C_PTR

 Integer(KIND=C_INT),  VALUE      :: ncid, varid
 Type(C_PTR),          VALUE      :: indexp
 Integer(KIND=C_LONG), Intent(IN) :: op

 Integer(KIND=C_INT)              :: nc_put_var1_long

 End Function nc_put_var1_long
End Interface
!---------------------------------- nc_get_var1_long --------------------------
Interface
 Function nc_get_var1_long(ncid, varid, indexp, ip) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_LONG, C_PTR

 Integer(KIND=C_INT),  VALUE       :: ncid, varid
 Type(C_PTR),          VALUE       :: indexp
 Integer(KIND=C_LONG), Intent(OUT) :: ip

 Integer(KIND=C_INT)               :: nc_get_var1_long

 End Function nc_get_var1_long
End Interface
!---------------------------------- nc_put_var1_float -------------------------
Interface
 Function nc_put_var1_float(ncid, varid, indexp, op) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_FLOAT, C_PTR

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: indexp
 Real(KIND=C_FLOAT),  Intent(IN) :: op

 Integer(KIND=C_INT)             :: nc_put_var1_float

 End Function nc_put_var1_float
End Interface
!---------------------------------- nc_get_var1_float -------------------------
Interface
 Function nc_get_var1_float(ncid, varid, indexp, ip) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_FLOAT, C_PTR

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: indexp
 Real(KIND=C_FLOAT),  Intent(OUT) :: ip

 Integer(KIND=C_INT)              :: nc_get_var1_float

 End Function nc_get_var1_float
End Interface
!---------------------------------- nc_put_var1_double ------------------------
Interface
 Function nc_put_var1_double(ncid, varid, indexp, op) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_DOUBLE, C_PTR

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: indexp
 Real(KIND=C_DOUBLE), Intent(IN) :: op

 Integer(KIND=C_INT)             :: nc_put_var1_double

 End Function nc_put_var1_double
End Interface
!---------------------------------- nc_get_var1_double ------------------------
Interface
 Function nc_get_var1_double(ncid, varid, indexp, ip) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_DOUBLE, C_PTR

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: indexp
 Real(KIND=C_DOUBLE), Intent(OUT) :: ip

 Integer(KIND=C_INT)              :: nc_get_var1_double

 End Function nc_get_var1_double
End Interface
!---------------------------------- nc_put_var1 ------------------------------
Interface
 Function nc_put_var1(ncid, varid, indexp, op) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT), VALUE :: ncid, varid
 Type(C_PTR),         VALUE :: indexp
 Type(C_PTR),         VALUE :: op

 Integer(KIND=C_INT)        :: nc_put_var1

 End Function nc_put_var1
End Interface
!---------------------------------- nc_get_var1 ------------------------------
Interface
 Function nc_get_var1(ncid, varid, indexp, op) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT),    VALUE         :: ncid, varid
 Type(C_PTR),            VALUE         :: indexp
 Character(KIND=C_CHAR), Intent(INOUT) :: op(*) ! op is actually void * in C

 Integer(KIND=C_INT)                   :: nc_get_var1

 End Function nc_get_var1
End Interface
!---------------------------------- nc_put_vara_text --------------------------
Interface
 Function nc_put_vara_text(ncid, varid, startp, countp, op)  BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT),    VALUE      :: ncid, varid
 Type(C_PTR),            VALUE      :: startp, countp
 Character(KIND=C_CHAR), Intent(IN) :: op(*)

 Integer(KIND=C_INT)                :: nc_put_vara_text

 End Function nc_put_vara_text
End Interface
!---------------------------------- nc_get_vara_text --------------------------
Interface
 Function nc_get_vara_text(ncid, varid, startp, countp, ip)  BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid, varid
 Type(C_PTR),            VALUE       :: startp, countp
 Character(KIND=C_CHAR), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)                 :: nc_get_vara_text

 End Function nc_get_vara_text
End Interface
!---------------------------------- nc_put_vara_uchar -------------------------
Interface
 Function nc_put_vara_uchar(ncid, varid, startp, countp, op) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: startp, countp
 Integer(KIND=CINT1), Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_vara_uchar

 End Function nc_put_vara_uchar
End Interface
!---------------------------------- nc_get_vara_uchar -------------------------
Interface
 Function nc_get_vara_uchar(ncid, varid, startp, countp, ip) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: startp, countp
 Integer(KIND=CINT1), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_vara_uchar

 End Function nc_get_vara_uchar
End Interface
!---------------------------------- nc_put_vara_schar -------------------------
Interface
 Function nc_put_vara_schar(ncid, varid, startp, countp, op) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: startp, countp
 Integer(KIND=CINT1), Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_vara_schar

 End Function nc_put_vara_schar
End Interface
!---------------------------------- nc_get_vara_schar -------------------------
Interface
 Function nc_get_vara_schar(ncid, varid, startp, countp, ip) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: startp, countp
 Integer(KIND=CINT1), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_vara_schar

 End Function nc_get_vara_schar
End Interface
!---------------------------------- nc_put_vara_short -------------------------
Interface
 Function nc_put_vara_short(ncid, varid, startp, countp, op) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT2

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: startp, countp
 Integer(KIND=CINT2), Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_vara_short

 End Function nc_put_vara_short
End Interface
!---------------------------------- nc_get_vara_short -------------------------
Interface
 Function nc_get_vara_short(ncid, varid, startp, countp, ip) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT2

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: startp, countp
 Integer(KIND=CINT2), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_vara_short

 End Function nc_get_vara_short
End Interface
!--------------------------------- nc_put_vara_int ----------------------------
Interface
 Function nc_put_vara_int(ncid, varid, startp, countp, op) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: startp, countp
 Integer(KIND=CINT),  Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_vara_int

 End Function nc_put_vara_int
End Interface
!--------------------------------- nc_get_vara_int ----------------------------
Interface
 Function nc_get_vara_int(ncid, varid, startp, countp, ip) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: startp, countp
 Integer(KIND=CINT),  Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_vara_int

 End Function nc_get_vara_int
End Interface
!--------------------------------- nc_put_vara_long ---------------------------
Interface
 Function nc_put_vara_long(ncid, varid, startp, countp, op) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_LONG, C_PTR

 Integer(KIND=C_INT),  VALUE      :: ncid, varid
 Type(C_PTR),          VALUE      :: startp, countp
 Integer(KIND=C_LONG), Intent(IN) :: op(*)

 Integer(KIND=C_INT)              :: nc_put_vara_long

 End Function nc_put_vara_long
End Interface
!--------------------------------- nc_get_vara_long ---------------------------
Interface
 Function nc_get_vara_long(ncid, varid, startp, countp, ip) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_LONG, C_PTR

 Integer(KIND=C_INT),  VALUE       :: ncid, varid
 Type(C_PTR),          VALUE       :: startp, countp
 Integer(KIND=C_LONG), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)               :: nc_get_vara_long

 End Function nc_get_vara_long
End Interface
!--------------------------------- nc_put_vara_float --------------------------
Interface
 Function nc_put_vara_float(ncid, varid, startp, countp, op) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_FLOAT, C_PTR

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: startp, countp
 Real(KIND=C_FLOAT),  Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_vara_float

 End Function nc_put_vara_float
End Interface
!--------------------------------- nc_get_vara_float --------------------------
Interface
 Function nc_get_vara_float(ncid, varid, startp, countp, ip) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_FLOAT, C_PTR

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: startp, countp
 Real(KIND=C_FLOAT),  Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_vara_float

 End Function nc_get_vara_float
End Interface
!--------------------------------- nc_put_vara_double -------------------------
Interface
 Function nc_put_vara_double(ncid, varid, startp, countp, op) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_DOUBLE, C_PTR

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: startp, countp
 Real(KIND=C_DOUBLE), Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_vara_double

 End Function nc_put_vara_double
End Interface
!--------------------------------- nc_get_vara_double -------------------------
Interface
 Function nc_get_vara_double(ncid, varid, startp, countp, ip) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_DOUBLE, C_PTR

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: startp, countp
 Real(KIND=C_DOUBLE), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_vara_double

 End Function nc_get_vara_double
End Interface
!---------------------------------- nc_put_vara -------------------------------
Interface
 Function nc_put_vara(ncid, varid, startp, countp, op)  BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR

 Integer(KIND=C_INT), VALUE :: ncid, varid
 Type(C_PTR),         VALUE :: startp, countp
 Type(C_PTR),         VALUE :: op

 Integer(KIND=C_INT)        :: nc_put_vara

 End Function nc_put_vara
End Interface
!---------------------------------- nc_get_vara -------------------------------
Interface
 Function nc_get_vara(ncid, varid, startp, countp, ip)  BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT),    VALUE         :: ncid, varid
 Type(C_PTR),            VALUE         :: startp, countp
 Character(KIND=C_CHAR), Intent(INOUT) :: ip(*)

 Integer(KIND=C_INT)                   :: nc_get_vara

 End Function nc_get_vara
End Interface
!--------------------------------- nc_put_vars_text ---------------------------
Interface
 Function nc_put_vars_text(ncid, varid, startp, countp, stridep, op)  BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT),    VALUE      :: ncid, varid
 Type(C_PTR),            VALUE      :: startp, countp, stridep
 Character(KIND=C_CHAR), Intent(IN) :: op(*)

 Integer(KIND=C_INT)                :: nc_put_vars_text

 End Function nc_put_vars_text
End Interface
!--------------------------------- nc_get_vars_text ---------------------------
Interface
 Function nc_get_vars_text(ncid, varid, startp, countp, stridep, ip)  BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid, varid
 Type(C_PTR),            VALUE       :: startp, countp, stridep
 Character(KIND=C_CHAR), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)                 :: nc_get_vars_text

 End Function nc_get_vars_text
End Interface
!--------------------------------- nc_put_vars_uchar --------------------------
Interface
 Function nc_put_vars_uchar(ncid, varid, startp, countp, stridep, op) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: startp, countp, stridep
 Integer(KIND=CINT1), Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_vars_uchar

 End Function nc_put_vars_uchar
End Interface
!--------------------------------- nc_get_vars_uchar --------------------------
Interface
 Function nc_get_vars_uchar(ncid, varid, startp, countp, stridep, ip) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: startp, countp, stridep
 Integer(KIND=CINT1), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_vars_uchar

 End Function nc_get_vars_uchar
End Interface
!--------------------------------- nc_put_vars_schar --------------------------
Interface
 Function nc_put_vars_schar(ncid, varid, startp, countp, stridep, op) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: startp, countp, stridep
 Integer(KIND=CINT1), Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_vars_schar

 End Function nc_put_vars_schar
End Interface
!--------------------------------- nc_get_vars_schar --------------------------
Interface
 Function nc_get_vars_schar(ncid, varid, startp, countp, stridep, ip) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: startp, countp, stridep
 Integer(KIND=CINT1), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_vars_schar

 End Function nc_get_vars_schar
End Interface
!--------------------------------- nc_put_vars_short --------------------------
Interface
 Function nc_put_vars_short(ncid, varid, startp, countp, stridep, op) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT2

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: startp, countp, stridep
 Integer(KIND=CINT2), Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_vars_short

 End Function nc_put_vars_short
End Interface
!--------------------------------- nc_get_vars_short --------------------------
Interface
 Function nc_get_vars_short(ncid, varid, startp, countp, stridep, ip) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT,  C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT2

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: startp, countp, stridep
 Integer(KIND=CINT2), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_vars_short

 End Function nc_get_vars_short
End Interface
!--------------------------------- nc_put_vars_int ----------------------------
Interface
 Function nc_put_vars_int(ncid, varid, startp, countp, stridep, op) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: startp, countp, stridep
 Integer(KIND=CINT),  Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_vars_int

 End Function nc_put_vars_int
End Interface
!--------------------------------- nc_get_vars_int ----------------------------
Interface
 Function nc_get_vars_int(ncid, varid, startp, countp, stridep, ip) BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: startp, countp, stridep
 Integer(KIND=CINT),  Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_vars_int

 End Function nc_get_vars_int
End Interface
!--------------------------------- nc_put_vars_long ---------------------------
Interface
 Function nc_put_vars_long(ncid, varid, startp, countp, stridep, op) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_LONG, C_PTR

 Integer(KIND=C_INT),  VALUE      :: ncid, varid
 Type(C_PTR),          VALUE      :: startp, countp, stridep
 Integer(KIND=C_LONG), Intent(IN) :: op(*)

 Integer(KIND=C_INT)              :: nc_put_vars_long

 End Function nc_put_vars_long
End Interface
!--------------------------------- nc_get_vars_long ---------------------------
Interface
 Function nc_get_vars_long(ncid, varid, startp, countp, stridep, ip) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_LONG, C_PTR

 Integer(KIND=C_INT),  VALUE       :: ncid, varid
 Type(C_PTR),          VALUE       :: startp, countp, stridep
 Integer(KIND=C_LONG), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)               :: nc_get_vars_long

 End Function nc_get_vars_long
End Interface
!--------------------------------- nc_put_vars_float --------------------------
Interface
 Function nc_put_vars_float(ncid, varid, startp, countp, stridep, op) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_FLOAT, C_PTR

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: startp, countp, stridep
 Real(KIND=C_FLOAT),  Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_vars_float

 End Function nc_put_vars_float
End Interface
!--------------------------------- nc_get_vars_float --------------------------
Interface
 Function nc_get_vars_float(ncid, varid, startp, countp, stridep, ip) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_FLOAT, C_PTR

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: startp, countp, stridep
 Real(KIND=C_FLOAT),  Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_vars_float

 End Function nc_get_vars_float
End Interface
!--------------------------------- nc_put_vars_double -------------------------
Interface
 Function nc_put_vars_double(ncid, varid, startp, countp, stridep, op) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_DOUBLE, C_PTR

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: startp, countp, stridep
 Real(KIND=C_DOUBLE), Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_vars_double

 End Function nc_put_vars_double
End Interface
!--------------------------------- nc_get_vars_double -------------------------
Interface
 Function nc_get_vars_double(ncid, varid, startp, countp, stridep, ip) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_DOUBLE, C_PTR

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: startp, countp, stridep
 Real(KIND=C_DOUBLE), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_vars_double

 End Function nc_get_vars_double
End Interface
!--------------------------------- nc_put_vars --------------------------------
Interface
 Function nc_put_vars(ncid, varid, startp, countp, stridep, op)  BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR

 Integer(KIND=C_INT), VALUE :: ncid, varid
 Type(C_PTR),         VALUE :: startp, countp, stridep
 Type(C_PTR),         VALUE :: op

 Integer(KIND=C_INT)        :: nc_put_vars

 End Function nc_put_vars
End Interface
!--------------------------------- nc_get_vars ---------------------------
Interface
 Function nc_get_vars(ncid, varid, startp, countp, stridep, ip)  BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT),    VALUE         :: ncid, varid
 Type(C_PTR),            VALUE         :: startp, countp, stridep
 Character(KIND=C_CHAR), Intent(INOUT) :: ip(*)

 Integer(KIND=C_INT)                   :: nc_get_vars

 End Function nc_get_vars
End Interface
!--------------------------------- nc_put_varm_text ---------------------------
Interface
! array of characters
 Function nc_put_varm_text(ncid, varid, startp, countp, stridep, imapp,op)  &
                             BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT),    VALUE      :: ncid, varid
 Type(C_PTR),            VALUE      :: startp, countp, stridep, imapp
 Character(KIND=C_CHAR), Intent(IN) :: op(*)

 Integer(KIND=C_INT)                :: nc_put_varm_text

 End Function nc_put_varm_text
End Interface
!--------------------------------- nc_get_varm_text ---------------------------
Interface
 Function nc_get_varm_text(ncid, varid, startp, countp, stridep, imapp,ip)  &
                           BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_PTR, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid, varid
 Type(C_PTR),            VALUE       :: startp, countp, stridep, imapp
 Character(KIND=C_CHAR), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)                 :: nc_get_varm_text

 End Function nc_get_varm_text
End Interface
!--------------------------------- nc_put_varm_uchar --------------------------
Interface
 Function nc_put_varm_uchar(ncid, varid, startp, countp, stridep, imapp, op)  &
                            BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: startp, countp, stridep, imapp
 Integer(KIND=CINT1), Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_varm_uchar

 End Function nc_put_varm_uchar
End Interface
!--------------------------------- nc_get_varm_uchar --------------------------
Interface
 Function nc_get_varm_uchar(ncid, varid, startp, countp, stridep, imapp, ip)  &
                            BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: startp, countp, stridep, imapp
 Integer(KIND=CINT1), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_varm_uchar

 End Function nc_get_varm_uchar
End Interface
!--------------------------------- nc_put_varm_schar --------------------------
Interface
 Function nc_put_varm_schar(ncid, varid, startp, countp, stridep, imapp, op)  &
                            BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: startp, countp, stridep, imapp
 Integer(KIND=CINT1), Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_varm_schar

 End Function nc_put_varm_schar
End Interface
!--------------------------------- nc_get_varm_schar --------------------------
Interface
 Function nc_get_varm_schar(ncid, varid, startp, countp, stridep, imapp, ip)  &
                            BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: startp, countp, stridep, imapp
 Integer(KIND=CINT1), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_varm_schar

 End Function nc_get_varm_schar
End Interface
!--------------------------------- nc_put_varm_short --------------------------
Interface
 Function nc_put_varm_short(ncid, varid, startp, countp, stridep, imapp, op)  &
                            BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT2

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: startp, countp, stridep, imapp
 Integer(KIND=CINT2), Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_varm_short

 End Function nc_put_varm_short
End Interface
!--------------------------------- nc_get_varm_short --------------------------
Interface
 Function nc_get_varm_short(ncid, varid, startp, countp, stridep, imapp, ip)  &
                            BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT2

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: startp, countp, stridep, imapp
 Integer(KIND=CINT2), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_varm_short

 End Function nc_get_varm_short
End Interface
!--------------------------------- nc_put_varm_int ----------------------------
Interface
 Function nc_put_varm_int(ncid, varid, startp, countp, stridep, imapp, op)  &
                          BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: startp, countp, stridep, imapp
 Integer(KIND=CINT),  Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_varm_int

 End Function nc_put_varm_int
End Interface
!--------------------------------- nc_get_varm_int ----------------------------
Interface
 Function nc_get_varm_int(ncid, varid, startp, countp, stridep, imapp, ip)  &
                          BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_PTR
 USE NETCDF_NC_DATA, ONLY: CINT

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: startp, countp, stridep, imapp
 Integer(KIND=CINT),  Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_varm_int

 End Function nc_get_varm_int
End Interface
!--------------------------------- nc_put_varm_long ---------------------------
Interface
 Function nc_put_varm_long(ncid, varid, startp, countp, stridep, imapp, op)  &
                           BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_LONG, C_PTR

 Integer(KIND=C_INT),  VALUE      :: ncid, varid
 Type(C_PTR),          VALUE      :: startp, countp, stridep, imapp
 Integer(KIND=C_LONG), Intent(IN) :: op(*)

 Integer(KIND=C_INT)              :: nc_put_varm_long

 End Function nc_put_varm_long
End Interface
!--------------------------------- nc_get_varm_long ---------------------------
Interface
 Function nc_get_varm_long(ncid, varid, startp, countp, stridep, imapp, ip)  &
                           BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_LONG, C_PTR

 Integer(KIND=C_INT),  VALUE       :: ncid, varid
 Type(C_PTR),          VALUE       :: startp, countp, stridep, imapp
 Integer(KIND=C_LONG), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)               :: nc_get_varm_long

 End Function nc_get_varm_long
End Interface
!--------------------------------- nc_put_varm_float --------------------------
Interface
 Function nc_put_varm_float(ncid, varid, startp, countp, stridep, imapp, op)  &
                            BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_FLOAT, C_PTR

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: startp, countp, stridep, imapp
 Real(KIND=C_FLOAT),  Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_varm_float

 End Function nc_put_varm_float
End Interface
!--------------------------------- nc_get_varm_float --------------------------
Interface
 Function nc_get_varm_float(ncid, varid, startp, countp, stridep, imapp, ip)  &
                            BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_FLOAT, C_PTR

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: startp, countp, stridep, imapp
 Real(KIND=C_FLOAT),  Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_varm_float

 End Function nc_get_varm_float
End Interface
!--------------------------------- nc_put_varm_double -------------------------
Interface
 Function nc_put_varm_double(ncid, varid, startp, countp, stridep,imapp, op)  &
                             BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_DOUBLE, C_PTR

 Integer(KIND=C_INT), VALUE      :: ncid, varid
 Type(C_PTR),         VALUE      :: startp, countp, stridep, imapp
 Real(KIND=C_DOUBLE), Intent(IN) :: op(*)

 Integer(KIND=C_INT)             :: nc_put_varm_double

 End Function nc_put_varm_double
End Interface
!--------------------------------- nc_get_varm_double -------------------------
Interface
 Function nc_get_varm_double(ncid, varid, startp, countp, stridep,imapp, ip)  &
                             BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_DOUBLE, C_PTR

 Integer(KIND=C_INT), VALUE       :: ncid, varid
 Type(C_PTR),         VALUE       :: startp, countp, stridep, imapp
 Real(KIND=C_DOUBLE), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)              :: nc_get_varm_double

 End Function nc_get_varm_double
End Interface
!--------------------------------- nc_inq_att --------------------------------
Interface
 Function nc_inq_att(ncid, varid, name, xtypep, lenp)  BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_SIZE_T, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid, varid
 Character(KIND=C_CHAR), Intent(IN)  :: name(*)
 Integer(KIND=C_INT),    Intent(OUT) :: xtypep
 Integer(KIND=C_SIZE_T), Intent(OUT) :: lenp

 Integer(KIND=C_INT)                 :: nc_inq_att

 End Function nc_inq_att
End Interface
!--------------------------------- nc_inq_attid ------------------------------
Interface
 Function nc_inq_attid(ncid, varid, name, attnump)   BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid, varid
 Character(KIND=C_CHAR), Intent(IN)  :: name(*)
 Integer(KIND=C_INT),    Intent(OUT) :: attnump

 Integer(KIND=C_INT)                 :: nc_inq_attid

 End Function nc_inq_attid
End Interface
!--------------------------------- nc_inq_atttype ----------------------------
Interface
 Function nc_inq_atttype(ncid, varid, name, xtypep)   BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid, varid
 Character(KIND=C_CHAR), Intent(IN)  :: name(*)
 Integer(KIND=C_INT),    Intent(OUT) :: xtypep

 Integer(KIND=C_INT)                 :: nc_inq_atttype

 End Function nc_inq_atttype
End Interface
!--------------------------------- nc_inq_attlen -----------------------------
Interface
 Function nc_inq_attlen(ncid, varid, name, lenp)   BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_SIZE_T, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid, varid
 Character(KIND=C_CHAR), Intent(IN)  :: name(*)
 Integer(KIND=C_SIZE_T), Intent(OUT) :: lenp

 Integer(KIND=C_INT)                 :: nc_inq_attlen

 End Function nc_inq_attlen
End Interface
!--------------------------------- nc_inq_attname ----------------------------
Interface
 Function nc_inq_attname(ncid, varid, attnum, name)   BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE         :: ncid, varid, attnum
 Character(KIND=C_CHAR), Intent(INOUT) :: name(*)

 Integer(KIND=C_INT)                   :: nc_inq_attname

 End Function nc_inq_attname
End Interface
!--------------------------------- nc_copy_att -------------------------------
Interface
 Function nc_copy_att(ncid_in, varid_in, name, ncid_out, varid_out )  BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE      :: ncid_in, varid_in, varid_out, &
                                       ncid_out
 Character(KIND=C_CHAR), Intent(IN) :: name(*)

 Integer(KIND=C_INT)                :: nc_copy_att

 End Function nc_copy_att
End Interface
!--------------------------------- nc_rename_att -----------------------------
Interface
 Function nc_rename_att(ncid, varid, name, newname)   BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE      :: ncid, varid
 Character(KIND=C_CHAR), Intent(IN) :: name(*), newname(*)

 Integer(KIND=C_INT)                :: nc_rename_att

 End Function nc_rename_att
End Interface
!--------------------------------- nc_del_att --------------------------------
Interface
 Function nc_del_att(ncid, varid, name)  BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE      :: ncid, varid
 Character(KIND=C_CHAR), Intent(IN) :: name(*)

 Integer(KIND=C_INT)                :: nc_del_att

 End Function nc_del_att
End Interface
!--------------------------------- nc_put_att_text ---------------------------
Interface
 Function nc_put_att_text(ncid, varid, name, nlen, op) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_SIZE_T, C_CHAR

 Integer(KIND=C_INT),    VALUE      :: ncid, varid
 Integer(KIND=C_SIZE_T), VALUE      :: nlen
 Character(KIND=C_CHAR), Intent(IN) :: name(*)
 Character(KIND=C_CHAR), Intent(IN) :: op(*)

 Integer(KIND=C_INT)                :: nc_put_att_text

 End Function nc_put_att_text
End Interface
!--------------------------------- nc_get_att_text ---------------------------
Interface
 Function nc_get_att_text(ncid, varid, name, ip) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid, varid
 Character(KIND=C_CHAR), Intent(IN)  :: name(*)
 Character(KIND=C_CHAR), Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)                 :: nc_get_att_text

 End Function nc_get_att_text
End Interface
!--------------------------------- nc_put_att_uchar --------------------------
Interface
 Function nc_put_att_uchar(ncid, varid, name, xtype, nlen, op)   BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_SIZE_T, C_CHAR
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT),    VALUE      :: ncid, varid
 Integer(KIND=C_SIZE_T), VALUE      :: nlen
 Integer(KIND=C_INT),    VALUE      :: xtype
 Character(KIND=C_CHAR), Intent(IN) :: name(*)
 Integer(KIND=CINT1),    Intent(IN) :: op(*)

 Integer(KIND=C_INT)                :: nc_put_att_uchar

 End Function nc_put_att_uchar
End Interface
!--------------------------------- nc_get_att_uchar --------------------------
Interface
 Function nc_get_att_uchar(ncid, varid, name, ip)   BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_CHAR
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT),    VALUE       :: ncid, varid
 Character(KIND=C_CHAR), Intent(IN)  :: name(*)
 Integer(KIND=CINT1),    Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)                 :: nc_get_att_uchar

 End Function nc_get_att_uchar
End Interface
!--------------------------------- nc_put_att_schar --------------------------
Interface
 Function nc_put_att_schar(ncid, varid, name, xtype, nlen, op)   BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_SIZE_T, C_CHAR
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT),    VALUE      :: ncid, varid
 Integer(KIND=C_SIZE_T), VALUE      :: nlen
 Integer(KIND=C_INT),    VALUE      :: xtype
 Character(KIND=C_CHAR), Intent(IN) :: name(*)
 Integer(KIND=CINT1),    Intent(IN) :: op(*)

 Integer(KIND=C_INT)                :: nc_put_att_schar

 End Function nc_put_att_schar
End Interface
!--------------------------------- nc_get_att_schar --------------------------
Interface
 Function nc_get_att_schar(ncid, varid, name, ip)   BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_CHAR
 USE NETCDF_NC_DATA, ONLY: CINT1

 Integer(KIND=C_INT),    VALUE       :: ncid, varid
 Character(KIND=C_CHAR), Intent(IN)  :: name(*)
 Integer(KIND=CINT1),    Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)                 :: nc_get_att_schar

 End Function nc_get_att_schar
End Interface
!--------------------------------- nc_put_att_short --------------------------
Interface
 Function nc_put_att_short(ncid, varid, name, xtype, nlen, op)   BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_SIZE_T, C_CHAR
 USE NETCDF_NC_DATA, ONLY: CINT2

 Integer(KIND=C_INT),    VALUE      :: ncid, varid
 Integer(KIND=C_SIZE_T), VALUE      :: nlen
 Integer(KIND=C_INT),    VALUE      :: xtype
 Character(KIND=C_CHAR), Intent(IN) :: name(*)
 Integer(KIND=CINT2),    Intent(IN) :: op(*)

 Integer(KIND=C_INT)                :: nc_put_att_short

 End Function nc_put_att_short
End Interface
!--------------------------------- nc_get_att_short --------------------------
Interface
 Function nc_get_att_short(ncid, varid, name, ip)   BIND(C)

 USE ISO_C_BINDING,  ONLY: C_INT, C_CHAR
 USE NETCDF_NC_DATA, ONLY: CINT2

 Integer(KIND=C_INT),    VALUE       :: ncid, varid
 Character(KIND=C_CHAR), Intent(IN)  :: name(*)
 Integer(KIND=CINT2),    Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)                 :: nc_get_att_short

 End Function nc_get_att_short
End Interface
!--------------------------------- nc_put_att_int --------------------------
Interface
 Function nc_put_att_int(ncid, varid, name, xtype, nlen, op)   BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_SIZE_T, C_CHAR

 Integer(KIND=C_INT),    VALUE      :: ncid, varid
 Integer(KIND=C_SIZE_T), VALUE      :: nlen
 Integer(KIND=C_INT),    VALUE      :: xtype
 Character(KIND=C_CHAR), Intent(IN) :: name(*)
 Integer(KIND=C_INT),    Intent(IN) :: op(*)

 Integer(KIND=C_INT)                :: nc_put_att_int

 End Function nc_put_att_int
End Interface
!--------------------------------- nc_get_att_int -----------------------------
Interface
 Function nc_get_att_int(ncid, varid, name, ip)   BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid, varid
 Character(KIND=C_CHAR), Intent(IN)  :: name(*)
 Integer(KIND=C_INT),    Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)                 :: nc_get_att_int

 End Function nc_get_att_int
End Interface
!--------------------------------- nc_put_att_long --------------------------
Interface
 Function nc_put_att_long(ncid, varid, name, xtype, nlen, op)   BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_SIZE_T, C_LONG, C_CHAR

 Integer(KIND=C_INT),    VALUE      :: ncid, varid
 Integer(KIND=C_SIZE_T), VALUE      :: nlen
 Integer(KIND=C_INT),    VALUE      :: xtype
 Character(KIND=C_CHAR), Intent(IN) :: name(*)
 Integer(KIND=C_LONG),   Intent(IN) :: op(*)

 Integer(KIND=C_INT)                :: nc_put_att_long

 End Function nc_put_att_long
End Interface
!--------------------------------- nc_get_att_long --------------------------
Interface
 Function nc_get_att_long(ncid, varid, name, ip)   BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_LONG, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid, varid
 Character(KIND=C_CHAR), Intent(IN)  :: name(*)
 Integer(KIND=C_LONG),   Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)                 :: nc_get_att_long

 End Function nc_get_att_long
End Interface
!--------------------------------- nc_put_att_float --------------------------
Interface
 Function nc_put_att_float(ncid, varid, name, xtype, nlen, op)   BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_SIZE_T, C_FLOAT, C_CHAR

 Integer(KIND=C_INT),    VALUE      :: ncid, varid
 Integer(KIND=C_SIZE_T), VALUE      :: nlen
 Integer(KIND=C_INT),    VALUE      :: xtype
 Character(KIND=C_CHAR), Intent(IN) :: name(*)
 Real(KIND=C_FLOAT),     Intent(IN) :: op(*)

 Integer(KIND=C_INT) :: nc_put_att_float

 End Function nc_put_att_float
End Interface
!--------------------------------- nc_get_att_float --------------------------
Interface
 Function nc_get_att_float(ncid, varid, name, ip)   BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_FLOAT, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid, varid
 Character(KIND=C_CHAR), Intent(IN)  :: name(*)
 Real(KIND=C_FLOAT),     Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)                 :: nc_get_att_float

 End Function nc_get_att_float
End Interface
!--------------------------------- nc_put_att_double -------------------------
Interface
 Function nc_put_att_double(ncid, varid, name, xtype, nlen, op) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_SIZE_T, C_DOUBLE, C_CHAR

 Integer(KIND=C_INT),    VALUE      :: ncid, varid
 Integer(KIND=C_SIZE_T), VALUE      :: nlen
 Integer(KIND=C_INT),    VALUE      :: xtype
 Character(KIND=C_CHAR), Intent(IN) :: name(*)
 Real(KIND=C_DOUBLE),    Intent(IN) :: op(*)

 Integer(KIND=C_INT)                :: nc_put_att_double

 End Function nc_put_att_double
End Interface
!------------------------------- nc_get_att_double -------------------------
Interface
 Function nc_get_att_double(ncid, varid, name, ip) BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT, C_DOUBLE, C_CHAR

 Integer(KIND=C_INT),    VALUE       :: ncid, varid
 Character(KIND=C_CHAR), Intent(IN)  :: name(*)
 Real(KIND=C_DOUBLE),    Intent(OUT) :: ip(*)

 Integer(KIND=C_INT)                 :: nc_get_att_double

 End Function nc_get_att_double
End Interface
!------------------------------- nc_copy_var --------------------------------
Interface
 Function nc_copy_var(ncid_in, varid, ncid_out)  BIND(C)

 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE :: ncid_in, varid, ncid_out

 Integer(KIND=C_INT)        :: nc_copy_var

 End Function nc_copy_var
End Interface
!------------------------------- nc_set_default_format -----------------------
Interface
 Function nc_set_default_format(newform, old_format)  BIND(C)
!
 USE ISO_C_BINDING, ONLY: C_INT

 Integer(KIND=C_INT), VALUE       :: newform
 Integer(KIND=C_INT), Intent(OUT) :: old_format

 Integer(KIND=C_INT)              :: nc_set_default_format

 End Function nc_set_default_format
End Interface
!---------------------------- Start of module procedures ---------------------
CONTAINS

! Utilities to support C interface routines

!----------------------------------- addCNullChar -----------------------------
 Function addCNullChar(string, nlen) Result(cstring)

! Add a C_NULL_CHAR to a string to create a C compatible
! string. Assumes target variable will be of length
! LEN(string)+1. Trailing blanks will be stripped
! from string and length of trimmed string will
! be returned in nlen

! USE ISO_C_BINDING

 Implicit NONE

 Character(LEN=*), Intent(IN)    :: string
 Integer,          Intent(INOUT) :: nlen

 Character(LEN=(LEN(string)+1))  :: cstring

 Integer :: inull


! first check to see if we already have a C NULL char attached
! to string and strip trailing blanks. We will overwrite it if
! we do

 nlen  = LEN_TRIM(string)
 inull = SCAN(string, C_NULL_CHAR)

 If (inull > 1) nlen = inull - 1
 nlen = MAX(1,nlen)  ! Make sure nlen is at least 1

! append null char to trimmed string

 cstring = REPEAT(" ", LEN(cstring)) ! init to blanks
 cstring = string(1:nlen)//C_NULL_CHAR

 End Function addCNullChar
!----------------------------------- stripCNullChar ----------------------------
 Function StripCNullChar(cstring, nlen) Result(string)

! Check cstring for a C NULL char, strip it off and
! return regular string. Limit length of cstring loaded
! into string to nlen

! USE ISO_C_BINDING, ONLY: C_NULL_CHAR

 Implicit NONE

 Character(LEN=*), Intent(IN) :: cstring
 Integer,          Intent(IN) :: nlen

 Character(LEN=nlen)          :: string

 Integer :: ie, inull

 ie    = LEN_TRIM(cstring)
 inull = SCAN(cstring, C_NULL_CHAR)

 If (inull > 1) ie=inull-1
 ie = MAX(1, MIN(ie,nlen)) ! limit ie to 1 or nlen

 string       = REPEAT(" ", nlen)
 string(1:ie) = cstring(1:ie)

 End Function StripCNullChar
!
!----------------------------End of Module netcdf_c_interfaces ----------------
End Module netcdf_nc_interfaces

  !
  ! Attribute routines:
  !
  ! -------
  function nf90_copy_att(ncid_in, varid_in, name, ncid_out, varid_out)
    integer,             intent( in) :: ncid_in,  varid_in
    character (len = *), intent( in) :: name
    integer,             intent( in) :: ncid_out, varid_out
    integer                          :: nf90_copy_att

    nf90_copy_att = nf_copy_att(ncid_in, varid_in, name, ncid_out, varid_out)
  end function nf90_copy_att
  ! -------
  function nf90_rename_att(ncid, varid, curname, newname)
    integer,             intent( in) :: ncid,  varid
    character (len = *), intent( in) :: curname, newname
    integer                          :: nf90_rename_att

    nf90_rename_att = nf_rename_att(ncid, varid, curname, newname)
  end function nf90_rename_att
  ! -------
  function nf90_del_att(ncid, varid, name)
    integer,             intent( in) :: ncid, varid
    character (len = *), intent( in) :: name
    integer                          :: nf90_del_att

    nf90_del_att = nf_del_att(ncid, varid, name)
  end function nf90_del_att
  ! -------
  ! Attribute inquiry functions
  ! -------
  function nf90_inq_attname(ncid, varid, attnum, name)
    integer,             intent( in) :: ncid, varid, attnum
    character (len = *), intent(out) :: name
    integer                          :: nf90_inq_attname

    nf90_inq_attname = nf_inq_attname(ncid, varid, attnum, name)
  end function nf90_inq_attname
  ! -------
  function nf90_inquire_attribute(ncid, varid, name, xtype, len, attnum)
    integer,             intent( in)           :: ncid, varid
    character (len = *), intent( in)           :: name
    integer,             intent(out), optional :: xtype, len, attnum
    integer                                    :: nf90_inquire_attribute

    integer                          :: local_xtype, local_len

    ! Do we need to worry about not saving the state from this call?
    if(present(attnum)) &
      nf90_inquire_attribute = nf_inq_attid(ncid, varid, name, attnum)
    nf90_inquire_attribute   = nf_inq_att  (ncid, varid, name, local_xtype, local_len)
    if(present(xtype)) xtype = local_xtype
    if(present(len  )) len   = local_len
  end function nf90_inquire_attribute
  ! -------
  ! Put and get functions; these will get overloaded
  ! -------
  ! Text
  ! -------
  function nf90_put_att_text(ncid, varid, name, values)
    integer,                          intent( in) :: ncid, varid
    character(len = *),               intent( in) :: name
    character(len = *),               intent( in) :: values
    integer                                       :: nf90_put_att_text

    nf90_put_att_text = nf_put_att_text(ncid, varid, name, len_trim(values), trim(values))
  end function nf90_put_att_text
  ! -------
  function nf90_get_att_text(ncid, varid, name, values)
    integer,                          intent( in) :: ncid, varid
    character(len = *),               intent( in) :: name
    character(len = *),               intent(out) :: values
    integer                                       :: nf90_get_att_text

    values = ' '  !! make sure result will be blank padded
    nf90_get_att_text = nf_get_att_text(ncid, varid, name, values)
  end function nf90_get_att_text
  ! -------
  ! Integer attributes
  ! -------
  function nf90_put_att_OneByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind =  OneByteInt), dimension(:), intent( in) :: values
    integer                                                 :: nf90_put_att_OneByteInt

    nf90_put_att_OneByteInt = nf_put_att_int1(ncid, varid, name, nf90_int1, size(values), values)
  end function nf90_put_att_OneByteInt
  ! -------
  function nf90_put_att_one_OneByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind =  OneByteInt),               intent( in) :: values
    integer                                                 :: nf90_put_att_one_OneByteInt

    integer (kind =  OneByteInt), dimension(1)              :: valuesA
    valuesA(1) = values
    nf90_put_att_one_OneByteInt = nf_put_att_int1(ncid, varid, name, nf90_int1, 1, valuesA)
  end function nf90_put_att_one_OneByteInt
  ! -------
  function nf90_get_att_OneByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind =  OneByteInt), dimension(:), intent(out) :: values
    integer                                                 :: nf90_get_att_OneByteInt

    nf90_get_att_OneByteInt = nf_get_att_int1(ncid, varid, name, values)
  end function nf90_get_att_OneByteInt
  ! -------
  function nf90_get_att_one_OneByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind =  OneByteInt),               intent(out) :: values
    integer                                                 :: nf90_get_att_one_OneByteInt

    integer (kind =  OneByteInt), dimension(1)              :: valuesA
    nf90_get_att_one_OneByteInt = nf_get_att_int1(ncid, varid, name, valuesA)
    values = valuesA(1)
  end function nf90_get_att_one_OneByteInt
  ! -------
  function nf90_put_att_TwoByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind =  TwoByteInt), dimension(:), intent( in) :: values
    integer                                                 :: nf90_put_att_TwoByteInt

    nf90_put_att_TwoByteInt = nf_put_att_int2(ncid, varid, name, nf90_int2, size(values), values)
  end function nf90_put_att_TwoByteInt
  ! -------
  function nf90_put_att_one_TwoByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind =  TwoByteInt),               intent( in) :: values
    integer                                                 :: nf90_put_att_one_TwoByteInt

    integer (kind =  TwoByteInt), dimension(1)              :: valuesA
    valuesA(1) = values
    nf90_put_att_one_TwoByteInt = nf_put_att_int2(ncid, varid, name, nf90_int2, 1, valuesA)
  end function nf90_put_att_one_TwoByteInt
  ! -------
  function nf90_get_att_TwoByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind =  TwoByteInt), dimension(:), intent(out) :: values
    integer                                                 :: nf90_get_att_TwoByteInt

    nf90_get_att_TwoByteInt = nf_get_att_int2(ncid, varid, name, values)
  end function nf90_get_att_TwoByteInt
  ! -------
  function nf90_get_att_one_TwoByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind =  TwoByteInt),               intent(out) :: values
    integer                                                 :: nf90_get_att_one_TwoByteInt

    integer (kind =  TwoByteInt), dimension(1)              :: valuesA
    nf90_get_att_one_TwoByteInt = nf_get_att_int2(ncid, varid, name, valuesA)
    values = valuesA(1)
  end function nf90_get_att_one_TwoByteInt
  ! -------
  function nf90_put_att_FourByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind = FourByteInt), dimension(:), intent( in) :: values
    integer                                                 :: nf90_put_att_FourByteInt

    nf90_put_att_FourByteInt = nf_put_att_int(ncid, varid, name, nf90_int, size(values), int(values))
  end function nf90_put_att_FourByteInt
  ! -------
  function nf90_put_att_one_FourByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind = FourByteInt),               intent( in) :: values
    integer                                                 :: nf90_put_att_one_FourByteInt

    integer (kind = FourByteInt), dimension(1)              :: valuesA
    valuesA(1) = int(values)
    nf90_put_att_one_FourByteInt = nf_put_att_int(ncid, varid, name, nf90_int, 1, int(valuesA))
  end function nf90_put_att_one_FourByteInt
  ! -------
  function nf90_get_att_FourByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind = FourByteInt), dimension(:), intent(out) :: values
    integer                                                 :: nf90_get_att_FourByteInt
    
    integer, dimension(size(values)) :: defaultInteger

    nf90_get_att_FourByteInt = nf_get_att_int(ncid, varid, name, defaultInteger)
    values(:) = defaultInteger(:)
  end function nf90_get_att_FourByteInt
  ! -------
  function nf90_get_att_one_FourByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind = FourByteInt),               intent(out) :: values
    integer                                                 :: nf90_get_att_one_FourByteInt

    integer, dimension(1) :: defaultInteger

    nf90_get_att_one_FourByteInt = nf_get_att_int(ncid, varid, name, defaultInteger)
    values = defaultInteger(1)
  end function nf90_get_att_one_FourByteInt
  ! -------
  function nf90_put_att_EightByteInt(ncid, varid, name, values)
    integer,                                     intent( in) :: ncid, varid
    character(len = *),                          intent( in) :: name
    integer (kind = EightByteInt), dimension(:), intent( in) :: values
    integer                                                  :: nf90_put_att_EightByteInt

    nf90_put_att_EightByteInt = nf_put_att_int(ncid, varid, name, nf90_int, size(values), int(values))
  end function nf90_put_att_EightByteInt
  ! -------
  function nf90_put_att_one_EightByteInt(ncid, varid, name, values)
    integer,                                     intent( in) :: ncid, varid
    character(len = *),                          intent( in) :: name
    integer (kind = EightByteInt),               intent( in) :: values
    integer                                                  :: nf90_put_att_one_EightByteInt

    integer, dimension(1) :: valuesA
    valuesA(1) = values
    nf90_put_att_one_EightByteInt = nf_put_att_int(ncid, varid, name, nf90_int, 1, valuesA)
  end function nf90_put_att_one_EightByteInt
  ! -------
  function nf90_get_att_EightByteInt(ncid, varid, name, values)
    integer,                                     intent( in) :: ncid, varid
    character(len = *),                          intent( in) :: name
    integer (kind = EightByteInt), dimension(:), intent(out) :: values
    integer                                                 :: nf90_get_att_EightByteInt
    
    integer, dimension(size(values)) :: defaultInteger

    nf90_get_att_EightByteInt = nf_get_att_int(ncid, varid, name, defaultInteger)
    values(:) = defaultInteger(:)
  end function nf90_get_att_EightByteInt
  ! -------
  function nf90_get_att_one_EightByteInt(ncid, varid, name, values)
    integer,                                     intent( in) :: ncid, varid
    character(len = *),                          intent( in) :: name
    integer (kind = EightByteInt),               intent(out) :: values
    integer                                                 :: nf90_get_att_one_EightByteInt

    integer, dimension(1) :: defaultInteger

    nf90_get_att_one_EightByteInt = nf_get_att_int(ncid, varid, name, defaultInteger)
    values = defaultInteger(1)
  end function nf90_get_att_one_EightByteInt
  ! -------
  ! Real attributes
  ! -------
  function nf90_put_att_FourByteReal(ncid, varid, name, values)
    integer,                                   intent( in) :: ncid, varid
    character(len = *),                        intent( in) :: name
    real (kind =  FourByteReal), dimension(:), intent( in) :: values
    integer                                                :: nf90_put_att_FourByteReal

    nf90_put_att_FourByteReal = nf_put_att_real(ncid, varid, name, nf90_real4, size(values), values)
  end function nf90_put_att_FourByteReal
  ! -------
  function nf90_put_att_one_FourByteReal(ncid, varid, name, values)
    integer,                                   intent( in) :: ncid, varid
    character(len = *),                        intent( in) :: name
    real (kind =  FourByteReal),               intent( in) :: values
    integer                                                :: nf90_put_att_one_FourByteReal

    real (kind =  FourByteReal), dimension(1) :: valuesA
    valuesA(1) = values
    nf90_put_att_one_FourByteReal = nf_put_att_real(ncid, varid, name, nf90_real4, 1, valuesA)
  end function nf90_put_att_one_FourByteReal
  ! -------
  function nf90_get_att_FourByteReal(ncid, varid, name, values)
    integer,                                   intent( in) :: ncid, varid
    character(len = *),                        intent( in) :: name
    real (kind =  FourByteReal), dimension(:), intent(out) :: values
    integer                                                :: nf90_get_att_FourByteReal

    nf90_get_att_FourByteReal = nf_get_att_real(ncid, varid, name, values)
  end function nf90_get_att_FourByteReal
  ! -------
  function nf90_get_att_one_FourByteReal(ncid, varid, name, values)
    integer,                                   intent( in) :: ncid, varid
    character(len = *),                        intent( in) :: name
    real (kind =  FourByteReal),               intent(out) :: values
    integer                                                :: nf90_get_att_one_FourByteReal

    real (kind =  FourByteReal), dimension(1) :: valuesA
    nf90_get_att_one_FourByteReal = nf_get_att_real(ncid, varid, name, valuesA)
    values = valuesA(1)
  end function nf90_get_att_one_FourByteReal
  ! -------
  function nf90_put_att_EightByteReal(ncid, varid, name, values)
    integer,                                   intent( in) :: ncid, varid
    character(len = *),                        intent( in) :: name
    real (kind = EightByteReal), dimension(:), intent( in) :: values
    integer                                                :: nf90_put_att_EightByteReal

    nf90_put_att_EightByteReal = nf_put_att_double(ncid, varid, name, nf90_real8, size(values), values)
  end function nf90_put_att_EightByteReal
  ! -------
  function nf90_put_att_one_EightByteReal(ncid, varid, name, values)
    integer,                                   intent( in) :: ncid, varid
    character(len = *),                        intent( in) :: name
    real (kind = EightByteReal),               intent( in) :: values
    integer                                                :: nf90_put_att_one_EightByteReal

    real (kind = EightByteReal), dimension(1) :: valuesA
    valuesA(1) = values
    nf90_put_att_one_EightByteReal = nf_put_att_double(ncid, varid, name, nf90_real8, 1, valuesA)
  end function nf90_put_att_one_EightByteReal
  ! -------
  function nf90_get_att_EightByteReal(ncid, varid, name, values)
    integer,                                   intent( in) :: ncid, varid
    character(len = *),                        intent( in) :: name
    real (kind = EightByteReal), dimension(:), intent(out) :: values
    integer                                                :: nf90_get_att_EightByteReal

    nf90_get_att_EightByteReal = nf_get_att_double(ncid, varid, name, values)
  end function nf90_get_att_EightByteReal
  ! -------
  function nf90_get_att_one_EightByteReal(ncid, varid, name, values)
    integer,                                   intent( in) :: ncid, varid
    character(len = *),                        intent( in) :: name
    real (kind = EightByteReal),               intent(out) :: values
    integer                                                :: nf90_get_att_one_EightByteReal

    real (kind = EightByteReal), dimension(1) :: valuesA
    nf90_get_att_one_EightByteReal = nf_get_att_double(ncid, varid, name, valuesA)
    values = valuesA(1)
  end function nf90_get_att_one_EightByteReal
  ! -------

!------ Routines for defining and obtaining info about dataset variables ------

! Replacement for fort-genvar.c

! Written by: Richard Weed, Ph.D.
!             Center for Advanced Vehicular Systems 
!             Mississippi State University
!             rweed@cavs.msstate.edu


! License (and other Lawyer Language)
 
! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Corporation for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1.: Sept. 2005 - Initial Cray X1 version
! Version 2.: May   2006 - Updated to support g95
! Version 3.: April 2009 - Updated for netCDF 4.0.1
! Version 4.: April 2010 - Updated for netCDF 4.1.1
! Version 5.: May   2014 - Ensure return error status checked from C API calls
! Version 6.: Jan.  2016 - General code cleanup. Replaced automatic arrays
!                          sized with NC_MAX_DIMS with allocatable arrays.
!                          Change name processing to reflect change in
!                          addCNullChar

!-------------------------------- nf_def_var -------------------------------
 Function nf_def_var(ncid, name, xtype, nvdims, vdims, varid) RESULT (status)

! Define name, datatype, number of dimensions, and dimension ids for a
! dataset variable. Returns variable id

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, xtype, nvdims
 Integer,          Intent(IN)  :: vdims(*)
 Integer,          Intent(OUT) :: varid
 Character(LEN=*), Intent(IN)  :: name

 Integer                       :: status

 Integer(C_INT)               :: cncid, cnvdims, cvarid, cstatus, cxtype
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 Integer(C_INT), ALLOCATABLE :: cvdims(:)

 cncid   = ncid
 cnvdims = nvdims
 cxtype  = xtype
 
! Check if a C NULL character was appended to name in calling routine

 cname = addCNullChar(name, ie)

! Flip dimids to C order and subtract -1 to yield C ids prior
! to calling nc_def_var. Replaces C utility f2c_dimids

 If (nvdims > 0) Then
   ALLOCATE(cvdims(nvdims))
   cvdims(1:nvdims) = vdims(nvdims:1:-1)-1
 Else
   ALLOCATE(cvdims(1))
   cvdims(1) = 0
 EndIf

 cstatus = nc_def_var(cncid, cname(1:ie), cxtype, cnvdims, cvdims, &  
                      cvarid)

 If (cstatus == NC_NOERR) Then
    ! Add one to returned C varid to yield FORTRAN id
      varid = cvarid + 1
 EndIf

 status = cstatus
 
 If (ALLOCATED(cvdims)) DEALLOCATE(cvdims)

 End Function nf_def_var
!-------------------------------- nf_inq_varndims --------------------------
 Function nf_inq_varndims(ncid, varid, vndims) RESULT (status)

! Get variable dimension for a given varid from NetCDF dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid, varid
 Integer, Intent(OUT) :: vndims

 Integer              :: status

 Integer(C_INT) :: cncid, cvarid, cvndims, cstatus

 cncid   = ncid
 cvarid  = varid - 1

 cstatus = nc_inq_varndims(cncid, cvarid, cvndims)

 If (cstatus == NC_NOERR) Then
    vndims = cvndims
 EndIf
 status = cstatus

 End Function nf_inq_varndims
!-------------------------------- nf_inq_var ----------------------------
 Function nf_inq_var(ncid, varid, name, xtype, ndims, dimids, natts) &
                     RESULT (status)

! Get variable name, data type, dimension length, dimension ids, and
! number of attributes for a given varid 

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(OUT) :: name
 Integer,          Intent(OUT) :: dimids(*)
 Integer,          Intent(OUT) :: ndims, xtype, natts

 Integer                       :: status

 Integer(C_INT)               :: cncid, cstatus, cndims, cvarid, &
                                 cnatts, cstat1
 Integer(C_INT)               :: cxtype
 Character(LEN=NC_MAX_NAME+1) :: tmpname
 Integer                      :: nlen

 Integer(C_INT), ALLOCATABLE :: cdimids(:)

 cncid  = ncid
 cvarid = varid - 1 ! subtract -1 to yield cvarid

 nlen    = LEN(name)
 tmpname = REPEAT(" ", LEN(tmpname))
 name    = REPEAT(" ", nlen)

 cndims    = 0
 dimids(1) = 0
 xtype     = 0
 natts     = 0
 ndims     = 0

 cstat1  = nc_inq_varndims(cncid, cvarid, cndims)
 status  = cstat1

 If (cndims > 0) Then
   ALLOCATE(cdimids(cndims))
 Else
   ALLOCATE(cdimids(1))
 EndIf

 cdimids=0
 
 cstatus = nc_inq_var(cncid, cvarid, tmpname, cxtype, cndims, cdimids, cnatts)

 If (cstatus == NC_NOERR) Then
   xtype = cxtype
   natts = cnatts
   ndims = cndims

! Check tmpname for a C null character and strip it and trailing blanks

   name = stripCNullChar(tmpname, nlen)

! Reverse order of cdimids and add one to yield FORTRAN id numbers
! Replaces c2f_dimids C utility
 
   If (ndims > 0) Then
     dimids(1:ndims) = cdimids(ndims:1:-1)+1
   EndIf
 EndIf

 status = cstatus

 If (ALLOCATED(cdimids)) DEALLOCATE(cdimids)

 End Function nf_inq_var
!-------------------------------- nf_inq_vardimid -----------------------
 Function nf_inq_vardimid(ncid, varid, dimids) RESULT (status)

! Get variable dimension id for a dimension name

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid, varid
 Integer, Intent(OUT) :: dimids(*)

 Integer              :: status

 Integer(C_INT) :: cncid, cstatus, cstat2, cndims, cvarid
 Integer        :: ndims

 Integer(C_INT), ALLOCATABLE :: cvdimids(:)

 cncid     = ncid
 cvarid    = varid - 1 ! subtract -1 to get C id number
 dimids(1) = 0
 cndims    = 0
 ndims     = 0
 
 cstat2  = nc_inq_varndims(cncid, cvarid, cndims)

 If (cndims > 0) Then
   ALLOCATE(cvdimids(cndims))
 Else
   ALLOCATE(cvdimids(1))
 EndIf

 cvdimids = 0

 cstatus = nc_inq_vardimid(cncid, cvarid, cvdimids)

! Reverse order of cdimids and add 1 to yield FORTRAN id numbers
! Replaces c2f_dimids C utility
 
 If (cstatus == NC_NOERR) Then
   ndims = cndims
   If (ndims > 0) Then    
     dimids(1:ndims) = cvdimids(ndims:1:-1)+1
   EndIf
 Else
   ndims = 0
 EndIf
 
 status = cstatus

 If (ALLOCATED(cvdimids)) DEALLOCATE(cvdimids)

 End Function nf_inq_vardimid
!-------------------------------- nf_inq_varid --------------------------
 Function nf_inq_varid(ncid, name, varid) RESULT (status)

! Get variable id for a variable name from NetCDF dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: varid

 Integer                       :: status

 Integer(C_INT)               :: cncid, cvarid, cstatus
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid = ncid

! Check name for a C NULL character added in calling routine

 cname = addCNullChar(name, ie)

 cstatus = nc_inq_varid(cncid, cname(1:ie), cvarid)

 If (cstatus == NC_NOERR) Then
    varid  = cvarid + 1  ! add one to get Fortran id number
 EndIf
 status = cstatus

 End Function nf_inq_varid
!-------------------------------- nf_inq_varname ------------------------
 Function nf_inq_varname (ncid, varid, name) RESULT (status)

! Get variable name for a given varid from NetCDF dataset ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)   :: ncid, varid
 Character(LEN=*), Intent(OUT)  :: name

 Integer                        :: status

 Integer(C_INT)               :: cncid, cvarid, cstatus
 Character(LEN=NC_MAX_NAME+1) :: tmpname 
 Integer                      :: nlen

 cncid   = ncid
 cvarid  = varid - 1 ! subtract one to get C id number

 nlen    = LEN(name)
 tmpname = REPEAT(" ", LEN(tmpname))
 name    = REPEAT(" ", nlen)

! Get tmpname from C interface

 cstatus = nc_inq_varname(cncid, cvarid, tmpname)

 ! Find first C null character in tmpname if present and set end of string

 If (cstatus == NC_NOERR) Then
    name = stripCNullChar(tmpname, nlen)
 EndIf
 status = cstatus

 End Function nf_inq_varname
!-------------------------------- nf_inq_vartype -------------------------
 Function nf_inq_vartype(ncid, varid, xtype) RESULT(status)

! Inquire about numeric type of variable attributes for NetCDF file id ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid, varid
 Integer, Intent(OUT) :: xtype

 Integer              :: status

 Integer(C_INT) :: cncid, cvarid, cstatus
 Integer(C_INT) :: cxtype

 cncid  = ncid
 cvarid = varid - 1 ! Subtract one to get C id number

 cstatus = nc_inq_vartype(cncid, cvarid, cxtype)

 If (cstatus == NC_NOERR) Then
    xtype  = cxtype
 EndIf
 status = cstatus

 End Function nf_inq_vartype
!-------------------------------- nf_inq_varnatts -----------------------
 Function nf_inq_varnatts(ncid, varid, nvatts) RESULT(status)

! Inquire about number of variable attributes for NetCDF file id ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid, varid
 Integer, Intent(OUT) :: nvatts

 Integer              :: status

 Integer(C_INT) :: cncid, cvarid, cnvatts, cstatus

 cncid  = ncid
 cvarid = varid - 1 ! subtract one to get C id number

 cstatus = nc_inq_varnatts(cncid, cvarid, cnvatts)

 If (cstatus == NC_NOERR) Then
    nvatts = cnvatts
 EndIf

 status = cstatus

 End Function nf_inq_varnatts
!-------------------------------- nf_rename_var -------------------------
 Function nf_rename_var(ncid, varid, name) RESULT (status)

! Rename dimension name for a given dimension id

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN) :: ncid, varid 
 Character(LEN=*), Intent(IN) :: name

 Integer                      :: status

 Integer(C_INT)               :: cncid, cvarid, cstatus
 Character(LEN=(LEN(name)+1)) :: cname
 Integer                      :: ie

 cncid  = ncid
 cvarid = varid - 1 ! Subtract one to get C id number

! Check name for a C NULL character added in calling routine

 cname = addCNullChar(name, ie)

 cstatus = nc_rename_var(cncid, cvarid, cname(1:ie))

 status = cstatus

 End Function nf_rename_var
!-------------------------------- nf_copy_var ---------------------------
 Function nf_copy_var(ncid_in, varid, ncid_out) RESULT(status)

! Copies a given variable from dataset ncid_in to dataset ncid_out

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN) :: ncid_in, varid, ncid_out
 Integer             :: status

 Integer(C_INT) :: cncidin, cvarid, cncidout, cstatus

 cncidin  = ncid_in
 cncidout = ncid_out
 cvarid   = varid - 1 ! Subtract one to get C id number

 cstatus = nc_copy_var(cncidin, cvarid, cncidout)

 status = cstatus

 End Function nf_copy_var

!-- Routines for processing error messages, obtaining version numbers, etc. --

! Replacement for fort-misc.c

! Written by: Richard Weed, Ph.D.
!             Center for Advanced Vehicular Systems
!             Mississippi State University
!             rweed@cavs.msstate.edu
 

! License (and other Lawyer Language)
 
! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Corporation for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1.: Sept. 2005 - Initial Cray X1 version
! Version 2.: May   2006 - Updated to support g95
! Version 3.: April 2009 - Updated for netCDF 4.0.1
! Version 4.: April 2010 - Updated for netCDF 4.1.1
 
!-------------------------------- nf_inq_libvers ---------------------------
 Function nf_inq_libvers() RESULT(vermsg)

! Return string with current version of NetCDF library

 USE netcdf_nc_interfaces

 Implicit NONE

 Character(LEN=80) :: vermsg

 Character(LEN=81), Pointer :: fstrptr
 TYPE(C_PTR)                :: cstrptr
 Integer                    :: inull, ilen

 vermsg = REPEAT(" ", LEN(vermsg)) !initialize vermsg to blanks

! Get C character pointer returned by nc_inq_vers and associate it
! Fortran character pointer (fstrptr). Have to do this when the C
! routine allocates space for the pointer and/or knows where it lives
! not Fortran. This is also how you can pass character data back to
! FORTRAN from C using a C function that returns a character pointer
! instead using a void jacket function and passing the string as a hidden 
! argument. At least this is how cfortran.h appears to do it. 

 
 NULLIFY(fstrptr) ! Nullify fstrptr

 cstrptr = nc_inq_libvers()         ! Get C pointer to version string and

 Call C_F_POINTER(cstrptr, fstrptr) ! associate it with FORTRAN pointer

! Locate first C null character and then set it and remaining characters
! in string to blanks

 ilen  = LEN_TRIM(fstrptr)
 inull = SCAN(fstrptr,C_NULL_CHAR)
 If (inull /= 0) ilen = inull-1
 ilen = MAX(1, MIN(ilen,80)) ! Limit ilen to >=1 and <=80

! Load return value with trimmed fstrptr string

 vermsg(1:ilen) = fstrptr(1:ilen)

 End Function nf_inq_libvers
!-------------------------------- nf_stderror ------------------------------
 Function nf_strerror(ncerr) RESULT(errmsg)

! Returns an error message string given static error code ncerr

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer(KIND=C_INT), Intent(IN) :: ncerr

 Character(LEN=80)               :: errmsg

 Character(LEN=81), Pointer :: fstrptr
 TYPE(C_PTR)                :: cstrptr
 Integer                    :: inull, ilen
 Integer(KIND=C_INT)        :: cncerr

 errmsg = REPEAT(" ", LEN(errmsg)) !initialize errmsg to blanks

! Get C character pointer returned by nc_stderror and associate it
! Fortran character pointer (fstrptr). Have to do this when the C
! routine allocates space for the pointer and/or knows where it lives
! not Fortran. This is also how you can pass character data back to
! FORTRAN from C using a C function that returns a character pointer
! instead using a void jacket function and passing the string as a hidden 
! argument. At least this is how cfortran.h appears to do it. 
 
 NULLIFY(fstrptr) ! Nullify fstrptr

 cncerr  = ncerr

 cstrptr = nc_strerror(cncerr)      ! Return C character pointer and
 Call C_F_POINTER(cstrptr, fstrptr) ! associate C ptr with FORTRAN pointer

! Locate first C null character and then set it and remaining characters
! in string to blanks 

 ilen  = LEN_TRIM(fstrptr)
 inull = SCAN(fstrptr,C_NULL_CHAR)
 If (inull /= 0) ilen = inull-1 
 ilen  = MAX(1, MIN(ilen,80)) ! Limit ilen to >=1 and <=80

! Load return value with trimmed fstrptr string

 errmsg(1:ilen) = fstrptr(1:ilen)

 End Function nf_strerror
!-------------------------------- nf_issyserr ------------------------------
 Function nf_issyserr(nerr) RESULT(status)

! Check to see if nerr is > 0

 Integer, Intent(IN) :: nerr

 Logical             :: status

 status = (nerr > 0) 

 End Function nf_issyserr

  !
  ! NetCDF-4 extra routines:
  !
  ! -----------
  function nf90_create_par(path, cmode, comm, info, ncid, cache_size, &
       cache_nelems, cache_preemption)
    character (len = *), intent(in) :: path
    integer, intent(in) :: cmode
    integer, intent(in) :: comm
    integer, intent(in) :: info
    integer, intent(out) :: ncid
    integer, optional, intent(in) :: cache_size, cache_nelems
    real, optional, intent(in) :: cache_preemption
    integer :: size_in, nelems_in, preemption_in
    integer :: size_out, nelems_out, preemption_out, ret
    integer :: nf90_create_par
    
    ! If the user specified chuck cache parameters, use them. But user
    ! may have specified one, two, or three settings. Leave the others
    ! unchanged.
    if (present(cache_size) .or. present(cache_nelems) .or. &
         present(cache_preemption)) then
       ret = nf_get_chunk_cache(size_in, nelems_in, preemption_in)
       if (ret .ne. nf90_noerr) then
          nf90_create_par = ret
          return
       end if
       if (present(cache_size)) then
          size_out = cache_size
       else
          size_out = size_in
       end if
       if (present(cache_nelems)) then
          nelems_out = cache_nelems
       else
          nelems_out = nelems_in
       end if
       if (present(cache_preemption)) then
          preemption_out = cache_preemption
       else
          preemption_out = preemption_in
       end if
       nf90_create_par = nf_set_chunk_cache(size_out, nelems_out, preemption_out)
       if (nf90_create_par .ne. nf90_noerr) return
    end if 

    nf90_create_par = nf_create_par(path, cmode, comm, info, ncid)
  end function nf90_create_par
  ! -----------
  function nf90_open_par(path, cmode, comm, info, ncid, cache_size, &
       cache_nelems, cache_preemption)
    character (len = *), intent(in) :: path
    integer, intent(in) :: cmode
    integer, intent(in) :: comm
    integer, intent(in) :: info
    integer, intent(out) :: ncid
    integer, optional, intent(in) :: cache_size, cache_nelems
    real, optional, intent(in) :: cache_preemption
    integer :: size_in, nelems_in, preemption_in
    integer :: size_out, nelems_out, preemption_out, ret
    integer :: nf90_open_par
  
    ! If the user specified chuck cache parameters, use them. But user
    ! may have specified one, two, or three settings. Leave the others
    ! unchanged.
    if (present(cache_size) .or. present(cache_nelems) .or. &
         present(cache_preemption)) then
       ret = nf_get_chunk_cache(size_in, nelems_in, preemption_in)
       if (ret .ne. nf90_noerr) then
          nf90_open_par = ret
          return
       end if
       if (present(cache_size)) then
          size_out = cache_size
       else
          size_out = size_in
       end if
       if (present(cache_nelems)) then
          nelems_out = cache_nelems
       else
          nelems_out = nelems_in
       end if
       if (present(cache_preemption)) then
          preemption_out = cache_preemption
       else
          preemption_out = preemption_in
       end if
       nf90_open_par = nf_set_chunk_cache(size_out, nelems_out, preemption_out)
       if (nf90_open_par .ne. nf90_noerr) return
    end if 

    nf90_open_par = nf_open_par(path, cmode, comm, info, ncid)
  end function nf90_open_par
  ! -----------
  function nf90_var_par_access(ncid, varid, access)
    integer, intent(in) :: ncid
    integer, intent(in) :: varid
    integer, intent(in) :: access
    integer :: nf90_var_par_access
  
    nf90_var_par_access = nf_var_par_access(ncid, varid, access)
  end function nf90_var_par_access
  ! -----------
  function nf90_inq_ncid(ncid, name, grp_ncid)
    integer, intent(in) :: ncid
    character (len = *), intent(in) :: name
    integer, intent(out) :: grp_ncid
    integer :: nf90_inq_ncid
  
    nf90_inq_ncid = nf_inq_ncid(ncid, name, grp_ncid)
  end function nf90_inq_ncid
  ! -----------
  function nf90_inq_grps(ncid, numgrps, ncids)
    integer, intent(in) :: ncid
    integer, intent(out) :: numgrps
    integer, dimension(:), intent(out) :: ncids
    integer :: nf90_inq_grps
  
    nf90_inq_grps = nf_inq_grps(ncid, numgrps, ncids)
  end function nf90_inq_grps
  ! -----------
  function nf90_inq_grpname_len(ncid, len)
    integer, intent(in) :: ncid
    integer, intent(out) :: len
    integer :: nf90_inq_grpname_len
  
    nf90_inq_grpname_len = nf_inq_grpname_len(ncid, len)
  end function nf90_inq_grpname_len
  ! -----------
  function nf90_inq_grp_ncid(ncid, name, grpid)
    integer, intent(in) :: ncid
    character (len = *), intent(in) :: name
    integer, intent(out) :: grpid
    integer :: nf90_inq_grp_ncid
  
    nf90_inq_grp_ncid = nf_inq_grp_ncid(ncid, name, grpid)
  end function nf90_inq_grp_ncid
  ! -----------
  function nf90_inq_grp_full_ncid(ncid, full_name, grpid)
    integer, intent(in) :: ncid
    character (len = *), intent(in) :: full_name
    integer, intent(out) :: grpid
    integer :: nf90_inq_grp_full_ncid
  
    nf90_inq_grp_full_ncid = nf_inq_grp_full_ncid(ncid, full_name, grpid)
  end function nf90_inq_grp_full_ncid
  ! -----------
  function nf90_inq_grp_parent(ncid, parent_ncid)
    integer, intent(in) :: ncid
    integer, intent(out) :: parent_ncid
    integer :: nf90_inq_grp_parent
  
    nf90_inq_grp_parent = nf_inq_grp_parent(ncid, parent_ncid)
  end function nf90_inq_grp_parent
  ! -----------
  function nf90_inq_grpname(ncid, name)
    integer, intent(in) :: ncid
    character (len = *), intent(out) :: name
    integer :: nf90_inq_grpname
  
    nf90_inq_grpname = nf_inq_grpname(ncid, name)
  end function nf90_inq_grpname
  ! -----------
  function nf90_inq_grpname_full(ncid, len, name)
    integer, intent(in) :: ncid
    integer, intent(out) :: len
    character (len = *), intent(out) :: name
    integer :: nf90_inq_grpname_full
  
    nf90_inq_grpname_full = nf_inq_grpname_full(ncid, len, name)
  end function nf90_inq_grpname_full
  ! -----------
  function nf90_inq_varids(ncid, nvars, varids)
    integer, intent(in) :: ncid
    integer, intent(out) :: nvars
    integer, dimension(:), intent(out) :: varids
    integer :: nf90_inq_varids
  
    nf90_inq_varids = nf_inq_varids(ncid, nvars, varids)
  end function nf90_inq_varids
  ! -----------
  function nf90_inq_dimids(ncid, ndims, dimids, include_parents)
    integer, intent(in) :: ncid
    integer, intent(out) :: ndims
    integer, dimension(:), intent(out) :: dimids
    integer, intent(out) :: include_parents
    integer :: nf90_inq_dimids
  
    nf90_inq_dimids = nf_inq_dimids(ncid, ndims, dimids, include_parents)
  end function nf90_inq_dimids
  ! -----------
  function nf90_inq_typeids(ncid, ntypes, typeids)
    integer, intent(in) :: ncid
    integer, optional, intent(out) :: ntypes
    integer, dimension(:), optional, intent(out) :: typeids
    integer :: nf90_inq_typeids
    
    nf90_inq_typeids = nf_inq_typeids(ncid, ntypes, typeids)

  end function nf90_inq_typeids
  ! -----------
  function nf90_inq_typeid(ncid, name, typeid)
    integer, intent(in) :: ncid
    character (len = *), intent(in) :: name
    integer, optional, intent(out) :: typeid
    integer :: nf90_inq_typeid
    
    nf90_inq_typeid = nf_inq_typeid(ncid, name, typeid)

  end function nf90_inq_typeid
  ! -----------
  function nf90_def_grp(parent_ncid, name, new_ncid)
    integer, intent(in) :: parent_ncid
    character (len = *), intent(in) :: name
    integer, intent(out) :: new_ncid
    integer :: nf90_def_grp
  
    nf90_def_grp = nf_def_grp(parent_ncid, name, new_ncid)
  end function nf90_def_grp
  ! -----------
  function nf90_rename_grp(grpid, name)
    integer, intent(in) :: grpid
    character (len = *), intent(in) :: name
    integer :: nf90_rename_grp

    nf90_rename_grp = nf_rename_grp(grpid, name)
  end function nf90_rename_grp
  ! -----------
  function nf90_def_compound(ncid, size, name, typeid)
    integer, intent(in) :: ncid
    integer, intent(in) :: size
    character (len = *), intent(in) :: name
    integer, intent(out) :: typeid
    integer :: nf90_def_compound
  
    nf90_def_compound = nf_def_compound(ncid, size, name, typeid)
  end function nf90_def_compound
  ! -----------
  function nf90_insert_compound(ncid, xtype, name, offset, field_typeid)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(in) :: name
    integer, intent(in) :: offset
    integer, intent(in) :: field_typeid
    integer :: nf90_insert_compound
  
    nf90_insert_compound = nf_insert_compound(ncid, xtype, name, offset, field_typeid)
  end function nf90_insert_compound
  ! -----------
  function nf90_insert_array_compound(ncid, xtype, name, offset, field_typeid, &
       ndims, dim_sizes)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(in) :: name
    integer, intent(in) :: offset
    integer, intent(in) :: field_typeid
    integer, intent(in) :: ndims
    integer, intent(in) :: dim_sizes
    integer :: nf90_insert_array_compound
  
    nf90_insert_array_compound = nf_insert_array_compound(ncid, xtype, name, &
         offset, field_typeid, ndims, dim_sizes)
  end function nf90_insert_array_compound
  ! -----------
  function nf90_inq_type(ncid, xtype, name, size)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(out) :: name
    integer, intent(out) :: size
    integer :: nf90_inq_type
  
    nf90_inq_type = nf_inq_type(ncid, xtype, name, size)
  end function nf90_inq_type
  ! -----------
  function nf90_inq_compound(ncid, xtype, name, size, nfields)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(out) :: name
    integer, intent(out) :: size
    integer, intent(out) :: nfields
    integer :: nf90_inq_compound
  
    nf90_inq_compound = nf_inq_compound(ncid, xtype, name, size, nfields)
  end function nf90_inq_compound
  ! -----------
  function nf90_inq_compound_name(ncid, xtype, name)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(out) :: name
    integer :: nf90_inq_compound_name
  
    nf90_inq_compound_name = nf_inq_compound_name(ncid, xtype, name)
  end function nf90_inq_compound_name
  ! -----------
  function nf90_inq_compound_size(ncid, xtype, size)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    integer, intent(out) :: size
    integer :: nf90_inq_compound_size
  
    nf90_inq_compound_size = nf_inq_compound_size(ncid, xtype, size)
  end function nf90_inq_compound_size
  ! -----------
  function nf90_inq_compound_nfields(ncid, xtype, nfields)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    integer, intent(out) :: nfields
    integer :: nf90_inq_compound_nfields
  
    nf90_inq_compound_nfields = nf_inq_compound_nfields(ncid, xtype, nfields)
  end function nf90_inq_compound_nfields
  ! -----------
  function nf90_inq_compound_field(ncid, xtype, fieldid, name, offset, &
       field_typeid, ndims, dim_sizes)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    integer, intent(in) :: fieldid
    character (len = *), intent(out) :: name
    integer, intent(out) :: offset
    integer, intent(out) :: field_typeid
    integer, intent(out) :: ndims
    integer, intent(out) :: dim_sizes
    integer :: nf90_inq_compound_field
  
    nf90_inq_compound_field = nf_inq_compound_field(ncid, xtype, fieldid, name, offset, &
       field_typeid, ndims, dim_sizes)
  end function nf90_inq_compound_field
  ! -----------
  function nf90_inq_compound_fieldname(ncid, xtype, fieldid, name)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    integer, intent(in) :: fieldid
    character (len = *), intent(out) :: name
    integer :: nf90_inq_compound_fieldname
  
    nf90_inq_compound_fieldname = nf_inq_compound_fieldname(ncid, xtype, fieldid, name)
  end function nf90_inq_compound_fieldname
  ! -----------
  function nf90_inq_compound_fieldindex(ncid, xtype, name, fieldid)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(in) :: name
    integer, intent(out) :: fieldid
    integer :: nf90_inq_compound_fieldindex
  
    nf90_inq_compound_fieldindex = nf_inq_compound_fieldindex(ncid, xtype, name, fieldid)
  end function nf90_inq_compound_fieldindex
  ! -----------
  function nf90_inq_compound_fieldoffset(ncid, xtype, fieldid, offset)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    integer, intent(in) :: fieldid
    integer, intent(out) :: offset
    integer :: nf90_inq_compound_fieldoffset
  
    nf90_inq_compound_fieldoffset = nf_inq_compound_fieldoffset(ncid, xtype, fieldid, offset)
  end function nf90_inq_compound_fieldoffset
  ! -----------
  function nf90_inq_compound_fieldtype(ncid, xtype, fieldid, field_typeid)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    integer, intent(in) :: fieldid
    integer, intent(out) :: field_typeid
    integer :: nf90_inq_compound_fieldtype
  
    nf90_inq_compound_fieldtype = nf_inq_compound_fieldtype(ncid, xtype, fieldid, field_typeid)
  end function nf90_inq_compound_fieldtype
  ! -----------
  function nf90_inq_compound_fieldndims(ncid, xtype, fieldid, ndims)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    integer, intent(in) :: fieldid
    integer, intent(out) :: ndims
    integer :: nf90_inq_compound_fieldndims
  
    nf90_inq_compound_fieldndims = nf_inq_compound_fieldndims(ncid, xtype, fieldid, ndims)
  end function nf90_inq_compound_fieldndims
  ! -----------
  function nf90_inq_cmp_fielddim_sizes(ncid, xtype, fieldid, dim_sizes)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    integer, intent(in) :: fieldid
    integer, intent(out) :: dim_sizes
    integer :: nf90_inq_cmp_fielddim_sizes
  
    nf90_inq_cmp_fielddim_sizes = nf_inq_compound_fielddim_sizes(ncid, xtype, fieldid, dim_sizes)
  end function nf90_inq_cmp_fielddim_sizes
  ! -----------
  function nf90_def_vlen(ncid, name, base_typeid, xtypeid)
    integer, intent(in) :: ncid
    character (len = *), intent(in) :: name
    integer, intent(in) :: base_typeid
    integer, intent(out) :: xtypeid
    integer :: nf90_def_vlen
  
    nf90_def_vlen = nf_def_vlen(ncid, name, base_typeid, xtypeid)
  end function nf90_def_vlen
  ! -----------
  function nf90_inq_vlen(ncid, xtype, name, datum_size, base_nc_type)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(out) :: name
    integer, intent(out) :: datum_size
    integer, intent(out) :: base_nc_type
    integer :: nf90_inq_vlen
  
    nf90_inq_vlen = nf_inq_vlen(ncid, xtype, name, datum_size, base_nc_type)
  end function nf90_inq_vlen
  ! -----------
  function nf90_free_vlen(vl)
    character (len = *), intent(in) :: vl
    integer :: nf90_free_vlen
  
    nf90_free_vlen = nf_free_vlen(vl)
  end function nf90_free_vlen
!   ! -----------
  function nf90_def_enum(ncid, base_typeid, name, typeid)
    integer, intent(in) :: ncid
    integer, intent(in) :: base_typeid
    character (len = *), intent(in) :: name
    integer, intent(out) :: typeid
    integer :: nf90_def_enum
  
    nf90_def_enum = nf_def_enum(ncid, base_typeid, name, typeid)
  end function nf90_def_enum
!   ! -----------
  function nf90_inq_user_type(ncid, xtype, name, size, base_typeid, nfields, class)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(out) :: name
    integer, intent(out) :: size
    integer, intent(out) :: base_typeid
    integer, intent(out) :: nfields
    integer, intent(out) :: class
    integer :: nf90_inq_user_type
  
    nf90_inq_user_type = nf_inq_user_type(ncid, xtype, name, size, base_typeid, nfields, class)
  end function nf90_inq_user_type
  ! -----------
  function nf90_insert_enum(ncid, xtype, name, value)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(in) :: name
    integer, intent(in) :: value
    integer :: nf90_insert_enum
  
    nf90_insert_enum = nf_insert_enum(ncid, xtype, name, value)
  end function nf90_insert_enum
  ! -----------
  function nf90_inq_enum(ncid, xtype, name, base_nc_type, base_size, num_members)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(out) :: name
    integer, intent(out) :: base_nc_type
    integer, intent(out) :: base_size
    integer, intent(out) :: num_members
    integer :: nf90_inq_enum
  
    nf90_inq_enum = nf_inq_enum(ncid, xtype, name, base_nc_type, base_size, num_members)
  end function nf90_inq_enum
  ! -----------
  function nf90_inq_enum_member(ncid, xtype, idx, name, value)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    integer, intent(in) :: idx
    character (len = *), intent(out) :: name
    integer, intent(in) :: value
    integer :: nf90_inq_enum_member
  
    nf90_inq_enum_member = nf_inq_enum_member(ncid, xtype, idx, name, value)
  end function nf90_inq_enum_member
  ! -----------
  function nf90_inq_enum_ident(ncid, xtype, value, idx)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    integer, intent(in) :: value
    integer, intent(out) :: idx
    integer :: nf90_inq_enum_ident
  
    nf90_inq_enum_ident = nf_inq_enum_ident(ncid, xtype, value, idx)
  end function nf90_inq_enum_ident
  ! -----------
  function nf90_def_opaque(ncid, size, name, xtype)
    integer, intent(in) :: ncid
    integer, intent(in) :: size
    character (len = *), intent(in) :: name
    integer, intent(out) :: xtype
    integer :: nf90_def_opaque
  
    nf90_def_opaque = nf_def_opaque(ncid, size, name, xtype)
  end function nf90_def_opaque
  ! -----------
  function nf90_inq_opaque(ncid, xtype, name, size)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(out) :: name
    integer, intent(out) :: size
    integer :: nf90_inq_opaque
  
    nf90_inq_opaque = nf_inq_opaque(ncid, xtype, name, size)
  end function nf90_inq_opaque
  ! -----------
  function nf90_def_var_chunking(ncid, varid, contiguous, chunksizes)
    integer, intent(in) :: ncid
    integer, intent(in) :: varid
    integer, intent(in) :: contiguous
    integer, dimension(:), intent(in) :: chunksizes
    integer :: nf90_def_var_chunking
  
    nf90_def_var_chunking = nf_def_var_chunking(ncid, varid, contiguous, chunksizes)
  end function nf90_def_var_chunking
  ! -----------
  function nf90_def_var_deflate(ncid, varid, shuffle, deflate, deflate_level)
    integer, intent(in) :: ncid
    integer, intent(in) :: varid
    integer, intent(in) :: shuffle
    integer, intent(in) :: deflate
    integer, intent(in) :: deflate_level
    integer :: nf90_def_var_deflate
  
    nf90_def_var_deflate = nf_def_var_deflate(ncid, varid, shuffle, deflate, deflate_level)
  end function nf90_def_var_deflate
  ! -----------
  function nf90_def_var_fletcher32(ncid, varid, fletcher32)
    integer, intent(in) :: ncid
    integer, intent(in) :: varid
    integer, intent(in) :: fletcher32
    integer :: nf90_def_var_fletcher32
  
    nf90_def_var_fletcher32 = nf_def_var_fletcher32(ncid, varid, fletcher32)
  end function nf90_def_var_fletcher32
  ! -----------
  function nf90_inq_var_chunking(ncid, varid, contiguous, chunksizes)
    integer, intent(in) :: ncid
    integer, intent(in) :: varid
    integer, intent(out) :: contiguous
    integer, dimension(:), intent(out) :: chunksizes
    integer :: nf90_inq_var_chunking
  
    nf90_inq_var_chunking = nf_inq_var_chunking(ncid, varid, contiguous, chunksizes)
  end function nf90_inq_var_chunking
  ! -----------
  function nf90_inq_var_deflate(ncid, varid, shuffle, deflate, deflate_level)
    integer, intent(in) :: ncid
    integer, intent(in) :: varid
    integer, intent(out) :: shuffle
    integer, intent(out) :: deflate
    integer, intent(out) :: deflate_level
    integer :: nf90_inq_var_deflate
  
    nf90_inq_var_deflate = nf_inq_var_deflate(ncid, varid, shuffle, deflate, deflate_level)
  end function nf90_inq_var_deflate
  ! -----------
  function nf90_inq_var_fletcher32(ncid, varid, fletcher32)
    integer, intent(in) :: ncid
    integer, intent(in) :: varid
    integer, intent(out) :: fletcher32
    integer :: nf90_inq_var_fletcher32
  
    nf90_inq_var_fletcher32 = nf_inq_var_fletcher32(ncid, varid, fletcher32)
  end function nf90_inq_var_fletcher32
  ! -----------
  function nf90_def_var_endian(ncid, varid, endian)
    integer, intent(in) :: ncid
    integer, intent(in) :: varid
    integer, intent(in) :: endian
    integer :: nf90_def_var_endian
  
    nf90_def_var_endian = nf_def_var_endian(ncid, varid, endian)
  end function nf90_def_var_endian
  ! -----------
  function nf90_inq_var_endian(ncid, varid, endian)
    integer, intent(in) :: ncid
    integer, intent(in) :: varid
    integer, intent(out) :: endian
    integer :: nf90_inq_var_endian
  
    nf90_inq_var_endian = nf_inq_var_endian(ncid, varid, endian)
  end function nf90_inq_var_endian
  ! -----------
!  function nf90_def_var_fill(ncid, varid, no_fill, fill)
!    integer, intent(in) :: ncid
!    integer, intent(in) :: varid
!    integer, intent(in) :: no_fill
!    integer, intent(in) :: fill
!    integer :: nf90_def_var_fill
  
!    nf90_def_var_fill = nf_def_var_fill(ncid, varid, no_fill, fill)
!  end function nf90_def_var_fill
  ! -----------
!  function nf90_inq_var_fill(ncid, varid, no_fill, fill)
!    integer, intent(in) :: ncid
!    integer, intent(in) :: varid
!    integer, intent(out) :: no_fill
!    integer, intent(out) :: fill
!    integer :: nf90_inq_var_fill
  
!    nf90_inq_var_fill = nf_inq_var_fill(ncid, varid, no_fill, fill)
!  end function nf90_inq_var_fill

  function nf90_def_var_fill_OneByteInt(ncid, varid, no_fill, fill)
    integer, intent(in)                  :: ncid
    integer, intent(in)                  :: varid
    integer, intent(in)                  :: no_fill
    integer(kind=OneByteInt), intent(in) :: fill
    integer :: nf90_def_var_fill_OneByteInt
  
    nf90_def_var_fill_OneByteInt = nf_def_var_fill(ncid, varid, no_fill, fill)
  end function nf90_def_var_fill_OneByteInt
  ! -----------
  function nf90_def_var_fill_TwoByteInt(ncid, varid, no_fill, fill)
    integer, intent(in)                  :: ncid
    integer, intent(in)                  :: varid
    integer, intent(in)                  :: no_fill
    integer(kind=TwoByteInt), intent(in) :: fill
    integer :: nf90_def_var_fill_TwoByteInt
  
    nf90_def_var_fill_TwoByteInt = nf_def_var_fill(ncid, varid, no_fill, fill)
  end function nf90_def_var_fill_TwoByteInt
  ! -----------
  function nf90_def_var_fill_FourByteInt(ncid, varid, no_fill, fill)
    integer, intent(in)                  :: ncid
    integer, intent(in)                  :: varid
    integer, intent(in)                  :: no_fill
    integer(kind=FourByteInt), intent(in) :: fill
    integer :: nf90_def_var_fill_FourByteInt
  
    nf90_def_var_fill_FourByteInt = nf_def_var_fill(ncid, varid, no_fill, fill)
  end function nf90_def_var_fill_FourByteInt
  ! -----------
  function nf90_def_var_fill_EightByteInt(ncid, varid, no_fill, fill)
    integer, intent(in)                  :: ncid
    integer, intent(in)                  :: varid
    integer, intent(in)                  :: no_fill
    integer(kind=EightByteInt), intent(in) :: fill
    integer :: nf90_def_var_fill_EightByteInt
  
    nf90_def_var_fill_EightByteInt = nf_def_var_fill(ncid, varid, no_fill, fill)
  end function nf90_def_var_fill_EightByteInt
  ! -----------
  function nf90_def_var_fill_FourByteReal(ncid, varid, no_fill, fill)
    integer, intent(in)                  :: ncid
    integer, intent(in)                  :: varid
    integer, intent(in)                  :: no_fill
    real(kind=FourByteReal), intent(in) :: fill
    integer :: nf90_def_var_fill_FourByteReal
  
    nf90_def_var_fill_FourByteReal = nf_def_var_fill(ncid, varid, no_fill, fill)
  end function nf90_def_var_fill_FourByteReal
  ! -----------
  function nf90_def_var_fill_EightByteReal(ncid, varid, no_fill, fill)
    integer, intent(in)                  :: ncid
    integer, intent(in)                  :: varid
    integer, intent(in)                  :: no_fill
    real(kind=EightByteReal), intent(in) :: fill
    integer :: nf90_def_var_fill_EightByteReal
  
    nf90_def_var_fill_EightByteReal = nf_def_var_fill(ncid, varid, no_fill, fill)
  end function nf90_def_var_fill_EightByteReal
  ! -----------
  function nf90_inq_var_fill_OneByteInt(ncid, varid, no_fill, fill)
    integer, intent(in)                     :: ncid
    integer, intent(in)                     :: varid
    integer, intent(inout)                  :: no_fill
    integer(kind=OneByteInt), intent(inout) :: fill
    integer :: nf90_inq_var_fill_OneByteInt
  
    nf90_inq_var_fill_OneByteInt = nf_inq_var_fill(ncid, varid, no_fill, fill)
  end function nf90_inq_var_fill_OneByteInt
  ! -----------
  function nf90_inq_var_fill_TwoByteInt(ncid, varid, no_fill, fill)
    integer, intent(in)                     :: ncid
    integer, intent(in)                     :: varid
    integer, intent(inout)                  :: no_fill
    integer(kind=TwoByteInt), intent(inout) :: fill
    integer :: nf90_inq_var_fill_TwoByteInt
  
    nf90_inq_var_fill_TwoByteInt = nf_inq_var_fill(ncid, varid, no_fill, fill)
  end function nf90_inq_var_fill_TwoByteInt
  ! -----------
  function nf90_inq_var_fill_FourByteInt(ncid, varid, no_fill, fill)
    integer, intent(in)                      :: ncid
    integer, intent(in)                      :: varid
    integer, intent(inout)                   :: no_fill
    integer(kind=FourByteInt), intent(inout) :: fill
    integer :: nf90_inq_var_fill_FourByteInt
  
    nf90_inq_var_fill_FourByteInt = nf_inq_var_fill(ncid, varid, no_fill, fill)
  end function nf90_inq_var_fill_FourByteInt
  ! -----------
  function nf90_inq_var_fill_EightByteInt(ncid, varid, no_fill, fill)
    integer, intent(in)                       :: ncid
    integer, intent(in)                       :: varid
    integer, intent(inout)                    :: no_fill
    integer(kind=EightByteInt), intent(inout) :: fill
    integer :: nf90_inq_var_fill_EightByteInt
  
    nf90_inq_var_fill_EightByteInt = nf_inq_var_fill(ncid, varid, no_fill, fill)
  end function nf90_inq_var_fill_EightByteInt
  ! -----------
  function nf90_inq_var_fill_FourByteReal(ncid, varid, no_fill, fill)
    integer, intent(in)                    :: ncid
    integer, intent(in)                    :: varid
    integer, intent(inout)                 :: no_fill
    real(kind=FourByteReal), intent(inout) :: fill
    integer :: nf90_inq_var_fill_FourByteReal
  
    nf90_inq_var_fill_FourByteReal = nf_inq_var_fill(ncid, varid, no_fill, fill)
  end function nf90_inq_var_fill_FourByteReal
  ! -----------
  function nf90_inq_var_fill_EightByteReal(ncid, varid, no_fill, fill)
    integer, intent(in)                        :: ncid
    integer, intent(in)                        :: varid
    integer, intent(inout)                     :: no_fill
    real(kind=EightByteReal), intent(inout)    :: fill
    integer :: nf90_inq_var_fill_EightByteReal
  
    nf90_inq_var_fill_EightByteReal = nf_inq_var_fill(ncid, varid, no_fill, fill)
  end function nf90_inq_var_fill_EightByteReal
  ! -----------
  function nf90_put_att_any(ncid, varid, name, typeid, length, values)
    integer,                          intent( in) :: ncid, varid
    character(len = *),               intent( in) :: name
    integer,                          intent( in) :: typeid, length
    character(len = *),               intent( in) :: values
    integer                                       :: nf90_put_att_any

    nf90_put_att_any = nf_put_att(ncid, varid, name, typeid, length, values)
  end function nf90_put_att_any
  ! -----------
  function nf90_get_att_any(ncid, varid, name, length, values)
    integer,                          intent( in) :: ncid, varid
    character(len = *),               intent( in) :: name
    integer,                          intent( in) :: length
    character(len = *),               intent( in) :: values
    integer                                       :: nf90_get_att_any

    nf90_get_att_any = nf_get_att(ncid, varid, name, values)
  end function nf90_get_att_any
  ! -----------
   function nf90_put_var_any(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     character (len = *),             intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_any

     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride
 
     ! Set local arguments to default values
     localStart (:)  = 1
     localCount (1)  = len_trim(values); localCount (2:) = 1
     localStride(:)  = 1
          
     if(present(start))  localStart (:size(start) ) = start(:)
     if(present(count))  localCount (:size(count) ) = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)

     nf90_put_var_any = nf_put_vars(ncid, varid, localStart, localCount, localStride, values)
   end function nf90_put_var_any
  ! -----------
   function nf90_get_var_any(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     character (len = *),             intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_any
 
     integer, dimension(nf90_max_var_dims) :: textDimIDs
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride 
     integer                               :: stringLength
 
     ! Set local arguments to default values
     localStart (:)  = 1
     localCount (1)  = len(values); localCount (2:) = 1
     localStride(:)  = 1
     
     if(present(start))  localStart (:size(start) ) = start(:)
     if(present(count))  localCount (:size(count) ) = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)

     nf90_get_var_any = nf_get_vars(ncid, varid, localStart, localCount, localStride, values)
   end function nf90_get_var_any

!------- Routines for obtaining info on dimensions, varible sizes, etc -------

! Replacement for fort-geninq.c

! Written by: Richard Weed, Ph.D.
!             Center for Advanced Vehicular Systems 
!             Mississippi State University
!             rweed@cavs.msstate.edu


! License (and other Lawyer Language)
 
! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Corporation for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1.: Sept. 2005  - Initial Cray X1 version
!             April 2006  - Updated to include 3.6.1 function nf_inq_format
! Version 2.: May   2006  - Updated to support g95
! Version 3.: April 2009  - Updated to Netcdf 4.0.1 
! Version 4.: April 2010  - Updated to Netcdf 4.1.1 
! Version 5.: May   2014  - Ensure return error status checked from C API calls
! Version 6.: Jan.  2016  - General code cleanup.
!          
!-------------------------------- nf_inq ----------------------------------
 Function nf_inq(ncid, ndims, nvars, ngatts, unlimdimid) RESULT(status)

! Inquire about number of dimensions, number of varibles, number of
! global attributes, and the id of the ulimited dimension for NetCDF file
! id ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid
 Integer, Intent(OUT) :: ndims, nvars, ngatts, unlimdimid

 Integer              :: status

 Integer(C_INT) :: cncid, cndims, cnvars, cngatts, cunlimdimid, cstatus

 cncid = ncid

 cstatus = nc_inq(cncid, cndims, cnvars, cngatts, cunlimdimid)

 If (cstatus == NC_NOERR) Then
    ndims  = cndims
    nvars  = cnvars
    ngatts = cngatts
    
! Shift C id by plus one to Fortran id if unlimdimid is not -1

    If (cunlimdimid == - 1) Then
       unlimdimid  = -1
    Else
       unlimdimid = cunlimdimid + 1
    EndIf
 EndIf
 status = cstatus

 End Function nf_inq
!-------------------------------- nf_inq_ndims -----------------------------
 Function nf_inq_ndims(ncid, ndims) RESULT(status)

! Inquire about number of dimensions for NetCDF file id ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid
 Integer, Intent(OUT) :: ndims

 Integer              :: status

 Integer(C_INT) :: cncid, cndims, cstatus

 cncid = ncid

 cstatus = nc_inq_ndims(cncid, cndims)

 If (cstatus == NC_NOERR) Then
    ndims  = cndims
 EndIf    
 status = cstatus

 End Function nf_inq_ndims
!-------------------------------- nf_inq_nvars -----------------------------
 Function nf_inq_nvars(ncid, nvars) RESULT(status)

! Inquire about number of variables for NetCDF file id ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid
 Integer, Intent(OUT) :: nvars

 Integer              :: status

 Integer(C_INT) :: cncid, cnvars, cstatus

 cncid = ncid

 cstatus = nc_inq_nvars(cncid, cnvars)

 If (cstatus == NC_NOERR) Then
    nvars  = cnvars
 EndIf    
 status = cstatus

 End Function nf_inq_nvars
!-------------------------------- nf_inq_natts -----------------------------
 Function nf_inq_natts(ncid, ngatts) RESULT(status)

! Inquire about number of global attributes for NetCDF file id ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid
 Integer, Intent(OUT) :: ngatts

 Integer              :: status

 Integer(C_INT) :: cncid, cngatts, cstatus

 cncid = ncid

 cstatus = nc_inq_natts(cncid, cngatts)

 If (cstatus == NC_NOERR) Then
    ngatts = cngatts
 EndIf
 status = cstatus

 End Function nf_inq_natts
!-------------------------------- nf_inq_unlimdim --------------------------
 Function nf_inq_unlimdim(ncid, unlimdimid) RESULT(status)

! Inquire about id of unlimited dimension for NetCDF file id ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid
 Integer, Intent(OUT) :: unlimdimid

 Integer              :: status

 Integer(C_INT) :: cncid, cunlimdimid, cstatus

 cncid = ncid

 cstatus = nc_inq_unlimdim(cncid, cunlimdimid)

! Shift C id by plus one to Fortran id if unlimdimid is not -1

 If (cstatus == NC_NOERR) Then
    If (cunlimdimid == -1) Then
       unlimdimid = -1
    Else
       unlimdimid = cunlimdimid + 1
    EndIf
 EndIf
 status = cstatus

 End Function nf_inq_unlimdim
!-------------------------------- nf_inq_format -------------------------------
 Function nf_inq_format(ncid, format_type) RESULT(status)

! Inquire about internal file format for NetCDF file id ncid

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid
 Integer, Intent(OUT) :: format_type 

 Integer              :: status

 Integer(C_INT) :: cncid, cformatp, cstatus

 cncid = ncid

 cstatus = nc_inq_format(cncid, cformatp)

 If (cstatus == NC_NOERR) Then
! Return format_type 
    
    format_type = cformatp
 EndIf
 status  = cstatus

 End Function nf_inq_format

!----- Routines to put/get single data items of a variety of data types ------

! Replacement for fort-var1io.c

! Written by: Richard Weed, Ph.D
!             Center for Advanced Vehicular Systems 
!             Mississippi State University
!             rweed@cavs.msstate.edu


! License (and other Lawyer Language)
 
! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Corporation for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1.: Sept. 2005 - Initial Cray X1 version
! Version 2.: May   2006 - Updated to support g95
!                          Updated to pass ndex as C_PTR variable
! Version 3.: April 2009 - Updated for netCDF 4.0.1
! Version 4.: April 2010 - Updated for netCDF 4.1.1
!                          Added preprocessor test for int and real types
! Version 5.: Jan.  2016 - Replace automatic array for cndex with allocatable
!                          array and general code cleanup
 
!--------------------------------- nf_put_var1_text ------------------------
 Function nf_put_var1_text(ncid, varid, ndex, chval) RESULT(status)

! Write out a single character variable to location vector ndex in dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN) :: ncid, varid
 Integer,          Intent(IN) :: ndex(*)
 Character(LEN=1), Intent(IN) :: chval

 Integer                      :: status

 Integer(C_INT)  :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)     :: cndexptr
 Integer         :: ndims

 Integer(C_SIZE_T), ALLOCATABLE, TARGET :: cndex(:)

 cncid  = ncid
 cvarid = varid - 1 ! Subtract one to get C varid
 
 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cndexptr = C_NULL_PTR
 ndims    = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! reverse array order and subtract 1 to get C index
     ALLOCATE(cndex(ndims)) 
     cndex(1:ndims) = ndex(ndims:1:-1) - 1
     cndexptr       = C_LOC(cndex)
   EndIf
 EndIf

 cstatus = nc_put_var1_text(cncid, cvarid, cndexptr, chval)

 status = cstatus

! Make sure there are no dangling pointers or allocated arrays

 cndexptr = C_NULL_PTR
 If (ALLOCATED(cndex)) DEALLOCATE(cndex)

 End Function nf_put_var1_text
!--------------------------------- nf_put_var1_int1 ------------------------
 Function nf_put_var1_int1(ncid, varid, ndex, ival) RESULT(status)

! Write out a 8 bit integer variable to location vector ndex in dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,         Intent(IN) :: ncid, varid
 Integer,         Intent(IN) :: ndex(*)
 Integer(NFINT1), Intent(IN) :: ival

 Integer                     :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cndexptr
 Integer(CINT1) :: cival
 Integer        :: ndims

 Integer(C_SIZE_T), ALLOCATABLE, TARGET :: cndex(:)

 If (C_SIGNED_CHAR < 0) Then ! schar not supported by processor exit
   status = NC_EBADTYPE
   RETURN
 EndIf

 cncid  = ncid
 cvarid = varid - 1 ! Subtract one to get C varid
 cival  = ival

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cndexptr = C_NULL_PTR
 ndims    = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! reverse array order and subtract 1 to get C index 
     ALLOCATE(cndex(ndims)) 
     cndex(1:ndims) = ndex(ndims:1:-1) - 1
     cndexptr       = C_LOC(cndex)
   EndIf
 EndIf

#if NF_INT1_IS_C_SIGNED_CHAR
 cstatus = nc_put_var1_schar(cncid, cvarid, cndexptr, cival)
#elif NF_INT1_IS_C_SHORT
 cstatus = nc_put_var1_short(cncid, cvarid, cndexptr, cival)
#elif NF_INT1_IS_C_INT
 cstatus = nc_put_var1_int(cncid, cvarid, cndexptr, cival)
#elif NF_INT1_IS_C_LONG
 cstatus = nc_put_var1_long(cncid, cvarid, cndexptr, cival)
#endif

 status = cstatus

! Make sure there are no dangling pointers or allocated arrays

 cndexptr = C_NULL_PTR
 If (ALLOCATED(cndex)) DEALLOCATE(cndex)

 End Function nf_put_var1_int1
!--------------------------------- nf_put_var1_int2 ------------------------
 Function nf_put_var1_int2(ncid, varid, ndex, ival) RESULT(status)

! Write out a 16 bit integer variable to location vector ndex in dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,         Intent(IN) :: ncid, varid
 Integer,         Intent(IN) :: ndex(*)
 Integer(NFINT2), Intent(IN) :: ival

 Integer                     :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cndexptr
 Integer(CINT2) :: cival
 Integer        :: ndims

 Integer(C_SIZE_T), ALLOCATABLE, TARGET :: cndex(:)

 If (C_SHORT < 0) Then ! short not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf

 cncid  = ncid
 cvarid = varid - 1 ! Subtract one to get C varid
 cival  = ival

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cndexptr = C_NULL_PTR
 ndims    = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! reverse array order and subtract 1 to get C index 
     ALLOCATE(cndex(ndims)) 
     cndex(1:ndims) = ndex(ndims:1:-1) - 1
     cndexptr       = C_LOC(cndex)
   EndIf
 EndIf

#if NF_INT2_IS_C_SHORT
 cstatus = nc_put_var1_short(cncid, cvarid, cndexptr, cival)
#elif NF_INT2_IS_C_INT
 cstatus = nc_put_var1_int(cncid, cvarid, cndexptr, cival)
#elif NF_INT2_IS_C_LONG
 cstatus = nc_put_var1_long(cncid, cvarid, cndexptr, cival)
#endif

 status = cstatus

! Make sure there are no dangling pointers or allocated arrays

 cndexptr = C_NULL_PTR
 If (ALLOCATED(cndex)) DEALLOCATE(cndex)

 End Function nf_put_var1_int2
!--------------------------------- nf_put_var1_int -------------------------
 Function nf_put_var1_int(ncid, varid, ndex, ival) RESULT(status)

! Write out a default integer variable to location vector ndex to dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,        Intent(IN) :: ncid, varid
 Integer,        Intent(IN) :: ndex(*)
 Integer(NFINT), Intent(IN) :: ival

 Integer                    :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cndexptr
 Integer(CINT)  :: cival
 Integer        :: ndims

 Integer(C_SIZE_T), ALLOCATABLE, TARGET :: cndex(:)

 cncid  = ncid
 cvarid = varid - 1 ! Subtract one to get C varid
 cival  = ival

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cndexptr = C_NULL_PTR
 ndims    = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! reverse array order and subtract 1 to get C index 
     ALLOCATE(cndex(ndims)) 
     cndex(1:ndims) = ndex(ndims:1:-1) - 1
     cndexptr       = C_LOC(cndex)
   EndIf
 EndIf

#if NF_INT_IS_C_INT
 cstatus = nc_put_var1_int(cncid, cvarid, cndexptr, cival)
#elif NF_INT_IS_C_LONG
 cstatus = nc_put_var1_long(cncid, cvarid, cndexptr, cival)
#endif

 status = cstatus

! Make sure there are no dangling pointers or allocated arrays

 cndexptr = C_NULL_PTR
 If (ALLOCATED(cndex)) DEALLOCATE(cndex)

 End Function nf_put_var1_int
!--------------------------------- nf_put_var1_real ------------------------
 Function nf_put_var1_real(ncid, varid, ndex, rval) RESULT(status)

! Write out a 32 bit real variable to location vector ndex in dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,      Intent(IN) :: ncid, varid
 Integer,      Intent(IN) :: ndex(*)
 Real(NFREAL), Intent(IN) :: rval

 Integer                  :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cndexptr
 Integer        :: ndims

 Integer(C_SIZE_T), ALLOCATABLE, TARGET :: cndex(:)

 cncid  = ncid
 cvarid = varid - 1 ! Subtract one to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cndexptr = C_NULL_PTR
 ndims    = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! reverse array order and subtract 1 to get C index 
     ALLOCATE(cndex(ndims)) 
     cndex(1:ndims) = ndex(ndims:1:-1) - 1
     cndexptr       = C_LOC(cndex)
   EndIf
 EndIf

#if NF_REAL_IS_C_DOUBLE
 cstatus = nc_put_var1_double(cncid, cvarid, cndexptr, rval)
#else
 cstatus = nc_put_var1_float(cncid, cvarid, cndexptr, rval)
#endif

 status = cstatus

! Make sure there are no dangling pointers or allocated arrays

 cndexptr = C_NULL_PTR
 If (ALLOCATED(cndex)) DEALLOCATE(cndex)

 End Function nf_put_var1_real
!--------------------------------- nf_put_var1_double ----------------------
 Function nf_put_var1_double(ncid, varid, ndex, dval) RESULT(status)

! Write out a 64 bit real variable to location vector ndex in dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,   Intent(IN) :: ncid, varid
 Integer,   Intent(IN) :: ndex(*)
 Real(RK8), Intent(IN) :: dval

 Integer               :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cndexptr
 Integer        :: ndims

 Integer(C_SIZE_T), ALLOCATABLE, TARGET :: cndex(:)

 cncid  = ncid
 cvarid = varid - 1 ! Subtract one to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims) ! get varid dimension

 cndexptr = C_NULL_PTR
 ndims    = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then
     ALLOCATE(cndex(ndims)) 
     cndex(1:ndims) = ndex(ndims:1:-1) - 1
     cndexptr       = C_LOC(cndex)
   EndIf
 EndIf

 cstatus = nc_put_var1_double(cncid, cvarid, cndexptr, dval)

 status = cstatus

! Make sure there are no dangling pointers or allocated arrays

 cndexptr = C_NULL_PTR
 If (ALLOCATED(cndex)) DEALLOCATE(cndex)

 End Function nf_put_var1_double
!--------------------------------- nf_put_var1_int64 --------------------------
 Function nf_put_var1_int64(ncid, varid, ndex, ival) RESULT(status)

! Write out a 64 bit integer variable to location vector ndex to dataset
! Note that the default fort interfaces pass ival as an integer to
! nc_put_var1_longlong which is expecting a longlong. We chose to
! pass ival as an integer of type SELECTED_INT_KIND(18) which is
! consistent with the f90 interfaces that call these routines

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,      Intent(IN) :: ncid, varid
 Integer,      Intent(IN) :: ndex(*)
 Integer(IK8), Intent(IN) :: ival

 Integer                  :: status

 Integer(C_INT)       :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(C_LONG_LONG) :: cival
 Type(C_PTR)          :: cndexptr
 Integer              :: ndims

 Integer(C_SIZE_T), ALLOCATABLE, TARGET :: cndex(:)

 cncid  = ncid
 cvarid = varid - 1 ! Subtract one to get C varid
 cival  = ival

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cndexptr = C_NULL_PTR
 ndims    = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! reverse array order and subtract 1 to get C index
     ALLOCATE(cndex(ndims))
     cndex(1:ndims) = ndex(ndims:1:-1) - 1
     cndexptr       = C_LOC(cndex)
   EndIf
 EndIf

 cstatus = nc_put_var1_longlong(cncid, cvarid, cndexptr, cival)

 status = cstatus

! Make sure there are no dangling pointers and allocated values

 cndexptr = C_NULL_PTR
 If (ALLOCATED(cndex)) DEALLOCATE(cndex)

 End Function nf_put_var1_int64
!--------------------------------- nf_put_var1 ------------------------
 Function nf_put_var1(ncid, varid, ndex, values) RESULT(status)

! Write out values of any type. We use a C interop character string to
! hold values. Therefore, an explicit interface to nf_put_var1 should
! not be defined in the calling program to avoid rigid TKR conflict
! Just declare it external

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,                Intent(IN)         :: ncid, varid
 Integer,                Intent(IN)         :: ndex(*)
 Character(KIND=C_CHAR), Intent(IN), TARGET :: values(*)

 Integer                                    :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cndexptr, cvaluesptr
 Integer        :: ndims

 Integer(C_SIZE_T), ALLOCATABLE, TARGET :: cndex(:)

 cncid  = ncid
 cvarid = varid - 1 ! Subtract one to get C varid
 
 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cndexptr = C_NULL_PTR
 ndims    = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! reverse array order and subtract 1 to get C index 
     ALLOCATE(cndex(ndims)) 
     cndex(1:ndims) = ndex(ndims:1:-1) - 1
     cndexptr       = C_LOC(cndex)
   Else
     ALLOCATE(cndex(1))
     cndex(1:ndims) = ndex(ndims:1:-1) - 1
     cndexptr       = C_LOC(cndex)
   EndIf
 EndIf

 cvaluesptr = C_LOC(values)

 cstatus = nc_put_var1(cncid, cvarid, cndexptr, cvaluesptr)

 status = cstatus

! Make sure there are no dangling pointers or allocated arrays

 cndexptr = C_NULL_PTR
 If (ALLOCATED(cndex)) DEALLOCATE(cndex)

 End Function nf_put_var1
!--------------------------------- nf_get_var1_text ------------------------
 Function nf_get_var1_text(ncid, varid, ndex, chval) RESULT(status)

! Read in a single character variable from location vector ndex in dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(IN)  :: ndex(*)
 Character(LEN=1), Intent(OUT) :: chval

 Integer                       :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cndexptr
 Integer        :: ndims

 Integer(C_SIZE_T), ALLOCATABLE, TARGET :: cndex(:)

 cncid  = ncid
 cvarid = varid - 1 ! Subtract one to get C varid
 chval  = ' '

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cndexptr = C_NULL_PTR
 ndims    = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! reverse array order and subtract 1 to get C index 
     ALLOCATE(cndex(ndims)) 
     cndex(1:ndims) = ndex(ndims:1:-1) -1
     cndexptr       = C_LOC(cndex)
   EndIf
  EndIf
 
 cstatus = nc_get_var1_text(cncid, cvarid, cndexptr, chval)

 status = cstatus

! Make sure there are no dangling pointers or allocated arrays

 cndexptr = C_NULL_PTR
 If (ALLOCATED(cndex)) DEALLOCATE(cndex)

 End Function nf_get_var1_text
!--------------------------------- nf_get_var1_int1 ------------------------
 Function nf_get_var1_int1(ncid, varid, ndex, ival) RESULT(status)

! Read in a 8 bit integer variable from location vector ndex in dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,         Intent(IN)  :: ncid, varid
 Integer,         Intent(IN)  :: ndex(*)
 Integer(NFINT1), Intent(OUT) :: ival

 Integer                      :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cndexptr
 Integer(CINT1) :: cival
 Integer        :: ndims

 Integer(C_SIZE_T), ALLOCATABLE, TARGET :: cndex(:)

 If (C_SIGNED_CHAR < 0) Then ! schar not supported by processor exit
   status = NC_EBADTYPE
   RETURN
 EndIf

 cncid  = ncid
 cvarid = varid - 1 ! Subtract one to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cndexptr = C_NULL_PTR
 ndims    = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! reverse array order and subtract 1 to get C index 
     ALLOCATE(cndex(ndims)) 
     cndex(1:ndims) = ndex(ndims:1:-1) - 1
     cndexptr       = C_LOC(cndex)
   EndIf
 EndIf

#if NF_INT1_IS_C_SIGNED_CHAR
 cstatus = nc_get_var1_schar(cncid, cvarid, cndexptr, cival)
#elif NF_INT1_IS_C_SHORT
 cstatus = nc_get_var1_short(cncid, cvarid, cndexptr, cival)
#elif NF_INT1_IS_C_INT
 cstatus = nc_get_var1_int(cncid, cvarid, cndexptr, cival)
#elif NF_INT1_IS_C_LONG
 cstatus = nc_get_var1_long(cncid, cvarid, cndexptr, cival)
#endif
 
 ival   = cival
 status = cstatus

! Make sure there are no dangling pointers or allocated arrays

 cndexptr = C_NULL_PTR
 If (ALLOCATED(cndex)) DEALLOCATE(cndex)

 End Function nf_get_var1_int1
!--------------------------------- nf_get_var1_int2 ------------------------
 Function nf_get_var1_int2(ncid, varid, ndex, ival) RESULT(status)

! Read in a 16 bit integer variable from location vector ndex in dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,         Intent(IN)  :: ncid, varid
 Integer,         Intent(IN)  :: ndex(*)
 Integer(NFINT2), Intent(OUT) :: ival

 Integer                      :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cndexptr
 Integer(CINT2) :: cival
 Integer        :: ndims

 Integer(C_SIZE_T), ALLOCATABLE, TARGET :: cndex(:)

 If (C_SHORT < 0) Then ! short not supported by processor
   status = NC_EBADTYPE
   RETURN
 EndIf

 cncid  = ncid
 cvarid = varid - 1 ! Subtract one to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cndexptr = C_NULL_PTR
 ndims    = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! reverse array order and subtract 1 to get C index 
     ALLOCATE(cndex(ndims)) 
     cndex(1:ndims) = ndex(ndims:1:-1) - 1
     cndexptr       = C_LOC(cndex)
   EndIf
 EndIf

#if NF_INT2_IS_C_SHORT
 cstatus = nc_get_var1_short(cncid, cvarid, cndexptr, cival)
#elif NF_INT2_IS_C_INT
 cstatus = nc_get_var1_int(cncid, cvarid, cndexptr, cival)
#elif NF_INT2_IS_C_LONG
 cstatus = nc_get_var1_long(cncid, cvarid, cndexptr, cival)
#endif
 
 ival   = cival
 status = cstatus

! Make sure there are no dangling pointers or allocated arrays

 cndexptr = C_NULL_PTR
 If (ALLOCATED(cndex)) DEALLOCATE(cndex)

 End Function nf_get_var1_int2
!--------------------------------- nf_get_var1_int -------------------------
 Function nf_get_var1_int(ncid, varid, ndex, ival) RESULT(status)

! Read in 32 bit integer variable from location vector ndex in dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer, Intent(IN)  :: ncid, varid
 Integer, Intent(IN)  :: ndex(*)
 Integer, Intent(OUT) :: ival

 Integer              :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cndexptr
 Integer(CINT)  :: cival
 Integer        :: ndims

 Integer(C_SIZE_T), ALLOCATABLE, TARGET :: cndex(:)

 cncid  = ncid
 cvarid = varid - 1 ! Subtract one to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cndexptr = C_NULL_PTR
 ndims    = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! reverse array order and subtract 1 to get C index 
     ALLOCATE(cndex(ndims)) 
     cndex(1:ndims) = ndex(ndims:1:-1) - 1
     cndexptr       = C_LOC(cndex)
   EndIf
 EndIf

#if NF_INT_IS_C_INT
 cstatus = nc_get_var1_int(cncid, cvarid, cndexptr, cival)
#elif NF_INT_IS_C_LONG
 cstatus = nc_get_var1_long(cncid, cvarid, cndexptr, cival)
#endif

 ival   = cival
 status = cstatus

! Make sure there are no dangling pointers or allocated arrays

 cndexptr = C_NULL_PTR
 If (ALLOCATED(cndex)) DEALLOCATE(cndex)

 End Function nf_get_var1_int
!--------------------------------- nf_get_var1_real ------------------------
 Function nf_get_var1_real(ncid, varid, ndex, rval) RESULT(status)

! Read in a 32 bit real variable to location vector ndex in dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,      Intent(IN)  :: ncid, varid
 Integer,      Intent(IN)  :: ndex(*)
 Real(NFREAL), Intent(OUT) :: rval

 Integer                   :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cndexptr
 Integer        :: ndims

 Integer(C_SIZE_T), ALLOCATABLE, TARGET :: cndex(:)

 cncid  = ncid
 cvarid = varid - 1 ! Subtract one to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cndexptr = C_NULL_PTR
 ndims    = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! reverse array order and subtract 1 to get C index 
     ALLOCATE(cndex(ndims)) 
     cndex(1:ndims) = ndex(ndims:1:-1) - 1
     cndexptr       = C_LOC(cndex)
   EndIf
 EndIf

#if NF_REAL_IS_C_DOUBLE
 cstatus = nc_get_var1_double(cncid, cvarid, cndexptr, rval)
#else
 cstatus = nc_get_var1_float(cncid, cvarid, cndexptr, rval)
#endif

 status = cstatus

! Make sure there are no dangling pointers or allocated arrays

 cndexptr = C_NULL_PTR
 If (ALLOCATED(cndex)) DEALLOCATE(cndex)

 End Function nf_get_var1_real
!--------------------------------- nf_get_var1_double ----------------------
 Function nf_get_var1_double(ncid, varid, ndex, dval) RESULT(status)

! Read in a 64 bit real variable to location vector ndex in dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,   Intent(IN)  :: ncid, varid
 Integer,   Intent(IN)  :: ndex(*)
 Real(RK8), Intent(OUT) :: dval

 Integer                :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cndexptr
 Integer        :: ndims

 Integer(C_SIZE_T), ALLOCATABLE, TARGET :: cndex(:)

 cncid  = ncid
 cvarid = varid - 1 ! Subtract one to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims) ! get varid dimension

 cndexptr = C_NULL_PTR
 ndims    = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! reverse array order and subtract 1 to get C index 
     ALLOCATE(cndex(ndims)) 
     cndex(1:ndims) = ndex(ndims:1:-1) - 1
     cndexptr       = C_LOC(cndex)
   EndIf
 EndIf

 cstatus = nc_get_var1_double(cncid, cvarid, cndexptr, dval)

 status = cstatus

! Make sure there are no dangling pointers or allocated arrays

 cndexptr = C_NULL_PTR
 If (ALLOCATED(cndex)) DEALLOCATE(cndex)

 End Function nf_get_var1_double
!--------------------------------- nf_get_var1_int64 -------------------------
 Function nf_get_var1_int64(ncid, varid, ndex, ival) RESULT(status)

! Read in 64 bit integer variable from location vector ndex in dataset

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,      Intent(IN)  :: ncid, varid
 Integer,      Intent(IN)  :: ndex(*)
 Integer(IK8), Intent(OUT) :: ival

 Integer                   :: status

 Integer(C_INT)       :: cncid, cvarid, cndims, cstat1, cstatus
 Integer(C_LONG_LONG) :: cival
 Type(C_PTR)          :: cndexptr
 Integer              :: ndims

 Integer(C_SIZE_T), ALLOCATABLE, TARGET :: cndex(:)

 cncid  = ncid
 cvarid = varid - 1 ! Subtract one to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims)

 cndexptr = C_NULL_PTR
 ndims    = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! reverse array order and subtract 1 to get C index
     ALLOCATE(cndex(ndims))
     cndex(1:ndims) = ndex(ndims:1:-1) - 1
     cndexptr       = C_LOC(cndex)
   EndIf
 EndIf

 cstatus = nc_get_var1_longlong(cncid, cvarid, cndexptr, cival)

 ival   = cival
 status = cstatus

! Make sure there are no dangling pointers and allocated values

 cndexptr = C_NULL_PTR
 If (ALLOCATED(cndex)) DEALLOCATE(cndex)

 End Function nf_get_var1_int64
!--------------------------------- nf_get_var1 -------------------------------
 Function nf_get_var1(ncid, varid, ndex, values) RESULT(status)

! Read in values of any type. We use a C interop character string to
! hold values. Therefore, an explicit interface to nf_get_var1 should
! not be defined in the calling program to avoid rigid TKR conflict
! Just declare it external

 USE netcdf_nc_interfaces

 Implicit NONE

 Integer,                Intent(IN)          :: ncid, varid
 Integer,                Intent(IN)          :: ndex(*)
 Character(KIND=C_CHAR), Intent(OUT), TARGET :: values(*)

 Integer                                     :: status

 Integer(C_INT) :: cncid, cvarid, cndims, cstat1, cstatus
 Type(C_PTR)    :: cndexptr
 Integer        :: ndims

 Integer(C_SIZE_T), ALLOCATABLE, TARGET :: cndex(:)

 cncid  = ncid
 cvarid = varid - 1 ! Subtract one to get C varid

 cstat1 = nc_inq_varndims(cncid, cvarid, cndims) ! get varid dimension

 cndexptr = C_NULL_PTR
 ndims    = cndims

 If (cstat1 == NC_NOERR) Then
   If (ndims > 0) Then ! reverse array order and subtract 1 to get C index 
     ALLOCATE(cndex(ndims)) 
     cndex(1:ndims) = ndex(ndims:1:-1) - 1
     cndexptr       = C_LOC(cndex)
   EndIf
 EndIf

 cstatus = nc_get_var1(cncid, cvarid, cndexptr, values)

 status = cstatus

! Make sure there are no dangling pointers or allocated arrays

 cndexptr = C_NULL_PTR
 If (ALLOCATED(cndex)) DEALLOCATE(cndex)

 End Function nf_get_var1
